/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/nls","vs/base/common/charCode","vs/base/common/decorators","vs/base/common/process","vs/platform/terminal/common/terminal","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/platform/terminal/common/capabilities/capabilities","vs/base/common/lazy","vs/base/common/resources","vs/base/common/map","vs/base/common/marshallingIds","vs/base/node/pfs","child_process","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/processes","vs/base/common/objects","vs/base/common/extpath","fs","vs/base/node/processes","vs/base/parts/sandbox/node/electronTypes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/uint","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/uuid","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/base/common/date","vs/base/common/errorMessage","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","util","minimist","node-pty","vs/base/common/performance","@xterm/headless","vs/platform/terminal/node/ptyHostMain"],fe=function(ie){for(var e=[],a=0,t=ie.length;a<t;a++)e[a]=he[ie[a]];return e};define(he[43],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=a,e.$fb=t,e.$gb=S,e.$hb=$,e.$ib=B,e.$jb=P,e.$kb=p,e.$mb=L,e.$nb=b,e.$ob=d,e.$pb=u,e.$qb=c;function a(h,f){const l=t(h,f);if(l!==-1)return h[l]}function t(h,f,l=h.length-1){for(let n=l;n>=0;n--){const w=h[n];if(f(w))return n}return-1}function S(h,f){const l=$(h,f);return l===-1?void 0:h[l]}function $(h,f,l=0,n=h.length){let w=l,v=n;for(;w<v;){const o=Math.floor((w+v)/2);f(h[o])?w=o+1:v=o}return w-1}function B(h,f){const l=P(h,f);return l===h.length?void 0:h[l]}function P(h,f,l=0,n=h.length){let w=l,v=n;for(;w<v;){const o=Math.floor((w+v)/2);f(h[o])?v=o:w=o+1}return w}function p(h,f,l=0,n=h.length){const w=P(h,f,l,n);return w===h.length?-1:w}class r{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(r.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!f(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const l=$(this.e,f,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$lb=r;function L(h,f){if(h.length===0)return;let l=h[0];for(let n=1;n<h.length;n++){const w=h[n];f(w,l)>0&&(l=w)}return l}function b(h,f){if(h.length===0)return;let l=h[0];for(let n=1;n<h.length;n++){const w=h[n];f(w,l)>=0&&(l=w)}return l}function d(h,f){return L(h,(l,n)=>-f(l,n))}function u(h,f){if(h.length===0)return-1;let l=0;for(let n=1;n<h.length;n++){const w=h[n];f(w,h[l])>0&&(l=n)}return l}function c(h,f){for(const l of h){const n=f(l);if(n!==void 0)return n}}}),define(he[13],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var a;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(a||(e.CharCode=a={}))}),define(he[44],fe([0,1]),function(ie,e){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=t,e.$d=S,e.$e=$,e.$f=B;function t(p,r){const L=Object.create(null);for(const b of p){const d=r(b);let u=L[d];u||(u=L[d]=[]),u.push(b)}return L}function S(p,r){const L=[],b=[];for(const d of p)r.has(d)||L.push(d);for(const d of r)p.has(d)||b.push(d);return{removed:L,added:b}}function $(p,r){const L=[],b=[];for(const[d,u]of p)r.has(d)||L.push(u);for(const[d,u]of r)p.has(d)||b.push(u);return{removed:L,added:b}}function B(p,r){const L=new Set;for(const b of r)p.has(b)&&L.add(b);return L}class P{static{a=Symbol.toStringTag}constructor(r,L){this.b=L,this.a=new Map,this[a]="SetWithKey";for(const b of r)this.add(b)}get size(){return this.a.size}add(r){const L=this.b(r);return this.a.set(L,r),this}delete(r){return this.a.delete(this.b(r))}has(r){return this.a.has(this.b(r))}*entries(){for(const r of this.a.values())yield[r,r]}keys(){return this.values()}*values(){for(const r of this.a.values())yield r}clear(){this.a.clear()}forEach(r,L){this.a.forEach(b=>r.call(L,b,b,this))}[Symbol.iterator](){return this.values()}}e.$g=P}),define(he[14],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=t,e.$$h=S,e.$_h=$;function a(B){return(P,p,r)=>{let L=null,b=null;if(typeof r.value=="function"?(L="value",b=r.value):typeof r.get=="function"&&(L="get",b=r.get),!b)throw new Error("not supported");r[L]=B(b,p)}}function t(B,P,p){let r=null,L=null;if(typeof p.value=="function"?(r="value",L=p.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(r="get",L=p.get),!L)throw new Error("not supported");const b=`$memoize$${P}`;p[r]=function(...d){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,d)}),this[b]}}function S(B,P,p){return a((r,L)=>{const b=`$debounce$${L}`,d=`$debounce$result$${L}`;return function(...u){this[d]||(this[d]=p?p():void 0),clearTimeout(this[b]),P&&(this[d]=P(this[d],...u),u=[this[d]]),this[b]=setTimeout(()=>{r.apply(this,u),this[d]=p?p():void 0},B)}})}function $(B,P,p){return a((r,L)=>{const b=`$throttle$timer$${L}`,d=`$throttle$result$${L}`,u=`$throttle$lastRun$${L}`,c=`$throttle$pending$${L}`;return function(...h){if(this[d]||(this[d]=p?p():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),P&&(this[d]=P(this[d],...h)),this[c])return;const f=this[u]+B;f<=Date.now()?(this[u]=Date.now(),r.apply(this,[this[d]]),this[d]=p?p():void 0):(this[c]=!0,this[b]=setTimeout(()=>{this[c]=!1,this[u]=Date.now(),r.apply(this,[this[d]]),this[d]=p?p():void 0},f-Date.now()))}})}}),define(he[7],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=t,e.$X=S,e.$Y=$,e.$Z=B,e.$1=P,e.$2=p,e.$3=L,e.$5=d,e.$6=u,e.$7=c,e.$9=f;class a{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?v.isErrorNoTelemetry(i)?new v(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(g=>{g(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=a,e.$V=new a;function t(s){e.$V.setUnexpectedErrorHandler(s)}function S(s){if(!s||typeof s!="object")return!1;const i=s;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function $(s){L(s)||e.$V.onUnexpectedError(s)}function B(s){L(s)||e.$V.onUnexpectedExternalError(s)}function P(s){if(s instanceof Error){const{name:i,message:g}=s,_=s.stacktrace||s.stack;return{$isError:!0,name:i,message:g,stack:_,noTelemetry:v.isErrorNoTelemetry(s)}}return s}function p(s){let i;return s.noTelemetry?i=new v:(i=new Error,i.name=s.name),i.message=s.message,i.stack=s.stack,i}const r="Canceled";function L(s){return s instanceof b?!0:s instanceof Error&&s.name===r&&s.message===r}class b extends Error{constructor(){super(r),this.name=this.message}}e.$4=b;function d(){const s=new Error(r);return s.name=s.message,s}function u(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function c(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class h extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=h;function f(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class l extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=l;class n extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=n;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=w;class v extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof v)return i;const g=new v;return g.message=i.message,g.stack=i.stack,g}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=v;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$bb=o}),define(he[17],fe([0,1,7,43]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=S,e.$sb=$,e.$tb=B,e.$ub=P,e.$vb=p,e.$wb=r,e.$xb=L,e.$yb=b,e.$zb=d,e.$Ab=u,e.$Bb=c,e.$Cb=h,e.$Db=f,e.top=l,e.$Fb=n,e.$Gb=v,e.$Hb=o,e.$Ib=s,e.$Jb=i,e.$Kb=g,e.$Lb=_,e.$Mb=C,e.$Nb=E,e.$Ob=k,e.$Pb=R,e.$Qb=M,e.$Rb=q,e.$Sb=I,e.$Tb=y,e.$Ub=U,e.$Vb=A,e.$Wb=D,e.$Xb=F,e.$Yb=J,e.$Zb=V,e.$1b=Q,e.$2b=re,e.$3b=ce,e.$4b=K,e.$5b=ee,e.$6b=le,e.$9b=me,e.$ac=oe;function S(N,X=0){return N[N.length-(1+X)]}function $(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function B(N,X,T=(O,H)=>O===H){if(N===X)return!0;if(!N||!X||N.length!==X.length)return!1;for(let O=0,H=N.length;O<H;O++)if(!T(N[O],X[O]))return!1;return!0}function P(N,X){const T=N.length-1;X<T&&(N[X]=N[T]),N.pop()}function p(N,X,T){return r(N.length,O=>T(N[O],X))}function r(N,X){let T=0,O=N-1;for(;T<=O;){const H=(T+O)/2|0,Z=X(H);if(Z<0)T=H+1;else if(Z>0)O=H-1;else return H}return-(T+1)}function L(N,X,T){if(N=N|0,N>=X.length)throw new TypeError("invalid index");const O=X[Math.floor(X.length*Math.random())],H=[],Z=[],ne=[];for(const be of X){const Ee=T(be,O);Ee<0?H.push(be):Ee>0?Z.push(be):ne.push(be)}return N<H.length?L(N,H,T):N<H.length+ne.length?ne[0]:L(N-(H.length+ne.length),Z,T)}function b(N,X){const T=[];let O;for(const H of N.slice(0).sort(X))!O||X(O[0],H)!==0?(O=[H],T.push(O)):O.push(H);return T}function*d(N,X){let T,O;for(const H of N)O!==void 0&&X(O,H)?T.push(H):(T&&(yield T),T=[H]),O=H;T&&(yield T)}function u(N,X){for(let T=0;T<=N.length;T++)X(T===0?void 0:N[T-1],T===N.length?void 0:N[T])}function c(N,X){for(let T=0;T<N.length;T++)X(T===0?void 0:N[T-1],N[T],T+1===N.length?void 0:N[T+1])}function h(N,X,T){const O=[];function H(be,Ee,Ae){if(Ee===0&&Ae.length===0)return;const ge=O[O.length-1];ge&&ge.start+ge.deleteCount===be?(ge.deleteCount+=Ee,ge.toInsert.push(...Ae)):O.push({start:be,deleteCount:Ee,toInsert:Ae})}let Z=0,ne=0;for(;;){if(Z===N.length){H(Z,0,X.slice(ne));break}if(ne===X.length){H(Z,N.length-Z,[]);break}const be=N[Z],Ee=X[ne],Ae=T(be,Ee);Ae===0?(Z+=1,ne+=1):Ae<0?(H(Z,1,[]),Z+=1):Ae>0&&(H(Z,0,[Ee]),ne+=1)}return O}function f(N,X,T){const O=h(N,X,T),H=[],Z=[];for(const ne of O)H.push(...N.slice(ne.start,ne.start+ne.deleteCount)),Z.push(...ne.toInsert);return{removed:H,added:Z}}function l(N,X,T){if(T===0)return[];const O=N.slice(0,T).sort(X);return w(N,X,O,T,N.length),O}function n(N,X,T,O,H){return T===0?Promise.resolve([]):new Promise((Z,ne)=>{(async()=>{const be=N.length,Ee=N.slice(0,T).sort(X);for(let Ae=T,ge=Math.min(T+O,be);Ae<be;Ae=ge,ge=Math.min(ge+O,be)){if(Ae>T&&await new Promise(de=>setTimeout(de)),H&&H.isCancellationRequested)throw new a.$4;w(N,X,Ee,Ae,ge)}return Ee})().then(Z,ne)})}function w(N,X,T,O,H){for(const Z=T.length;O<H;O++){const ne=N[O];if(X(ne,T[Z-1])<0){T.pop();const be=(0,t.$jb)(T,Ee=>X(ne,Ee)<0);T.splice(be,0,ne)}}}function v(N){return N.filter(X=>!!X)}function o(N){let X=0;for(let T=0;T<N.length;T++)N[T]&&(N[X]=N[T],X+=1);N.length=X}function s(N,X,T){N.splice(T,0,N.splice(X,1)[0])}function i(N){return!Array.isArray(N)||N.length===0}function g(N){return Array.isArray(N)&&N.length>0}function _(N,X=T=>T){const T=new Set;return N.filter(O=>{const H=X(O);return T.has(H)?!1:(T.add(H),!0)})}function C(N){const X=new Set;return T=>{const O=N(T);return X.has(O)?!1:(X.add(O),!0)}}function E(N,X){return N.length>0?N[0]:X}function k(N,X){return N.length>0?N[N.length-1]:X}function R(N,X,T=(O,H)=>O===H){let O=0;for(let H=0,Z=Math.min(N.length,X.length);H<Z&&T(N[H],X[H]);H++)O++;return O}function M(N,X){let T=typeof X=="number"?N:0;typeof X=="number"?T=N:(T=0,X=N);const O=[];if(T<=X)for(let H=T;H<X;H++)O.push(H);else for(let H=T;H>X;H--)O.push(H);return O}function q(N,X,T){return N.reduce((O,H)=>(O[X(H)]=T?T(H):H,O),Object.create(null))}function I(N,X){return N.push(X),()=>y(N,X)}function y(N,X){const T=N.indexOf(X);if(T>-1)return N.splice(T,1),X}function U(N,X,T){const O=N.slice(0,X),H=N.slice(X);return O.concat(T,H)}function A(N,X){let T;if(typeof X=="number"){let O=X;T=()=>{const H=Math.sin(O++)*179426549;return H-Math.floor(H)}}else T=Math.random;for(let O=N.length-1;O>0;O-=1){const H=Math.floor(T()*(O+1)),Z=N[O];N[O]=N[H],N[H]=Z}}function D(N,X){const T=N.indexOf(X);T>-1&&(N.splice(T,1),N.unshift(X))}function F(N,X){const T=N.indexOf(X);T>-1&&(N.splice(T,1),N.push(X))}function J(N,X){for(const T of X)N.push(T)}function V(N,X){return Array.isArray(N)?N.map(X):X(N)}function Q(N){return Array.isArray(N)?N:[N]}function re(N){return N[Math.floor(Math.random()*N.length)]}function ce(N,X,T){const O=j(N,X),H=N.length,Z=T.length;N.length=H+Z;for(let ne=H-1;ne>=O;ne--)N[ne+Z]=N[ne];for(let ne=0;ne<Z;ne++)N[ne+O]=T[ne]}function K(N,X,T,O){const H=j(N,X);let Z=N.splice(H,T);return Z===void 0&&(Z=[]),ce(N,H,O),Z}function j(N,X){return X<0?Math.max(X+N.length,0):Math.min(X,N.length)}var Y;(function(N){function X(Z){return Z<0}N.isLessThan=X;function T(Z){return Z<=0}N.isLessThanOrEqual=T;function O(Z){return Z>0}N.isGreaterThan=O;function H(Z){return Z===0}N.isNeitherLessOrGreaterThan=H,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(Y||(e.CompareResult=Y={}));function ee(N,X){return(T,O)=>X(N(T),N(O))}function le(...N){return(X,T)=>{for(const O of N){const H=O(X,T);if(!Y.isNeitherLessOrGreaterThan(H))return H}return Y.neitherLessOrGreaterThan}}const G=(N,X)=>N-X;e.$7b=G;const ae=(N,X)=>(0,e.$7b)(N?1:0,X?1:0);e.$8b=ae;function me(N){return(X,T)=>-N(X,T)}class te{constructor(X){this.g=X,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(X){let T=this.c;for(;T<this.g.length&&X(this.g[T]);)T++;const O=T===this.c?null:this.g.slice(this.c,T);return this.c=T,O}takeFromEndWhile(X){let T=this.d;for(;T>=0&&X(this.g[T]);)T--;const O=T===this.d?null:this.g.slice(T+1,this.d+1);return this.d=T,O}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const X=this.g[this.c];return this.c++,X}removeLast(){const X=this.g[this.d];return this.d--,X}takeCount(X){const T=this.g.slice(this.c,this.c+X);return this.c+=X,T}}e.$0b=te;class m{static{this.empty=new m(X=>{})}constructor(X){this.iterate=X}forEach(X){this.iterate(T=>(X(T),!0))}toArray(){const X=[];return this.iterate(T=>(X.push(T),!0)),X}filter(X){return new m(T=>this.iterate(O=>X(O)?T(O):!0))}map(X){return new m(T=>this.iterate(O=>T(X(O))))}some(X){let T=!1;return this.iterate(O=>(T=X(O),!T)),T}findFirst(X){let T;return this.iterate(O=>X(O)?(T=O,!1):!0),T}findLast(X){let T;return this.iterate(O=>(X(O)&&(T=O),!0)),T}findLastMaxBy(X){let T,O=!0;return this.iterate(H=>((O||Y.isGreaterThan(X(H,T)))&&(O=!1,T=H),!0)),T}}e.$$b=m;class W{constructor(X){this.c=X}static createSortPermutation(X,T){const O=Array.from(X.keys()).sort((H,Z)=>T(X[H],X[Z]));return new W(O)}apply(X){return X.map((T,O)=>X[this.c[O]])}inverse(){const X=this.c.slice();for(let T=0;T<this.c.length;T++)X[this.c[T]]=T;return new W(X)}}e.$_b=W;async function oe(N,X){return(await Promise.all(N.map(async(O,H)=>({element:O,ok:await X(O,H)})))).find(O=>O.ok)?.element}}),define(he[45],fe([0,1,7]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=t,e.$ed=S,e.$fd=$,e.$gd=B,e.$hd=P,e.$id=p;function t(r,L){if(!r)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}function S(r,L="Unreachable"){throw new Error(L)}function $(r,L="unexpected state"){if(!r)throw new a.$bb(`Assertion Failed: ${L}`)}function B(r){r||(0,a.$Y)(new a.$bb("Soft Assertion Failed"))}function P(r){if(!r()){debugger;r(),(0,a.$Y)(new a.$bb("Assertion Failed"))}}function p(r,L){let b=0;for(;b<r.length-1;){const d=r[b],u=r[b+1];if(!L(d,u))return!1;b++}return!0}}),define(he[31],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=a;function a(t,S){const $=this;let B=!1,P;return function(){if(B)return P;if(B=!0,S)try{P=t.apply($,arguments)}finally{S()}else P=t.apply($,arguments);return P}}}),define(he[46],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(t){function S(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}t.is=S;const $=Object.freeze([]);function B(){return $}t.empty=B;function*P(i){yield i}t.single=P;function p(i){return S(i)?i:P(i)}t.wrap=p;function r(i){return i||$}t.from=r;function*L(i){for(let g=i.length-1;g>=0;g--)yield i[g]}t.reverse=L;function b(i){return!i||i[Symbol.iterator]().next().done===!0}t.isEmpty=b;function d(i){return i[Symbol.iterator]().next().value}t.first=d;function u(i,g){let _=0;for(const C of i)if(g(C,_++))return!0;return!1}t.some=u;function c(i,g){for(const _ of i)if(g(_))return _}t.find=c;function*h(i,g){for(const _ of i)g(_)&&(yield _)}t.filter=h;function*f(i,g){let _=0;for(const C of i)yield g(C,_++)}t.map=f;function*l(i,g){let _=0;for(const C of i)yield*g(C,_++)}t.flatMap=l;function*n(...i){for(const g of i)yield*g}t.concat=n;function w(i,g,_){let C=_;for(const E of i)C=g(C,E);return C}t.reduce=w;function*v(i,g,_=i.length){for(g<0&&(g+=i.length),_<0?_+=i.length:_>i.length&&(_=i.length);g<_;g++)yield i[g]}t.slice=v;function o(i,g=Number.POSITIVE_INFINITY){const _=[];if(g===0)return[_,i];const C=i[Symbol.iterator]();for(let E=0;E<g;E++){const k=C.next();if(k.done)return[_,t.empty()];_.push(k.value)}return[_,{[Symbol.iterator](){return C}}]}t.consume=o;async function s(i){const g=[];for await(const _ of i)g.push(_);return Promise.resolve(g)}t.asyncToArray=s})(a||(e.Iterable=a={}))}),define(he[24],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class a{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=a}),define(he[47],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class a{static{this.Undefined=new a(void 0)}constructor($){this.element=$,this.next=a.Undefined,this.prev=a.Undefined}}class t{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let $=this.a;for(;$!==a.Undefined;){const B=$.next;$.prev=a.Undefined,$.next=a.Undefined,$=B}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift($){return this.d($,!1)}push($){return this.d($,!0)}d($,B){const P=new a($);if(this.a===a.Undefined)this.a=P,this.b=P;else if(B){const r=this.b;this.b=P,P.prev=r,r.next=P}else{const r=this.a;this.a=P,P.next=r,r.prev=P}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(P))}}shift(){if(this.a!==a.Undefined){const $=this.a.element;return this.e(this.a),$}}pop(){if(this.b!==a.Undefined){const $=this.b.element;return this.e(this.b),$}}e($){if($.prev!==a.Undefined&&$.next!==a.Undefined){const B=$.prev;B.next=$.next,$.next.prev=B}else $.prev===a.Undefined&&$.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):$.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):$.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let $=this.a;for(;$!==a.Undefined;)yield $.element,$=$.next}}e.$5c=t}),define(he[26],fe([0,1]),function(ie,e){"use strict";var a,t,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=$,e.$yc=B,e.$zc=P,e.$Ic=v;function $(o,s,i){let g=o.get(s);return g===void 0&&(g=i,o.set(s,g)),g}function B(o){const s=[];return o.forEach((i,g)=>{s.push(`${g} => ${i}`)}),`Map(${o.size}) {${s.join(", ")}}`}function P(o){const s=[];return o.forEach(i=>{s.push(i)}),`Set(${o.size}) {${s.join(", ")}}`}class p{constructor(s,i){this.uri=s,this.value=i}}function r(o){return Array.isArray(o)}class L{static{this.c=s=>s.toString()}constructor(s,i){if(this[a]="ResourceMap",s instanceof L)this.d=new Map(s.d),this.e=i??L.c;else if(r(s)){this.d=new Map,this.e=i??L.c;for(const[g,_]of s)this.set(g,_)}else this.d=new Map,this.e=s??L.c}set(s,i){return this.d.set(this.e(s),new p(s,i)),this}get(s){return this.d.get(this.e(s))?.value}has(s){return this.d.has(this.e(s))}get size(){return this.d.size}clear(){this.d.clear()}delete(s){return this.d.delete(this.e(s))}forEach(s,i){typeof i<"u"&&(s=s.bind(i));for(const[g,_]of this.d)s(_.value,_.uri,this)}*values(){for(const s of this.d.values())yield s.value}*keys(){for(const s of this.d.values())yield s.uri}*entries(){for(const s of this.d.values())yield[s.uri,s.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.d)yield[s.uri,s.value]}}e.$Ac=L;class b{constructor(s,i){this[t]="ResourceSet",!s||typeof s=="function"?this.c=new L(s):(this.c=new L(i),s.forEach(this.add,this))}get size(){return this.c.size}add(s){return this.c.set(s,s),this}clear(){this.c.clear()}delete(s){return this.c.delete(s)}forEach(s,i){this.c.forEach((g,_)=>s.call(i,_,_,this))}has(s){return this.c.has(s)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=b;var d;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class u{constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(s){return this.c.has(s)}get(s,i=d.None){const g=this.c.get(s);if(g)return i!==d.None&&this.m(g,i),g.value}set(s,i,g=d.None){let _=this.c.get(s);if(_)_.value=i,g!==d.None&&this.m(_,g);else{switch(_={key:s,value:i,next:void 0,previous:void 0},g){case d.None:this.k(_);break;case d.AsOld:this.j(_);break;case d.AsNew:this.k(_);break;default:this.k(_);break}this.c.set(s,_),this.f++}return this}delete(s){return!!this.remove(s)}remove(s){const i=this.c.get(s);if(i)return this.c.delete(s),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const s=this.d;return this.c.delete(s.key),this.l(s),this.f--,s.value}forEach(s,i){const g=this.g;let _=this.d;for(;_;){if(i?s.bind(i)(_.value,_.key,this):s(_.value,_.key,this),this.g!==g)throw new Error("LinkedMap got modified during iteration.");_=_.next}}keys(){const s=this,i=this.g;let g=this.d;const _={[Symbol.iterator](){return _},next(){if(s.g!==i)throw new Error("LinkedMap got modified during iteration.");if(g){const C={value:g.key,done:!1};return g=g.next,C}else return{value:void 0,done:!0}}};return _}values(){const s=this,i=this.g;let g=this.d;const _={[Symbol.iterator](){return _},next(){if(s.g!==i)throw new Error("LinkedMap got modified during iteration.");if(g){const C={value:g.value,done:!1};return g=g.next,C}else return{value:void 0,done:!0}}};return _}entries(){const s=this,i=this.g;let g=this.d;const _={[Symbol.iterator](){return _},next(){if(s.g!==i)throw new Error("LinkedMap got modified during iteration.");if(g){const C={value:[g.key,g.value],done:!1};return g=g.next,C}else return{value:void 0,done:!0}}};return _}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(s){if(s>=this.size)return;if(s===0){this.clear();return}let i=this.d,g=this.size;for(;i&&g>s;)this.c.delete(i.key),i=i.next,g--;this.d=i,this.f=g,i&&(i.previous=void 0),this.g++}i(s){if(s>=this.size)return;if(s===0){this.clear();return}let i=this.e,g=this.size;for(;i&&g>s;)this.c.delete(i.key),i=i.previous,g--;this.e=i,this.f=g,i&&(i.next=void 0),this.g++}j(s){if(!this.d&&!this.e)this.e=s;else if(this.d)s.next=this.d,this.d.previous=s;else throw new Error("Invalid list");this.d=s,this.g++}k(s){if(!this.d&&!this.e)this.d=s;else if(this.e)s.previous=this.e,this.e.next=s;else throw new Error("Invalid list");this.e=s,this.g++}l(s){if(s===this.d&&s===this.e)this.d=void 0,this.e=void 0;else if(s===this.d){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.d=s.next}else if(s===this.e){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.e=s.previous}else{const i=s.next,g=s.previous;if(!i||!g)throw new Error("Invalid list");i.previous=g,g.next=i}s.next=void 0,s.previous=void 0,this.g++}m(s,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==d.AsOld&&i!==d.AsNew)){if(i===d.AsOld){if(s===this.d)return;const g=s.next,_=s.previous;s===this.e?(_.next=void 0,this.e=_):(g.previous=_,_.next=g),s.previous=void 0,s.next=this.d,this.d.previous=s,this.d=s,this.g++}else if(i===d.AsNew){if(s===this.e)return;const g=s.next,_=s.previous;s===this.d?(g.previous=void 0,this.d=g):(g.previous=_,_.next=g),s.next=void 0,s.previous=this.e,this.e.next=s,this.e=s,this.g++}}}toJSON(){const s=[];return this.forEach((i,g)=>{s.push([g,i])}),s}fromJSON(s){this.clear();for(const[i,g]of s)this.set(i,g)}}e.$Cc=u;class c extends u{constructor(s,i=1){super(),this.n=s,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(s){this.n=s,this.p()}get ratio(){return this.o}set ratio(s){this.o=Math.min(Math.max(0,s),1),this.p()}get(s,i=d.AsNew){return super.get(s,i)}peek(s){return super.get(s,d.None)}set(s,i){return super.set(s,i,d.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class h extends c{constructor(s,i=1){super(s,i)}q(s){this.h(s)}set(s,i){return super.set(s,i),this.p(),this}}e.$Dc=h;class f extends c{constructor(s,i=1){super(s,i)}q(s){this.i(s)}set(s,i){return this.n<=this.size&&!this.has(s)&&this.q(Math.round(this.n*this.o)-1),super.set(s,i),this}}e.$Ec=f;class l{constructor(){this.c=new Map}add(s){return this.c.set(s,(this.c.get(s)||0)+1),this}delete(s){let i=this.c.get(s)||0;return i===0?!1:(i--,i===0?this.c.delete(s):this.c.set(s,i),!0)}has(s){return this.c.has(s)}}e.$Fc=l;class n{constructor(s){if(this.c=new Map,this.d=new Map,s)for(const[i,g]of s)this.set(i,g)}clear(){this.c.clear(),this.d.clear()}set(s,i){this.c.set(s,i),this.d.set(i,s)}get(s){return this.c.get(s)}getKey(s){return this.d.get(s)}delete(s){const i=this.c.get(s);return i===void 0?!1:(this.c.delete(s),this.d.delete(i),!0)}forEach(s,i){this.c.forEach((g,_)=>{s.call(i,g,_,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=n;class w{constructor(){this.c=new Map}add(s,i){let g=this.c.get(s);g||(g=new Set,this.c.set(s,g)),g.add(i)}delete(s,i){const g=this.c.get(s);g&&(g.delete(i),g.size===0&&this.c.delete(s))}forEach(s,i){const g=this.c.get(s);g&&g.forEach(i)}get(s){const i=this.c.get(s);return i||new Set}}e.$Hc=w;function v(o,s){if(o===s)return!0;if(o.size!==s.size)return!1;for(const[i,g]of o)if(!s.has(i)||s.get(i)!==g)return!1;for(const[i]of s)if(!o.has(i))return!1;return!0}}),define(he[2],fe([0,1,17,44,26,31,46]),function(ie,e,a,t,S,$,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=L,e.$Lc=b,e.$Mc=d,e.$Nc=h,e.$Oc=f,e.$Pc=l,e.$Qc=n,e.$Rc=w,e.$Sc=v,e.$3c=M;const P=!1;let p=null;class r{constructor(){this.b=new Map}static{this.a=0}c(y){let U=this.b.get(y);return U||(U={parent:null,source:null,isSingleton:!1,value:y,idx:r.a++},this.b.set(y,U)),U}trackDisposable(y){const U=this.c(y);U.source||(U.source=new Error().stack)}setParent(y,U){const A=this.c(y);A.parent=U}markAsDisposed(y){this.b.delete(y)}markAsSingleton(y){this.c(y).isSingleton=!0}f(y,U){const A=U.get(y);if(A)return A;const D=y.parent?this.f(this.c(y.parent),U):y;return U.set(y,D),D}getTrackedDisposables(){const y=new Map;return[...this.b.entries()].filter(([,A])=>A.source!==null&&!this.f(A,y).isSingleton).flatMap(([A])=>A)}computeLeakingDisposables(y=10,U){let A;if(U)A=U;else{const Q=new Map,re=[...this.b.values()].filter(K=>K.source!==null&&!this.f(K,Q).isSingleton);if(re.length===0)return;const ce=new Set(re.map(K=>K.value));if(A=re.filter(K=>!(K.parent&&ce.has(K.parent))),A.length===0)throw new Error("There are cyclic diposable chains!")}if(!A)return;function D(Q){function re(K,j){for(;K.length>0&&j.some(Y=>typeof Y=="string"?Y===K[0]:K[0].match(Y));)K.shift()}const ce=Q.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return re(ce,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ce.reverse()}const F=new S.$Hc;for(const Q of A){const re=D(Q);for(let ce=0;ce<=re.length;ce++)F.add(re.slice(0,ce).join(`
`),Q)}A.sort((0,a.$5b)(Q=>Q.idx,a.$7b));let J="",V=0;for(const Q of A.slice(0,y)){V++;const re=D(Q),ce=[];for(let K=0;K<re.length;K++){let j=re[K];j=`(shared with ${F.get(re.slice(0,K+1).join(`
`)).size}/${A.length} leaks) at ${j}`;const ee=F.get(re.slice(0,K).join(`
`)),le=(0,t.$c)([...ee].map(G=>D(G)[K]),G=>G);delete le[re[K]];for(const[G,ae]of Object.entries(le))ce.unshift(`    - stacktraces of ${ae.length} other leaks continue with ${G}`);ce.unshift(j)}J+=`


==================== Leaking disposable ${V}/${A.length}: ${Q.value.constructor.name} ====================
${ce.join(`
`)}
============================================================

`}return A.length>y&&(J+=`


... and ${A.length-y} more leaking disposables

`),{leaks:A,details:J}}}e.$Jc=r;function L(I){p=I}if(P){const I="__is_disposable_tracked__";L(new class{trackDisposable(y){const U=new Error("Potentially leaked disposable").stack;setTimeout(()=>{y[I]||console.log(U)},3e3)}setParent(y,U){if(y&&y!==s.None)try{y[I]=!0}catch{}}markAsDisposed(y){if(y&&y!==s.None)try{y[I]=!0}catch{}}markAsSingleton(y){}})}function b(I){return p?.trackDisposable(I),I}function d(I){p?.markAsDisposed(I)}function u(I,y){p?.setParent(I,y)}function c(I,y){if(p)for(const U of I)p.setParent(U,y)}function h(I){return p?.markAsSingleton(I),I}function f(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function l(I){if(B.Iterable.is(I)){const y=[];for(const U of I)if(U)try{U.dispose()}catch(A){y.push(A)}if(y.length===1)throw y[0];if(y.length>1)throw new AggregateError(y,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function n(I){for(const y of I)f(y)&&y.dispose();return[]}function w(...I){const y=v(()=>l(I));return c(I,y),y}function v(I){const y=b({dispose:(0,$.$cb)(()=>{d(y),I()})});return y}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(y){if(!y)return y;if(y===this)throw new Error("Cannot register a disposable on itself!");return u(y,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(y),y}delete(y){if(y){if(y===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(y),y.dispose()}}deleteAndLeak(y){y&&this.f.has(y)&&(this.f.delete(y),u(y,null))}}e.$Tc=o;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,b(this),u(this.q,this)}dispose(){d(this),this.q.dispose()}B(y){if(y===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(y)}}e.$Uc=s;class i{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(y){this.b||y===this.a||(this.a?.dispose(),y&&u(y,this),this.a=y)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const y=this.a;return this.a=void 0,y&&u(y,null),y}}e.$Vc=i;class g{constructor(y){this.a=new i,this.b=!1,this.a.value=y}get value(){return this.a.value}set value(y){this.b||y===this.a.value||(this.a.value=y)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=g;class _{constructor(y){this.b=y,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=_;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(y){let U=y;return this.unset=()=>U=void 0,this.isset=()=>U!==void 0,this.dispose=()=>{U&&(U(),U=void 0,d(this))},this}}e.$Yc=C;class E{constructor(){this.a=new Map}acquire(y,...U){let A=this.a.get(y);A||(A={counter:0,object:this.b(y,...U)},this.a.set(y,A));const{object:D}=A,F=(0,$.$cb)(()=>{--A.counter===0&&(this.c(y,A.object),this.a.delete(y))});return A.counter++,{object:D,dispose:F}}}e.$Zc=E;class k{constructor(y){this.a=y}async acquire(y,...U){const A=this.a.acquire(y,...U);try{return{object:await A.object,dispose:()=>A.dispose()}}catch(D){throw A.dispose(),D}}}e.$1c=k;class R{constructor(y){this.object=y}dispose(){}}e.$2c=R;function M(I){const y=new o;try{I(y)}finally{y.dispose()}}class q{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(y){return this.a.has(y)}get size(){return this.a.size}get(y){return this.a.get(y)}set(y,U,A=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),A||this.a.get(y)?.dispose(),this.a.set(y,U)}deleteAndDispose(y){this.a.get(y)?.dispose(),this.a.delete(y)}deleteAndLeak(y){const U=this.a.get(y);return this.a.delete(y),U}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=q}),define(he[27],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var a;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(a||(e.MarshalledId=a={}))}),define(he[48],fe([0,1,26]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=S,e.$om=B;const t=new a.$Dc(1e4);function S(r){return p(r,"NFC",t)}const $=new a.$Dc(1e4);function B(r){return p(r,"NFD",$)}const P=/[^\u0000-\u0080]/;function p(r,L,b){if(!r)return r;const d=b.get(r);if(d)return d;let u;return P.test(r)?u=r.normalize(L):u=r,b.set(r,u),u}e.$pm=function(){const r=/[\u0300-\u036f]/g;return function(L){return B(L).replace(r,"")}}()}),function(){function ie(S){const $=[];typeof S=="number"&&$.push("code/timeOrigin",S);function B(p){$.push(p,Date.now())}function P(){const p=[];for(let r=0;r<$.length;r+=2)p.push({name:$[r],startTime:$[r+1]});return p}return{mark:B,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const $=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const B of performance.getEntriesByType("mark"))$.push({name:B.name,startTime:Math.round(S+B.startTime)});return $}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function a(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=a(t))}(),define(he[3],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=s,e.$E=k,e.$K=R,e.$h="en";let a=!1,t=!1,S=!1,$=!1,B=!1,P=!1,p=!1,r=!1,L=!1,b=!1,d,u=e.$h,c=e.$h,h,f;const l=globalThis;let n;typeof l.vscode<"u"&&typeof l.vscode.process<"u"?n=l.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const w=typeof n?.versions?.electron=="string",v=w&&n?.type==="renderer";if(typeof n=="object"){a=n.platform==="win32",t=n.platform==="darwin",S=n.platform==="linux",$=S&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,p=w,L=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$h,u=e.$h;const M=n.env.VSCODE_NLS_CONFIG;if(M)try{const q=JSON.parse(M);d=q.userLocale,c=q.osLocale,u=q.resolvedLanguage||e.$h,h=q.languagePack?.translationsConfigFile}catch{}B=!0}else typeof navigator=="object"&&!v?(f=navigator.userAgent,a=f.indexOf("Windows")>=0,t=f.indexOf("Macintosh")>=0,r=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=f.indexOf("Linux")>=0,b=f?.indexOf("Mobi")>=0,P=!0,u=globalThis._VSCODE_NLS_LANGUAGE||e.$h,d=navigator.language.toLowerCase(),c=d):console.error("Unable to resolve platform.");var o;(function(M){M[M.Web=0]="Web",M[M.Mac=1]="Mac",M[M.Linux=2]="Linux",M[M.Windows=3]="Windows"})(o||(e.Platform=o={}));function s(M){switch(M){case o.Web:return"Web";case o.Mac:return"Mac";case o.Linux:return"Linux";case o.Windows:return"Windows"}}let i=o.Web;t?i=o.Mac:a?i=o.Windows:S&&(i=o.Linux),e.$j=a,e.$k=t,e.$l=S,e.$m=$,e.$n=B,e.$o=p,e.$p=P,e.$q=P&&typeof l.importScripts=="function",e.$r=e.$q?l.origin:void 0,e.$s=r,e.$t=b,e.$u=L,e.$v=i,e.$w=f,e.$x=u;var g;(function(M){function q(){return e.$x}M.value=q;function I(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}M.isDefaultVariant=I;function y(){return e.$x==="en"}M.isDefault=y})(g||(e.Language=g={})),e.$y=d,e.$z=c,e.$A=h,e.$B=typeof l.postMessage=="function"&&!l.importScripts,e.$C=(()=>{if(e.$B){const M=[];l.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let y=0,U=M.length;y<U;y++){const A=M[y];if(A.id===I.data.vscodeScheduleAsyncWork){M.splice(y,1),A.callback();return}}});let q=0;return I=>{const y=++q;M.push({id:y,callback:I}),l.postMessage({vscodeScheduleAsyncWork:y},"*")}}return M=>setTimeout(M)})();var _;(function(M){M[M.Windows=1]="Windows",M[M.Macintosh=2]="Macintosh",M[M.Linux=3]="Linux"})(_||(e.OperatingSystem=_={})),e.OS=t||r?_.Macintosh:a?_.Windows:_.Linux;let C=!0,E=!1;function k(){if(!E){E=!0;const M=new Uint8Array(2);M[0]=1,M[1]=2,C=new Uint16Array(M.buffer)[0]===513}return C}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function R(M){return parseFloat(M)>=20}}),define(he[15],fe([0,1,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let t;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const $=S.process;t={get platform(){return $.platform},get arch(){return $.arch},get env(){return $.env},cwd(){return $.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return a.$j?"win32":a.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$dc=t.platform,e.$ec=t.arch});var Je=this&&this.__createBinding||(Object.create?function(ie,e,a,t){t===void 0&&(t=a);var S=Object.getOwnPropertyDescriptor(e,a);(!S||("get"in S?!e.__esModule:S.writable||S.configurable))&&(S={enumerable:!0,get:function(){return e[a]}}),Object.defineProperty(ie,t,S)}:function(ie,e,a,t){t===void 0&&(t=a),ie[t]=e[a]}),Qe=this&&this.__setModuleDefault||(Object.create?function(ie,e){Object.defineProperty(ie,"default",{enumerable:!0,value:e})}:function(ie,e){ie.default=e}),Se=this&&this.__importStar||function(ie){if(ie&&ie.__esModule)return ie;var e={};if(ie!=null)for(var a in ie)a!=="default"&&Object.prototype.hasOwnProperty.call(ie,a)&&Je(e,ie,a);return Qe(e,ie),e};define(he[5],fe([0,1,15]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0,a=Se(a);const t=65,S=97,$=90,B=122,P=46,p=47,r=92,L=58,b=63;class d extends Error{constructor(g,_,C){let E;typeof _=="string"&&_.indexOf("not ")===0?(E="must not be",_=_.replace(/^not /,"")):E="must be";const k=g.indexOf(".")!==-1?"property":"argument";let R=`The "${g}" ${k} ${E} of type ${_}`;R+=`. Received type ${typeof C}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function u(i,g){if(i===null||typeof i!="object")throw new d(g,"Object",i)}function c(i,g){if(typeof i!="string")throw new d(g,"string",i)}const h=a.$dc==="win32";function f(i){return i===p||i===r}function l(i){return i===p}function n(i){return i>=t&&i<=$||i>=S&&i<=B}function w(i,g,_,C){let E="",k=0,R=-1,M=0,q=0;for(let I=0;I<=i.length;++I){if(I<i.length)q=i.charCodeAt(I);else{if(C(q))break;q=p}if(C(q)){if(!(R===I-1||M===1))if(M===2){if(E.length<2||k!==2||E.charCodeAt(E.length-1)!==P||E.charCodeAt(E.length-2)!==P){if(E.length>2){const y=E.lastIndexOf(_);y===-1?(E="",k=0):(E=E.slice(0,y),k=E.length-1-E.lastIndexOf(_)),R=I,M=0;continue}else if(E.length!==0){E="",k=0,R=I,M=0;continue}}g&&(E+=E.length>0?`${_}..`:"..",k=2)}else E.length>0?E+=`${_}${i.slice(R+1,I)}`:E=i.slice(R+1,I),k=I-R-1;R=I,M=0}else q===P&&M!==-1?++M:M=-1}return E}function v(i){return i?`${i[0]==="."?"":"."}${i}`:""}function o(i,g){u(g,"pathObject");const _=g.dir||g.root,C=g.base||`${g.name||""}${v(g.ext)}`;return _?_===g.root?`${_}${C}`:`${_}${i}${C}`:C}e.$fc={resolve(...i){let g="",_="",C=!1;for(let E=i.length-1;E>=-1;E--){let k;if(E>=0){if(k=i[E],c(k,`paths[${E}]`),k.length===0)continue}else g.length===0?k=a.cwd():(k=a.env[`=${g}`]||a.cwd(),(k===void 0||k.slice(0,2).toLowerCase()!==g.toLowerCase()&&k.charCodeAt(2)===r)&&(k=`${g}\\`));const R=k.length;let M=0,q="",I=!1;const y=k.charCodeAt(0);if(R===1)f(y)&&(M=1,I=!0);else if(f(y))if(I=!0,f(k.charCodeAt(1))){let U=2,A=U;for(;U<R&&!f(k.charCodeAt(U));)U++;if(U<R&&U!==A){const D=k.slice(A,U);for(A=U;U<R&&f(k.charCodeAt(U));)U++;if(U<R&&U!==A){for(A=U;U<R&&!f(k.charCodeAt(U));)U++;(U===R||U!==A)&&(q=`\\\\${D}\\${k.slice(A,U)}`,M=U)}}}else M=1;else n(y)&&k.charCodeAt(1)===L&&(q=k.slice(0,2),M=2,R>2&&f(k.charCodeAt(2))&&(I=!0,M=3));if(q.length>0)if(g.length>0){if(q.toLowerCase()!==g.toLowerCase())continue}else g=q;if(C){if(g.length>0)break}else if(_=`${k.slice(M)}\\${_}`,C=I,I&&g.length>0)break}return _=w(_,!C,"\\",f),C?`${g}\\${_}`:`${g}${_}`||"."},normalize(i){c(i,"path");const g=i.length;if(g===0)return".";let _=0,C,E=!1;const k=i.charCodeAt(0);if(g===1)return l(k)?"\\":i;if(f(k))if(E=!0,f(i.charCodeAt(1))){let M=2,q=M;for(;M<g&&!f(i.charCodeAt(M));)M++;if(M<g&&M!==q){const I=i.slice(q,M);for(q=M;M<g&&f(i.charCodeAt(M));)M++;if(M<g&&M!==q){for(q=M;M<g&&!f(i.charCodeAt(M));)M++;if(M===g)return`\\\\${I}\\${i.slice(q)}\\`;M!==q&&(C=`\\\\${I}\\${i.slice(q,M)}`,_=M)}}}else _=1;else n(k)&&i.charCodeAt(1)===L&&(C=i.slice(0,2),_=2,g>2&&f(i.charCodeAt(2))&&(E=!0,_=3));let R=_<g?w(i.slice(_),!E,"\\",f):"";return R.length===0&&!E&&(R="."),R.length>0&&f(i.charCodeAt(g-1))&&(R+="\\"),C===void 0?E?`\\${R}`:R:E?`${C}\\${R}`:`${C}${R}`},isAbsolute(i){c(i,"path");const g=i.length;if(g===0)return!1;const _=i.charCodeAt(0);return f(_)||g>2&&n(_)&&i.charCodeAt(1)===L&&f(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let g,_;for(let k=0;k<i.length;++k){const R=i[k];c(R,"path"),R.length>0&&(g===void 0?g=_=R:g+=`\\${R}`)}if(g===void 0)return".";let C=!0,E=0;if(typeof _=="string"&&f(_.charCodeAt(0))){++E;const k=_.length;k>1&&f(_.charCodeAt(1))&&(++E,k>2&&(f(_.charCodeAt(2))?++E:C=!1))}if(C){for(;E<g.length&&f(g.charCodeAt(E));)E++;E>=2&&(g=`\\${g.slice(E)}`)}return e.$fc.normalize(g)},relative(i,g){if(c(i,"from"),c(g,"to"),i===g)return"";const _=e.$fc.resolve(i),C=e.$fc.resolve(g);if(_===C||(i=_.toLowerCase(),g=C.toLowerCase(),i===g))return"";let E=0;for(;E<i.length&&i.charCodeAt(E)===r;)E++;let k=i.length;for(;k-1>E&&i.charCodeAt(k-1)===r;)k--;const R=k-E;let M=0;for(;M<g.length&&g.charCodeAt(M)===r;)M++;let q=g.length;for(;q-1>M&&g.charCodeAt(q-1)===r;)q--;const I=q-M,y=R<I?R:I;let U=-1,A=0;for(;A<y;A++){const F=i.charCodeAt(E+A);if(F!==g.charCodeAt(M+A))break;F===r&&(U=A)}if(A!==y){if(U===-1)return C}else{if(I>y){if(g.charCodeAt(M+A)===r)return C.slice(M+A+1);if(A===2)return C.slice(M+A)}R>y&&(i.charCodeAt(E+A)===r?U=A:A===2&&(U=3)),U===-1&&(U=0)}let D="";for(A=E+U+1;A<=k;++A)(A===k||i.charCodeAt(A)===r)&&(D+=D.length===0?"..":"\\..");return M+=U,D.length>0?`${D}${C.slice(M,q)}`:(C.charCodeAt(M)===r&&++M,C.slice(M,q))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const g=e.$fc.resolve(i);if(g.length<=2)return i;if(g.charCodeAt(0)===r){if(g.charCodeAt(1)===r){const _=g.charCodeAt(2);if(_!==b&&_!==P)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(n(g.charCodeAt(0))&&g.charCodeAt(1)===L&&g.charCodeAt(2)===r)return`\\\\?\\${g}`;return i},dirname(i){c(i,"path");const g=i.length;if(g===0)return".";let _=-1,C=0;const E=i.charCodeAt(0);if(g===1)return f(E)?i:".";if(f(E)){if(_=C=1,f(i.charCodeAt(1))){let M=2,q=M;for(;M<g&&!f(i.charCodeAt(M));)M++;if(M<g&&M!==q){for(q=M;M<g&&f(i.charCodeAt(M));)M++;if(M<g&&M!==q){for(q=M;M<g&&!f(i.charCodeAt(M));)M++;if(M===g)return i;M!==q&&(_=C=M+1)}}}}else n(E)&&i.charCodeAt(1)===L&&(_=g>2&&f(i.charCodeAt(2))?3:2,C=_);let k=-1,R=!0;for(let M=g-1;M>=C;--M)if(f(i.charCodeAt(M))){if(!R){k=M;break}}else R=!1;if(k===-1){if(_===-1)return".";k=_}return i.slice(0,k)},basename(i,g){g!==void 0&&c(g,"suffix"),c(i,"path");let _=0,C=-1,E=!0,k;if(i.length>=2&&n(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(_=2),g!==void 0&&g.length>0&&g.length<=i.length){if(g===i)return"";let R=g.length-1,M=-1;for(k=i.length-1;k>=_;--k){const q=i.charCodeAt(k);if(f(q)){if(!E){_=k+1;break}}else M===-1&&(E=!1,M=k+1),R>=0&&(q===g.charCodeAt(R)?--R===-1&&(C=k):(R=-1,C=M))}return _===C?C=M:C===-1&&(C=i.length),i.slice(_,C)}for(k=i.length-1;k>=_;--k)if(f(i.charCodeAt(k))){if(!E){_=k+1;break}}else C===-1&&(E=!1,C=k+1);return C===-1?"":i.slice(_,C)},extname(i){c(i,"path");let g=0,_=-1,C=0,E=-1,k=!0,R=0;i.length>=2&&i.charCodeAt(1)===L&&n(i.charCodeAt(0))&&(g=C=2);for(let M=i.length-1;M>=g;--M){const q=i.charCodeAt(M);if(f(q)){if(!k){C=M+1;break}continue}E===-1&&(k=!1,E=M+1),q===P?_===-1?_=M:R!==1&&(R=1):_!==-1&&(R=-1)}return _===-1||E===-1||R===0||R===1&&_===E-1&&_===C+1?"":i.slice(_,E)},format:o.bind(null,"\\"),parse(i){c(i,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return g;const _=i.length;let C=0,E=i.charCodeAt(0);if(_===1)return f(E)?(g.root=g.dir=i,g):(g.base=g.name=i,g);if(f(E)){if(C=1,f(i.charCodeAt(1))){let U=2,A=U;for(;U<_&&!f(i.charCodeAt(U));)U++;if(U<_&&U!==A){for(A=U;U<_&&f(i.charCodeAt(U));)U++;if(U<_&&U!==A){for(A=U;U<_&&!f(i.charCodeAt(U));)U++;U===_?C=U:U!==A&&(C=U+1)}}}}else if(n(E)&&i.charCodeAt(1)===L){if(_<=2)return g.root=g.dir=i,g;if(C=2,f(i.charCodeAt(2))){if(_===3)return g.root=g.dir=i,g;C=3}}C>0&&(g.root=i.slice(0,C));let k=-1,R=C,M=-1,q=!0,I=i.length-1,y=0;for(;I>=C;--I){if(E=i.charCodeAt(I),f(E)){if(!q){R=I+1;break}continue}M===-1&&(q=!1,M=I+1),E===P?k===-1?k=I:y!==1&&(y=1):k!==-1&&(y=-1)}return M!==-1&&(k===-1||y===0||y===1&&k===M-1&&k===R+1?g.base=g.name=i.slice(R,M):(g.name=i.slice(R,k),g.base=i.slice(R,M),g.ext=i.slice(k,M))),R>0&&R!==C?g.dir=i.slice(0,R-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(h){const i=/\\/g;return()=>{const g=a.cwd().replace(i,"/");return g.slice(g.indexOf("/"))}}return()=>a.cwd()})();e.$gc={resolve(...i){let g="",_=!1;for(let C=i.length-1;C>=-1&&!_;C--){const E=C>=0?i[C]:s();c(E,`paths[${C}]`),E.length!==0&&(g=`${E}/${g}`,_=E.charCodeAt(0)===p)}return g=w(g,!_,"/",l),_?`/${g}`:g.length>0?g:"."},normalize(i){if(c(i,"path"),i.length===0)return".";const g=i.charCodeAt(0)===p,_=i.charCodeAt(i.length-1)===p;return i=w(i,!g,"/",l),i.length===0?g?"/":_?"./":".":(_&&(i+="/"),g?`/${i}`:i)},isAbsolute(i){return c(i,"path"),i.length>0&&i.charCodeAt(0)===p},join(...i){if(i.length===0)return".";let g;for(let _=0;_<i.length;++_){const C=i[_];c(C,"path"),C.length>0&&(g===void 0?g=C:g+=`/${C}`)}return g===void 0?".":e.$gc.normalize(g)},relative(i,g){if(c(i,"from"),c(g,"to"),i===g||(i=e.$gc.resolve(i),g=e.$gc.resolve(g),i===g))return"";const _=1,C=i.length,E=C-_,k=1,R=g.length-k,M=E<R?E:R;let q=-1,I=0;for(;I<M;I++){const U=i.charCodeAt(_+I);if(U!==g.charCodeAt(k+I))break;U===p&&(q=I)}if(I===M)if(R>M){if(g.charCodeAt(k+I)===p)return g.slice(k+I+1);if(I===0)return g.slice(k+I)}else E>M&&(i.charCodeAt(_+I)===p?q=I:I===0&&(q=0));let y="";for(I=_+q+1;I<=C;++I)(I===C||i.charCodeAt(I)===p)&&(y+=y.length===0?"..":"/..");return`${y}${g.slice(k+q)}`},toNamespacedPath(i){return i},dirname(i){if(c(i,"path"),i.length===0)return".";const g=i.charCodeAt(0)===p;let _=-1,C=!0;for(let E=i.length-1;E>=1;--E)if(i.charCodeAt(E)===p){if(!C){_=E;break}}else C=!1;return _===-1?g?"/":".":g&&_===1?"//":i.slice(0,_)},basename(i,g){g!==void 0&&c(g,"ext"),c(i,"path");let _=0,C=-1,E=!0,k;if(g!==void 0&&g.length>0&&g.length<=i.length){if(g===i)return"";let R=g.length-1,M=-1;for(k=i.length-1;k>=0;--k){const q=i.charCodeAt(k);if(q===p){if(!E){_=k+1;break}}else M===-1&&(E=!1,M=k+1),R>=0&&(q===g.charCodeAt(R)?--R===-1&&(C=k):(R=-1,C=M))}return _===C?C=M:C===-1&&(C=i.length),i.slice(_,C)}for(k=i.length-1;k>=0;--k)if(i.charCodeAt(k)===p){if(!E){_=k+1;break}}else C===-1&&(E=!1,C=k+1);return C===-1?"":i.slice(_,C)},extname(i){c(i,"path");let g=-1,_=0,C=-1,E=!0,k=0;for(let R=i.length-1;R>=0;--R){const M=i.charCodeAt(R);if(M===p){if(!E){_=R+1;break}continue}C===-1&&(E=!1,C=R+1),M===P?g===-1?g=R:k!==1&&(k=1):g!==-1&&(k=-1)}return g===-1||C===-1||k===0||k===1&&g===C-1&&g===_+1?"":i.slice(g,C)},format:o.bind(null,"/"),parse(i){c(i,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return g;const _=i.charCodeAt(0)===p;let C;_?(g.root="/",C=1):C=0;let E=-1,k=0,R=-1,M=!0,q=i.length-1,I=0;for(;q>=C;--q){const y=i.charCodeAt(q);if(y===p){if(!M){k=q+1;break}continue}R===-1&&(M=!1,R=q+1),y===P?E===-1?E=q:I!==1&&(I=1):E!==-1&&(I=-1)}if(R!==-1){const y=k===0&&_?1:k;E===-1||I===0||I===1&&E===R-1&&E===k+1?g.base=g.name=i.slice(y,R):(g.name=i.slice(y,E),g.base=i.slice(y,R),g.ext=i.slice(E,R))}return k>0?g.dir=i.slice(0,k-1):_&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=h?e.$fc.normalize:e.$gc.normalize,e.$ic=h?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=h?e.$fc.join:e.$gc.join,e.$kc=h?e.$fc.resolve:e.$gc.resolve,e.$lc=h?e.$fc.relative:e.$gc.relative,e.$mc=h?e.$fc.dirname:e.$gc.dirname,e.$nc=h?e.$fc.basename:e.$gc.basename,e.$oc=h?e.$fc.extname:e.$gc.extname,e.$pc=h?e.$fc.format:e.$gc.format,e.$qc=h?e.$fc.parse:e.$gc.parse,e.$rc=h?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=h?e.$fc.sep:e.$gc.sep,e.$tc=h?e.$fc.delimiter:e.$gc.delimiter}),define(he[32],fe([0,1,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=$,e.$mm=B;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t||(e.Source=t={}));var S;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function $(P,...p){const r=p.reduce((d,u)=>(d[u]=!0,d),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(d=>!r[d]).forEach(d=>{for(let u=0;u<L.length;u++)if(d.search(L[u])!==-1){delete P[d];break}})}function B(P){P&&(delete P.DEBUG,a.$l&&delete P.LD_PRELOAD)}}),define(he[49],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const a=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create($){return new t($)}constructor($){this.c=a&&$===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=t}),define(he[4],fe([0,1,7,31,2,47,49]),function(ie,e,a,t,S,$,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=u;const P=!1,p=!1,r=!1;var L;(function(D){D.None=()=>S.$Uc.None;function F(ge){if(r){const{onDidAddListener:de}=ge,we=h.create();let $e=0;ge.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),we.print()),de?.()}}}function J(ge,de){return G(ge,()=>{},0,void 0,!0,void 0,de)}D.defer=J;function V(ge){return(de,we=null,$e)=>{let ve=!1,ke;return ke=ge(De=>{if(!ve)return ke?ke.dispose():ve=!0,de.call(we,De)},null,$e),ve&&ke.dispose(),ke}}D.once=V;function Q(ge,de,we){return ee(($e,ve=null,ke)=>ge(De=>$e.call(ve,de(De)),null,ke),we)}D.map=Q;function re(ge,de,we){return ee(($e,ve=null,ke)=>ge(De=>{de(De),$e.call(ve,De)},null,ke),we)}D.forEach=re;function ce(ge,de,we){return ee(($e,ve=null,ke)=>ge(De=>de(De)&&$e.call(ve,De),null,ke),we)}D.filter=ce;function K(ge){return ge}D.signal=K;function j(...ge){return(de,we=null,$e)=>{const ve=(0,S.$Rc)(...ge.map(ke=>ke(De=>de.call(we,De))));return le(ve,$e)}}D.any=j;function Y(ge,de,we,$e){let ve=we;return Q(ge,ke=>(ve=de(ve,ke),ve),$e)}D.reduce=Y;function ee(ge,de){let we;const $e={onWillAddFirstListener(){we=ge(ve.fire,ve)},onDidRemoveLastListener(){we?.dispose()}};de||F($e);const ve=new i($e);return de?.add(ve),ve.event}function le(ge,de){return de instanceof Array?de.push(ge):de&&de.add(ge),ge}function G(ge,de,we=100,$e=!1,ve=!1,ke,De){let _e,Ie,Ce,Le=0,Me;const He={leakWarningThreshold:ke,onWillAddFirstListener(){_e=ge(Xe=>{Le++,Ie=de(Ie,Xe),$e&&!Ce&&(ze.fire(Ie),Ie=void 0),Me=()=>{const xe=Ie;Ie=void 0,Ce=void 0,(!$e||Le>1)&&ze.fire(xe),Le=0},typeof we=="number"?(clearTimeout(Ce),Ce=setTimeout(Me,we)):Ce===void 0&&(Ce=0,queueMicrotask(Me))})},onWillRemoveListener(){ve&&Le>0&&Me?.()},onDidRemoveLastListener(){Me=void 0,_e.dispose()}};De||F(He);const ze=new i(He);return De?.add(ze),ze.event}D.debounce=G;function ae(ge,de=0,we){return D.debounce(ge,($e,ve)=>$e?($e.push(ve),$e):[ve],de,void 0,!0,void 0,we)}D.accumulate=ae;function me(ge,de=($e,ve)=>$e===ve,we){let $e=!0,ve;return ce(ge,ke=>{const De=$e||!de(ke,ve);return $e=!1,ve=ke,De},we)}D.latch=me;function te(ge,de,we){return[D.filter(ge,de,we),D.filter(ge,$e=>!de($e),we)]}D.split=te;function m(ge,de=!1,we=[],$e){let ve=we.slice(),ke=ge(Ie=>{ve?ve.push(Ie):_e.fire(Ie)});$e&&$e.add(ke);const De=()=>{ve?.forEach(Ie=>_e.fire(Ie)),ve=null},_e=new i({onWillAddFirstListener(){ke||(ke=ge(Ie=>_e.fire(Ie)),$e&&$e.add(ke))},onDidAddFirstListener(){ve&&(de?setTimeout(De):De())},onDidRemoveLastListener(){ke&&ke.dispose(),ke=null}});return $e&&$e.add(_e),_e.event}D.buffer=m;function W(ge,de){return($e,ve,ke)=>{const De=de(new N);return ge(function(_e){const Ie=De.evaluate(_e);Ie!==oe&&$e.call(ve,Ie)},void 0,ke)}}D.chain=W;const oe=Symbol("HaltChainable");class N{constructor(){this.f=[]}map(de){return this.f.push(de),this}forEach(de){return this.f.push(we=>(de(we),we)),this}filter(de){return this.f.push(we=>de(we)?we:oe),this}reduce(de,we){let $e=we;return this.f.push(ve=>($e=de($e,ve),$e)),this}latch(de=(we,$e)=>we===$e){let we=!0,$e;return this.f.push(ve=>{const ke=we||!de(ve,$e);return we=!1,$e=ve,ke?ve:oe}),this}evaluate(de){for(const we of this.f)if(de=we(de),de===oe)break;return de}}function X(ge,de,we=$e=>$e){const $e=(..._e)=>De.fire(we(..._e)),ve=()=>ge.on(de,$e),ke=()=>ge.removeListener(de,$e),De=new i({onWillAddFirstListener:ve,onDidRemoveLastListener:ke});return De.event}D.fromNodeEventEmitter=X;function T(ge,de,we=$e=>$e){const $e=(..._e)=>De.fire(we(..._e)),ve=()=>ge.addEventListener(de,$e),ke=()=>ge.removeEventListener(de,$e),De=new i({onWillAddFirstListener:ve,onDidRemoveLastListener:ke});return De.event}D.fromDOMEventEmitter=T;function O(ge){return new Promise(de=>V(ge)(de))}D.toPromise=O;function H(ge){const de=new i;return ge.then(we=>{de.fire(we)},()=>{de.fire(void 0)}).finally(()=>{de.dispose()}),de.event}D.fromPromise=H;function Z(ge,de){return ge(we=>de.fire(we))}D.forward=Z;function ne(ge,de,we){return de(we),ge($e=>de($e))}D.runAndSubscribe=ne;class be{constructor(de,we){this._observable=de,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{de.addObserver(this)},onDidRemoveLastListener:()=>{de.removeObserver(this)}};we||F($e),this.emitter=new i($e),we&&we.add(this.emitter)}beginUpdate(de){this.f++}handlePossibleChange(de){}handleChange(de,we){this.g=!0}endUpdate(de){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(ge,de){return new be(ge,de).emitter.event}D.fromObservable=Ee;function Ae(ge){return(de,we,$e)=>{let ve=0,ke=!1;const De={beginUpdate(){ve++},endUpdate(){ve--,ve===0&&(ge.reportChanges(),ke&&(ke=!1,de.call(we)))},handlePossibleChange(){},handleChange(){ke=!0}};ge.addObserver(De),ge.reportChanges();const _e={dispose(){ge.removeObserver(De)}};return $e instanceof S.$Tc?$e.add(_e):Array.isArray($e)&&$e.push(_e),_e}}D.fromObservableLight=Ae})(L||(e.Event=L={}));class b{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${b.f++}`,b.all.add(this)}start(F){this.g=new B.$fe,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$he=b;let d=-1;function u(D){const F=d;return d=D,{dispose(){d=F}}}class c{static{this.f=1}constructor(F,J,V=(c.f++).toString(16).padStart(3,"0")){this.j=F,this.threshold=J,this.name=V,this.h=0}dispose(){this.g?.clear()}check(F,J){const V=this.threshold;if(V<=0||J<V)return;this.g||(this.g=new Map);const Q=this.g.get(F.value)||0;if(this.g.set(F.value,Q+1),this.h-=1,this.h<=0){this.h=V*.5;const[re,ce]=this.getMostFrequentStack(),K=`[${this.name}] potential listener LEAK detected, having ${J} listeners already. MOST frequent listener (${ce}):`;console.warn(K),console.warn(re);const j=new f(K,re);this.j(j)}return()=>{const re=this.g.get(F.value)||0;this.g.set(F.value,re-1)}}getMostFrequentStack(){if(!this.g)return;let F,J=0;for(const[V,Q]of this.g)(!F||J<Q)&&(F=[V,Q],J=Q);return F}}class h{static create(){const F=new Error;return new h(F.stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f extends Error{constructor(F,J){super(F),this.name="ListenerLeakError",this.stack=J}}e.$je=f;class l extends Error{constructor(F,J){super(F),this.name="ListenerRefusalError",this.stack=J}}e.$ke=l;let n=0;class w{constructor(F){this.value=F,this.id=n++}}const v=2,o=(D,F)=>{if(D instanceof w)F(D);else for(let J=0;J<D.length;J++){const V=D[J];V&&F(V)}};let s;if(P){const D=[];setInterval(()=>{D.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(D.join(`
`)),D.length=0)},3e3),s=new FinalizationRegistry(F=>{typeof F=="string"&&D.push(F)})}class i{constructor(F){this.z=0,this.f=F,this.g=d>0||this.f?.leakWarningThreshold?new c(F?.onListenerError??a.$Y,this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(p){const F=this.u;queueMicrotask(()=>{o(F,J=>J.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,J,V)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const Y=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new l(`${j}. HINT: Stack shows most frequent listener (${Y[1]}-times)`,Y[0]);return(this.f?.onListenerError||a.$Y)(ee),S.$Uc.None}if(this.m)return S.$Uc.None;J&&(F=F.bind(J));const Q=new w(F);let re,ce;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(Q.stack=h.create(),re=this.g.check(Q.stack,this.z+1)),p&&(Q.stack=ce??h.create()),this.u?this.u instanceof w?(this.w??=new _,this.u=[this.u,Q]):this.u.push(Q):(this.f?.onWillAddFirstListener?.(this),this.u=Q,this.f?.onDidAddFirstListener?.(this)),this.z++;const K=(0,S.$Sc)(()=>{s?.unregister(K),re?.(),this.A(Q)});if(V instanceof S.$Tc?V.add(K):Array.isArray(V)&&V.push(K),s){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Y=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);s.register(K,Y?.[2]??j,K)}return K},this.q}A(F){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const J=this.u,V=J.indexOf(F);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,J[V]=void 0;const Q=this.w.current===this;if(this.z*v<=J.length){let re=0;for(let ce=0;ce<J.length;ce++)J[ce]?J[re++]=J[ce]:Q&&(this.w.end--,re<this.w.i&&this.w.i--);J.length=re}}B(F,J){if(!F)return;const V=this.f?.onListenerError||a.$Y;if(!V){F.value(J);return}try{F.value(J)}catch(Q){V(Q)}}C(F){const J=F.current.u;for(;F.i<F.end;)this.B(J[F.i++],F.value);F.reset()}fire(F){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof w)this.B(this.u,F);else{const J=this.w;J.enqueue(this,F,this.u.length),this.C(J)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=i;const g=()=>new _;e.$me=g;class _{constructor(){this.i=-1,this.end=0}enqueue(F,J,V){this.i=0,this.end=V,this.current=F,this.value=J}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class C extends i{async fireAsync(F,J,V){if(this.u)for(this.h||(this.h=new $.$5c),o(this.u,Q=>this.h.push([Q.value,F]));this.h.size>0&&!J.isCancellationRequested;){const[Q,re]=this.h.shift(),ce=[],K={...re,token:J,waitUntil:j=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");V&&(j=V(j,Q)),ce.push(j)}};try{Q(K)}catch(j){(0,a.$Y)(j);continue}Object.freeze(ce),await Promise.allSettled(ce).then(j=>{for(const Y of j)Y.status==="rejected"&&(0,a.$Y)(Y.reason)})}}}e.$ne=C;class E extends i{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new $.$5c,this.t=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.t(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.z&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$oe=E;class k extends E{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$pe=k;class R extends i{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(J=>super.fire(J)),this.h=[]}))}}e.$qe=R;class M{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const J={event:F,listener:null};this.h.push(J),this.g&&this.m(J);const V=()=>{this.g&&this.o(J);const Q=this.h.indexOf(J);this.h.splice(Q,1)};return(0,S.$Sc)((0,t.$cb)(V))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(J=>this.f.fire(J))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$re=M;class q{constructor(F,J,V,Q){this.f=new S.$Tc;const re=this.f.add(new M),ce=this.f.add(new S.$4c);function K(j){ce.set(j,re.add(Q(j)))}for(const j of F)K(j);this.f.add(J(j=>{K(j)})),this.f.add(V(j=>{ce.deleteAndDispose(j)})),this.event=re.event}dispose(){this.f.dispose()}}e.$se=q;class I{constructor(){this.f=[]}wrapEvent(F,J,V){return(Q,re,ce)=>F(K=>{const j=this.f[this.f.length-1];if(!J){j?j.buffers.push(()=>Q.call(re,K)):Q.call(re,K);return}const Y=j;if(!Y){Q.call(re,J(V,K));return}Y.items??=[],Y.items.push(K),Y.buffers.length===0&&j.buffers.push(()=>{Y.reducedResult??=V?Y.items.reduce(J,V):Y.items.reduce(J),Q.call(re,Y.reducedResult)})},void 0,ce)}bufferEvents(F){const J={buffers:new Array};this.f.push(J);const V=F();return this.f.pop(),J.buffers.forEach(Q=>Q()),V}}e.$te=I;class y{constructor(){this.f=!1,this.g=L.None,this.h=S.$Uc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=y;class U{static const(F){return new A(F)}constructor(F){this.g=F,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$ve=U;class A{constructor(F){this.value=F,this.onDidChange=L.None}}}),define(he[18],fe([0,1,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=P;const t=Object.freeze(function(p,r){const L=setTimeout(p.bind(r),0);return{dispose(){clearTimeout(L)}}});var S;(function(p){function r(L){return L===p.None||L===p.Cancelled||L instanceof $?!0:!L||typeof L!="object"?!1:typeof L.isCancellationRequested=="boolean"&&typeof L.onCancellationRequested=="function"}p.isCancellationToken=r,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(S||(e.CancellationToken=S={}));class ${constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new a.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class B{constructor(r){this.f=void 0,this.g=void 0,this.g=r&&r.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new $),this.f}cancel(){this.f?this.f instanceof $&&this.f.cancel():this.f=S.Cancelled}dispose(r=!1){r&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof $&&this.f.dispose():this.f=S.None}}e.$we=B;function P(p){const r=new B;return p.add({dispose(){r.cancel()}}),r.token}}),define(he[50],fe([0,1,18]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=S;class t{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new a.$we,r=this.b(p.token);return this.a={promise:r,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$9e=t;function S(P){return P}class ${constructor(p,r){this.a=void 0,this.b=void 0,typeof p=="function"?(this.c=p,this.d=S):(this.c=r,this.d=p.getCacheKey)}get(p){const r=this.d(p);return this.b!==r&&(this.b=r,this.a=this.c(p)),this.a}}e.$$e=$;class B{get cachedValues(){return this.a}constructor(p,r){this.a=new Map,this.b=new Map,typeof p=="function"?(this.c=p,this.d=S):(this.c=r,this.d=p.getCacheKey)}get(p){const r=this.d(p);if(this.b.has(r))return this.b.get(r);const L=this.c(p);return this.a.set(p,L),this.b.set(r,L),L}}e.$_e=B}),define(he[51],fe([0,1,7,2]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=S,e.$ze=$,e.$Ae=B,e.$Be=P,e.$Ce=r,e.$De=L,e.$Ee=b,e.$Fe=d,e.$Ge=u,e.$He=c,e.$Ie=h,e.$Je=f,e.$Ke=l,e.$Le=n,e.$Me=w;function S(v){const o=v;return o?typeof o.read=="function":!1}function $(v){const o=v;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}function B(v){const o=v;return o?$(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function P(v,o){return new p(v,o)}class p{constructor(o,s){this.e=o,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(s=>s(o))}h(o){this.c.error.length===0?(0,a.$Y)(o):this.c.error.slice(0).forEach(s=>s(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,s){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(o,s){if(this.a.destroyed)return;let i;switch(o){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const g=i.indexOf(s);g>=0&&i.splice(g,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(v,o){const s=[];let i;for(;(i=v.read())!==null;)s.push(i);return o(s)}function L(v,o,s){const i=[];let g;for(;(g=v.read())!==null&&i.length<s;)i.push(g);return g===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof g<"u"){const _=g;return g=void 0,_}return v.read()}}}function b(v,o){return new Promise((s,i)=>{const g=[];d(v,{onData:_=>{o&&g.push(_)},onError:_=>{o?i(_):s(void 0)},onEnd:()=>{s(o?o(g):void 0)}})})}function d(v,o,s){v.on("error",i=>{s?.isCancellationRequested||o.onError(i)}),v.on("end",()=>{s?.isCancellationRequested||o.onEnd()}),v.on("data",i=>{s?.isCancellationRequested||o.onData(i)})}function u(v,o){return new Promise((s,i)=>{const g=new t.$Tc,_=[],C=R=>{if(_.push(R),_.length>o)return g.dispose(),v.pause(),s({stream:v,buffer:_,ended:!1})},E=R=>(g.dispose(),i(R)),k=()=>(g.dispose(),s({stream:v,buffer:_,ended:!0}));g.add((0,t.$Sc)(()=>v.removeListener("error",E))),v.on("error",E),g.add((0,t.$Sc)(()=>v.removeListener("end",k))),v.on("end",k),g.add((0,t.$Sc)(()=>v.removeListener("data",C))),v.on("data",C)})}function c(v,o){const s=P(o);return s.end(v),s}function h(){const v=P(()=>{throw new Error("not supported")});return v.end(),v}function f(v){let o=!1;return{read:()=>o?null:(o=!0,v)}}function l(v,o,s){const i=P(s);return d(v,{onData:g=>i.write(o.data(g)),onError:g=>i.error(o.error?o.error(g):g),onEnd:()=>i.end()}),i}function n(v,o,s){let i=!1;return{read:()=>{const g=o.read();return i?g:(i=!0,g!==null?s([v,g]):v)}}}function w(v,o,s){let i=!1;const g=P(s);return d(o,{onData:_=>i?g.write(_):(i=!0,g.write(s([v,_]))),onError:_=>g.error(_),onEnd:()=>{i||(i=!0,g.write(v)),g.end()}}),g}}),define(he[19],fe([0,1,24,51]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=r,e.$Pe=L,e.$Qe=b,e.$Re=d,e.$Se=u,e.$Te=c,e.$Ue=h,e.$Ve=f,e.$We=l,e.$Xe=n,e.$Ye=w,e.$Ze=v,e.$1e=o,e.$2e=s,e.$3e=i,e.$4e=g,e.$5e=_,e.$6e=C,e.$7e=E,e.$8e=M,t=Se(t);const S=typeof Buffer<"u",$=new a.$T(()=>new Uint8Array(256));let B,P;class p{static alloc(I){return S?new p(Buffer.allocUnsafe(I)):new p(new Uint8Array(I))}static wrap(I){return S&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new p(I)}static fromString(I,y){return!(y?.dontUseNodeBuffer||!1)&&S?new p(Buffer.from(I)):(B||(B=new TextEncoder),new p(B.encode(I)))}static fromByteArray(I){const y=p.alloc(I.length);for(let U=0,A=I.length;U<A;U++)y.buffer[U]=I[U];return y}static concat(I,y){if(typeof y>"u"){y=0;for(let D=0,F=I.length;D<F;D++)y+=I[D].byteLength}const U=p.alloc(y);let A=0;for(let D=0,F=I.length;D<F;D++){const J=I[D];U.set(J,A),A+=J.byteLength}return U}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=p.alloc(this.byteLength);return I.set(this),I}toString(){return S?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(I,y){return new p(this.buffer.subarray(I,y))}set(I,y){if(I instanceof p)this.buffer.set(I.buffer,y);else if(I instanceof Uint8Array)this.buffer.set(I,y);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),y);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return d(this.buffer,I)}writeUInt32BE(I,y){u(this.buffer,I,y)}readUInt32LE(I){return c(this.buffer,I)}writeUInt32LE(I,y){h(this.buffer,I,y)}readUInt8(I){return f(this.buffer,I)}writeUInt8(I,y){l(this.buffer,I,y)}indexOf(I,y=0){return r(this.buffer,I instanceof p?I.buffer:I,y)}}e.$Ne=p;function r(q,I,y=0){const U=I.byteLength,A=q.byteLength;if(U===0)return 0;if(U===1)return q.indexOf(I[0]);if(U>A-y)return-1;const D=$.value;D.fill(I.length);for(let Q=0;Q<I.length;Q++)D[I[Q]]=I.length-Q-1;let F=y+I.length-1,J=F,V=-1;for(;F<A;)if(q[F]===I[J]){if(J===0){V=F;break}F--,J--}else F+=Math.max(I.length-J,D[q[F]]),J=I.length-1;return V}function L(q,I){return q[I+0]<<0>>>0|q[I+1]<<8>>>0}function b(q,I,y){q[y+0]=I&255,I=I>>>8,q[y+1]=I&255}function d(q,I){return q[I]*2**24+q[I+1]*2**16+q[I+2]*2**8+q[I+3]}function u(q,I,y){q[y+3]=I,I=I>>>8,q[y+2]=I,I=I>>>8,q[y+1]=I,I=I>>>8,q[y]=I}function c(q,I){return q[I+0]<<0>>>0|q[I+1]<<8>>>0|q[I+2]<<16>>>0|q[I+3]<<24>>>0}function h(q,I,y){q[y+0]=I&255,I=I>>>8,q[y+1]=I&255,I=I>>>8,q[y+2]=I&255,I=I>>>8,q[y+3]=I&255}function f(q,I){return q[I]}function l(q,I,y){q[y]=I}function n(q){return t.$Ce(q,I=>p.concat(I))}function w(q){return t.$Je(q)}function v(q){return t.$Ee(q,I=>p.concat(I))}async function o(q){return q.ended?p.concat(q.buffer):p.concat([...q.buffer,await v(q.stream)])}function s(q){return t.$He(q,I=>p.concat(I))}function i(q){return t.$Ke(q,{data:I=>typeof I=="string"?p.fromString(I):p.wrap(I)},I=>p.concat(I))}function g(q){return t.$Be(I=>p.concat(I),q)}function _(q,I){return t.$Le(q,I,y=>p.concat(y))}function C(q,I){return t.$Me(q,I,y=>p.concat(y))}function E(q){let I=0,y=0,U=0;const A=new Uint8Array(Math.floor(q.length/4*3)),D=J=>{switch(y){case 3:A[U++]=I|J,y=0;break;case 2:A[U++]=I|J>>>2,I=J<<6,y=3;break;case 1:A[U++]=I|J>>>4,I=J<<4,y=2;break;default:I=J<<2,y=1}};for(let J=0;J<q.length;J++){const V=q.charCodeAt(J);if(V>=65&&V<=90)D(V-65);else if(V>=97&&V<=122)D(V-97+26);else if(V>=48&&V<=57)D(V-48+52);else if(V===43||V===45)D(62);else if(V===47||V===95)D(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${q[J]}`)}}const F=U;for(;y>0;)D(0);return p.wrap(A).slice(0,F)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:q},I=!0,y=!1){const U=y?R:k;let A="";const D=q.byteLength%3;let F=0;for(;F<q.byteLength-D;F+=3){const J=q[F+0],V=q[F+1],Q=q[F+2];A+=U[J>>>2],A+=U[(J<<4|V>>>4)&63],A+=U[(V<<2|Q>>>6)&63],A+=U[Q&63]}if(D===1){const J=q[F+0];A+=U[J>>>2],A+=U[J<<4&63],I&&(A+="==")}else if(D===2){const J=q[F+0],V=q[F+1];A+=U[J>>>2],A+=U[(J<<4|V>>>4)&63],A+=U[V<<2&63],I&&(A+="=")}return A}}),define(he[52],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(he[9],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=a,e.$fg=t,e.$gg=S,e.$hg=$,e.$ig=B,e.$jg=P,e.$kg=p,e.$lg=r,e.$mg=L,e.$ng=b,e.$og=d,e.$pg=u,e.$qg=c,e.$rg=f,e.$sg=l,e.$tg=n,e.$ug=w,e.$vg=v,e.$wg=o;function a(s){return typeof s=="string"}function t(s){return Array.isArray(s)&&s.every(i=>a(i))}function S(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function $(s){const i=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof i}function B(s){return typeof s=="number"&&!isNaN(s)}function P(s){return!!s&&typeof s[Symbol.iterator]=="function"}function p(s){return s===!0||s===!1}function r(s){return typeof s>"u"}function L(s){return!b(s)}function b(s){return r(s)||s===null}function d(s,i){if(!s)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function u(s){if(b(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function c(...s){const i=[];for(let g=0;g<s.length;g++){const _=s[g];if(b(_))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);i.push(_)}return i}const h=Object.prototype.hasOwnProperty;function f(s){if(!S(s))return!1;for(const i in s)if(h.call(s,i))return!1;return!0}function l(s){return typeof s=="function"}function n(...s){return s.length>0&&s.every(l)}function w(s,i){const g=Math.min(s.length,i.length);for(let _=0;_<g;_++)v(s[_],i[_])}function v(s,i){if(a(i)){if(typeof s!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(l(i)){try{if(s instanceof i)return}catch{}if(!b(s)&&s.constructor===i||i.length===1&&i.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function o(s){return s}}),define(he[33],fe([0,1,9]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=t,e.$fo=S,e.$go=B,e.$ho=p,e.$io=r,e.$jo=L,e.$ko=b,e.$lo=d,e.$mo=u,e.$no=c,e.$oo=h,e.$po=f,e.$qo=l;function t(n){if(!n||typeof n!="object"||n instanceof RegExp)return n;const w=Array.isArray(n)?[]:{};return Object.entries(n).forEach(([v,o])=>{w[v]=o&&typeof o=="object"?t(o):o}),w}function S(n){if(!n||typeof n!="object")return n;const w=[n];for(;w.length>0;){const v=w.shift();Object.freeze(v);for(const o in v)if($.call(v,o)){const s=v[o];typeof s=="object"&&!Object.isFrozen(s)&&!(0,a.$hg)(s)&&w.push(s)}}return n}const $=Object.prototype.hasOwnProperty;function B(n,w){return P(n,w,new Set)}function P(n,w,v){if((0,a.$ng)(n))return n;const o=w(n);if(typeof o<"u")return o;if(Array.isArray(n)){const s=[];for(const i of n)s.push(P(i,w,v));return s}if((0,a.$gg)(n)){if(v.has(n))throw new Error("Cannot clone recursive data-structure");v.add(n);const s={};for(const i in n)$.call(n,i)&&(s[i]=P(n[i],w,v));return v.delete(n),s}return n}function p(n,w,v=!0){return(0,a.$gg)(n)?((0,a.$gg)(w)&&Object.keys(w).forEach(o=>{o in n?v&&((0,a.$gg)(n[o])&&(0,a.$gg)(w[o])?p(n[o],w[o],v):n[o]=w[o]):n[o]=w[o]}),n):w}function r(n,w){if(n===w)return!0;if(n==null||w===null||w===void 0||typeof n!=typeof w||typeof n!="object"||Array.isArray(n)!==Array.isArray(w))return!1;let v,o;if(Array.isArray(n)){if(n.length!==w.length)return!1;for(v=0;v<n.length;v++)if(!r(n[v],w[v]))return!1}else{const s=[];for(o in n)s.push(o);s.sort();const i=[];for(o in w)i.push(o);if(i.sort(),!r(s,i))return!1;for(v=0;v<s.length;v++)if(!r(n[s[v]],w[s[v]]))return!1}return!0}function L(n){const w=new Set;return JSON.stringify(n,(v,o)=>{if((0,a.$gg)(o)||Array.isArray(o)){if(w.has(o))return"[Circular]";w.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function b(n,w){const v=Object.create(null);return!n||!w||Object.keys(w).forEach(s=>{const i=n[s],g=w[s];r(i,g)||(v[s]=g)}),v}function d(n,w){const v=w.toLowerCase(),o=Object.keys(n).find(s=>s.toLowerCase()===v);return o?n[o]:n[w]}function u(n,w){const v=Object.create(null);for(const[o,s]of Object.entries(n))w(o,s)&&(v[o]=s);return v}function c(n){let w=[];for(;Object.prototype!==n;)w=w.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return w}function h(n){const w=[];for(const v of c(n))typeof n[v]=="function"&&w.push(v);return w}function f(n,w){const v=s=>function(){const i=Array.prototype.slice.call(arguments,0);return w(s,i)},o={};for(const s of n)o[s]=v(s);return o}function l(n,w){const v={};for(const[o,s]of Object.entries(n))v[o]=w(s,o);return v}}),define(he[53],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=t,e.$bf=S;var a;(function($){$[$.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",$[$.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",$[$.MAX_UINT_8=255]="MAX_UINT_8",$[$.MAX_UINT_16=65535]="MAX_UINT_16",$[$.MAX_UINT_32=4294967295]="MAX_UINT_32",$[$.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a||(e.Constants=a={}));function t($){return $<0?0:$>a.MAX_UINT_8?a.MAX_UINT_8:$|0}function S($){return $<0?0:$>a.MAX_UINT_32?a.MAX_UINT_32:$|0}}),define(he[10],fe([0,1,50,13,24,53]),function(ie,e,a,t,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=B,e.$df=p,e.$ef=L,e.$ff=b,e.$gf=d,e.$hf=u,e.$if=c,e.$jf=h,e.$kf=f,e.$lf=l,e.$mf=n,e.$nf=w,e.$of=v,e.$pf=o,e.$qf=s,e.$rf=i,e.$sf=g,e.$tf=_,e.$uf=C,e.$vf=E,e.$wf=k,e.$xf=R,e.$yf=M,e.$zf=q,e.$Af=I,e.$Bf=y,e.$Cf=U,e.$Df=A,e.$Ef=D,e.$Ff=F,e.$Gf=J,e.$Hf=V,e.$If=Q,e.$Jf=re,e.$Kf=ce,e.$Lf=K,e.$Mf=j,e.$Pf=G,e.$Qf=ae,e.$Rf=me,e.$Sf=te,e.$Tf=oe,e.$Uf=X,e.$Wf=T,e.$Xf=O,e.$Yf=H,e.$Zf=Z,e.$1f=be,e.$2f=Ee,e.$3f=ge,e.$5f=de,e.$6f=we,e.$7f=$e,e.$8f=ve,e.$9f=ke,e.$0f=De,e.$$f=_e,e.$_f=Ie,e.$ag=ze;function B(z){return!z||typeof z!="string"?!0:z.trim().length===0}const P=/{(\d+)}/g;function p(z,...x){return x.length===0?z:z.replace(P,function(se,ue){const ye=parseInt(ue,10);return isNaN(ye)||ye<0||ye>=x.length?se:x[ye]})}const r=/{([^}]+)}/g;function L(z,x){return Object.keys(x).length===0?z:z.replace(r,(se,ue)=>x[ue]??se)}function b(z){return z.replace(/[<>"'&]/g,x=>{switch(x){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return x})}function d(z){return z.replace(/[<>&]/g,function(x){switch(x){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return x}})}function u(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(z,x){let se=0,ue=z.indexOf(x);for(;ue!==-1;)se++,ue=z.indexOf(x,ue+x.length);return se}function h(z,x,se="\u2026"){return z.length<=x?z:`${z.substr(0,x)}${se}`}function f(z,x,se="\u2026"){if(z.length<=x)return z;const ue=Math.ceil(x/2)-se.length/2,ye=Math.floor(x/2)-se.length/2;return`${z.substr(0,ue)}${se}${z.substr(z.length-ye)}`}function l(z,x=" "){const se=n(z,x);return w(se,x)}function n(z,x){if(!z||!x)return z;const se=x.length;if(se===0||z.length===0)return z;let ue=0;for(;z.indexOf(x,ue)===ue;)ue=ue+se;return z.substring(ue)}function w(z,x){if(!z||!x)return z;const se=x.length,ue=z.length;if(se===0||ue===0)return z;let ye=ue,Pe=-1;for(;Pe=z.lastIndexOf(x,ye-1),!(Pe===-1||Pe+se!==ye);){if(Pe===0)return"";ye=Pe}return z.substring(0,ye)}function v(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function o(z){return z.replace(/\*/g,"")}function s(z,x,se={}){if(!z)throw new Error("Cannot create regex from empty string");x||(z=u(z)),se.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let ue="";return se.global&&(ue+="g"),se.matchCase||(ue+="i"),se.multiline&&(ue+="m"),se.unicode&&(ue+="u"),new RegExp(z,ue)}function i(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}function g(z){return z.split(/\r\n|\r|\n/)}function _(z){const x=[],se=z.split(/(\r\n|\r|\n)/);for(let ue=0;ue<Math.ceil(se.length/2);ue++)x.push(se[2*ue]+(se[2*ue+1]??""));return x}function C(z){for(let x=0,se=z.length;x<se;x++){const ue=z.charCodeAt(x);if(ue!==t.CharCode.Space&&ue!==t.CharCode.Tab)return x}return-1}function E(z,x=0,se=z.length){for(let ue=x;ue<se;ue++){const ye=z.charCodeAt(ue);if(ye!==t.CharCode.Space&&ye!==t.CharCode.Tab)return z.substring(x,ue)}return z.substring(x,se)}function k(z,x=z.length-1){for(let se=x;se>=0;se--){const ue=z.charCodeAt(se);if(ue!==t.CharCode.Space&&ue!==t.CharCode.Tab)return se}return-1}function R(z,x,se){const ue=[];let ye=0;for(const Pe of z.matchAll(x)){if(ue.push(z.slice(ye,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");ye=Pe.index+Pe[0].length,ue.push(se(Pe[0],...Pe.slice(1),Pe.index,z,Pe.groups))}return ue.push(z.slice(ye)),Promise.all(ue).then(Pe=>Pe.join(""))}function M(z,x){return z<x?-1:z>x?1:0}function q(z,x,se=0,ue=z.length,ye=0,Pe=x.length){for(;se<ue&&ye<Pe;se++,ye++){const Te=z.charCodeAt(se),Ue=x.charCodeAt(ye);if(Te<Ue)return-1;if(Te>Ue)return 1}const Re=ue-se,Fe=Pe-ye;return Re<Fe?-1:Re>Fe?1:0}function I(z,x){return y(z,x,0,z.length,0,x.length)}function y(z,x,se=0,ue=z.length,ye=0,Pe=x.length){for(;se<ue&&ye<Pe;se++,ye++){let Te=z.charCodeAt(se),Ue=x.charCodeAt(ye);if(Te===Ue)continue;if(Te>=128||Ue>=128)return q(z.toLowerCase(),x.toLowerCase(),se,ue,ye,Pe);A(Te)&&(Te-=32),A(Ue)&&(Ue-=32);const Oe=Te-Ue;if(Oe!==0)return Oe}const Re=ue-se,Fe=Pe-ye;return Re<Fe?-1:Re>Fe?1:0}function U(z){return z>=t.CharCode.Digit0&&z<=t.CharCode.Digit9}function A(z){return z>=t.CharCode.a&&z<=t.CharCode.z}function D(z){return z>=t.CharCode.A&&z<=t.CharCode.Z}function F(z,x){return z.length===x.length&&y(z,x)===0}function J(z,x){const se=x.length;return x.length>z.length?!1:y(z,x,0,se)===0}function V(z,x){const se=Math.min(z.length,x.length);let ue;for(ue=0;ue<se;ue++)if(z.charCodeAt(ue)!==x.charCodeAt(ue))return ue;return se}function Q(z,x){const se=Math.min(z.length,x.length);let ue;const ye=z.length-1,Pe=x.length-1;for(ue=0;ue<se;ue++)if(z.charCodeAt(ye-ue)!==x.charCodeAt(Pe-ue))return ue;return se}function re(z){return 55296<=z&&z<=56319}function ce(z){return 56320<=z&&z<=57343}function K(z,x){return(z-55296<<10)+(x-56320)+65536}function j(z,x,se){const ue=z.charCodeAt(se);if(re(ue)&&se+1<x){const ye=z.charCodeAt(se+1);if(ce(ye))return K(ue,ye)}return ue}function Y(z,x){const se=z.charCodeAt(x-1);if(ce(se)&&x>1){const ue=z.charCodeAt(x-2);if(re(ue))return K(ue,se)}return se}class ee{get offset(){return this.e}constructor(x,se=0){this.c=x,this.d=x.length,this.e=se}setOffset(x){this.e=x}prevCodePoint(){const x=Y(this.c,this.e);return this.e-=x>=$.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,x}nextCodePoint(){const x=j(this.c,this.d,this.e);return this.e+=x>=$.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,x}eol(){return this.e>=this.d}}e.$Nf=ee;class le{get offset(){return this.c.offset}constructor(x,se=0){this.c=new ee(x,se)}nextGraphemeLength(){const x=Me.getInstance(),se=this.c,ue=se.offset;let ye=x.getGraphemeBreakType(se.nextCodePoint());for(;!se.eol();){const Pe=se.offset,Re=x.getGraphemeBreakType(se.nextCodePoint());if(Ce(ye,Re)){se.setOffset(Pe);break}ye=Re}return se.offset-ue}prevGraphemeLength(){const x=Me.getInstance(),se=this.c,ue=se.offset;let ye=x.getGraphemeBreakType(se.prevCodePoint());for(;se.offset>0;){const Pe=se.offset,Re=x.getGraphemeBreakType(se.prevCodePoint());if(Ce(Re,ye)){se.setOffset(Pe);break}ye=Re}return ue-se.offset}eol(){return this.c.eol()}}e.$Of=le;function G(z,x){return new le(z,x).nextGraphemeLength()}function ae(z,x){return new le(z,x).prevGraphemeLength()}function me(z,x){x>0&&ce(z.charCodeAt(x))&&x--;const se=x+G(z,x);return[se-ae(z,se),se]}function te(z){const x=new le(z);let se=0;for(;!x.eol();)se++,x.nextGraphemeLength();return se}let m;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(z){return m||(m=W()),m.test(z)}const N=/^[\t\n\r\x20-\x7E]*$/;function X(z){return N.test(z)}e.$Vf=/[\u2028\u2029]/;function T(z){return e.$Vf.test(z)}function O(z){return z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}function H(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129008||z>=129280&&z<=129535||z>=129648&&z<=129782}function Z(z,x,se=""){const ue=z.trimStart();if(ue.length<x)return ue;const ye=/\b/g;let Pe=0;for(;ye.test(ue)&&!(ue.length-ye.lastIndex<x);)Pe=ye.lastIndex,ye.lastIndex+=1;return Pe===0?ue:se+ue.substring(Pe).trimStart()}const ne=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*be(z){let x=0;for(const se of z.matchAll(ne))x!==se.index&&(yield{isCode:!1,str:z.substring(x,se.index)}),yield{isCode:!0,str:se[0]},x=se.index+se[0].length;x!==z.length&&(yield{isCode:!1,str:z.substring(x)})}function Ee(z){return z&&(z=z.replace(ne,"")),z}const Ae=/\\\[.*?\\\]/g;function ge(z){return Ee(z).replace(Ae,"")}e.$4f=String.fromCharCode(t.CharCode.UTF8_BOM);function de(z){return!!(z&&z.length>0&&z.charCodeAt(0)===t.CharCode.UTF8_BOM)}function we(z){return de(z)?z.substr(1):z}function $e(z,x){if(!z||!x||z.length<x.length)return!1;const se=x.length,ue=z.toLowerCase();let ye=0,Pe=-1;for(;ye<se;){const Re=ue.indexOf(x[ye],Pe+1);if(Re<0)return!1;Pe=Re,ye++}return!0}function ve(z,x=!1){return z?(x&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}function ke(z){return z.charAt(0).toUpperCase()+z.slice(1)}function De(z,x=1){if(x===0)return"";let se=-1;do se=z.indexOf(`
`,se+1),x--;while(x>0&&se>=0);return se===-1?z:(z[se-1]==="\r"&&se--,z.substr(0,se))}function _e(z){const x=t.CharCode.Z-t.CharCode.A+1;return z=z%(2*x),z<x?String.fromCharCode(t.CharCode.a+z):String.fromCharCode(t.CharCode.A+z-x)}function Ie(z){return Me.getInstance().getGraphemeBreakType(z)}function Ce(z,x){return z===Le.Other?x!==Le.Extend&&x!==Le.SpacingMark:z===Le.CR&&x===Le.LF?!1:z===Le.Control||z===Le.CR||z===Le.LF||x===Le.Control||x===Le.CR||x===Le.LF?!0:!(z===Le.L&&(x===Le.L||x===Le.V||x===Le.LV||x===Le.LVT)||(z===Le.LV||z===Le.V)&&(x===Le.V||x===Le.T)||(z===Le.LVT||z===Le.T)&&x===Le.T||x===Le.Extend||x===Le.ZWJ||x===Le.SpacingMark||z===Le.Prepend||z===Le.ZWJ&&x===Le.Extended_Pictographic||z===Le.Regional_Indicator&&x===Le.Regional_Indicator)}var Le;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Me{static{this.c=null}static getInstance(){return Me.c||(Me.c=new Me),Me.c}constructor(){this.d=He()}getGraphemeBreakType(x){if(x<32)return x===t.CharCode.LineFeed?Le.LF:x===t.CharCode.CarriageReturn?Le.CR:Le.Control;if(x<127)return Le.Other;const se=this.d,ue=se.length/3;let ye=1;for(;ye<=ue;)if(x<se[3*ye])ye=2*ye;else if(x>se[3*ye+1])ye=2*ye+1;else return se[3*ye+2];return Le.Other}}function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(z,x){if(z===0)return 0;const se=Xe(z,x);if(se!==void 0)return se;const ue=new ee(x,z);return ue.prevCodePoint(),ue.offset}function Xe(z,x){const se=new ee(x,z);let ue=se.prevCodePoint();for(;xe(ue)||ue===We.emojiVariantSelector||ue===We.enclosingKeyCap;){if(se.offset===0)return;ue=se.prevCodePoint()}if(!H(ue))return;let ye=se.offset;return ye>0&&se.prevCodePoint()===We.zwj&&(ye=se.offset),ye}function xe(z){return 127995<=z&&z<=127999}var We;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),e.$bg="\xA0";class Ge{static{this.c=new S.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new a.$$e({getCacheKey:JSON.stringify},x=>{function se(Oe){const je=new Map;for(let Ne=0;Ne<Oe.length;Ne+=2)je.set(Oe[Ne],Oe[Ne+1]);return je}function ue(Oe,je){const Ne=new Map(Oe);for(const[Ve,Ye]of je)Ne.set(Ve,Ye);return Ne}function ye(Oe,je){if(!Oe)return je;const Ne=new Map;for(const[Ve,Ye]of Oe)je.has(Ve)&&Ne.set(Ve,Ye);return Ne}const Pe=this.c.value;let Re=x.filter(Oe=>!Oe.startsWith("_")&&Oe in Pe);Re.length===0&&(Re=["_default"]);let Fe;for(const Oe of Re){const je=se(Pe[Oe]);Fe=ye(Fe,je)}const Te=se(Pe._common),Ue=ue(Te,Fe);return new Ge(Ue)})}static getInstance(x){return Ge.d.get(Array.from(x))}static{this.e=new S.$T(()=>Object.keys(Ge.c.value).filter(x=>!x.startsWith("_")))}static getLocales(){return Ge.e.value}constructor(x){this.f=x}isAmbiguous(x){return this.f.has(x)}containsAmbiguousCharacter(x){for(let se=0;se<x.length;se++){const ue=x.codePointAt(se);if(typeof ue=="number"&&this.isAmbiguous(ue))return!0}return!1}getPrimaryConfusable(x){return this.f.get(x)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=Ge;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(x){return qe.e().has(x)}static containsInvisibleCharacter(x){for(let se=0;se<x.length;se++){const ue=x.codePointAt(se);if(typeof ue=="number"&&qe.isInvisibleCharacter(ue))return!0}return!1}static get codePoints(){return qe.e()}}e.$dg=qe}),define(he[34],fe([0,1,13,5,3,10,9]),function(ie,e,a,t,S,$,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=P,e.$yg=p,e.$zg=r,e.$Ag=L,e.$Bg=b,e.$Cg=h,e.$Dg=f,e.$Eg=l,e.$Fg=n,e.$Gg=w,e.$Hg=v,e.$Ig=o,e.$Jg=s,e.$Kg=i,e.$Lg=g,e.$Mg=_,e.$Ng=k;function P(R){return R===a.CharCode.Slash||R===a.CharCode.Backslash}function p(R){return R.replace(/[\\/]/g,t.$gc.sep)}function r(R){return R.indexOf("/")===-1&&(R=p(R)),/^[a-zA-Z]:(\/|$)/.test(R)&&(R="/"+R),R}function L(R,M=t.$gc.sep){if(!R)return"";const q=R.length,I=R.charCodeAt(0);if(P(I)){if(P(R.charCodeAt(1))&&!P(R.charCodeAt(2))){let U=3;const A=U;for(;U<q&&!P(R.charCodeAt(U));U++);if(A!==U&&!P(R.charCodeAt(U+1))){for(U+=1;U<q;U++)if(P(R.charCodeAt(U)))return R.slice(0,U+1).replace(/[\\/]/g,M)}}return M}else if(n(I)&&R.charCodeAt(1)===a.CharCode.Colon)return P(R.charCodeAt(2))?R.slice(0,2)+M:R.slice(0,2);let y=R.indexOf("://");if(y!==-1){for(y+=3;y<q;y++)if(P(R.charCodeAt(y)))return R.slice(0,y+1)}return""}function b(R){if(!S.$j||!R||R.length<5)return!1;let M=R.charCodeAt(0);if(M!==a.CharCode.Backslash||(M=R.charCodeAt(1),M!==a.CharCode.Backslash))return!1;let q=2;const I=q;for(;q<R.length&&(M=R.charCodeAt(q),M!==a.CharCode.Backslash);q++);return!(I===q||(M=R.charCodeAt(q+1),isNaN(M)||M===a.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,u=/[/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(R,M=S.$j){const q=M?d:u;return!(!R||R.length===0||/^\s+$/.test(R)||(q.lastIndex=0,q.test(R))||M&&c.test(R)||R==="."||R===".."||M&&R[R.length-1]==="."||M&&R.length!==R.trim().length||R.length>255)}function f(R,M,q){const I=R===M;return!q||I?I:!R||!M?!1:(0,$.$Ff)(R,M)}function l(R,M,q,I=t.sep){if(R===M)return!0;if(!R||!M||M.length>R.length)return!1;if(q){if(!(0,$.$Gf)(R,M))return!1;if(M.length===R.length)return!0;let U=M.length;return M.charAt(M.length-1)===I&&U--,R.charAt(U)===I}return M.charAt(M.length-1)!==I&&(M+=I),R.indexOf(M)===0}function n(R){return R>=a.CharCode.A&&R<=a.CharCode.Z||R>=a.CharCode.a&&R<=a.CharCode.z}function w(R,M){return S.$j&&R.endsWith(":")&&(R+=t.sep),(0,t.$ic)(R)||(R=(0,t.$jc)(M,R)),R=(0,t.$hc)(R),v(R)}function v(R){return S.$j?(R=(0,$.$nf)(R,t.sep),R.endsWith(":")&&(R+=t.sep)):(R=(0,$.$nf)(R,t.sep),R||(R=t.sep)),R}function o(R){const M=(0,t.$hc)(R);return S.$j?R.length>3?!1:s(M)&&(R.length===2||M.charCodeAt(2)===a.CharCode.Backslash):M===t.$gc.sep}function s(R,M=S.$j){return M?n(R.charCodeAt(0))&&R.charCodeAt(1)===a.CharCode.Colon:!1}function i(R,M=S.$j){return s(R,M)?R[0]:void 0}function g(R,M,q){return M.length>R.length?-1:R===M?0:(q&&(R=R.toLowerCase(),M=M.toLowerCase()),R.indexOf(M))}function _(R){const M=R.split(":");let q,I,y;for(const U of M){const A=Number(U);(0,B.$ig)(A)?I===void 0?I=A:y===void 0&&(y=A):q=q?[q,U].join(":"):U}if(!q)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:q,line:I!==void 0?I:void 0,column:y!==void 0?y:I!==void 0?1:void 0}}const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function k(R,M,q=8){let I="";for(let U=0;U<q;U++){let A;U===0&&S.$j&&!M&&(q===3||q===4)?A=E:A=C,I+=A.charAt(Math.floor(Math.random()*A.length))}let y;return M?y=`${M}-${I}`:y=I,R?(0,t.$jc)(R,y):y}}),define(he[54],fe([0,1,10]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=t,e.$uj=S,e.$vj=$,e.$wj=P,e.$yj=h,a=Se(a);function t(l){return S(l,0)}function S(l,n){switch(typeof l){case"object":return l===null?$(349,n):Array.isArray(l)?p(l,n):r(l,n);case"string":return P(l,n);case"boolean":return B(l,n);case"number":return $(l,n);case"undefined":return $(937,n);default:return $(617,n)}}function $(l,n){return(n<<5)-n+l|0}function B(l,n){return $(l?433:863,n)}function P(l,n){n=$(149417,n);for(let w=0,v=l.length;w<v;w++)n=$(l.charCodeAt(w),n);return n}function p(l,n){return n=$(104579,n),l.reduce((w,v)=>S(v,w),n)}function r(l,n){return n=$(181387,n),Object.keys(l).sort().reduce((w,v)=>(w=P(v,w),S(l[v],w)),n)}class L{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=S(n,this.g),this.g}}e.$xj=L;var b;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function d(l,n,w=32){const v=w-n,o=~((1<<v)-1);return(l<<n|(o&l)>>>v)>>>0}function u(l,n=0,w=l.byteLength,v=0){for(let o=0;o<w;o++)l[n+o]=v}function c(l,n,w="0"){for(;l.length<n;)l=w+l;return l}function h(l,n=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(w=>w.toString(16).padStart(2,"0")).join(""):c((l>>>0).toString(16),n/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(b.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const w=n.length;if(w===0)return;const v=this.p;let o=this.r,s=this.u,i,g;for(s!==0?(i=s,g=-1,s=0):(i=n.charCodeAt(0),g=0);;){let _=i;if(a.$Jf(i))if(g+1<w){const C=n.charCodeAt(g+1);a.$Kf(C)?(g++,_=a.$Lf(i,C)):_=b.UNICODE_REPLACEMENT}else{s=i;break}else a.$Kf(i)&&(_=b.UNICODE_REPLACEMENT);if(o=this.w(v,o,_),g++,g<w)i=n.charCodeAt(g);else break}this.r=o,this.u=s}w(n,w,v){return v<128?n[w++]=v:v<2048?(n[w++]=192|(v&1984)>>>6,n[w++]=128|(v&63)>>>0):v<65536?(n[w++]=224|(v&61440)>>>12,n[w++]=128|(v&4032)>>>6,n[w++]=128|(v&63)>>>0):(n[w++]=240|(v&1835008)>>>18,n[w++]=128|(v&258048)>>>12,n[w++]=128|(v&4032)>>>6,n[w++]=128|(v&63)>>>0),w>=b.BLOCK_SIZE&&(this.y(),w-=b.BLOCK_SIZE,this.t+=b.BLOCK_SIZE,n[0]=n[b.BLOCK_SIZE+0],n[1]=n[b.BLOCK_SIZE+1],n[2]=n[b.BLOCK_SIZE+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,b.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=f.g,w=this.q;for(let k=0;k<64;k+=4)n.setUint32(k,w.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)n.setUint32(k,d(n.getUint32(k-12,!1)^n.getUint32(k-32,!1)^n.getUint32(k-56,!1)^n.getUint32(k-64,!1),1),!1);let v=this.h,o=this.l,s=this.m,i=this.n,g=this.o,_,C,E;for(let k=0;k<80;k++)k<20?(_=o&s|~o&i,C=1518500249):k<40?(_=o^s^i,C=1859775393):k<60?(_=o&s|o&i|s&i,C=2400959708):(_=o^s^i,C=3395469782),E=d(v,5)+_+g+C+n.getUint32(k*4,!1)&4294967295,g=i,i=s,s=d(o,30),o=v,v=E;this.h=this.h+v&4294967295,this.l=this.l+o&4294967295,this.m=this.m+s&4294967295,this.n=this.n+i&4294967295,this.o=this.o+g&4294967295}}e.$zj=f}),define(he[55],fe([0,1,17,13,10]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class ${constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const h=c.charCodeAt(0),f=this.b.charCodeAt(this.c);return h-f}value(){return this.b[this.c]}}e.$Hi=$;class B{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===t.CharCode.Period)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,S.$zf)(c,this.b,0,c.length,this.c,this.d):(0,S.$Bf)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=B;class P{constructor(c=!0,h=!0){this.f=c,this.g=h}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let h=c.length-1;h>=0;h--,this.c--){const f=this.b.charCodeAt(h);if(!(f===t.CharCode.Slash||this.f&&f===t.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===t.CharCode.Slash||this.f&&h===t.CharCode.Backslash)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,S.$zf)(c,this.b,0,c.length,this.d,this.e):(0,S.$Bf)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=P;var p;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(p||(p={}));class r{constructor(c,h){this.f=c,this.g=h,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new P(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(p.Path)),this.g(c)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===p.Scheme)return(0,S.$Af)(c,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,S.$Af)(c,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(c);if(this.d[this.e]===p.Query)return(0,S.$yf)(c,this.c.query);if(this.d[this.e]===p.Fragment)return(0,S.$yf)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ki=r;class L{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(b||(b={}));class d{static forUris(c=()=>!1,h=()=>!1){return new d(new r(c,h))}static forPaths(c=!1){return new d(new P(void 0,!c))}static forStrings(){return new d(new $)}static forConfigKeys(){return new d(new B)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,h){if(h){const f=h.slice(0);(0,a.$Vb)(f);for(const l of f)this.set(l,c)}else{const f=c.slice(0);(0,a.$Vb)(f);for(const l of f)this.set(l[0],l[1])}}set(c,h){const f=this.b.reset(c);let l;this.c||(this.c=new L,this.c.segment=f.value());const n=[];for(l=this.c;;){const v=f.cmp(l.segment);if(v>0)l.left||(l.left=new L,l.left.segment=f.value()),n.push([b.Left,l]),l=l.left;else if(v<0)l.right||(l.right=new L,l.right.segment=f.value()),n.push([b.Right,l]),l=l.right;else if(f.hasNext())f.next(),l.mid||(l.mid=new L,l.mid.segment=f.value()),n.push([b.Mid,l]),l=l.mid;else break}const w=l.value;l.value=h,l.key=c;for(let v=n.length-1;v>=0;v--){const o=n[v][1];o.updateHeight();const s=o.balanceFactor();if(s<-1||s>1){const i=n[v][0],g=n[v+1][0];if(i===b.Right&&g===b.Right)n[v][1]=o.rotateLeft();else if(i===b.Left&&g===b.Left)n[v][1]=o.rotateRight();else if(i===b.Right&&g===b.Left)o.right=n[v+1][1]=n[v+1][1].rotateRight(),n[v][1]=o.rotateLeft();else if(i===b.Left&&g===b.Right)o.left=n[v+1][1]=n[v+1][1].rotateLeft(),n[v][1]=o.rotateRight();else throw new Error;if(v>0)switch(n[v-1][0]){case b.Left:n[v-1][1].left=n[v][1];break;case b.Right:n[v-1][1].right=n[v][1];break;case b.Mid:n[v-1][1].mid=n[v][1];break}else this.c=n[0][1]}}return w}get(c){return this.d(c)?.value}d(c){const h=this.b.reset(c);let f=this.c;for(;f;){const l=h.cmp(f.segment);if(l>0)f=f.left;else if(l<0)f=f.right;else if(h.hasNext())h.next(),f=f.mid;else break}return f}has(c){const h=this.d(c);return!(h?.value===void 0&&h?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,h){const f=this.b.reset(c),l=[];let n=this.c;for(;n;){const w=f.cmp(n.segment);if(w>0)l.push([b.Left,n]),n=n.left;else if(w<0)l.push([b.Right,n]),n=n.right;else if(f.hasNext())f.next(),l.push([b.Mid,n]),n=n.mid;else break}if(n){if(h?(n.left=void 0,n.mid=void 0,n.right=void 0,n.height=1):(n.key=void 0,n.value=void 0),!n.mid&&!n.value)if(n.left&&n.right){const w=this.f(n.right);if(w.key){const{key:v,value:o,segment:s}=w;this.e(w.key,!1),n.key=v,n.value=o,n.segment=s}}else{const w=n.left??n.right;if(l.length>0){const[v,o]=l[l.length-1];switch(v){case b.Left:o.left=w;break;case b.Mid:o.mid=w;break;case b.Right:o.right=w;break}}else this.c=w}for(let w=l.length-1;w>=0;w--){const v=l[w][1];v.updateHeight();const o=v.balanceFactor();if(o>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),l[w][1]=v.rotateLeft()):o<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),l[w][1]=v.rotateRight()),w>0)switch(l[w-1][0]){case b.Left:l[w-1][1].left=l[w][1];break;case b.Right:l[w-1][1].right=l[w][1];break;case b.Mid:l[w-1][1].mid=l[w][1];break}else this.c=l[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const h=this.b.reset(c);let f=this.c,l;for(;f;){const n=h.cmp(f.segment);if(n>0)f=f.left;else if(n<0)f=f.right;else if(h.hasNext())h.next(),l=f.value||l,f=f.mid;else break}return f&&f.value||l}findSuperstr(c){return this.g(c,!1)}g(c,h){const f=this.b.reset(c);let l=this.c;for(;l;){const n=f.cmp(l.segment);if(n>0)l=l.left;else if(n<0)l=l.right;else if(f.hasNext())f.next(),l=l.mid;else return l.mid?this.h(l.mid):h?l.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[h,f]of this)c(f,h)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const h=[];return this.j(c,h),h[Symbol.iterator]()}j(c,h){c&&(c.left&&this.j(c.left,h),c.value&&h.push([c.key,c.value]),c.mid&&this.j(c.mid,h),c.right&&this.j(c.right,h))}_isBalanced(){const c=h=>{if(!h)return!0;const f=h.balanceFactor();return f<-1||f>1?!1:c(h.left)&&c(h.right)};return c(this.c)}}e.$Li=d}),define(he[6],fe([0,1,13,27,5,3]),function(ie,e,a,t,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=f,e.$wc=s,S=Se(S);const B=/^\w[\w\d+.-]*$/,P=/^\//,p=/^\/\//;function r(E,k){if(!E.scheme&&k)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${E.authority}", path: "${E.path}", query: "${E.query}", fragment: "${E.fragment}"}`);if(E.scheme&&!B.test(E.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(E.path){if(E.authority){if(!P.test(E.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(E.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function L(E,k){return!E&&!k?"file":E}function b(E,k){switch(E){case"https":case"http":case"file":k?k[0]!==u&&(k=u+k):k=u;break}return k}const d="",u="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(k){return k instanceof h?!0:k?typeof k.authority=="string"&&typeof k.fragment=="string"&&typeof k.path=="string"&&typeof k.query=="string"&&typeof k.scheme=="string"&&typeof k.fsPath=="string"&&typeof k.with=="function"&&typeof k.toString=="function":!1}constructor(k,R,M,q,I,y=!1){typeof k=="object"?(this.scheme=k.scheme||d,this.authority=k.authority||d,this.path=k.path||d,this.query=k.query||d,this.fragment=k.fragment||d):(this.scheme=L(k,y),this.authority=R||d,this.path=b(this.scheme,M||d),this.query=q||d,this.fragment=I||d,r(this,y))}get fsPath(){return s(this,!1)}with(k){if(!k)return this;let{scheme:R,authority:M,path:q,query:I,fragment:y}=k;return R===void 0?R=this.scheme:R===null&&(R=d),M===void 0?M=this.authority:M===null&&(M=d),q===void 0?q=this.path:q===null&&(q=d),I===void 0?I=this.query:I===null&&(I=d),y===void 0?y=this.fragment:y===null&&(y=d),R===this.scheme&&M===this.authority&&q===this.path&&I===this.query&&y===this.fragment?this:new n(R,M,q,I,y)}static parse(k,R=!1){const M=c.exec(k);return M?new n(M[2]||d,C(M[4]||d),C(M[5]||d),C(M[7]||d),C(M[9]||d),R):new n(d,d,d,d,d)}static file(k){let R=d;if($.$j&&(k=k.replace(/\\/g,u)),k[0]===u&&k[1]===u){const M=k.indexOf(u,2);M===-1?(R=k.substring(2),k=u):(R=k.substring(2,M),k=k.substring(M)||u)}return new n("file",R,k,d,d)}static from(k,R){return new n(k.scheme,k.authority,k.path,k.query,k.fragment,R)}static joinPath(k,...R){if(!k.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return $.$j&&k.scheme==="file"?M=h.file(S.$fc.join(s(k,!0),...R)).path:M=S.$gc.join(k.path,...R),k.with({path:M})}toString(k=!1){return i(this,k)}toJSON(){return this}static revive(k){if(k){if(k instanceof h)return k;{const R=new n(k);return R._formatted=k.external??null,R._fsPath=k._sep===l?k.fsPath??null:null,R}}else return k}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=h;function f(E){return!E||typeof E!="object"?!1:typeof E.scheme=="string"&&(typeof E.authority=="string"||typeof E.authority>"u")&&(typeof E.path=="string"||typeof E.path>"u")&&(typeof E.query=="string"||typeof E.query>"u")&&(typeof E.fragment=="string"||typeof E.fragment>"u")}const l=$.$j?1:void 0;class n extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(k=!1){return k?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const k={$mid:t.MarshalledId.Uri};return this._fsPath&&(k.fsPath=this._fsPath,k._sep=l),this._formatted&&(k.external=this._formatted),this.path&&(k.path=this.path),this.scheme&&(k.scheme=this.scheme),this.authority&&(k.authority=this.authority),this.query&&(k.query=this.query),this.fragment&&(k.fragment=this.fragment),k}}const w={[a.CharCode.Colon]:"%3A",[a.CharCode.Slash]:"%2F",[a.CharCode.QuestionMark]:"%3F",[a.CharCode.Hash]:"%23",[a.CharCode.OpenSquareBracket]:"%5B",[a.CharCode.CloseSquareBracket]:"%5D",[a.CharCode.AtSign]:"%40",[a.CharCode.ExclamationMark]:"%21",[a.CharCode.DollarSign]:"%24",[a.CharCode.Ampersand]:"%26",[a.CharCode.SingleQuote]:"%27",[a.CharCode.OpenParen]:"%28",[a.CharCode.CloseParen]:"%29",[a.CharCode.Asterisk]:"%2A",[a.CharCode.Plus]:"%2B",[a.CharCode.Comma]:"%2C",[a.CharCode.Semicolon]:"%3B",[a.CharCode.Equals]:"%3D",[a.CharCode.Space]:"%20"};function v(E,k,R){let M,q=-1;for(let I=0;I<E.length;I++){const y=E.charCodeAt(I);if(y>=a.CharCode.a&&y<=a.CharCode.z||y>=a.CharCode.A&&y<=a.CharCode.Z||y>=a.CharCode.Digit0&&y<=a.CharCode.Digit9||y===a.CharCode.Dash||y===a.CharCode.Period||y===a.CharCode.Underline||y===a.CharCode.Tilde||k&&y===a.CharCode.Slash||R&&y===a.CharCode.OpenSquareBracket||R&&y===a.CharCode.CloseSquareBracket||R&&y===a.CharCode.Colon)q!==-1&&(M+=encodeURIComponent(E.substring(q,I)),q=-1),M!==void 0&&(M+=E.charAt(I));else{M===void 0&&(M=E.substr(0,I));const U=w[y];U!==void 0?(q!==-1&&(M+=encodeURIComponent(E.substring(q,I)),q=-1),M+=U):q===-1&&(q=I)}}return q!==-1&&(M+=encodeURIComponent(E.substring(q))),M!==void 0?M:E}function o(E){let k;for(let R=0;R<E.length;R++){const M=E.charCodeAt(R);M===a.CharCode.Hash||M===a.CharCode.QuestionMark?(k===void 0&&(k=E.substr(0,R)),k+=w[M]):k!==void 0&&(k+=E[R])}return k!==void 0?k:E}function s(E,k){let R;return E.authority&&E.path.length>1&&E.scheme==="file"?R=`//${E.authority}${E.path}`:E.path.charCodeAt(0)===a.CharCode.Slash&&(E.path.charCodeAt(1)>=a.CharCode.A&&E.path.charCodeAt(1)<=a.CharCode.Z||E.path.charCodeAt(1)>=a.CharCode.a&&E.path.charCodeAt(1)<=a.CharCode.z)&&E.path.charCodeAt(2)===a.CharCode.Colon?k?R=E.path.substr(1):R=E.path[1].toLowerCase()+E.path.substr(2):R=E.path,$.$j&&(R=R.replace(/\//g,"\\")),R}function i(E,k){const R=k?o:v;let M="",{scheme:q,authority:I,path:y,query:U,fragment:A}=E;if(q&&(M+=q,M+=":"),(I||q==="file")&&(M+=u,M+=u),I){let D=I.indexOf("@");if(D!==-1){const F=I.substr(0,D);I=I.substr(D+1),D=F.lastIndexOf(":"),D===-1?M+=R(F,!1,!1):(M+=R(F.substr(0,D),!1,!1),M+=":",M+=R(F.substr(D+1),!1,!0)),M+="@"}I=I.toLowerCase(),D=I.lastIndexOf(":"),D===-1?M+=R(I,!1,!0):(M+=R(I.substr(0,D),!1,!0),M+=I.substr(D))}if(y){if(y.length>=3&&y.charCodeAt(0)===a.CharCode.Slash&&y.charCodeAt(2)===a.CharCode.Colon){const D=y.charCodeAt(1);D>=a.CharCode.A&&D<=a.CharCode.Z&&(y=`/${String.fromCharCode(D+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===a.CharCode.Colon){const D=y.charCodeAt(0);D>=a.CharCode.A&&D<=a.CharCode.Z&&(y=`${String.fromCharCode(D+32)}:${y.substr(2)}`)}M+=R(y,!0,!1)}return U&&(M+="?",M+=R(U,!1,!1)),A&&(M+="#",M+=k?A:v(A,!1,!1)),M}function g(E){try{return decodeURIComponent(E)}catch{return E.length>3?E.substr(0,3)+g(E.substr(3)):E}}const _=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function C(E){return E.match(_)?E.replace(_,k=>g(k)):E}}),define(he[56],fe([0,1,6]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=t,e.$er=S,e.$fr=$,e.log=P;function t(r){const L=r;return L&&typeof L.type=="string"&&typeof L.severity=="string"}function S(r){const L=[];let b;try{const d=JSON.parse(r.arguments),u=d[d.length-1];u&&u.__$stack&&(d.pop(),b=u.__$stack),L.push(...d)}catch{L.push("Unable to log remote console arguments",r.arguments)}return{args:L,stack:b}}function $(r){if(typeof r!="string")return $(S(r).stack);const L=r;if(L){const b=B(L),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(d&&d.length===4)return{uri:a.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function B(r){if(!r)return r;const L=r.indexOf(`
`);return L===-1?r:r.substring(0,L)}function P(r,L){const{args:b,stack:d}=S(r),u=typeof b[0]=="string"&&b.length===1;let c=B(d);c&&(c=`(${c.trim()})`);let h=[];if(typeof b[0]=="string"?c&&u?h=[`%c[${L}] %c${b[0]} %c${c}`,p("blue"),p(""),p("grey")]:h=[`%c[${L}] %c${b[0]}`,p("blue"),p(""),...b.slice(1)]:h=[`%c[${L}]%`,p("blue"),...b],c&&!u&&h.push(c),typeof console[r.severity]!="function")throw new Error("Unknown console method");console[r.severity].apply(console,h)}function p(r){return`color: ${r}`}}),define(he[57],fe([0,1,19,6,27]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=$,e.$bi=B,e.$ci=p;function $(r){return JSON.stringify(r,P)}function B(r){let L=JSON.parse(r);return L=p(L),L}function P(r,L){return L instanceof RegExp?{$mid:S.MarshalledId.Regexp,source:L.source,flags:L.flags}:L}function p(r,L=0){if(!r||L>200)return r;if(typeof r=="object"){switch(r.$mid){case S.MarshalledId.Uri:return t.URI.revive(r);case S.MarshalledId.Regexp:return new RegExp(r.source,r.flags);case S.MarshalledId.Date:return new Date(r.source)}if(r instanceof a.$Ne||r instanceof Uint8Array)return r;if(Array.isArray(r))for(let b=0;b<r.length;++b)r[b]=p(r[b],L+1);else for(const b in r)Object.hasOwnProperty.call(r,b)&&(r[b]=p(r[b],L+1))}return r}}),define(he[20],fe([0,1,7,3,10,6,5]),function(ie,e,a,t,S,$,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=p,e.$Pg=r,e.$Tg=b,a=Se(a),t=Se(t),B=Se(B);var P;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(P||(e.Schemas=P={}));function p(c,h){return $.URI.isUri(c)?(0,S.$Ff)(c.scheme,h):(0,S.$Gf)(c,h+":")}function r(c,...h){return h.some(f=>p(c,f))}e.$Qg="vscode-tkn",e.$Rg="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h,f){this.f=b(h,f)}getServerRootPath(){return this.f}get g(){return B.$gc.join(this.f,P.vscodeRemoteResource)}set(h,f,l){this.a[h]=f,this.b[h]=l}setConnectionToken(h,f){this.c[h]=f}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(o){return a.$Y(o),h}const f=h.authority;let l=this.a[f];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const n=this.b[f],w=this.c[f];let v=`path=${encodeURIComponent(h.path)}`;return typeof w=="string"&&(v+=`&${e.$Rg}=${encodeURIComponent(w)}`),$.URI.from({scheme:t.$p?this.d:P.vscodeRemoteResource,authority:`${l}:${n}`,path:this.g,query:v})}}e.$Sg=new L;function b(c,h){return B.$gc.join(h??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class d{static{this.a=e.$Yg}asBrowserUri(h){const f=this.b(h,ie);return this.uriToBrowserUri(f)}uriToBrowserUri(h){return h.scheme===P.vscodeRemote?e.$Sg.rewrite(h):h.scheme===P.file&&(t.$n||t.$r===`${P.vscodeFileResource}://${d.a}`)?h.with({scheme:P.vscodeFileResource,authority:h.authority||d.a,query:null,fragment:null}):h}asFileUri(h){const f=this.b(h,ie);return this.uriToFileUri(f)}uriToFileUri(h){return h.scheme===P.vscodeFileResource?h.with({scheme:P.file,authority:h.authority!==d.a?h.authority:null,query:null,fragment:null}):h}b(h,f){return $.URI.isUri(h)?h:$.URI.parse(f.toUrl(h))}}e.$Zg=new d;var u;(function(c){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(h.get("3"));const f="vscode-coi";function l(w){let v;typeof w=="string"?v=new URL(w).searchParams:w instanceof URL?v=w.searchParams:$.URI.isUri(w)&&(v=new URL(w.toString(!0)).searchParams);const o=v?.get(f);if(o)return h.get(o)}c.getHeadersFromQuery=l;function n(w,v,o){if(!globalThis.crossOriginIsolated)return;const s=v&&o?"3":o?"2":"1";w instanceof URLSearchParams?w.set(f,s):w[f]=s}c.addSearchParam=n})(u||(e.COI=u={}))}),define(he[25],fe([0,1,13,34,20,5,3,10,6]),function(ie,e,a,t,S,$,B,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=r,e.$ph=b,e.$qh=u,t=Se(t),$=Se($);function r(c){return(0,p.$wc)(c,!0)}class L{constructor(h){this.a=h}compare(h,f,l=!1){return h===f?0:(0,P.$yf)(this.getComparisonKey(h,l),this.getComparisonKey(f,l))}isEqual(h,f,l=!1){return h===f?!0:!h||!f?!1:this.getComparisonKey(h,l)===this.getComparisonKey(f,l)}getComparisonKey(h,f=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,f,l=!1){if(h.scheme===f.scheme){if(h.scheme===S.Schemas.file)return t.$Eg(r(h),r(f),this.a(h))&&h.query===f.query&&(l||h.fragment===f.fragment);if((0,e.$lh)(h.authority,f.authority))return t.$Eg(h.path,f.path,this.a(h),"/")&&h.query===f.query&&(l||h.fragment===f.fragment)}return!1}joinPath(h,...f){return p.URI.joinPath(h,...f)}basenameOrAuthority(h){return(0,e.$dh)(h)||h.authority}basename(h){return $.$gc.basename(h.path)}extname(h){return $.$gc.extname(h.path)}dirname(h){if(h.path.length===0)return h;let f;return h.scheme===S.Schemas.file?f=p.URI.file($.$mc(r(h))).path:(f=$.$gc.dirname(h.path),h.authority&&f.length&&f.charCodeAt(0)!==a.CharCode.Slash&&(console.error(`dirname("${h.toString})) resulted in a relative path`),f="/")),h.with({path:f})}normalizePath(h){if(!h.path.length)return h;let f;return h.scheme===S.Schemas.file?f=p.URI.file($.$hc(r(h))).path:f=$.$gc.normalize(h.path),h.with({path:f})}relativePath(h,f){if(h.scheme!==f.scheme||!(0,e.$lh)(h.authority,f.authority))return;if(h.scheme===S.Schemas.file){const w=$.$lc(r(h),r(f));return B.$j?t.$yg(w):w}let l=h.path||"/";const n=f.path||"/";if(this.a(h)){let w=0;for(const v=Math.min(l.length,n.length);w<v&&!(l.charCodeAt(w)!==n.charCodeAt(w)&&l.charAt(w).toLowerCase()!==n.charAt(w).toLowerCase());w++);l=n.substr(0,w)+l.substr(w)}return $.$gc.relative(l,n)}resolvePath(h,f){if(h.scheme===S.Schemas.file){const l=p.URI.file($.$kc(r(h),f));return h.with({authority:l.authority,path:l.path})}return f=t.$zg(f),h.with({path:$.$gc.resolve(h.path,f)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,f){return h===f||h!==void 0&&f!==void 0&&(0,P.$Ff)(h,f)}hasTrailingPathSeparator(h,f=$.sep){if(h.scheme===S.Schemas.file){const l=r(h);return l.length>t.$Ag(l).length&&l[l.length-1]===f}else{const l=h.path;return l.length>1&&l.charCodeAt(l.length-1)===a.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,f=$.sep){return(0,e.$mh)(h,f)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,f=$.sep){let l=!1;if(h.scheme===S.Schemas.file){const n=r(h);l=n!==void 0&&n.length===t.$Ag(n).length&&n[n.length-1]===f}else{f="/";const n=h.path;l=n.length===1&&n.charCodeAt(n.length-1)===a.CharCode.Slash}return!l&&!(0,e.$mh)(h,f)?h.with({path:h.path+"/"}):h}}e.$8g=L,e.$9g=new L(()=>!1),e.$0g=new L(c=>c.scheme===S.Schemas.file?!B.$l:!0),e.$$g=new L(c=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function b(c,h){const f=[];for(let l=0;l<c.length;l++){const n=h(c[l]);c.some((w,v)=>v===l?!1:(0,e.$ah)(n,h(w)))||f.push(c[l])}return f}var d;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function h(f){const l=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(v=>{const[o,s]=v.split(":");o&&s&&l.set(o,s)});const w=f.path.substring(0,f.path.indexOf(";"));return w&&l.set(c.META_DATA_MIME,w),l}c.parseMetaData=h})(d||(e.DataUri=d={}));function u(c,h,f){if(h){let l=c.path;return l&&l[0]!==$.$gc.sep&&(l=$.$gc.sep+l),c.with({scheme:f,authority:h,path:l})}return c.with({scheme:f})}}),define(he[11],fe([0,1,18,7,4,2,25,3,52,24]),function(ie,e,a,t,S,$,B,P,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=L,e.$sh=b,e.$th=d,e.$uh=u,e.$vh=c,e.$wh=h,e.$xh=f,e.$yh=l,e.$Gh=E,e.$Hh=k,e.$Ih=R,e.$Jh=M,e.$Kh=q,e.$Zh=j,e.$8h=N;function L(T){return!!T&&typeof T.then=="function"}function b(T){const O=new a.$we,H=T(O.token),Z=new Promise((ne,be)=>{const Ee=O.token.onCancellationRequested(()=>{Ee.dispose(),be(new t.$4)});Promise.resolve(H).then(Ae=>{Ee.dispose(),O.dispose(),ne(Ae)},Ae=>{Ee.dispose(),O.dispose(),be(Ae)})});return new class{cancel(){O.cancel(),O.dispose()}then(ne,be){return Z.then(ne,be)}catch(ne){return this.then(void 0,ne)}finally(ne){return Z.finally(ne)}}}function d(T,O,H){return new Promise((Z,ne)=>{const be=O.onCancellationRequested(()=>{be.dispose(),Z(H)});T.then(Z,ne).finally(()=>be.dispose())})}function u(T,O){return new Promise((H,Z)=>{const ne=O.onCancellationRequested(()=>{ne.dispose(),Z(new t.$4)});T.then(H,Z).finally(()=>ne.dispose())})}async function c(T){let O=-1;const H=T.map((Z,ne)=>Z.then(be=>(O=ne,be)));try{return await Promise.race(H)}finally{T.forEach((Z,ne)=>{ne!==O&&Z.cancel()})}}function h(T,O,H){let Z;const ne=setTimeout(()=>{Z?.(void 0),H?.()},O);return Promise.race([T.finally(()=>clearTimeout(ne)),new Promise(be=>Z=be)])}function f(T){return new Promise((O,H)=>{const Z=T();L(Z)?Z.then(O,H):O(Z)})}function l(){let T,O;return{promise:new Promise((Z,ne)=>{T=Z,O=ne}),resolve:T,reject:O}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(O){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=O,!this.b){const H=()=>{if(this.b=null,this.f)return;const Z=this.queue(this.d);return this.d=null,Z};this.b=new Promise(Z=>{this.a.then(H,H).then(Z)})}return new Promise((H,Z)=>{this.b.then(H,Z)})}return this.a=O(),new Promise((H,Z)=>{this.a.then(ne=>{this.a=null,H(ne)},ne=>{this.a=null,Z(ne)})})}dispose(){this.f=!0}}e.$zh=n;class w{constructor(){this.a=Promise.resolve(null)}queue(O){return this.a=this.a.then(()=>O(),()=>O())}}e.$Ah=w;class v{constructor(){this.a=new Map}queue(O,H){const ne=(this.a.get(O)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.a.get(O)===ne&&this.a.delete(O)});return this.a.set(O,ne),ne}}e.$Bh=v;const o=(T,O)=>{let H=!0;const Z=setTimeout(()=>{H=!1,O()},T);return{isTriggered:()=>H,dispose:()=>{clearTimeout(Z),H=!1}}},s=T=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,T())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};class i{constructor(O){this.defaultDelay=O,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(O,H=this.defaultDelay){this.g=O,this.h(),this.b||(this.b=new Promise((ne,be)=>{this.d=ne,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const ne=this.g;return this.g=null,ne()}}));const Z=()=>{this.a=null,this.d?.(null)};return this.a=H===p.$ge?s(Z):o(H,Z),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=i;class g{constructor(O){this.a=new i(O),this.b=new n}trigger(O,H){return this.a.trigger(()=>this.b.queue(O),H)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=g;class _{constructor(){this.a=!1,this.b=new Promise((O,H)=>{this.d=O})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=_;class C extends _{constructor(O){super(),this.f=setTimeout(()=>this.open(),O)}open(){clearTimeout(this.f),super.open()}}e.$Fh=C;function E(T,O){return O?new Promise((H,Z)=>{const ne=setTimeout(()=>{be.dispose(),H()},T),be=O.onCancellationRequested(()=>{clearTimeout(ne),be.dispose(),Z(new t.$4)})}):b(H=>E(T,H))}function k(T,O=0,H){const Z=setTimeout(()=>{T(),H&&ne.dispose()},O),ne=(0,$.$Sc)(()=>{clearTimeout(Z),H?.deleteAndLeak(ne)});return H?.add(ne),ne}function R(T){const O=[];let H=0;const Z=T.length;function ne(){return H<Z?T[H++]():null}function be(Ee){Ee!=null&&O.push(Ee);const Ae=ne();return Ae?Ae.then(be):Promise.resolve(O)}return Promise.resolve(null).then(be)}function M(T,O=Z=>!!Z,H=null){let Z=0;const ne=T.length,be=()=>{if(Z>=ne)return Promise.resolve(H);const Ee=T[Z++];return Promise.resolve(Ee()).then(ge=>O(ge)?Promise.resolve(ge):be())};return be()}function q(T,O=Z=>!!Z,H=null){if(T.length===0)return Promise.resolve(H);let Z=T.length;const ne=()=>{Z=-1;for(const be of T)be.cancel?.()};return new Promise((be,Ee)=>{for(const Ae of T)Ae.then(ge=>{--Z>=0&&O(ge)?(ne(),be(ge)):Z===0&&be(H)}).catch(ge=>{--Z>=0&&(ne(),Ee(ge))})})}class I{constructor(O){this.a=0,this.b=!1,this.f=O,this.g=[],this.d=0,this.h=new S.$le}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(O){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((H,Z)=>{this.g.push({factory:O,c:H,e:Z}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const O=this.g.shift();this.d++;const H=O.factory();H.then(O.c,O.e),H.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=I;class y extends I{constructor(){super(1)}}e.$Mh=y;class U{constructor(){this.a=new Y,this.b=0}queue(O){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,O())):this.a.run(this.b++,O())}}e.$Nh=U;class A{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const O=new G;return this.b.add(O),O.p}g(){for(const[,O]of this.a)if(O.size>0)return!1;return!0}queueSize(O,H=B.$9g){const Z=H.getComparisonKey(O);return this.a.get(Z)?.size??0}queueFor(O,H,Z=B.$9g){const ne=Z.getComparisonKey(O);let be=this.a.get(ne);if(!be){be=new y;const Ee=this.f++,Ae=S.Event.once(be.onDrained)(()=>{be?.dispose(),this.a.delete(ne),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new $.$4c),this.d.set(Ee,Ae),this.a.set(ne,be)}return be.queue(H)}h(){this.g()&&this.j()}j(){for(const O of this.b)O.complete();this.b.clear()}dispose(){for(const[,O]of this.a)O.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=A;class D{constructor(O,H){this.b=!1,this.a=-1,typeof O=="function"&&typeof H=="number"&&this.setIfNotSet(O,H)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(O,H){if(this.b)throw new t.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,O()},H)}setIfNotSet(O,H){if(this.b)throw new t.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,O()},H))}}e.$Ph=D;class F{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(O,H,Z=globalThis){if(this.f)throw new t.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ne=Z.setInterval(()=>{O()},H);this.d=(0,$.$Sc)(()=>{Z.clearInterval(ne),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=F;class J{constructor(O,H){this.b=-1,this.a=O,this.d=H,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(O=this.d){this.cancel(),this.b=setTimeout(this.f,O)}get delay(){return this.d}set delay(O){this.d=O}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=J;class V{constructor(O,H){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.a=O,this.b=H,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(O=this.b){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(O/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=V;class Q extends J{constructor(O,H){super(O,H),this.j=[]}work(O){this.j.push(O),this.isScheduled()||this.schedule()}h(){const O=this.j;this.j=[],this.a?.(O)}dispose(){this.j=[],super.dispose()}}e.$Th=Q;class re extends $.$Uc{constructor(O,H){super(),this.g=O,this.h=H,this.a=[],this.b=this.B(new $.$Vc),this.f=!1}get pending(){return this.a.length}work(O){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+O.length>this.g.maxBufferedWork)return!1}else if(this.pending+O.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const H of O)this.a.push(H);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new J(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(T,O)=>{(0,P.$C)(()=>{if(H)return;const Z=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Z-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.$Wh=(T,O,H)=>{const Z=T.requestIdleCallback(O,typeof H=="number"?{timeout:H}:void 0);let ne=!1;return{dispose(){ne||(ne=!0,T.cancelIdleCallback(Z))}}},e.$Vh=T=>(0,e.$Wh)(globalThis,T)}();class ce{constructor(O,H){this.g=!1,this.d=()=>{try{this.j=H()}catch(Z){this.l=Z}finally{this.g=!0}},this.f=(0,e.$Wh)(O,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=ce;class K extends ce{constructor(O){super(globalThis,O)}}e.$Yh=K;async function j(T,O,H){let Z;for(let ne=0;ne<H;ne++)try{return await T()}catch(be){Z=be,await E(O)}throw Z}class Y{isRunning(O){return typeof O=="number"?this.a?.taskId===O:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(O,H,Z){return this.a={taskId:O,cancel:()=>Z?.(),promise:H},H.then(()=>this.d(O),()=>this.d(O)),H}d(O){this.a&&O===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const O=this.b;this.b=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}queue(O){if(this.b)this.b.run=O;else{const{promise:H,resolve:Z,reject:ne}=l();this.b={run:O,promise:H,promiseResolve:Z,promiseReject:ne}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=Y;class ee{constructor(O,H=()=>Date.now()){this.d=O,this.f=H,this.a=0,this.b=0}increment(){const O=this.f();return O-this.a>this.d&&(this.a=O,this.b=0),this.b++,this.b}}e.$2h=ee;var le;(function(T){T[T.Resolved=0]="Resolved",T[T.Rejected=1]="Rejected"})(le||(le={}));class G{get isRejected(){return this.d?.outcome===le.Rejected}get isResolved(){return this.d?.outcome===le.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===le.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((O,H)=>{this.a=O,this.b=H})}complete(O){return new Promise(H=>{this.a(O),this.d={outcome:le.Resolved,value:O},H()})}error(O){return new Promise(H=>{this.b(O),this.d={outcome:le.Rejected,value:O},H()})}cancel(){return this.error(new t.$4)}}e.$3h=G;var ae;(function(T){async function O(Z){let ne;const be=await Promise.all(Z.map(Ee=>Ee.then(Ae=>Ae,Ae=>{ne||(ne=Ae)})));if(typeof ne<"u")throw ne;return be}T.settled=O;function H(Z){return new Promise(async(ne,be)=>{try{await Z(ne,be)}catch(Ee){be(Ee)}})}T.withAsyncBody=H})(ae||(e.Promises=ae={}));class me{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(O){this.a=void 0,this.b=void 0,this.d=!1,this.promise=O.then(H=>(this.a=H,this.d=!0,H),H=>{throw this.b=H,this.d=!0,H})}requireValue(){if(!this.d)throw new t.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=me;class te{constructor(O){this.b=O,this.a=new r.$T(()=>new me(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=te;var m;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(m||(m={}));class W{static fromArray(O){return new W(H=>{H.emitMany(O)})}static fromPromise(O){return new W(async H=>{H.emitMany(await O)})}static fromPromises(O){return new W(async H=>{await Promise.all(O.map(async Z=>H.emitOne(await Z)))})}static merge(O){return new W(async H=>{await Promise.all(O.map(async Z=>{for await(const ne of Z)H.emitOne(ne)}))})}static{this.EMPTY=W.fromArray([])}constructor(O,H){this.a=m.Initial,this.b=[],this.d=null,this.f=H,this.g=new S.$le,queueMicrotask(async()=>{const Z={emitOne:ne=>this.h(ne),emitMany:ne=>this.j(ne),reject:ne=>this.l(ne)};try{await Promise.resolve(O(Z)),this.k()}catch(ne){this.l(ne)}finally{Z.emitOne=void 0,Z.emitMany=void 0,Z.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this.a===m.DoneError)throw this.d;if(O<this.b.length)return{done:!1,value:this.b[O++]};if(this.a===m.DoneOK)return{done:!0,value:void 0};await S.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(O,H){return new W(async Z=>{for await(const ne of O)Z.emitOne(H(ne))})}map(O){return W.map(this,O)}static filter(O,H){return new W(async Z=>{for await(const ne of O)H(ne)&&Z.emitOne(ne)})}filter(O){return W.filter(this,O)}static coalesce(O){return W.filter(O,H=>!!H)}coalesce(){return W.coalesce(this)}static async toPromise(O){const H=[];for await(const Z of O)H.push(Z);return H}toPromise(){return W.toPromise(this)}h(O){this.a===m.Initial&&(this.b.push(O),this.g.fire())}j(O){this.a===m.Initial&&(this.b=this.b.concat(O),this.g.fire())}k(){this.a===m.Initial&&(this.a=m.DoneOK,this.g.fire())}l(O){this.a===m.Initial&&(this.a=m.DoneError,this.d=O,this.g.fire())}}e.$6h=W;class oe extends W{constructor(O,H){super(H),this.m=O}cancel(){this.m.cancel()}}e.$7h=oe;function N(T){const O=new a.$we,H=T(O.token);return new oe(O,async Z=>{const ne=O.token.onCancellationRequested(()=>{ne.dispose(),O.dispose(),Z.reject(new t.$4)});try{for await(const be of H){if(O.token.isCancellationRequested)return;Z.emitOne(be)}ne.dispose(),O.dispose()}catch(be){ne.dispose(),O.dispose(),Z.reject(be)}})}class X{constructor(O){this.a=new G,this.b=new W(ne=>{if(H){ne.reject(H);return}return Z&&ne.emitMany(Z),this.d=be=>ne.reject(be),this.f=be=>ne.emitOne(be),this.a.p},O);let H,Z;this.f=ne=>{Z||(Z=[]),Z.push(ne)},this.d=ne=>{H||(H=ne)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(O){this.d(O),this.a.complete()}emitOne(O){this.f(O)}}e.$9h=X}),define(he[58],fe([0,1,19,27,6]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=void 0,e.$On=p,e.$Pn=L,e.$Qn=b;function $(d){return d.toJSON()}class B{constructor(u){this.a=u}transformIncoming(u){const c=this.a.transformIncoming(u);return c===u?u:$(S.URI.from(c))}transformOutgoing(u){const c=this.a.transformOutgoing(u);return c===u?u:$(S.URI.from(c))}transformOutgoingURI(u){const c=this.a.transformOutgoing(u);return c===u?u:S.URI.from(c)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$Mn=B,e.$Nn=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function P(d,u,c){if(!d||c>200)return null;if(typeof d=="object"){if(d instanceof S.URI)return u.transformOutgoing(d);for(const h in d)if(Object.hasOwnProperty.call(d,h)){const f=P(d[h],u,c+1);f!==null&&(d[h]=f)}}return null}function p(d,u){const c=P(d,u,0);return c===null?d:c}function r(d,u,c,h){if(!d||h>200)return null;if(typeof d=="object"){if(d.$mid===t.MarshalledId.Uri)return c?S.URI.revive(u.transformIncoming(d)):u.transformIncoming(d);if(d instanceof a.$Ne)return null;for(const f in d)if(Object.hasOwnProperty.call(d,f)){const l=r(d[f],u,c,h+1);l!==null&&(d[f]=l)}}return null}function L(d,u){const c=r(d,u,!1,0);return c===null?d:c}function b(d,u){const c=r(d,u,!0,0);return c===null?d:c}}),define(he[59],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=t;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(S){return a.test(S)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(P){for(let p=0;p<P.length;p++)P[p]=Math.floor(Math.random()*256);return P};const $=new Uint8Array(16),B=[];for(let P=0;P<256;P++)B.push(P.toString(16).padStart(2,"0"));return function(){S($),$[6]=$[6]&15|64,$[8]=$[8]&63|128;let p=0,r="";return r+=B[$[p++]],r+=B[$[p++]],r+=B[$[p++]],r+=B[$[p++]],r+="-",r+=B[$[p++]],r+=B[$[p++]],r+="-",r+=B[$[p++]],r+=B[$[p++]],r+="-",r+=B[$[p++]],r+=B[$[p++]],r+="-",r+=B[$[p++]],r+=B[$[p++]],r+=B[$[p++]],r+=B[$[p++]],r+=B[$[p++]],r+=B[$[p++]],r}}()}),define(he[28],fe([0,1,35,21,100,11,34,48,5,3,25,6]),function(ie,e,a,t,S,$,B,P,p,r,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=w,e.whenDeleted=s,e.configureFlushOnWrite=E,e.writeFileSync=R,a=Se(a);var d;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function u(V,Q=d.UNLINK,re){if((0,B.$Ig)(V))throw new Error("rimraf - will refuse to recursively delete root");return Q===d.UNLINK?h(V):c(V,re)}async function c(V,Q=(0,B.$Ng)((0,t.tmpdir)())){try{try{await a.promises.rename(V,Q)}catch(re){return re.code==="ENOENT"?void 0:h(V)}h(Q).catch(re=>{})}catch(re){if(re.code!=="ENOENT")throw re}}async function h(V){return a.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function f(V){if((0,B.$Ig)(V))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function l(V,Q){return v(await(Q?n(V):a.promises.readdir(V)))}async function n(V){try{return await a.promises.readdir(V,{withFileTypes:!0})}catch(ce){console.warn("[node.js fs] readdir with filetypes failed with error: ",ce)}const Q=[],re=await l(V);for(const ce of re){let K=!1,j=!1,Y=!1;try{const ee=await a.promises.lstat((0,p.$jc)(V,ce));K=ee.isFile(),j=ee.isDirectory(),Y=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Q.push({name:ce,isFile:()=>K,isDirectory:()=>j,isSymbolicLink:()=>Y})}return Q}function w(V){return v(a.readdirSync(V))}function v(V){return V.map(Q=>typeof Q=="string"?r.$k?(0,P.$nm)(Q):Q:(Q.name=r.$k?(0,P.$nm)(Q.name):Q.name,Q))}async function o(V){const Q=await l(V),re=[];for(const ce of Q)await i.existsDirectory((0,p.$jc)(V,ce))&&re.push(ce);return re}function s(V,Q=1e3){return new Promise(re=>{let ce=!1;const K=setInterval(()=>{ce||(ce=!0,a.access(V,j=>{ce=!1,j&&(clearInterval(K),re(void 0))}))},Q)})}var i;(function(V){async function Q(K){let j;try{if(j=await a.promises.lstat(K),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await a.promises.stat(K),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(r.$j&&Y.code==="EACCES")try{return{stat:await a.promises.stat(await a.promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw ee}throw Y}}V.stat=Q;async function re(K){try{const{stat:j,symbolicLink:Y}=await V.stat(K);return j.isFile()&&Y?.dangling!==!0}catch{}return!1}V.existsFile=re;async function ce(K){try{const{stat:j,symbolicLink:Y}=await V.stat(K);return j.isDirectory()&&Y?.dangling!==!0}catch{}return!1}V.existsDirectory=ce})(i||(e.SymlinkSupport=i={}));const g=new $.$Oh;function _(V,Q,re){return g.queueFor(b.URI.file(V),()=>{const ce=M(re);return new Promise((K,j)=>k(V,Q,ce,Y=>Y?j(Y):K()))},L.$0g)}let C=!0;function E(V){C=V}function k(V,Q,re,ce){if(!C)return a.writeFile(V,Q,{mode:re.mode,flag:re.flag},ce);a.open(V,re.flag,re.mode,(K,j)=>{if(K)return ce(K);a.writeFile(j,Q,Y=>{if(Y)return a.close(j,()=>ce(Y));a.fdatasync(j,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),E(!1)),a.close(j,le=>ce(le))))})})}function R(V,Q,re){const ce=M(re);if(!C)return a.writeFileSync(V,Q,{mode:ce.mode,flag:ce.flag});const K=a.openSync(V,ce.flag,ce.mode);try{a.writeFileSync(K,Q);try{a.fdatasyncSync(K)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),E(!1)}}finally{a.closeSync(K)}}function M(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function q(V,Q,re=6e4){if(V!==Q)try{r.$j&&typeof re=="number"?await I(V,Q,Date.now(),re):await a.promises.rename(V,Q)}catch(ce){if(V.toLowerCase()!==Q.toLowerCase()&&ce.code==="EXDEV"||V.endsWith("."))await y(V,Q,{preserveSymlinks:!1}),await u(V,d.MOVE);else throw ce}}async function I(V,Q,re,ce,K=0){try{return await a.promises.rename(V,Q)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-re>=ce)throw console.error(`[node.js fs] rename failed after ${K} retries with error: ${j}`),j;if(K===0){let Y=!1;try{const{stat:ee}=await i.stat(Q);ee.isFile()||(Y=!0)}catch{}if(Y)throw j}return await(0,$.$Gh)(Math.min(100,K*10)),I(V,Q,re,ce,K+1)}}async function y(V,Q,re){return A(V,Q,{root:{source:V,target:Q},options:re,handledSourcePaths:new Set})}const U=511;async function A(V,Q,re){if(re.handledSourcePaths.has(V))return;re.handledSourcePaths.add(V);const{stat:ce,symbolicLink:K}=await i.stat(V);if(K){if(re.options.preserveSymlinks)try{return await J(V,Q,re)}catch{}if(K.dangling)return}return ce.isDirectory()?D(V,Q,ce.mode&U,re):F(V,Q,ce.mode&U)}async function D(V,Q,re,ce){await a.promises.mkdir(Q,{recursive:!0,mode:re});const K=await l(V);for(const j of K)await A((0,p.$jc)(V,j),(0,p.$jc)(Q,j),ce)}async function F(V,Q,re){await a.promises.copyFile(V,Q),await a.promises.chmod(Q,re)}async function J(V,Q,re){let ce=await a.promises.readlink(V);(0,B.$Eg)(ce,re.root.source,!r.$l)&&(ce=(0,p.$jc)(re.root.target,ce.substr(re.root.source.length+1))),await a.promises.symlink(ce,Q)}e.Promises=new class{get read(){return(V,Q,re,ce,K)=>new Promise((j,Y)=>{a.read(V,Q,re,ce,K,(ee,le,G)=>ee?Y(ee):j({bytesRead:le,buffer:G}))})}get write(){return(V,Q,re,ce,K)=>new Promise((j,Y)=>{a.write(V,Q,re,ce,K,(ee,le,G)=>ee?Y(ee):j({bytesWritten:le,buffer:G}))})}get fdatasync(){return(0,S.promisify)(a.fdatasync)}get open(){return(0,S.promisify)(a.open)}get close(){return(0,S.promisify)(a.close)}get realpath(){return(0,S.promisify)(a.realpath)}async exists(V){try{return await a.promises.access(V),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return o}get writeFile(){return _}get rm(){return u}get rename(){return q}get copy(){return y}}}),define(he[60],fe([0,1,21,5,28]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=n,e.$xm=w,a=Se(a),t=Se(t),S=Se(S);const $=/^\d+$/,B=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var p;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(p||(p={}));let r;switch(process.arch){case"ia32":r=p.x86;break;case"arm":case"arm64":r=p.ARM;break;default:r=p.x64;break}let L;process.env.PROCESSOR_ARCHITEW6432?L=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?p.ARM:p.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?L=p.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?L=p.x86:L=p.x64;class b{constructor(o,s,i){this.exePath=o,this.displayName=s,this.a=i}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:v=!1}={}){return v?r===p.x64?process.env["ProgramFiles(x86)"]||null:L===p.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:v=!1,findPreview:o=!1}={}){const s=d({useAlternateBitness:v});if(!s)return null;const i=t.$jc(s,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(i))return null;let g=-1,_=null;for(const k of await S.Promises.readdir(i)){let R=-1;if(o){const q=k.indexOf("-");if(q<0)continue;const I=k.substring(0,q);if(!$.test(I)||k.substring(q+1)!=="preview")continue;R=parseInt(I,10)}else{if(!$.test(k))continue;R=parseInt(k,10)}if(R<=g)continue;const M=t.$jc(i,k,"pwsh.exe");await S.SymlinkSupport.existsFile(M)&&(_=M,g=R)}if(!_)return null;const C=s.includes("x86")?" (x86)":"",E=o?" Preview":"";return new b(_,`PowerShell${E}${C}`,!0)}async function c({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const o=t.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:s,pwshMsixName:i}=v?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:B,pwshMsixName:"PowerShell (Store)"};for(const g of await S.Promises.readdir(o))if(s.test(g)){const _=t.$jc(o,g,"pwsh.exe");return new b(_,i)}return null}function h(){const v=t.$jc(a.homedir(),".dotnet","tools","pwsh.exe");return new b(v,".NET Core PowerShell Global Tool")}function f(){const v=t.$jc(process.env.windir,r===p.x86&&L!==p.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(v,"Windows PowerShell",!0)}async function*l(){let v=await u();v&&(yield v),v=await u({useAlternateBitness:!0}),v&&(yield v),v=await c(),v&&(yield v),v=h(),v&&(yield v),v=await u({findPreview:!0}),v&&(yield v),v=await c({findPreview:!0}),v&&(yield v),v=await u({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=f(),v&&(yield v)}async function*n(){for await(const v of l())await v.exists()&&(yield v)}async function w(){for await(const v of n())return v;return null}}),define(he[36],fe([0,1,35,5,3,15,32,9,28]),function(ie,e,a,t,S,$,B,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=r,e.$zm=L,t=Se(t),S=Se(S),$=Se($),P=Se(P),p=Se(p),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return B.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return B.TerminateResponseCode}});function r(d=$.env){return d.comspec||"cmd.exe"}function L(d){let u=[],c=!1;const h=function(f){if(c){u.push(f);return}(!d.send(f,n=>{if(n&&console.error(n),c=!1,u.length>0){const w=u.slice(0);u=[],w.forEach(v=>h(v))}})||S.$j)&&(c=!0)};return{send:h}}var b;(function(d){async function u(c,h,f){if(t.$ic(c))return c;if(h===void 0&&(h=$.cwd()),t.$mc(c)!=="."||(f===void 0&&P.$eg($.env.PATH)&&(f=$.env.PATH.split(t.$tc)),f===void 0||f.length===0))return t.$jc(h,c);async function n(w){if(await p.Promises.exists(w)){let v;try{v=await a.promises.stat(w)}catch(o){o.message.startsWith("EACCES")&&(v=await a.promises.lstat(w))}return v?!v.isDirectory():!1}return!1}for(const w of f){let v;if(t.$ic(w)?v=t.$jc(w,c):v=t.$jc(h,w,c),await n(v))return v;let o=v+".com";if(await n(o)||(o=v+".exe",await n(o)))return o}return t.$jc(h,c)}d.findExecutable=u})(b||(e.win32=b={}))}),define(he[61],fe([0,1,29,20]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=S;function S(B){return new Promise((P,p)=>{let r;const L=new Map;function b(u,c,h,f,l){const n=L.get(c);if(u===B||n){const w={name:d(h),cmd:h,pid:u,ppid:c,load:f,mem:l};L.set(u,w),u===B&&(r=w),n&&(n.children||(n.children=[]),n.children.push(w),n.children.length>1&&(n.children=n.children.sort((v,o)=>v.pid-o.pid)))}}function d(u){const c=/--utility-sub-type=network/i,h=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,n=/--type=([a-zA-Z-]+)/;if(h.exec(u))return"electron-crash-reporter";if(f.exec(u))return"winpty-agent";if(l.exec(u))return"conpty-agent";let w=n.exec(u);if(w&&w.length===2)return w[1]==="renderer"?"window":w[1]==="utility"?c.exec(u)?"utility-network-service":"utility-process":w[1]==="extensionHost"?"extension-host":w[1];const v=/[a-zA-Z-]+\.js/g;let o="";do w=v.exec(u),w&&(o+=w+" ");while(w);return o&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${o})`:u}if(process.platform==="win32"){const u=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,h)=>{ie(["@vscode/windows-process-tree"],c,h)}).then(Se).then(c=>{c.getProcessList(B,h=>{if(!h){p(new Error(`Root process ${B} not found`));return}c.getProcessCpuUsage(h,f=>{const l=new Map;f.forEach(n=>{const w=u(n.commandLine||"");l.set(n.pid,{name:d(w),cmd:w,pid:n.pid,ppid:n.ppid,load:n.cpu||0,mem:n.memory||0})}),r=l.get(B),r?(l.forEach(n=>{const w=l.get(n.ppid);w&&(w.children||(w.children=[]),w.children.push(n))}),l.forEach(n=>{n.children&&(n.children=n.children.sort((w,v)=>w.pid-v.pid))}),P(r)):p(new Error(`Root process ${B} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let u=function(){let c=[r];const h=[];for(;c.length;){const l=c.shift();l&&(h.push(l.pid),l.children&&(c=c.concat(l.children)))}let f=JSON.stringify(t.$Zg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+h.join(" "),(0,a.exec)(f,{},(l,n,w)=>{if(l||w)p(l||new Error(w.toString()));else{const v=n.toString().split(`
`);for(let o=0;o<h.length;o++){const s=L.get(h[o]);s.load=parseFloat(v[o])}if(!r){p(new Error(`Root process ${B} not found`));return}P(r)}})};(0,a.exec)("which ps",{},(c,h,f)=>{if(c||f)if(process.platform!=="linux")p(c||new Error(f.toString()));else{const l=JSON.stringify(t.$Zg.asFileUri("vs/base/node/ps.sh").fsPath);(0,a.exec)(l,{},(n,w,v)=>{n||v?p(n||new Error(v.toString())):($(w,b),u())})}else{const l=h.toString().trim();(0,a.exec)(`${l} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(w,v,o)=>{w||o&&!o.includes("screen size is bogus")?p(w||new Error(o.toString())):($(v,b),process.platform==="linux"?u():r?P(r):p(new Error(`Root process ${B} not found`)))})}})}})}function $(B,P){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,r=B.toString().split(`
`);for(const L of r){const b=p.exec(L.trim());b&&b.length===6&&P(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(he[62],fe([0,1,21,3,60,36]),function(ie,e,a,t,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=B,t=Se(t),$=Se($);async function B(b,d){return b===t.OperatingSystem.Windows?t.$j?L():$.$ym(d):p(b,d)}let P=null;function p(b,d){if(t.$l&&b===t.OperatingSystem.Macintosh||t.$k&&b===t.OperatingSystem.Linux)return"/bin/bash";if(!P){let u;if(t.$j)u="/bin/bash";else{if(u=d.SHELL,!u)try{u=(0,a.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}P=u}return P}let r=null;async function L(){return r||(r=(await(0,S.$xm)()).exePath),r}});var pe=this&&this.__decorate||function(ie,e,a,t){var S=arguments.length,$=S<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,a):t,B;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")$=Reflect.decorate(ie,e,a,t);else for(var P=ie.length-1;P>=0;P--)(B=ie[P])&&($=(S<3?B($):S>3?B(e,a,$):B(e,a))||$);return S>3&&$&&Object.defineProperty(e,a,$),$};define(he[30],fe([0,1,17,11,19,18,14,7,4,2,57,10,9]),function(ie,e,a,t,S,$,B,P,p,r,L,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=E,e.$gi=k,e.$li=U,e.$mi=A,b=Se(b);var u;(function(K){K[K.Promise=100]="Promise",K[K.PromiseCancel=101]="PromiseCancel",K[K.EventListen=102]="EventListen",K[K.EventDispose=103]="EventDispose"})(u||(u={}));function c(K){switch(K){case u.Promise:return"req";case u.PromiseCancel:return"cancel";case u.EventListen:return"subscribe";case u.EventDispose:return"unsubscribe"}}var h;(function(K){K[K.Initialize=200]="Initialize",K[K.PromiseSuccess=201]="PromiseSuccess",K[K.PromiseError=202]="PromiseError",K[K.PromiseErrorObj=203]="PromiseErrorObj",K[K.EventFire=204]="EventFire"})(h||(h={}));function f(K){switch(K){case h.Initialize:return"init";case h.PromiseSuccess:return"reply:";case h.PromiseError:case h.PromiseErrorObj:return"replyErr:";case h.EventFire:return"event:"}}var l;(function(K){K[K.Uninitialized=0]="Uninitialized",K[K.Idle=1]="Idle"})(l||(l={}));function n(K){let j=0;for(let Y=0;;Y+=7){const ee=K.read(1);if(j|=(ee.buffer[0]&127)<<Y,!(ee.buffer[0]&128))return j}}const w=g(0);function v(K,j){if(j===0){K.write(w);return}let Y=0;for(let le=j;le!==0;le=le>>>7)Y++;const ee=S.$Ne.alloc(Y);for(let le=0;j!==0;le++)ee.buffer[le]=j&127,j=j>>>7,j>0&&(ee.buffer[le]|=128);K.write(ee)}class o{constructor(j){this.b=j,this.a=0}read(j){const Y=this.b.slice(this.a,this.a+j);return this.a+=Y.byteLength,Y}}e.$di=o;class s{constructor(){this.a=[]}get buffer(){return S.$Ne.concat(this.a)}write(j){this.a.push(j)}}e.$ei=s;var i;(function(K){K[K.Undefined=0]="Undefined",K[K.String=1]="String",K[K.Buffer=2]="Buffer",K[K.VSBuffer=3]="VSBuffer",K[K.Array=4]="Array",K[K.Object=5]="Object",K[K.Int=6]="Int"})(i||(i={}));function g(K){const j=S.$Ne.alloc(1);return j.writeUInt8(K,0),j}const _={Undefined:g(i.Undefined),String:g(i.String),Buffer:g(i.Buffer),VSBuffer:g(i.VSBuffer),Array:g(i.Array),Object:g(i.Object),Uint:g(i.Int)},C=typeof Buffer<"u";function E(K,j){if(typeof j>"u")K.write(_.Undefined);else if(typeof j=="string"){const Y=S.$Ne.fromString(j);K.write(_.String),v(K,Y.byteLength),K.write(Y)}else if(C&&Buffer.isBuffer(j)){const Y=S.$Ne.wrap(j);K.write(_.Buffer),v(K,Y.byteLength),K.write(Y)}else if(j instanceof S.$Ne)K.write(_.VSBuffer),v(K,j.byteLength),K.write(j);else if(Array.isArray(j)){K.write(_.Array),v(K,j.length);for(const Y of j)E(K,Y)}else if(typeof j=="number"&&(j|0)===j)K.write(_.Uint),v(K,j);else{const Y=S.$Ne.fromString(JSON.stringify(j));K.write(_.Object),v(K,Y.byteLength),K.write(Y)}}function k(K){switch(K.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return K.read(n(K)).toString();case i.Buffer:return K.read(n(K)).buffer;case i.VSBuffer:return K.read(n(K));case i.Array:{const Y=n(K),ee=[];for(let le=0;le<Y;le++)ee.push(k(K));return ee}case i.Object:return JSON.parse(K.read(n(K)).toString());case i.Int:return n(K)}}class R{constructor(j,Y,ee=null,le=1e3){this.h=j,this.j=Y,this.k=ee,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:h.Initialize})}registerChannel(j,Y){this.b.set(j,Y),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case h.Initialize:{const Y=this.o([j.type]);this.k?.logOutgoing(Y,0,M.OtherSide,f(j.type));return}case h.PromiseSuccess:case h.PromiseError:case h.EventFire:case h.PromiseErrorObj:{const Y=this.o([j.type,j.id],j.data);this.k?.logOutgoing(Y,j.id,M.OtherSide,f(j.type),j.data);return}}}o(j,Y=void 0){const ee=new s;return E(ee,j),E(ee,Y),this.p(ee.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const Y=new o(j),ee=k(Y),le=k(Y),G=ee[0];switch(G){case u.Promise:return this.k?.logIncoming(j.byteLength,ee[1],M.OtherSide,`${c(G)}: ${ee[2]}.${ee[3]}`,le),this.s({type:G,id:ee[1],channelName:ee[2],name:ee[3],arg:le});case u.EventListen:return this.k?.logIncoming(j.byteLength,ee[1],M.OtherSide,`${c(G)}: ${ee[2]}.${ee[3]}`,le),this.t({type:G,id:ee[1],channelName:ee[2],name:ee[3],arg:le});case u.PromiseCancel:return this.k?.logIncoming(j.byteLength,ee[1],M.OtherSide,`${c(G)}`),this.u({type:G,id:ee[1]});case u.EventDispose:return this.k?.logIncoming(j.byteLength,ee[1],M.OtherSide,`${c(G)}`),this.u({type:G,id:ee[1]})}}s(j){const Y=this.b.get(j.channelName);if(!Y){this.v(j);return}const ee=new $.$we;let le;try{le=Y.call(this.j,j.name,j.arg,ee.token)}catch(me){le=Promise.reject(me)}const G=j.id;le.then(me=>{this.m({id:G,data:me,type:h.PromiseSuccess})},me=>{me instanceof Error?this.m({id:G,data:{message:me.message,name:me.name,stack:me.stack?me.stack.split(`
`):void 0},type:h.PromiseError}):this.m({id:G,data:me,type:h.PromiseErrorObj})}).finally(()=>{ae.dispose(),this.d.delete(j.id)});const ae=(0,r.$Sc)(()=>ee.cancel());this.d.set(j.id,ae)}t(j){const Y=this.b.get(j.channelName);if(!Y){this.v(j);return}const ee=j.id,G=Y.listen(this.j,j.name,j.arg)(ae=>this.m({id:ee,data:ae,type:h.EventFire}));this.d.set(j.id,G)}u(j){const Y=this.d.get(j.id);Y&&(Y.dispose(),this.d.delete(j.id))}v(j){let Y=this.g.get(j.channelName);Y||(Y=[],this.g.set(j.channelName,Y));const ee=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===u.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:h.PromiseError})},this.l);Y.push({request:j,timeoutTimer:ee})}w(j){const Y=this.g.get(j);if(Y){for(const ee of Y)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case u.Promise:this.s(ee.request);break;case u.EventListen:this.t(ee.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,r.$Pc)(this.d.values()),this.d.clear()}}e.$hi=R;var M;(function(K){K[K.LocalSide=0]="LocalSide",K[K.OtherSide=1]="OtherSide"})(M||(e.RequestInitiator=M={}));class q{constructor(j,Y=null){this.l=j,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=Y}getChannel(j){const Y=this;return{call(ee,le,G){return Y.a?Promise.reject(new P.$4):Y.m(j,ee,le,G)},listen(ee,le){return Y.a?p.Event.None:Y.o(j,ee,le)}}}m(j,Y,ee,le=$.CancellationToken.None){const G=this.g++,ae=u.Promise,me={id:G,type:ae,channelName:j,name:Y,arg:ee};if(le.isCancellationRequested)return Promise.reject(new P.$4);let te;return new Promise((W,oe)=>{if(le.isCancellationRequested)return oe(new P.$4);const N=()=>{const H=Z=>{switch(Z.type){case h.PromiseSuccess:this.f.delete(G),W(Z.data);break;case h.PromiseError:{this.f.delete(G);const ne=new Error(Z.data.message);ne.stack=Array.isArray(Z.data.stack)?Z.data.stack.join(`
`):Z.data.stack,ne.name=Z.data.name,oe(ne);break}case h.PromiseErrorObj:this.f.delete(G),oe(Z.data);break}};this.f.set(G,H),this.p(me)};let X=null;this.b===l.Idle?N():(X=(0,t.$sh)(H=>this.u()),X.then(()=>{X=null,N()}));const T=()=>{X?(X.cancel(),X=null):this.p({id:G,type:u.PromiseCancel}),oe(new P.$4)},O=le.onCancellationRequested(T);te=(0,r.$Rc)((0,r.$Sc)(T),O),this.d.add(te)}).finally(()=>{te.dispose(),this.d.delete(te)})}o(j,Y,ee){const le=this.g++,G=u.EventListen,ae={id:le,type:G,channelName:j,name:Y,arg:ee};let me=null;const te=new p.$le({onWillAddFirstListener:()=>{me=(0,t.$sh)(W=>this.u()),me.then(()=>{me=null,this.d.add(te),this.p(ae)})},onDidRemoveLastListener:()=>{me?(me.cancel(),me=null):(this.d.delete(te),this.p({id:le,type:u.EventDispose}))}}),m=W=>te.fire(W.data);return this.f.set(le,m),te.event}p(j){switch(j.type){case u.Promise:case u.EventListen:{const Y=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(Y,j.id,M.LocalSide,`${c(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case u.PromiseCancel:case u.EventDispose:{const Y=this.q([j.type,j.id]);this.j?.logOutgoing(Y,j.id,M.LocalSide,c(j.type));return}}}q(j,Y=void 0){const ee=new s;return E(ee,j),E(ee,Y),this.r(ee.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const Y=new o(j),ee=k(Y),le=k(Y),G=ee[0];switch(G){case h.Initialize:return this.j?.logIncoming(j.byteLength,0,M.LocalSide,f(G)),this.t({type:ee[0]});case h.PromiseSuccess:case h.PromiseError:case h.EventFire:case h.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,ee[1],M.LocalSide,f(G),le),this.t({type:ee[0],id:ee[1],data:le})}}t(j){if(j.type===h.Initialize){this.b=l.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,r.$Pc)(this.d.values()),this.d.clear()}}e.$ii=q,pe([B.$0h],q.prototype,"onDidInitializePromise",null);class I{get connections(){const j=[];return this.f.forEach(Y=>j.push(Y)),j}constructor(j,Y,ee){this.a=new Map,this.f=new Set,this.g=new p.$le,this.onDidAddConnection=this.g.event,this.h=new p.$le,this.onDidRemoveConnection=this.h.event,this.j=new r.$Tc,this.j.add(j(({protocol:le,onDidClientDisconnect:G})=>{const ae=p.Event.once(le.onMessage);this.j.add(ae(me=>{const te=new o(me),m=k(te),W=new R(le,m,Y,ee),oe=new q(le,Y);this.a.forEach((X,T)=>W.registerChannel(T,X));const N={channelServer:W,channelClient:oe,ctx:m};this.f.add(N),this.g.fire(N),this.j.add(G(()=>{W.dispose(),oe.dispose(),this.f.delete(N),this.h.fire(N)}))}))}))}getChannel(j,Y){const ee=this;return{call(le,G,ae){let me;if((0,d.$sg)(Y)){const m=(0,a.$2b)(ee.connections.filter(Y));me=m?Promise.resolve(m):p.Event.toPromise(p.Event.filter(ee.onDidAddConnection,Y))}else me=Y.routeCall(ee,le,G);const te=me.then(m=>m.channelClient.getChannel(j));return U(te).call(le,G,ae)},listen(le,G){if((0,d.$sg)(Y))return ee.k(j,Y,le,G);const ae=Y.routeEvent(ee,le,G).then(me=>me.channelClient.getChannel(j));return U(ae).listen(le,G)}}}k(j,Y,ee,le){const G=this;let ae;const me=new p.$le({onWillAddFirstListener:()=>{ae=new r.$Tc;const te=new p.$re,m=new Map,W=N=>{const T=N.channelClient.getChannel(j).listen(ee,le),O=te.add(T);m.set(N,O)},oe=N=>{const X=m.get(N);X&&(X.dispose(),m.delete(N))};G.connections.filter(Y).forEach(W),p.Event.filter(G.onDidAddConnection,Y)(W,void 0,ae),G.onDidRemoveConnection(oe,void 0,ae),te.event(me.fire,me,ae),ae.add(te)},onDidRemoveLastListener:()=>{ae?.dispose(),ae=void 0}});return me.event}registerChannel(j,Y){this.a.set(j,Y);for(const ee of this.f)ee.channelServer.registerChannel(j,Y)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=I;class y{constructor(j,Y,ee=null){const le=new s;E(le,Y),j.send(le.buffer),this.a=new q(j,ee),this.d=new R(j,Y,ee)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,Y){this.d.registerChannel(j,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=y;function U(K){return{call(j,Y,ee){return K.then(le=>le.call(j,Y,ee))},listen(j,Y){const ee=new p.$ue;return K.then(le=>ee.input=le.listen(j,Y)),ee.event}}}function A(K){let j=!1;return{call(Y,ee,le){return j?K.call(Y,ee,le):(0,t.$Gh)(0).then(()=>j=!0).then(()=>K.call(Y,ee,le))},listen(Y,ee){if(j)return K.listen(Y,ee);const le=new p.$ue;return(0,t.$Gh)(0).then(()=>j=!0).then(()=>le.input=K.listen(Y,ee)),le.event}}}class D{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const Y of j.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await p.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$ni=D;var F;(function(K){function j(G,ae,me){const te=G,m=me&&me.disableMarshalling,W=new Map;for(const oe in te)ee(oe)&&W.set(oe,p.Event.buffer(te[oe],!0,void 0,ae));return new class{listen(oe,N,X){const T=W.get(N);if(T)return T;const O=te[N];if(typeof O=="function"){if(le(N))return O.call(te,X);if(ee(N))return W.set(N,p.Event.buffer(te[N],!0,void 0,ae)),W.get(N)}throw new P.$ab(`Event not found: ${N}`)}call(oe,N,X){const T=te[N];if(typeof T=="function"){if(!m&&Array.isArray(X))for(let H=0;H<X.length;H++)X[H]=(0,L.$ci)(X[H]);let O=T.apply(te,X);return O instanceof Promise||(O=Promise.resolve(O)),O}throw new P.$ab(`Method not found: ${N}`)}}}K.fromService=j;function Y(G,ae){const me=ae&&ae.disableMarshalling;return new Proxy({},{get(te,m){if(typeof m=="string")return ae?.properties?.has(m)?ae.properties.get(m):le(m)?function(W){return G.listen(m,W)}:ee(m)?G.listen(m):async function(...W){let oe;ae&&!(0,d.$ng)(ae.context)?oe=[ae.context,...W]:oe=W;const N=await G.call(m,oe);return me?N:(0,L.$ci)(N)};throw new P.$ab(`Property not found: ${String(m)}`)}})}K.toService=Y;function ee(G){return G[0]==="o"&&G[1]==="n"&&b.$Ef(G.charCodeAt(2))}function le(G){return/^onDynamic/.test(G)&&b.$Ef(G.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(K){if(Array.isArray(K))return K;if(K&&typeof K=="object"&&typeof K.toString=="function"){const j=K.toString();if(j!=="[object Object]")return j}return K}function Q(K){return Array.isArray(K)?K.map(V):V(K)}function re(K,j,Y,ee,le,G,ae){ae=Q(ae);const me=J[le],te=me[ee%me.length];let m=[`%c[${K}]%c[${String(j).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${te}`];/\($/.test(G)?(m=m.concat(ae),m.push(")")):m.push(ae),console.log.apply(console,m)}class ce{constructor(j,Y){this.d=j,this.f=Y,this.a=0,this.b=0}logOutgoing(j,Y,ee,le,G){this.b+=j,re(this.d,this.b,j,Y,ee,le,G)}logIncoming(j,Y,ee,le,G){this.a+=j,re(this.f,this.a,j,Y,ee,le,G)}}e.$oi=ce}),define(he[63],fe([0,1,29,11,19,18,56,7,4,2,33,36,32,30]),function(ie,e,a,t,S,$,B,P,p,r,L,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=void 0,P=Se(P);class c extends u.$hi{constructor(l){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",n=>S.$Ne.wrap(Buffer.from(n,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$hr=c;class h{constructor(l,n){this.i=l,this.j=n,this.c=new Set,this.g=new Map,this.h=new p.$le,this.onDidProcessExit=this.h.event;const w=n&&n.timeout?n.timeout:6e4;this.b=new t.$Ch(w),this.d=null,this.f=null}getChannel(l){const n=this;return{call(w,v,o){return n.k(l,w,v,o)},listen(w,v){return n.l(l,w,v)}}}k(l,n,w,v=$.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(P.$5());this.b.cancel();const o=this.n(l),s=(0,t.$sh)(_=>o.call(n,w,_)),i=v.onCancellationRequested(()=>s.cancel()),g=(0,r.$Sc)(()=>s.cancel());return this.c.add(g),s.finally(()=>{i.dispose(),this.c.delete(g),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(l,n,w){if(!this.b)return p.Event.None;this.b.cancel();let v;const o=new p.$le({onWillAddFirstListener:()=>{v=this.n(l).listen(n,w)(o.fire,o),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,L.$eo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(E=>!/^--inspect(-brk)?=/.test(E)).filter(E=>!E.startsWith("--vscode-"))),(0,d.$mm)(n.env),this.d=(0,a.fork)(this.i,l,n);const w=new p.$le,o=p.Event.fromNodeEventEmitter(this.d,"message",E=>E)(E=>{if((0,B.$dr)(E)){(0,B.log)(E,`IPC Library: ${this.j.serverName}`);return}w.fire(S.$Ne.wrap(Buffer.from(E,"base64")))}),s=this.j.useQueue?(0,b.$zm)(this.d):this.d,i=E=>this.d&&this.d.connected&&s.send(E.buffer.toString("base64")),g=w.event,_={send:i,onMessage:g};this.f=new u.$ii(_);const C=()=>this.o();process.once("exit",C),this.d.on("error",E=>console.warn('IPC "'+this.j.serverName+'" errored with '+E)),this.d.on("exit",(E,k)=>{process.removeListener("exit",C),o.dispose(),this.c.forEach(R=>(0,r.$Pc)(R)),this.c.clear(),E!==0&&k!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+E+" and signal "+k),this.b?.cancel(),this.o(),this.h.fire({code:E,signal:k})})}return this.f}n(l){let n=this.g.get(l);return n||(n=this.m.getChannel(l),this.g.set(l,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$ir=h}),define(he[37],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9X=a;function a(t){return!!t.parentPort}}),define(he[64],fe([0,1,37,19,30,4,9,17]),function(ie,e,a,t,S,$,B,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0X=void 0,e.$$X=L;class p{constructor(d){this.a=d,this.onMessage=$.Event.fromNodeEventEmitter(this.a,"message",u=>u.data?t.$Ne.wrap(u.data):t.$Ne.alloc(0)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}class r extends S.$ji{static b(d){(0,B.$og)((0,a.$9X)(process),"Electron Utility Process");const u=new $.$le;return process.parentPort.on("message",c=>{if(d?.handledClientConnection(c))return;const h=(0,P.$Nb)(c.ports);h&&u.fire(h)}),$.Event.map(u.event,c=>({protocol:new p(c),onDidClientDisconnect:$.Event.fromNodeEventEmitter(c,"close")}))}constructor(d){super(r.b(d))}}e.$0X=r;function L(b,d,u){const c=h=>{h.data===d&&(b.removeListener("message",c),u())};b.on("message",c)}}),define(he[12],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=S,e.localize2=B;const a=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function t(P,p){let r;return p.length===0?r=P:r=P.replace(/\{(\d+)\}/g,(L,b)=>{const d=b[0],u=p[d];let c=L;return typeof u=="string"?c=u:(typeof u=="number"||typeof u=="boolean"||u===void 0||u===null)&&(c=String(u)),c}),a&&(r="\uFF3B"+r.replace(/[aouei]/g,"$&$&")+"\uFF3D"),r}function S(P,p,...r){return t(typeof P=="number"?$(P,p):p,r)}function $(P,p){const r=globalThis._VSCODE_NLS_MESSAGES?.[P];if(typeof r!="string"){if(typeof p=="string")return p;throw new Error(`!!! NLS MISSING: ${P} !!!`)}return r}function B(P,p,...r){let L;typeof P=="number"?L=$(P,p):L=p;const b=t(L,r);return{value:b,original:p===L?b:t(p,r)}}}),define(he[65],fe([0,1,12]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=r,e.$3m=L,e.$4m=b;const t=60,S=t*60,$=S*24,B=$*7,P=$*30,p=$*365;function r(d,u,c,h){typeof d!="number"&&(d=d.getTime());const f=Math.round((new Date().getTime()-d)/1e3);if(f<-30)return(0,a.localize)(12987,null,r(new Date().getTime()+f*1e3,!1));if(!h&&f<30)return(0,a.localize)(12988,null);let l;return f<t?(l=f,u?l===1?c?(0,a.localize)(12989,null,l):(0,a.localize)(12990,null,l):c?(0,a.localize)(12991,null,l):(0,a.localize)(12992,null,l):l===1?c?(0,a.localize)(12993,null,l):(0,a.localize)(12994,null,l):c?(0,a.localize)(12995,null,l):(0,a.localize)(12996,null,l)):f<S?(l=Math.floor(f/t),u?l===1?c?(0,a.localize)(12997,null,l):(0,a.localize)(12998,null,l):c?(0,a.localize)(12999,null,l):(0,a.localize)(13e3,null,l):l===1?c?(0,a.localize)(13001,null,l):(0,a.localize)(13002,null,l):c?(0,a.localize)(13003,null,l):(0,a.localize)(13004,null,l)):f<$?(l=Math.floor(f/S),u?l===1?c?(0,a.localize)(13005,null,l):(0,a.localize)(13006,null,l):c?(0,a.localize)(13007,null,l):(0,a.localize)(13008,null,l):l===1?c?(0,a.localize)(13009,null,l):(0,a.localize)(13010,null,l):c?(0,a.localize)(13011,null,l):(0,a.localize)(13012,null,l)):f<B?(l=Math.floor(f/$),u?l===1?(0,a.localize)(13013,null,l):(0,a.localize)(13014,null,l):l===1?(0,a.localize)(13015,null,l):(0,a.localize)(13016,null,l)):f<P?(l=Math.floor(f/B),u?l===1?c?(0,a.localize)(13017,null,l):(0,a.localize)(13018,null,l):c?(0,a.localize)(13019,null,l):(0,a.localize)(13020,null,l):l===1?c?(0,a.localize)(13021,null,l):(0,a.localize)(13022,null,l):c?(0,a.localize)(13023,null,l):(0,a.localize)(13024,null,l)):f<p?(l=Math.floor(f/P),u?l===1?c?(0,a.localize)(13025,null,l):(0,a.localize)(13026,null,l):c?(0,a.localize)(13027,null,l):(0,a.localize)(13028,null,l):l===1?c?(0,a.localize)(13029,null,l):(0,a.localize)(13030,null,l):c?(0,a.localize)(13031,null,l):(0,a.localize)(13032,null,l)):(l=Math.floor(f/p),u?l===1?c?(0,a.localize)(13033,null,l):(0,a.localize)(13034,null,l):c?(0,a.localize)(13035,null,l):(0,a.localize)(13036,null,l):l===1?c?(0,a.localize)(13037,null,l):(0,a.localize)(13038,null,l):c?(0,a.localize)(13039,null,l):(0,a.localize)(13040,null,l))}function L(d,u){const c=Math.abs(d/1e3);return c<1?u?(0,a.localize)(13041,null,d):(0,a.localize)(13042,null,d):c<t?u?(0,a.localize)(13043,null,Math.round(d)/1e3):(0,a.localize)(13044,null,Math.round(d)/1e3):c<S?u?(0,a.localize)(13045,null,Math.round(d/(1e3*t))):(0,a.localize)(13046,null,Math.round(d/(1e3*t))):c<$?u?(0,a.localize)(13047,null,Math.round(d/(1e3*S))):(0,a.localize)(13048,null,Math.round(d/(1e3*S))):(0,a.localize)(13049,null,Math.round(d/(1e3*$)))}function b(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[66],fe([0,1,17,9,12]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=p,e.$rj=r,e.$sj=L,a=Se(a),t=Se(t),S=Se(S);function $(b,d){return d&&(b.stack||b.stacktrace)?S.localize(12981,null,P(b),B(b.stack)||B(b.stacktrace)):P(b)}function B(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?S.localize(12982,null,b.message):b.message||S.localize(12983,null)}function p(b=null,d=!1){if(!b)return S.localize(12984,null);if(Array.isArray(b)){const u=a.$Gb(b),c=p(u[0],d);return u.length>1?S.localize(12985,null,c,u.length):c}if(t.$eg(b))return b;if(b.detail){const u=b.detail;if(u.error)return $(u.error,d);if(u.exception)return $(u.exception,d)}return b.stack?$(b,d):b.message?b.message:S.localize(12986,null)}function r(b){const d=b;return d instanceof Error&&Array.isArray(d.actions)}function L(b,d){let u;return typeof b=="string"?u=new Error(b):u=b,u.actions=d,u}}),define(he[67],fe([0,1,13,7,12]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var $;(function(L){L[L.LParen=0]="LParen",L[L.RParen=1]="RParen",L[L.Neg=2]="Neg",L[L.Eq=3]="Eq",L[L.NotEq=4]="NotEq",L[L.Lt=5]="Lt",L[L.LtEq=6]="LtEq",L[L.Gt=7]="Gt",L[L.GtEq=8]="GtEq",L[L.RegexOp=9]="RegexOp",L[L.RegexStr=10]="RegexStr",L[L.True=11]="True",L[L.False=12]="False",L[L.In=13]="In",L[L.Not=14]="Not",L[L.And=15]="And",L[L.Or=16]="Or",L[L.Str=17]="Str",L[L.QuotedStr=18]="QuotedStr",L[L.Error=19]="Error",L[L.EOF=20]="EOF"})($||(e.TokenType=$={}));function B(...L){switch(L.length){case 1:return(0,S.localize)(11585,null,L[0]);case 2:return(0,S.localize)(11586,null,L[0],L[1]);case 3:return(0,S.localize)(11587,null,L[0],L[1],L[2]);default:return}}const P=(0,S.localize)(11588,null),p=(0,S.localize)(11589,null);class r{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case $.LParen:return"(";case $.RParen:return")";case $.Neg:return"!";case $.Eq:return b.isTripleEq?"===":"==";case $.NotEq:return b.isTripleEq?"!==":"!=";case $.Lt:return"<";case $.LtEq:return"<=";case $.Gt:return">=";case $.GtEq:return">=";case $.RegexOp:return"=~";case $.RegexStr:return b.lexeme;case $.True:return"true";case $.False:return"false";case $.In:return"in";case $.Not:return"not";case $.And:return"&&";case $.Or:return"||";case $.Str:return b.lexeme;case $.QuotedStr:return b.lexeme;case $.Error:return b.lexeme;case $.EOF:return"EOF";default:throw(0,t.$7)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",$.Not],["in",$.In],["false",$.False],["true",$.True]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case a.CharCode.OpenParen:this.k($.LParen);break;case a.CharCode.CloseParen:this.k($.RParen);break;case a.CharCode.ExclamationMark:if(this.h(a.CharCode.Equals)){const d=this.h(a.CharCode.Equals);this.f.push({type:$.NotEq,offset:this.d,isTripleEq:d})}else this.k($.Neg);break;case a.CharCode.SingleQuote:this.o();break;case a.CharCode.Slash:this.q();break;case a.CharCode.Equals:if(this.h(a.CharCode.Equals)){const d=this.h(a.CharCode.Equals);this.f.push({type:$.Eq,offset:this.d,isTripleEq:d})}else this.h(a.CharCode.Tilde)?this.k($.RegexOp):this.l(B("==","=~"));break;case a.CharCode.LessThan:this.k(this.h(a.CharCode.Equals)?$.LtEq:$.Lt);break;case a.CharCode.GreaterThan:this.k(this.h(a.CharCode.Equals)?$.GtEq:$.Gt);break;case a.CharCode.Ampersand:this.h(a.CharCode.Ampersand)?this.k($.And):this.l(B("&&"));break;case a.CharCode.Pipe:this.h(a.CharCode.Pipe)?this.k($.Or):this.l(B("||"));break;case a.CharCode.Space:case a.CharCode.CarriageReturn:case a.CharCode.Tab:case a.CharCode.LineFeed:case a.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k($.EOF),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?a.CharCode.Null:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const d=this.d,u=this.c.substring(this.d,this.e),c={type:$.Error,offset:this.d,lexeme:u};this.g.push({offset:d,lexeme:u,additionalInfo:b}),this.f.push(c)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const d=this.c.substring(this.d,this.e),u=r.b.get(d);u?this.k(u):this.f.push({type:$.Str,lexeme:d,offset:this.d})}}o(){for(;this.j()!==a.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:$.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,d=!1,u=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(p);return}const h=this.c.charCodeAt(b);if(d)d=!1;else if(h===a.CharCode.Slash&&!u){b++;break}else h===a.CharCode.OpenSquareBracket?u=!0:h===a.CharCode.Backslash?d=!0:h===a.CharCode.CloseSquareBracket&&(u=!1);b++}for(;b<this.c.length&&r.a.has(this.c.charCodeAt(b));)b++;this.e=b;const c=this.c.substring(this.d,this.e);this.f.push({type:$.RegexStr,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=r}),define(he[68],fe([0,1,65,14,20,5,15,25,6]),function(ie,e,a,t,S,$,B,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=L,e.$8m=b,e.$5m=/^([^.]+\..+)[:=](.+)$/;class r{get appRoot(){return(0,$.$mc)(S.$Zg.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return p.URI.file((0,$.$jc)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.b.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,P.$gh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$gh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,a.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,$.$jc)(this.userDataPath,"logs",u)}return p.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$gh)(p.URI.file((0,$.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$gh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$gh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$gh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=B.env.VSCODE_PORTABLE;return u?p.URI.file((0,$.$jc)(u,"argv.json")):(0,P.$gh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,$.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,$.$kc)(u):(0,$.$hc)((0,$.$jc)(S.$Zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?p.URI.file((0,$.$kc)(u)):p.URI.file((0,$.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,$.$kc)(u);const c=B.env.VSCODE_EXTENSIONS;if(c)return c;const h=B.env.VSCODE_PORTABLE;return h?(0,$.$jc)(h,"extensions"):(0,P.$gh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(c=>/^[^:/?#]+?:\/\//.test(c)?p.URI.parse(c):p.URI.file((0,$.$hc)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?p.URI.parse(u):p.URI.file((0,$.$hc)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return L(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!B.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.$5m.test(u))}get extensionLogLevel(){const u=[];for(const c of this.args.log||[]){const h=e.$5m.exec(c);h&&h[1]&&h[2]&&u.push([h[1],h[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,P.$gh)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=B.env.VSCODE_PORTABLE;return u?p.URI.file((0,$.$jc)(u,"policy.json")):(0,P.$gh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,c,h){this.a=u,this.b=c,this.c=h,this.editSessionId=this.args.editSessionId}}e.$6m=r,pe([t.$0h],r.prototype,"appRoot",null),pe([t.$0h],r.prototype,"userHome",null),pe([t.$0h],r.prototype,"userDataPath",null),pe([t.$0h],r.prototype,"appSettingsHome",null),pe([t.$0h],r.prototype,"tmpDir",null),pe([t.$0h],r.prototype,"cacheHome",null),pe([t.$0h],r.prototype,"stateResource",null),pe([t.$0h],r.prototype,"userRoamingDataHome",null),pe([t.$0h],r.prototype,"userDataSyncHome",null),pe([t.$0h],r.prototype,"sync",null),pe([t.$0h],r.prototype,"machineSettingsResource",null),pe([t.$0h],r.prototype,"workspaceStorageHome",null),pe([t.$0h],r.prototype,"localHistoryHome",null),pe([t.$0h],r.prototype,"keyboardLayoutResource",null),pe([t.$0h],r.prototype,"argvResource",null),pe([t.$0h],r.prototype,"isExtensionDevelopment",null),pe([t.$0h],r.prototype,"untitledWorkspacesHome",null),pe([t.$0h],r.prototype,"builtinExtensionsPath",null),pe([t.$0h],r.prototype,"extensionsPath",null),pe([t.$0h],r.prototype,"extensionDevelopmentLocationURI",null),pe([t.$0h],r.prototype,"extensionDevelopmentKind",null),pe([t.$0h],r.prototype,"extensionTestsLocationURI",null),pe([t.$0h],r.prototype,"debugExtensionHost",null),pe([t.$0h],r.prototype,"logLevel",null),pe([t.$0h],r.prototype,"extensionLogLevel",null),pe([t.$0h],r.prototype,"serviceMachineIdResource",null),pe([t.$0h],r.prototype,"disableTelemetry",null),pe([t.$0h],r.prototype,"disableWorkspaceTrust",null),pe([t.$0h],r.prototype,"useInMemorySecretStorage",null),pe([t.$0h],r.prototype,"policyFile",null);function L(d,u){return b(d["inspect-extensions"],d["inspect-brk-extensions"],5870,u,d.debugId,d.extensionEnvironment)}function b(d,u,c,h,f,l){const w=Number(u||d)||(h?null:c),v=w?!!u:!1;let o;if(l)try{o=JSON.parse(l)}catch{}return{port:w,break:v,debugId:f,env:o}}});var Ke=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[69],fe([0,1,101,3,12]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=void 0,e.$Dm=P,e.$Em=r,e.$Fm=u,e.$Gm=c,a=Ke(a);const $={o:(0,S.localize)(11522,null),e:(0,S.localize)(11523,null),t:(0,S.localize)(11524,null)};e.$Bm=["tunnel","serve-web"],e.$Cm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(11525,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(11526,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(11527,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(11528,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(11529,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(11530,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(11531,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(11532,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11533,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(11534,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(11535,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(11536,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(11537,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(11538,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(11539,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(11540,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(11541,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(11542,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(11543,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(11544,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(11545,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(11546,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(11547,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(11548,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(11549,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(11550,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(11551,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(11552,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(11553,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(11554,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(11555,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(11556,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,S.localize)(11557,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(11558,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(11559,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(11560,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const B={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(h,f,l=B){const n=h.find(E=>E.length>0&&E[0]!=="-"),w={},v=["_"],o=[],s={};let i;for(const E in f){const k=f[E];k.type==="subcommand"?E===n&&(i=k):(k.alias&&(w[E]=k.alias),k.type==="string"||k.type==="string[]"?(v.push(E),k.deprecates&&v.push(...k.deprecates)):k.type==="boolean"&&(o.push(E),k.deprecates&&o.push(...k.deprecates)),k.global&&(s[E]=k))}if(i&&n){const E=s;for(const q in i.options)E[q]=i.options[q];const k=h.filter(q=>q!==n),R=l.getSubcommandReporter?l.getSubcommandReporter(n):void 0,M=P(k,E,R);return{[n]:M,_:[]}}const g=(0,a.default)(h,{string:v,boolean:o,alias:w}),_={},C=g;_._=g._.map(E=>String(E)).filter(E=>E.length>0),delete C._;for(const E in f){const k=f[E];if(k.type==="subcommand")continue;k.alias&&delete C[k.alias];let R=C[E];if(k.deprecates)for(const M of k.deprecates)C.hasOwnProperty(M)&&(R||(R=C[M],R&&l.onDeprecatedOption(M,k.deprecationMessage||(0,S.localize)(11561,null,E))),delete C[M]);if(typeof R<"u"){if(k.type==="string[]"){if(Array.isArray(R)||(R=[R]),!k.allowEmptyValue){const M=R.filter(q=>q.length>0);M.length!==R.length&&(l.onEmptyValue(E),R=M.length>0?M:void 0)}}else k.type==="string"&&(Array.isArray(R)?(R=R.pop(),l.onMultipleValues(E,R)):!R&&!k.allowEmptyValue&&(l.onEmptyValue(E),R=void 0));_[E]=R,k.deprecationMessage&&l.onDeprecatedOption(E,k.deprecationMessage)}delete C[E]}for(const E in C)l.onUnknownOption(E);return _}function p(h,f){let l="";return f.args&&(Array.isArray(f.args)?l=` <${f.args.join("> <")}>`:l=` <${f.args}>`),f.alias?`-${f.alias} --${h}${l}`:`--${h}${l}`}function r(h,f){const l=[];for(const n in h){const w=h[n],v=p(n,w);l.push([v,w.description])}return L(l,f)}function L(h,f){const n=h.reduce((o,s)=>Math.max(o,s[0].length),12)+2+1;if(f-n<25)return h.reduce((o,s)=>o.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);const w=f-n-1,v=[];for(const o of h){const s=o[0],i=d(o[1],w),g=b(n-s.length-2);v.push("  "+s+g+i[0]);for(let _=1;_<i.length;_++)v.push(b(n)+i[_])}return v}function b(h){return" ".repeat(h)}function d(h,f){const l=[];for(;h.length;){const n=h.length<f?h.length:h.lastIndexOf(" ",f),w=h.slice(0,n).trim();h=h.slice(n),l.push(w)}return l}function u(h,f,l,n,w){const v=process.stdout.isTTY&&process.stdout.columns||80,o=w?.noInputFiles!==!0?`[${(0,S.localize)(11562,null)}...]`:"",s=[`${h} ${l}`];s.push(""),s.push(`${(0,S.localize)(11563,null)}: ${f} [${(0,S.localize)(11564,null)}]${o}`),s.push(""),w?.noPipe!==!0&&(t.$j?s.push((0,S.localize)(11565,null,f)):s.push((0,S.localize)(11566,null,f)),s.push(""));const i={},g=[];for(const _ in n){const C=n[_];if(C.type==="subcommand")C.description&&g.push({command:_,description:C.description});else if(C.description&&C.cat){let E=i[C.cat];E||(i[C.cat]=E={}),E[_]=C}}for(const _ in i){const C=_,E=i[C];E&&(s.push($[C]),s.push(...r(E,v)),s.push(""))}return g.length&&(s.push((0,S.localize)(11567,null)),s.push(...L(g.map(_=>[_.command,_.description]),v)),s.push("")),s.join(`
`)}function c(h,f){return`${h||(0,S.localize)(11568,null)}
${f||(0,S.localize)(11569,null)}
${process.arch}`}}),function(){function ie(e,a,t){function S(B,P){const p=$(B,P),r=[p];return e.isAbsolute(p)||r.unshift(t),e.resolve(...r)}function $(B,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let r=process.env.VSCODE_APPDATA;if(r)return e.join(r,P);const L=B["user-data-dir"];if(L)return L;switch(process.platform){case"win32":if(r=process.env.APPDATA,!r){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");r=e.join(b,"AppData","Roaming")}break;case"darwin":r=e.join(a.homedir(),"Library","Application Support");break;case"linux":r=process.env.XDG_CONFIG_HOME||e.join(a.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(r,P)}return{getUserDataPath:S}}if(typeof define=="function")define(he[70],fe([71,21,15]),function(e,a,t){return ie(e,a,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),a=require("os");module.exports=ie(e,a,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[72],fe([0,1,21,68,70]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=B,e.$$m=P;class $ extends t.$6m{constructor(r,L){super(r,{homeDir:(0,a.homedir)(),tmpDir:(0,a.tmpdir)(),userDataDir:(0,S.getUserDataPath)(r,L.nameShort)},L)}}e.$9m=$;function B(p,r){return(0,t.$8m)(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,r,p.extensionEnvironment)}function P(p,r){return(0,t.$8m)(p["inspect-sharedprocess"],p["inspect-brk-sharedprocess"],5879,r,p.extensionEnvironment)}}),define(he[22],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=S,e.$Gi=$;var a;(function(B){B.serviceIds=new Map,B.DI_TARGET="$di$target",B.DI_DEPENDENCIES="$di$dependencies";function P(p){return p[B.DI_DEPENDENCIES]||[]}B.getServiceDependencies=P})(a||(e._util=a={})),e.$Ei=S("instantiationService");function t(B,P,p){P[a.DI_TARGET]===P?P[a.DI_DEPENDENCIES].push({id:B,index:p}):(P[a.DI_DEPENDENCIES]=[{id:B,index:p}],P[a.DI_TARGET]=P)}function S(B){if(a.serviceIds.has(B))return a.serviceIds.get(B);const P=function(p,r,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,p,L)};return P.toString=()=>B,a.serviceIds.set(B,P),P}function $(B){return B}}),define(he[38],fe([0,1,13,3,10,67,22,12,7]),function(ie,e,a,t,S,$,B,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=L,e.$Ej=g,e.$Fj=_,e.$Yj=G;const r=new Map;r.set("false",!1),r.set("true",!0),r.set("isMac",t.$k),r.set("isLinux",t.$l),r.set("isWindows",t.$j),r.set("isWeb",t.$p),r.set("isMacNative",t.$k&&!t.$p),r.set("isEdge",t.$I),r.set("isFirefox",t.$G),r.set("isChrome",t.$F),r.set("isSafari",t.$H);function L(te,m){if(r.get(te)!==void 0)throw(0,p.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");r.set(te,m)}const b=Object.prototype.hasOwnProperty;var d;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const u={regexParsingWithErrorRecovery:!0},c=(0,P.localize)(11599,null),h=(0,P.localize)(11600,null),f=(0,P.localize)(11601,null),l=(0,P.localize)(11602,null),n=(0,P.localize)(11603,null),w=(0,P.localize)(11604,null),v=(0,P.localize)(11605,null),o=(0,P.localize)(11606,null);class s{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(m=u){this.k=m,this.d=new $.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(m){if(m===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:h});return}this.f=this.d.reset(m).scan(),this.g=0,this.h=[];try{const W=this.l();if(!this.E()){const oe=this.D(),N=oe.type===$.TokenType.Str?w:void 0;throw this.h.push({message:n,offset:oe.offset,lexeme:$.$Aj.getLexeme(oe),additionalInfo:N}),s.c}return W}catch(W){if(W!==s.c)throw W;return}}l(){return this.m()}m(){const m=[this.o()];for(;this.y($.TokenType.Or);){const W=this.o();m.push(W)}return m.length===1?m[0]:i.or(...m)}o(){const m=[this.s()];for(;this.y($.TokenType.And);){const W=this.s();m.push(W)}return m.length===1?m[0]:i.and(...m)}s(){if(this.y($.TokenType.Neg)){const m=this.D();switch(m.type){case $.TokenType.True:return this.z(),E.INSTANCE;case $.TokenType.False:return this.z(),k.INSTANCE;case $.TokenType.LParen:{this.z();const W=this.l();return this.A($.TokenType.RParen,l),W?.negate()}case $.TokenType.Str:return this.z(),U.create(m.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",m)}}return this.t()}t(){const m=this.D();switch(m.type){case $.TokenType.True:return this.z(),i.true();case $.TokenType.False:return this.z(),i.false();case $.TokenType.LParen:{this.z();const W=this.l();return this.A($.TokenType.RParen,l),W}case $.TokenType.Str:{const W=m.lexeme;if(this.z(),this.y($.TokenType.RegexOp)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==$.TokenType.RegexStr)throw this.B("REGEX",N);const X=N.lexeme,T=X.lastIndexOf("/"),O=T===X.length-1?void 0:this.w(X.substring(T+1));let H;try{H=new RegExp(X.substring(1,T),O)}catch{throw this.B("REGEX",N)}return Q.create(W,H)}switch(N.type){case $.TokenType.RegexStr:case $.TokenType.Error:{const X=[N.lexeme];this.z();let T=this.D(),O=0;for(let Ee=0;Ee<N.lexeme.length;Ee++)N.lexeme.charCodeAt(Ee)===a.CharCode.OpenParen?O++:N.lexeme.charCodeAt(Ee)===a.CharCode.CloseParen&&O--;for(;!this.E()&&T.type!==$.TokenType.And&&T.type!==$.TokenType.Or;){switch(T.type){case $.TokenType.LParen:O++;break;case $.TokenType.RParen:O--;break;case $.TokenType.RegexStr:case $.TokenType.QuotedStr:for(let Ee=0;Ee<T.lexeme.length;Ee++)T.lexeme.charCodeAt(Ee)===a.CharCode.OpenParen?O++:N.lexeme.charCodeAt(Ee)===a.CharCode.CloseParen&&O--}if(O<0)break;X.push($.$Aj.getLexeme(T)),this.z(),T=this.D()}const H=X.join(""),Z=H.lastIndexOf("/"),ne=Z===H.length-1?void 0:this.w(H.substring(Z+1));let be;try{be=new RegExp(H.substring(1,Z),ne)}catch{throw this.B("REGEX",N)}return i.regex(W,be)}case $.TokenType.QuotedStr:{const X=N.lexeme;this.z();let T=null;if(!(0,S.$cf)(X)){const O=X.indexOf("/"),H=X.lastIndexOf("/");if(O!==H&&O>=0){const Z=X.slice(O+1,H),ne=X[H+1]==="i"?"i":"";try{T=new RegExp(Z,ne)}catch{throw this.B("REGEX",N)}}}if(T===null)throw this.B("REGEX",N);return Q.create(W,T)}default:throw this.B("REGEX",this.D())}}if(this.y($.TokenType.Not)){this.A($.TokenType.In,f);const N=this.u();return i.notIn(W,N)}switch(this.D().type){case $.TokenType.Eq:{this.z();const N=this.u();if(this.x().type===$.TokenType.QuotedStr)return i.equals(W,N);switch(N){case"true":return i.has(W);case"false":return i.not(W);default:return i.equals(W,N)}}case $.TokenType.NotEq:{this.z();const N=this.u();if(this.x().type===$.TokenType.QuotedStr)return i.notEquals(W,N);switch(N){case"true":return i.not(W);case"false":return i.has(W);default:return i.notEquals(W,N)}}case $.TokenType.Lt:return this.z(),J.create(W,this.u());case $.TokenType.LtEq:return this.z(),V.create(W,this.u());case $.TokenType.Gt:return this.z(),D.create(W,this.u());case $.TokenType.GtEq:return this.z(),F.create(W,this.u());case $.TokenType.In:return this.z(),i.in(W,this.u());default:return i.has(W)}}case $.TokenType.EOF:throw this.h.push({message:v,offset:m.offset,lexeme:"",additionalInfo:o}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const m=this.D();switch(m.type){case $.TokenType.Str:case $.TokenType.QuotedStr:return this.z(),m.lexeme;case $.TokenType.True:return this.z(),"true";case $.TokenType.False:return this.z(),"false";case $.TokenType.In:return this.z(),"in";default:return""}}w(m){return m.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(m){return this.C(m)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(m,W){if(this.C(m))return this.z();throw this.B(W,this.D())}B(m,W,oe){const N=(0,P.localize)(11607,null,m,$.$Aj.getLexeme(W)),X=W.offset,T=$.$Aj.getLexeme(W);return this.h.push({message:N,offset:X,lexeme:T,additionalInfo:oe}),s.c}C(m){return this.D().type===m}D(){return this.f[this.g]}E(){return this.D().type===$.TokenType.EOF}}e.$Cj=s;class i{static false(){return E.INSTANCE}static true(){return k.INSTANCE}static has(m){return R.create(m)}static equals(m,W){return M.create(m,W)}static notEquals(m,W){return y.create(m,W)}static regex(m,W){return Q.create(m,W)}static in(m,W){return q.create(m,W)}static notIn(m,W){return I.create(m,W)}static not(m){return U.create(m)}static and(...m){return K.create(m,null,!0)}static or(...m){return j.create(m,null,!0)}static greater(m,W){return D.create(m,W)}static greaterEquals(m,W){return F.create(m,W)}static smaller(m,W){return J.create(m,W)}static smallerEquals(m,W){return V.create(m,W)}static{this.c=new s({regexParsingWithErrorRecovery:!1})}static deserialize(m){return m==null?void 0:this.c.parse(m)}}e.$Dj=i;function g(te){const m=new s({regexParsingWithErrorRecovery:!1});return te.map(W=>(m.parse(W),m.lexingErrors.length>0?m.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,P.localize)(11608,null,oe.additionalInfo):(0,P.localize)(11609,null),offset:oe.offset,length:oe.lexeme.length})):m.parsingErrors.length>0?m.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function _(te,m){const W=te?te.substituteConstants():void 0,oe=m?m.substituteConstants():void 0;return!W&&!oe?!0:!W||!oe?!1:W.equals(oe)}function C(te,m){return te.cmp(m)}class E{static{this.INSTANCE=new E}constructor(){this.type=d.False}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return k.INSTANCE}}e.$Gj=E;class k{static{this.INSTANCE=new k}constructor(){this.type=d.True}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return E.INSTANCE}}e.$Hj=k;class R{static create(m,W=null){const oe=r.get(m);return typeof oe=="boolean"?oe?k.INSTANCE:E.INSTANCE:new R(m,W)}constructor(m,W){this.key=m,this.c=W,this.type=d.Defined}cmp(m){return m.type!==this.type?this.type-m.type:ee(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}substituteConstants(){const m=r.get(this.key);return typeof m=="boolean"?m?k.INSTANCE:E.INSTANCE:this}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return this.c||(this.c=U.create(this.key,this)),this.c}}e.$Ij=R;class M{static create(m,W,oe=null){if(typeof W=="boolean")return W?R.create(m,oe):U.create(m,oe);const N=r.get(m);return typeof N=="boolean"?W===(N?"true":"false")?k.INSTANCE:E.INSTANCE:new M(m,W,oe)}constructor(m,W,oe){this.c=m,this.d=W,this.f=oe,this.type=d.Equals}cmp(m){return m.type!==this.type?this.type-m.type:le(this.c,this.d,m.c,m.d)}equals(m){return m.type===this.type?this.c===m.c&&this.d===m.d:!1}substituteConstants(){const m=r.get(this.c);if(typeof m=="boolean"){const W=m?"true":"false";return this.d===W?k.INSTANCE:E.INSTANCE}return this}evaluate(m){return m.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(m){return m.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Jj=M;class q{static create(m,W){return new q(m,W)}constructor(m,W){this.d=m,this.f=W,this.type=d.In,this.c=null}cmp(m){return m.type!==this.type?this.type-m.type:le(this.d,this.f,m.d,m.f)}equals(m){return m.type===this.type?this.d===m.d&&this.f===m.f:!1}substituteConstants(){return this}evaluate(m){const W=m.getValue(this.f),oe=m.getValue(this.d);return Array.isArray(W)?W.includes(oe):typeof oe=="string"&&typeof W=="object"&&W!==null?b.call(W,oe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(m){return m.mapIn(this.d,this.f)}negate(){return this.c||(this.c=I.create(this.d,this.f)),this.c}}e.$Kj=q;class I{static create(m,W){return new I(m,W)}constructor(m,W){this.d=m,this.f=W,this.type=d.NotIn,this.c=q.create(m,W)}cmp(m){return m.type!==this.type?this.type-m.type:this.c.cmp(m.c)}equals(m){return m.type===this.type?this.c.equals(m.c):!1}substituteConstants(){return this}evaluate(m){return!this.c.evaluate(m)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(m){return m.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=I;class y{static create(m,W,oe=null){if(typeof W=="boolean")return W?U.create(m,oe):R.create(m,oe);const N=r.get(m);return typeof N=="boolean"?W===(N?"true":"false")?E.INSTANCE:k.INSTANCE:new y(m,W,oe)}constructor(m,W,oe){this.c=m,this.d=W,this.f=oe,this.type=d.NotEquals}cmp(m){return m.type!==this.type?this.type-m.type:le(this.c,this.d,m.c,m.d)}equals(m){return m.type===this.type?this.c===m.c&&this.d===m.d:!1}substituteConstants(){const m=r.get(this.c);if(typeof m=="boolean"){const W=m?"true":"false";return this.d===W?E.INSTANCE:k.INSTANCE}return this}evaluate(m){return m.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(m){return m.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Mj=y;class U{static create(m,W=null){const oe=r.get(m);return typeof oe=="boolean"?oe?E.INSTANCE:k.INSTANCE:new U(m,W)}constructor(m,W){this.c=m,this.d=W,this.type=d.Not}cmp(m){return m.type!==this.type?this.type-m.type:ee(this.c,m.c)}equals(m){return m.type===this.type?this.c===m.c:!1}substituteConstants(){const m=r.get(this.c);return typeof m=="boolean"?m?E.INSTANCE:k.INSTANCE:this}evaluate(m){return!m.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(m){return m.mapNot(this.c)}negate(){return this.d||(this.d=R.create(this.c,this)),this.d}}e.$Nj=U;function A(te,m){if(typeof te=="string"){const W=parseFloat(te);isNaN(W)||(te=W)}return typeof te=="string"||typeof te=="number"?m(te):E.INSTANCE}class D{static create(m,W,oe=null){return A(W,N=>new D(m,N,oe))}constructor(m,W,oe){this.c=m,this.d=W,this.f=oe,this.type=d.Greater}cmp(m){return m.type!==this.type?this.type-m.type:le(this.c,this.d,m.c,m.d)}equals(m){return m.type===this.type?this.c===m.c&&this.d===m.d:!1}substituteConstants(){return this}evaluate(m){return typeof this.d=="string"?!1:parseFloat(m.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(m){return m.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Oj=D;class F{static create(m,W,oe=null){return A(W,N=>new F(m,N,oe))}constructor(m,W,oe){this.c=m,this.d=W,this.f=oe,this.type=d.GreaterEquals}cmp(m){return m.type!==this.type?this.type-m.type:le(this.c,this.d,m.c,m.d)}equals(m){return m.type===this.type?this.c===m.c&&this.d===m.d:!1}substituteConstants(){return this}evaluate(m){return typeof this.d=="string"?!1:parseFloat(m.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(m){return m.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Pj=F;class J{static create(m,W,oe=null){return A(W,N=>new J(m,N,oe))}constructor(m,W,oe){this.c=m,this.d=W,this.f=oe,this.type=d.Smaller}cmp(m){return m.type!==this.type?this.type-m.type:le(this.c,this.d,m.c,m.d)}equals(m){return m.type===this.type?this.c===m.c&&this.d===m.d:!1}substituteConstants(){return this}evaluate(m){return typeof this.d=="string"?!1:parseFloat(m.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(m){return m.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Qj=J;class V{static create(m,W,oe=null){return A(W,N=>new V(m,N,oe))}constructor(m,W,oe){this.c=m,this.d=W,this.f=oe,this.type=d.SmallerEquals}cmp(m){return m.type!==this.type?this.type-m.type:le(this.c,this.d,m.c,m.d)}equals(m){return m.type===this.type?this.c===m.c&&this.d===m.d:!1}substituteConstants(){return this}evaluate(m){return typeof this.d=="string"?!1:parseFloat(m.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(m){return m.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Rj=V;class Q{static create(m,W){return new Q(m,W)}constructor(m,W){this.d=m,this.f=W,this.type=d.Regex,this.c=null}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.d<m.d)return-1;if(this.d>m.d)return 1;const W=this.f?this.f.source:"",oe=m.f?m.f.source:"";return W<oe?-1:W>oe?1:0}equals(m){if(m.type===this.type){const W=this.f?this.f.source:"",oe=m.f?m.f.source:"";return this.d===m.d&&W===oe}return!1}substituteConstants(){return this}evaluate(m){const W=m.getValue(this.d);return this.f?this.f.test(W):!1}serialize(){const m=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${m}`}keys(){return[this.d]}map(m){return m.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=re.create(this)),this.c}}e.$Sj=Q;class re{static create(m){return new re(m)}constructor(m){this.c=m,this.type=d.NotRegex}cmp(m){return m.type!==this.type?this.type-m.type:this.c.cmp(m.c)}equals(m){return m.type===this.type?this.c.equals(m.c):!1}substituteConstants(){return this}evaluate(m){return!this.c.evaluate(m)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(m){return new re(this.c.map(m))}negate(){return this.c}}e.$Tj=re;function ce(te){let m=null;for(let W=0,oe=te.length;W<oe;W++){const N=te[W].substituteConstants();if(te[W]!==N&&m===null){m=[];for(let X=0;X<W;X++)m[X]=te[X]}m!==null&&(m[W]=N)}return m===null?te:m}class K{static create(m,W,oe){return K.d(m,W,oe)}constructor(m,W){this.expr=m,this.c=W,this.type=d.And}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let W=0,oe=this.expr.length;W<oe;W++){const N=C(this.expr[W],m.expr[W]);if(N!==0)return N}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let W=0,oe=this.expr.length;W<oe;W++)if(!this.expr[W].equals(m.expr[W]))return!1;return!0}return!1}substituteConstants(){const m=ce(this.expr);return m===this.expr?this:K.create(m,this.c,!1)}evaluate(m){for(let W=0,oe=this.expr.length;W<oe;W++)if(!this.expr[W].evaluate(m))return!1;return!0}static d(m,W,oe){const N=[];let X=!1;for(const T of m)if(T){if(T.type===d.True){X=!0;continue}if(T.type===d.False)return E.INSTANCE;if(T.type===d.And){N.push(...T.expr);continue}N.push(T)}if(N.length===0&&X)return k.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(C);for(let T=1;T<N.length;T++)N[T-1].equals(N[T])&&(N.splice(T,1),T--);if(N.length===1)return N[0];for(;N.length>1;){const T=N[N.length-1];if(T.type!==d.Or)break;N.pop();const O=N.pop(),H=N.length===0,Z=j.create(T.expr.map(ne=>K.create([ne,O],null,oe)),null,H);Z&&(N.push(Z),N.sort(C))}if(N.length===1)return N[0];if(oe){for(let T=0;T<N.length;T++)for(let O=T+1;O<N.length;O++)if(N[T].negate().equals(N[O]))return E.INSTANCE;if(N.length===1)return N[0]}return new K(N,W)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(const W of this.expr)m.push(...W.keys());return m}map(m){return new K(this.expr.map(W=>W.map(m)),null)}negate(){if(!this.c){const m=[];for(const W of this.expr)m.push(W.negate());this.c=j.create(m,this,!0)}return this.c}}e.$Uj=K;class j{static create(m,W,oe){return j.d(m,W,oe)}constructor(m,W){this.expr=m,this.c=W,this.type=d.Or}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let W=0,oe=this.expr.length;W<oe;W++){const N=C(this.expr[W],m.expr[W]);if(N!==0)return N}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let W=0,oe=this.expr.length;W<oe;W++)if(!this.expr[W].equals(m.expr[W]))return!1;return!0}return!1}substituteConstants(){const m=ce(this.expr);return m===this.expr?this:j.create(m,this.c,!1)}evaluate(m){for(let W=0,oe=this.expr.length;W<oe;W++)if(this.expr[W].evaluate(m))return!0;return!1}static d(m,W,oe){let N=[],X=!1;if(m){for(let T=0,O=m.length;T<O;T++){const H=m[T];if(H){if(H.type===d.False){X=!0;continue}if(H.type===d.True)return k.INSTANCE;if(H.type===d.Or){N=N.concat(H.expr);continue}N.push(H)}}if(N.length===0&&X)return E.INSTANCE;N.sort(C)}if(N.length!==0){if(N.length===1)return N[0];for(let T=1;T<N.length;T++)N[T-1].equals(N[T])&&(N.splice(T,1),T--);if(N.length===1)return N[0];if(oe){for(let T=0;T<N.length;T++)for(let O=T+1;O<N.length;O++)if(N[T].negate().equals(N[O]))return k.INSTANCE;if(N.length===1)return N[0]}return new j(N,W)}}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(const W of this.expr)m.push(...W.keys());return m}map(m){return new j(this.expr.map(W=>W.map(m)),null)}negate(){if(!this.c){const m=[];for(const W of this.expr)m.push(W.negate());for(;m.length>1;){const W=m.shift(),oe=m.shift(),N=[];for(const X of me(W))for(const T of me(oe))N.push(K.create([X,T],null,!1));m.unshift(j.create(N,null,!1))}this.c=j.create(m,this,!0)}return this.c}}e.$Vj=j;class Y extends R{static{this.d=[]}static all(){return Y.d.values()}constructor(m,W,oe){super(m,null),this.f=W,typeof oe=="object"?Y.d.push({...oe,key:m}):oe!==!0&&Y.d.push({key:m,description:oe,type:W!=null?typeof W:void 0})}bindTo(m){return m.createKey(this.key,this.f)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(m){return M.create(this.key,m)}notEqualsTo(m){return y.create(this.key,m)}}e.$Wj=Y,e.$Xj=(0,B.$Fi)("contextKeyService");function ee(te,m){return te<m?-1:te>m?1:0}function le(te,m,W,oe){return te<W?-1:te>W?1:m<oe?-1:m>oe?1:0}function G(te,m){if(te.type===d.False||m.type===d.True)return!0;if(te.type===d.Or)return m.type===d.Or?ae(te.expr,m.expr):!1;if(m.type===d.Or){for(const W of m.expr)if(G(te,W))return!0;return!1}if(te.type===d.And){if(m.type===d.And)return ae(m.expr,te.expr);for(const W of te.expr)if(G(W,m))return!0;return!1}return te.equals(m)}function ae(te,m){let W=0,oe=0;for(;W<te.length&&oe<m.length;){const N=te[W].cmp(m[oe]);if(N<0)return!1;N===0&&W++,oe++}return W===te.length}function me(te){return te.type===d.Or?te.expr:[te]}}),define(he[73],fe([0,1,55,5,10,9,6,12,22,3,20,24]),function(ie,e,a,t,S,$,B,P,p,r,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=d,e.$cl=f,e.$dl=n,e.$el=w,e.$fl=v,e.$gl=o,e.$hl=s,e.$il=i,e.$jl=g,e.$kl=_,e.$ll=C,e.$nl=R,e.$ol=M,e.$pl=q,e.$ql=I,e.$rl=y,e.$ul=J,e.$Gl=j,e.$Hl=Y,e.$Jl=le,e.$al=(0,p.$Fi)("fileService");function d(G){return G.create===!0}var u;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var c;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var h;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(h||(e.FileChangeFilter=h={}));function f(G){const ae=G;return!!ae&&typeof ae.onDidChange=="function"}var l;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})(l||(e.FileSystemProviderCapabilities=l={}));function n(G){return!!(G.capabilities&l.FileReadWrite)}function w(G){return!!(G.capabilities&l.FileFolderCopy)}function v(G){return!!(G.capabilities&l.FileClone)}function o(G){return!!(G.capabilities&l.FileOpenReadWriteClose)}function s(G){return!!(G.capabilities&l.FileReadStream)}function i(G){return n(G)?!!(G.capabilities&l.FileAtomicRead):!1}function g(G){return n(G)?!!(G.capabilities&l.FileAtomicWrite):!1}function _(G){return!!(G.capabilities&l.FileAtomicDelete)}function C(G){return!!(G.capabilities&l.Readonly)}var E;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class k extends Error{static create(ae,me){const te=new k(ae.toString(),me);return q(te,me),te}constructor(ae,me){super(ae),this.code=me}}e.$ml=k;function R(G,ae){return k.create(G,ae)}function M(G){return G||R((0,P.localize)(11385,null),E.Unknown)}function q(G,ae){return G.name=ae?`${ae} (FileSystemError)`:"FileSystemError",G}function I(G){if(!G)return E.Unknown;if(G instanceof k)return G.code;const ae=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!ae)return E.Unknown;switch(ae[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function y(G){if(G instanceof V)return G.fileOperationResult;switch(I(G)){case E.FileNotFound:return ce.FILE_NOT_FOUND;case E.FileIsADirectory:return ce.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ce.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ce.FILE_WRITE_LOCKED;case E.NoPermissions:return ce.FILE_PERMISSION_DENIED;case E.FileExists:return ce.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ce.FILE_TOO_LARGE;default:return ce.FILE_OTHER_ERROR}}var U;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(U||(e.FileOperation=U={}));class A{constructor(ae,me,te){this.resource=ae,this.operation=me,this.target=te}isOperation(ae){return this.operation===ae}}e.$sl=A;var D;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(D||(e.FileChangeType=D={}));class F{static{this.a=null}constructor(ae,me){this.c=me,this.b=void 0,this.d=new b.$T(()=>{const te=a.$Li.forUris(()=>this.c);return te.fill(this.rawAdded.map(m=>[m,!0])),te}),this.f=new b.$T(()=>{const te=a.$Li.forUris(()=>this.c);return te.fill(this.rawUpdated.map(m=>[m,!0])),te}),this.g=new b.$T(()=>{const te=a.$Li.forUris(()=>this.c);return te.fill(this.rawDeleted.map(m=>[m,!0])),te}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const te of ae){switch(te.type){case D.ADDED:this.rawAdded.push(te.resource);break;case D.UPDATED:this.rawUpdated.push(te.resource);break;case D.DELETED:this.rawDeleted.push(te.resource);break}this.b!==F.a&&(typeof te.cId=="number"?this.b===void 0?this.b=te.cId:this.b!==te.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(ae,...me){return this.h(ae,{includeChildren:!1},...me)}affects(ae,...me){return this.h(ae,{includeChildren:!0},...me)}h(ae,me,...te){if(!ae)return!1;const m=te.length>0;return!!((!m||te.includes(D.ADDED))&&(this.d.value.get(ae)||me.includeChildren&&this.d.value.findSuperstr(ae))||(!m||te.includes(D.UPDATED))&&(this.f.value.get(ae)||me.includeChildren&&this.f.value.findSuperstr(ae))||(!m||te.includes(D.DELETED))&&(this.g.value.findSubstr(ae)||me.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$tl=F;function J(G,ae,me){return!G||!ae||G===ae||ae.length>G.length?!1:(ae.charAt(ae.length-1)!==t.sep&&(ae+=t.sep),me?(0,S.$Gf)(G,ae):G.indexOf(ae)===0)}class V extends Error{constructor(ae,me,te){super(ae),this.fileOperationResult=me,this.options=te}}e.$vl=V;class Q extends V{constructor(ae,me,te,m){super(ae,me,m),this.fileOperationResult=me,this.size=te}}e.$wl=Q;class re extends V{constructor(ae,me,te){super(ae,ce.FILE_NOT_MODIFIED_SINCE,te),this.stat=me}}e.$xl=re;var ce;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var K;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$Fl="";function j(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function Y(G,ae){if(!ae.hasProvider(B.URI.from({scheme:G.scheme})))return new Promise(me=>{const te=ae.onDidChangeFileSystemProviderRegistrations(m=>{m.scheme===G.scheme&&m.added&&(te.dispose(),me())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ae){return(0,$.$ig)(ae)||(ae=0),ae<ee.KB?(0,P.localize)(11386,null,ae.toFixed(0)):ae<ee.MB?(0,P.localize)(11387,null,(ae/ee.KB).toFixed(2)):ae<ee.GB?(0,P.localize)(11388,null,(ae/ee.MB).toFixed(2)):ae<ee.TB?(0,P.localize)(11389,null,(ae/ee.GB).toFixed(2)):(0,P.localize)(11390,null,(ae/ee.TB).toFixed(2))}}e.$Il=ee;function le(G){const ae=typeof G=="string"||G?.scheme===L.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===L.Schemas.file?1024*ee.MB:ae?10*ee.MB:r.$p?50*ee.MB:1024*ee.MB}}),define(he[8],fe([0,1,12,66,4,54,2,26,3,25,9,6,38,22]),function(ie,e,a,t,S,$,B,P,p,r,L,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=h,e.log=l,e.$ok=k,e.$pk=R,e.$qk=M,e.$rk=q,a=Se(a),e.$ak=(0,u.$Fi)("logService"),e.$bk=(0,u.$Fi)("loggerService");function c(){return new Date().toISOString()}function h(I){return(0,L.$ig)(I)}var f;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$dk=f.Info;function l(I,y,U){switch(y){case f.Trace:I.trace(U);break;case f.Debug:I.debug(U);break;case f.Info:I.info(U);break;case f.Warning:I.warn(U);break;case f.Error:I.error(U);break;case f.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function n(I,y=!1){let U="";for(let A=0;A<I.length;A++){let D=I[A];if(D instanceof Error&&(D=(0,t.$qj)(D,y)),typeof D=="object")try{D=JSON.stringify(D)}catch{}U+=(A>0?" ":"")+D}return U}class w extends B.$Uc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new S.$le),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==f.Off&&this.b<=y}}e.$fk=w;class v extends w{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...U){this.f(f.Trace)&&this.g(f.Trace,n([y,...U],!0))}debug(y,...U){this.f(f.Debug)&&this.g(f.Debug,n([y,...U]))}info(y,...U){this.f(f.Info)&&this.g(f.Info,n([y,...U]))}warn(y,...U){this.f(f.Warning)&&this.g(f.Warning,n([y,...U]))}error(y,...U){if(this.f(f.Error))if(y instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=y.stack,this.g(f.Error,n(A))}else this.g(f.Error,n([y,...U]))}flush(){}}e.$gk=v;class o extends w{constructor(y=e.$dk){super(),this.setLevel(y),this.g=!p.$j}trace(y,...U){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,y,...U):console.log(`[main ${c()}]`,y,...U))}debug(y,...U){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,y,...U):console.log(`[main ${c()}]`,y,...U))}info(y,...U){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,y,...U):console.log(`[main ${c()}]`,y,...U))}warn(y,...U){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,y,...U):console.warn(`[main ${c()}]`,y,...U))}error(y,...U){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,y,...U):console.error(`[main ${c()}]`,y,...U))}flush(){}}e.$hk=o;class s extends w{constructor(y=e.$dk,U=!0){super(),this.g=U,this.setLevel(y)}trace(y,...U){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...U):console.log(y,...U))}debug(y,...U){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...U):console.log(y,...U))}info(y,...U){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...U):console.log(y,...U))}warn(y,...U){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...U):console.log(y,...U))}error(y,...U){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...U):console.error(y,...U))}flush(){}}e.$ik=s;class i extends w{constructor(y,U=e.$dk){super(),this.g=y,this.setLevel(U)}trace(y,...U){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(y),...U])}debug(y,...U){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(y),...U])}info(y,...U){this.f(f.Info)&&this.g.log(f.Info,[this.h(y),...U])}warn(y,...U){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(y),...U])}error(y,...U){this.f(f.Error)&&this.g.log(f.Error,[this.h(y),...U])}h(y){return typeof y=="string"?y:(0,t.$qj)(y,this.f(f.Trace))}flush(){}}e.$jk=i;class g extends w{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const U of this.g)U.setLevel(y);super.setLevel(y)}trace(y,...U){for(const A of this.g)A.trace(y,...U)}debug(y,...U){for(const A of this.g)A.debug(y,...U)}info(y,...U){for(const A of this.g)A.info(y,...U)}warn(y,...U){for(const A of this.g)A.warn(y,...U)}error(y,...U){for(const A of this.g)A.error(y,...U)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$kk=g;class _ extends B.$Uc{constructor(y,U,A){if(super(),this.h=y,this.j=U,this.b=new P.$Ac,this.c=this.B(new S.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new S.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new S.$le),this.onDidChangeVisibility=this.g.event,A)for(const D of A)this.b.set(D.resource,{logger:void 0,info:D})}m(y){return(0,L.$eg)(y)?[...this.b.values()].find(U=>U.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,U){const A=this.n(y),D=(0,L.$eg)(y)?y:U?.id??(0,$.$tj)(A.toString()).toString(16);let F=this.b.get(A)?.logger;const J=U?.logLevel==="always"?f.Trace:U?.logLevel;F||(F=this.s(A,J??this.getLogLevel(A)??this.h,{...U,id:D}));const V={logger:F,info:{resource:A,id:D,logLevel:J,name:U?.name,hidden:U?.hidden,extensionId:U?.extensionId,when:U?.when}};return this.registerLogger(V.info),this.b.set(A,V),F}n(y){return(0,L.$eg)(y)?(0,r.$gh)(this.j,`${y}.log`):y}setLogLevel(y,U){if(b.URI.isUri(y)){const A=y,D=U,F=this.b.get(A);F&&D!==F.info.logLevel&&(F.info.logLevel=D===this.h?void 0:D,F.logger?.setLevel(D),this.b.set(F.info.resource,F),this.f.fire([A,D]))}else{this.h=y;for(const[A,D]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&D.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,U){const A=this.m(y);A&&U!==!A.info.hidden&&(A.info.hidden=!U,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,U]))}getLogLevel(y){let U;return y&&(U=this.b.get(y)?.info.logLevel),U??this.h}registerLogger(y){const U=this.b.get(y.resource);U?U.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const U=this.b.get(y);U&&(U.logger&&U.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[U.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=_;class C{constructor(){this.onDidChangeLogLevel=new S.$le().event}setLevel(y){}getLevel(){return f.Info}trace(y,...U){}debug(y,...U){}info(y,...U){}warn(y,...U){}error(y,...U){}critical(y,...U){}dispose(){}flush(){}}e.$mk=C;class E extends C{}e.$nk=E;function k(I){if(I.verbose)return f.Trace;if(typeof I.logLevel=="string"){const y=q(I.logLevel.toLowerCase());if(y!==void 0)return y}return e.$dk}function R(I){switch(I){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function M(I){switch(I){case f.Trace:return{original:"Trace",value:a.localize(11318,null)};case f.Debug:return{original:"Debug",value:a.localize(11319,null)};case f.Info:return{original:"Info",value:a.localize(11320,null)};case f.Warning:return{original:"Warning",value:a.localize(11321,null)};case f.Error:return{original:"Error",value:a.localize(11322,null)};case f.Off:return{original:"Off",value:a.localize(11323,null)}}}function q(I){switch(I){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$sk=new d.$Wj("logLevel",R(f.Info))}),define(he[74],fe([0,1,6,4,8,2]),function(ie,e,a,t,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.$us=e.$ts=void 0;class B extends S.$lk{constructor(b,d,u,c,h){super(d,u,c),this.r=b,this.t=h,this.B(h.listen("onDidChangeLogLevel",b)(f=>{(0,S.$ck)(f)?super.setLogLevel(f):super.setLogLevel(a.URI.revive(f[0]),f[1])})),this.B(h.listen("onDidChangeVisibility",b)(([f,l])=>super.setVisibility(a.URI.revive(f),l))),this.B(h.listen("onDidChangeLoggers",b)(({added:f,removed:l})=>{for(const n of f)super.registerLogger({...n,resource:a.URI.revive(n.resource)});for(const n of l)super.deregisterLogger(n.resource)}))}createConsoleMainLogger(){return new S.$jk({log:(b,d)=>{this.t.call("consoleLog",[b,d])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,d){super.setLogLevel(b,d),this.t.call("setLogLevel",[b,d])}setVisibility(b,d){super.setVisibility(b,d),this.t.call("setVisibility",[this.n(b),d])}s(b,d,u){return new P(this.t,b,d,u,this.r)}static setLogLevel(b,d,u){return b.call("setLogLevel",[d,u])}}e.$ts=B;class P extends S.$gk{constructor(b,d,u,c,h){super(c?.logLevel==="always"),this.r=b,this.s=d,this.m=!1,this.n=[],this.setLevel(u),this.r.call("createLogger",[d,c,h]).then(()=>{this.u(this.n),this.m=!0})}g(b,d){const u=[[b,d]];this.m?this.u(u):this.n.push(...u)}u(b){this.r.call("log",[this.s,b])}}class p{constructor(b,d){this.a=b,this.b=d}listen(b,d){const u=this.b(b);switch(d){case"onDidChangeLoggers":return t.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(h=>this.c(h,u)),removed:[...c.removed].map(h=>this.c(h,u))}));case"onDidChangeVisibility":return t.Event.map(this.a.onDidChangeVisibility,c=>[u.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return t.Event.map(this.a.onDidChangeLogLevel,c=>(0,S.$ck)(c)?c:[u.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${d}`)}async call(b,d,u){const c=this.b(b);switch(d){case"setLogLevel":return(0,S.$ck)(u[0])?this.a.setLogLevel(u[0]):this.a.setLogLevel(a.URI.revive(c.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(h=>this.c(h,c)))}throw new Error(`Call not found: ${d}`)}c(b,d){return{...b,resource:d.transformOutgoingURI(b.resource)}}}e.$us=p;class r extends $.$Uc{constructor(b,d){super(),d.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(u=>d.call("setLogLevel",[u]))),d.call("getRegisteredLoggers").then(u=>{for(const c of u)b.registerLogger({...c,resource:a.URI.revive(c.resource)})}),this.B(d.listen("onDidChangeVisibility")(([u,c])=>b.setVisibility(a.URI.revive(u),c))),this.B(d.listen("onDidChangeLoggers")(({added:u,removed:c})=>{for(const h of u)b.registerLogger({...h,resource:a.URI.revive(h.resource)});for(const h of c)b.deregisterLogger(h.resource)}))}}e.$vs=r}),define(he[75],fe([0,1,2,8]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KR=void 0;class S extends a.$Uc{constructor(B,P=[]){super(),this.a=new t.$kk([B,...P]),this.B(B.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(B){this.a.setLevel(B)}getLevel(){return this.a.getLevel()}trace(B,...P){this.a.trace(B,...P)}debug(B,...P){this.a.debug(B,...P)}info(B,...P){this.a.info(B,...P)}warn(B,...P){this.a.warn(B,...P)}error(B,...P){this.a.error(B,...P)}flush(){this.a.flush()}}e.$KR=S}),define(he[76],fe([0,1,73,8]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zR=void 0;var S;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(S||(S={}));async function $(r,L,b,d,u){try{const c=await new Promise((f,l)=>{ie(["@vscode/spdlog"],f,l)}).then(Se);c.setFlushOn(S.Trace);const h=await c.createAsyncRotatingLogger(r,L,b,d);return u?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(c){console.error(c)}return null}function B(r,L,b){switch(L){case t.LogLevel.Trace:r.trace(b);break;case t.LogLevel.Debug:r.debug(b);break;case t.LogLevel.Info:r.info(b);break;case t.LogLevel.Warning:r.warn(b);break;case t.LogLevel.Error:r.error(b);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function P(r,L){switch(L){case t.LogLevel.Trace:r.setLevel(S.Trace);break;case t.LogLevel.Debug:r.setLevel(S.Debug);break;case t.LogLevel.Info:r.setLevel(S.Info);break;case t.LogLevel.Warning:r.setLevel(S.Warning);break;case t.LogLevel.Error:r.setLevel(S.Error);break;case t.LogLevel.Off:r.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class p extends t.$gk{constructor(L,b,d,u,c){super(),this.m=[],this.setLevel(c),this.n=this.s(L,b,d,u),this.B(this.onDidChangeLogLevel(h=>{this.r&&P(this.r,h)}))}async s(L,b,d,u){const c=d?6:1,h=30/c*a.$Il.MB,f=await $(L,b,h,c,u);if(f){this.r=f,P(this.r,this.getLevel());for(const{level:l,message:n}of this.m)B(this.r,l,n);this.m=[]}}g(L,b){this.r?B(this.r,L,b):this.getLevel()<=L&&this.m.push({level:L,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$zR=p}),define(he[77],fe([0,1,59,8,76]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AR=void 0;class $ extends t.$lk{s(P,p,r){return new S.$zR((0,a.$2g)(),P.fsPath,!r?.donotRotate,!!r?.donotUseFormatters,p)}}e.$AR=$}),define(he[78],fe([0,1,15]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let t;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const $=S.context.configuration();if($)t=$.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(t=globalThis._VSCODE_PRODUCT_JSON,a.env.VSCODE_DEV&&Object.assign(t,{nameShort:`${t.nameShort} Dev`,nameLong:`${t.nameLong} Dev`,dataFolderName:`${t.dataFolderName}-dev`,serverDataFolderName:t.serverDataFolderName?`${t.serverDataFolderName}-dev`:void 0}),!t.version){const $=globalThis._VSCODE_PACKAGE_JSON;Object.assign(t,{version:$.version})}}else t={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",nlsCoreBaseUrl:"https://www.vscode-unpkg.net/nls/",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-toolsai.prompty":{onFileOpen:[{pathGlob:"{**/*.prompty}",important:!1}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"vmware.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{descriptionOverride:"GitHub Copilot is an AI pair programmer tool that helps you write code faster and smarter."}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},"vmware.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.1}],extensionsEnabledWithApiProposalVersion:["GitHub.copilot-chat"],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","testRelatedCode","attributableCoverage"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent","contribIssueReporter","terminalShellIntegration"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["activeComment","codiconDecoration","codeActionRanges","commentingRangeHint","commentReactor","commentReveal","commentThreadApplicability","contribAccessibilityHelpContent","contribCommentEditorActionsMenu","contribCommentPeekContext","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","contribEditorContentMenu","contribMultiDiffEditorMenus","contribShareMenu","diffCommand","fileComments","quickDiffProvider","shareProvider","tabInputTextMerge","tokenInformation","treeViewMarkdownMessage"],"GitHub.copilot":["authGetSessions","inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["interactive","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatParticipantAdditions","defaultChatParticipant","embeddings","chatVariableResolver","chatProvider","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","activeComment","commentReveal","contribSourceControlInputBoxMenu","contribCommentEditorActionsMenu","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","newSymbolNamesProvider","findFiles2","extensionsAny","authGetSessions","authLearnMore","testObserver","aiTextSearchProvider","documentFiltersExclusive","chatParticipantPrivate","lmTools"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["contribIssueReporter","contribViewsWelcome","debugVisualization","portsAttributes"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution","notebookCellExecution","notebookVariableProvider"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-azuretools.vscode-azure-github-copilot":["chatParticipantAdditions","embeddings","languageModelSystem","lmTools"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"],"TeamsDevApp.ms-teams-vscode-extension":["chatParticipantAdditions","languageModelSystem"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com","https://raw.githubusercontent.com","https://private-user-images.githubusercontent.com","https://avatars.githubusercontent.com"],trustedExtensionAuthAccess:{github:["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],"github-enterprise":["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],microsoft:["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],"microsoft-sovereign-cloud":["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"]},trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]},microsoft:{scopes:["46da2f7e-b5ef-422a-88d4-2a7f9de6a0b2/.default","profile","openid"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})...",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},chatParticipantRegistry:"https://az764295.vo.msecnd.net/extensions/chat.json",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.3",sha256:"7380a890787452f14b2db7835dfa94de538caf358ebc263f9d46dd68ac52de93",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.92.0",sha256:"e5d0a74728292423631f79d076ecb2bc129f9637bcbc2529e48a0fd53baa69cc",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.92.2",commit:"fee1edb8d6d72a0ddff41e5f71a671c23ed924b9",date:"2024-08-14T17:29:30.058Z"},Object.keys(t).length===0&&Object.assign(t,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=t}),define(he[79],fe([0,1,22]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,a.$Fi)("productService"),e.$uk="vscode://schemas/vscode-product"}),define(he[80],fe([0,1,45,9]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,a=Se(a),t=Se(t);class S{constructor(){this.a=new Map}add(B,P){a.ok(t.$eg(B)),a.ok(t.$gg(P)),a.ok(!this.a.has(B),"There is already an extension with this id"),this.a.set(B,P)}knows(B){return this.a.has(B)}as(B){return this.a.get(B)||null}}e.$ro=new S}),define(he[23],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CommandInvalidationReason=e.TerminalCapability=void 0;var a;(function(S){S[S.CwdDetection=0]="CwdDetection",S[S.NaiveCwdDetection=1]="NaiveCwdDetection",S[S.CommandDetection=2]="CommandDetection",S[S.PartialCommandDetection=3]="PartialCommandDetection",S[S.BufferMarkDetection=4]="BufferMarkDetection"})(a||(e.TerminalCapability=a={}));var t;(function(S){S.Windows="windows",S.NoProblemsReported="noProblemsReported"})(t||(e.CommandInvalidationReason=t={}))}),define(he[81],fe([0,1,4,2,23]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nwb=void 0;class $ extends t.$Uc{constructor(P){super(),this.f=P,this.type=S.TerminalCapability.BufferMarkDetection,this.a=new Map,this.b=new Map,this.c=this.B(new a.$le),this.onMarkAdded=this.c.event}*markers(){for(const P of this.a.values())yield P;for(const P of this.b.values())yield P}addMark(P){const p=P?.marker||this.f.registerMarker(),r=P?.id;p&&(r?(this.a.set(r,p),p.onDispose(()=>this.a.delete(r))):(this.b.set(p.id,p),p.onDispose(()=>this.b.delete(p.id))),this.c.fire({marker:p,id:r,hidden:P?.hidden,hoverMessage:P?.hoverMessage}))}getMark(P){return this.a.get(P)}}e.$Nwb=$});var Be=this&&this.__param||function(ie,e){return function(a,t){e(a,t,ie)}};define(he[82],fe([0,1,4,2,8,14]),function(ie,e,a,t,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0;var B;(function(p){p[p.Unknown=0]="Unknown",p[p.Input=1]="Input",p[p.Execute=2]="Execute"})(B||(B={}));let P=class extends t.$Uc{get value(){return this.j}get cursorIndex(){return this.m}get ghostTextIndex(){return this.n}constructor(r,L,b,d){super(),this.w=r,this.z=d,this.a=B.Unknown,this.c=0,this.h="",this.j="",this.m=0,this.n=-1,this.r=this.B(new a.$le),this.onDidStartInput=this.r.event,this.s=this.B(new a.$le),this.onDidChangeInput=this.s.event,this.t=this.B(new a.$le),this.onDidFinishInput=this.t.event,this.u=this.B(new a.$le),this.onDidInterrupt=this.u.event,this.B(a.Event.any(this.w.onCursorMove,this.w.onData,this.w.onWriteParsed)(()=>this.G())),this.B(this.w.onData(u=>this.I(u))),this.B(L(u=>this.D(u))),this.B(b(()=>this.F())),this.B(this.onDidStartInput(()=>this.C("PromptInputModel#onDidStartInput"))),this.B(this.onDidChangeInput(()=>this.C("PromptInputModel#onDidChangeInput"))),this.B(this.onDidFinishInput(()=>this.C("PromptInputModel#onDidFinishInput"))),this.B(this.onDidInterrupt(()=>this.C("PromptInputModel#onDidInterrupt")))}C(r){this.z.getLevel()===S.LogLevel.Trace&&this.z.trace(r,this.getCombinedString())}setContinuationPrompt(r){this.g=r,this.G()}setLastPromptLine(r){this.f=r,this.G()}setConfidentCommandLine(r){this.j!==r&&(this.j=r,this.m=-1,this.n=-1,this.s.fire(this.Q()))}getCombinedString(){const r=this.j.replaceAll(`
`,"\u23CE");if(this.m===-1)return r;let L=`${r.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(L+=`${r.substring(this.cursorIndex,this.ghostTextIndex)}[`,L+=`${r.substring(this.ghostTextIndex)}]`):L+=r.substring(this.cursorIndex),L}serialize(){return{modelState:this.Q(),commandStartX:this.c,lastPromptLine:this.f,continuationPrompt:this.g,lastUserInput:this.h}}deserialize(r){this.j=r.modelState.value,this.m=r.modelState.cursorIndex,this.n=r.modelState.ghostTextIndex,this.c=r.commandStartX,this.f=r.lastPromptLine,this.g=r.continuationPrompt,this.h=r.lastUserInput}D(r){this.a!==B.Input&&(this.a=B.Input,this.b=r.marker,this.c=this.w.buffer.active.cursorX,this.j="",this.m=0,this.r.fire(this.Q()),this.s.fire(this.Q()),this.f&&this.c!==this.f.length&&this.w.buffer.active.getLine(this.b.line)?.translateToString(!0).startsWith(this.f)&&(this.c=this.f.length,this.G()))}F(){if(this.a===B.Execute)return;this.m=-1,this.n!==-1&&(this.j=this.j.substring(0,this.n),this.n=-1);const r=this.Q();this.h===""&&(this.h="",this.u.fire(r)),this.a=B.Execute,this.t.fire(r),this.s.fire(r)}G(){try{this.H()}catch(r){this.z.error("Error while syncing prompt input model",r)}}H(){if(this.a!==B.Input)return;const r=this.b?.line;if(r===void 0)return;const L=this.w.buffer.active;let b=L.getLine(r);const d=b?.translateToString(!0,this.c);if(!b||d===void 0){this.z.trace("PromptInputModel#_sync: no line");return}const u=L.baseY+L.cursorY;let c=d,h=-1,f;u===r?f=this.O(this.c,L,b):f=d.trimEnd().length,u===r&&L.cursorX>1&&(h=this.J(L,b,f));for(let l=r+1;l<=u;l++){b=L.getLine(l);const n=b?.translateToString(!0);if(n&&b)if(b.isWrapped){c+=n;const w=this.O(0,L,b);u===l?f+=w:f+=n.length}else if(this.g===void 0||this.M(n)){const w=this.L(n);if(c+=`
${w}`,u===l){const v=this.N(b,n),o=this.O(v,L,b);f+=o+1}else f+=w.length+1}else break}for(let l=u+1;l<L.baseY+this.w.rows;l++){b=L.getLine(l);const n=b?.translateToString(!0);if(n&&b)if(this.g===void 0||this.M(n))c+=`
${this.L(n)}`;else break;else break}this.z.getLevel()===S.LogLevel.Trace&&this.z.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`);{let l=this.j.length-this.j.trimEnd().length;this.h==="\x7F"&&(this.h="",f===this.m-1&&(this.j.trimEnd().length>c.trimEnd().length&&c.trimEnd().length<=f?l=Math.max(this.j.length-1-c.trimEnd().length,0):l=Math.max(l-1,0))),this.h==="\x1B[3~"&&(this.h="",f===this.m&&(l=Math.max(l-1,0)));const n=c.split(`
`),w=n.length>1,v=c.trimEnd();if(!w){v.length<c.length&&(this.h===" "&&(this.h="",f>v.length&&f>this.m&&l++),l=Math.max(f-v.length,l,0));const o=f===0?"":c[f-1];l>0&&f===this.m+1&&this.h!==""&&o!==" "&&(l=this.j.length-this.m)}if(w){n[n.length-1]=n.at(-1)?.trimEnd()??"";const o=(n.length-1)*(this.g?.length??0);l=Math.max(0,f-c.length-o)}c=n.map(o=>o.trimEnd()).join(`
`)+" ".repeat(l)}(this.j!==c||this.m!==f||this.n!==h)&&(this.j=c,this.m=f,this.n=h,this.s.fire(this.Q()))}I(r){this.h=r}J(r,L,b){let d=-1,u=!1,c=r.cursorX;for(;c>0;){const h=L.getCell(--c);if(!h)break;if(h.getChars().trim().length>0){u=!this.P(h);break}}if(u){let h=0,f=r.cursorX;for(;f<L.length;){const l=L.getCell(f++);if(!l||l.getCode()===0)break;if(this.P(l)){d=b+h;break}h+=l.getChars().length}}return d}L(r){return this.M(r)&&(r=r.substring(this.g.length)),r}M(r){return!!(this.g&&r.startsWith(this.g))}N(r,L){if(!this.g||!L.startsWith(this.g))return 0;let b="",d=0;for(;b!==this.g;)b+=r.getCell(d++).getChars();return d}O(r,L,b){return b?.translateToString(!0,r,L.cursorX).length??0}P(r){return!!(r.isItalic()||r.isDim())}Q(){return Object.freeze({value:this.j,cursorIndex:this.m,ghostTextIndex:this.n})}};e.$ks=P,pe([(0,$.$_h)(0)],P.prototype,"G",null),e.$ks=P=pe([Be(3,S.$ak)],P)}),define(he[83],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=e.$ls=void 0;class a{get command(){return this.b.command}get commandLineConfidence(){return this.b.commandLineConfidence}get isTrusted(){return this.b.isTrusted}get timestamp(){return this.b.timestamp}get duration(){return this.b.duration}get promptStartMarker(){return this.b.promptStartMarker}get marker(){return this.b.marker}get endMarker(){return this.b.endMarker}set endMarker(L){this.b.endMarker=L}get executedMarker(){return this.b.executedMarker}get aliases(){return this.b.aliases}get wasReplayed(){return this.b.wasReplayed}get cwd(){return this.b.cwd}get exitCode(){return this.b.exitCode}get commandStartLineContent(){return this.b.commandStartLineContent}get markProperties(){return this.b.markProperties}get executedX(){return this.b.executedX}get startX(){return this.b.startX}constructor(L,b){this.a=L,this.b=b}static deserialize(L,b,d){const u=L.buffer.normal,c=b.startLine!==void 0?L.registerMarker(b.startLine-(u.baseY+u.cursorY)):void 0;if(!c)return;const h=b.promptStartLine!==void 0?L.registerMarker(b.promptStartLine-(u.baseY+u.cursorY)):void 0,f=b.endLine!==void 0?L.registerMarker(b.endLine-(u.baseY+u.cursorY)):void 0,l=b.executedLine!==void 0?L.registerMarker(b.executedLine-(u.baseY+u.cursorY)):void 0;return new a(L,{command:d?"":b.command,commandLineConfidence:b.commandLineConfidence??"low",isTrusted:b.isTrusted,promptStartMarker:h,marker:c,startX:b.startX,endMarker:f,executedMarker:l,executedX:b.executedX,timestamp:b.timestamp,duration:b.duration,cwd:b.cwd,commandStartLineContent:b.commandStartLineContent,exitCode:b.exitCode,markProperties:b.markProperties,aliases:void 0,wasReplayed:!0})}serialize(L){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:L?"":this.command,commandLineConfidence:L?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return S(this.a.buffer.active,this.a.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const L=this.executedMarker.line,b=this.endMarker.line;if(L===b)return;let d="",u;for(let c=L;c<b;c++)u=this.a.buffer.active.getLine(c),u&&(d+=u.translateToString(!u.isWrapped)+(u.isWrapped?"":`
`));return d===""?void 0:d}getOutputMatch(L){if(!this.executedMarker||!this.endMarker)return;const b=this.endMarker.line;if(b===-1)return;const d=this.a.buffer.active,u=Math.max(this.executedMarker.line,0),c=L.lineMatcher,h=typeof c=="string"?1:L.length||B(c),f=[];let l;if(L.anchor==="bottom")for(let n=b-(L.offset||0);n>=u;n--){let w=n;const v=n;for(;w>=u&&d.getLine(w)?.isWrapped;)w--;if(n=w,f.unshift($(d,w,v,this.a.cols)),l||(l=f[0].match(c)),f.length>=h)break}else for(let n=u+(L.offset||0);n<b;n++){const w=n;let v=n;for(;v+1<b&&d.getLine(v+1)?.isWrapped;)v++;if(n=v,f.push($(d,w,v,this.a.cols)),l||(l=f[f.length-1].match(c)),f.length>=h)break}return l?{regexMatch:l,outputLines:f}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return P(this,this.a.buffer.active)}getCommandRowCount(){return p(this)}}e.$ls=a;class t{constructor(L){this.c=L}serialize(L){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:L,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(L,b,d,u){if(b===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||d)return new a(this.c,{command:d?"":this.command||"",commandLineConfidence:d?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.b||0,cwd:L,exitCode:b,commandStartLineContent:this.commandStartLineContent,markProperties:u})}markExecutedTime(){this.a===void 0&&(this.a=Date.now())}markFinishedTime(){this.b===void 0&&this.a!==void 0&&(this.b=Date.now()-this.a)}extractCommandLine(){return S(this.c.buffer.active,this.c.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return P(this,this.c.buffer.active)}getCommandRowCount(){return p(this)}}e.$ms=t;function S(r,L,b,d,u,c){if(!b||!u||d===void 0||c===void 0)return"";let h="";for(let f=b.line;f<=u.line;f++){const l=r.getLine(f);l&&(h+=l.translateToString(!0,f===b.line?d:0,f===u.line?c:L))}return h}function $(r,L,b,d){const u=Math.max(2048/d*2);b=Math.min(b,L+u);let c="";for(let h=L;h<=b;h++){const f=r.getLine(h);f&&(c+=f.translateToString(!0,0,d))}return c}function B(r){if(!r.multiline)return 1;const L=r.source;let b=1,d=L.indexOf("\\n");for(;d!==-1;)b++,d=L.indexOf("\\n",d+1);return b}function P(r,L){const b="hasOutput"in r?r.marker:r.commandStartMarker;if(!b||!r.promptStartMarker)return 1;let d=1,u=r.promptStartMarker.line;for(;u<b.line&&(L.getLine(u)?.translateToString(!0)??"").length===0;)u++;return d=b.line-u+1,d}function p(r){const L="hasOutput"in r?r.marker:r.commandStartMarker,b="hasOutput"in r?r.executedMarker:r.commandExecutedMarker;if(!L||!b)return 1;let u=Math.max(b.line,L.line)-L.line+1;return("hasOutput"in r?r.executedX:r.commandExecutedX)===0&&u--,u}}),define(he[84],fe([0,1,11,14,4,2,8,23,83,82]),function(ie,e,a,t,S,$,B,P,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jwb=void 0,e.$Kwb=c;let L=class extends $.$Uc{get promptInputModel(){return this.c}get commands(){return this.f}get executingCommand(){return this.n.command}get executingCommandObject(){if(this.n.commandStartMarker)return{marker:this.n.commandStartMarker}}get currentCommand(){return this.n}get cwd(){return this.g}get promptTerminator(){return this.h}constructor(n,w){super(),this.L=n,this.M=w,this.type=P.TerminalCapability.CommandDetection,this.f=[],this.n=new p.$ms(this.L),this.r=[],this.t=!1,this.D=this.B(new S.$le),this.onCommandStarted=this.D.event,this.F=this.B(new S.$le),this.onBeforeCommandFinished=this.F.event,this.G=this.B(new S.$le),this.onCommandFinished=this.G.event,this.H=this.B(new S.$le),this.onCommandExecuted=this.H.event,this.I=this.B(new S.$le),this.onCommandInvalidated=this.I.event,this.J=this.B(new S.$le),this.onCurrentCommandInvalidated=this.J.event,this.c=this.B(new r.$ks(this.L,this.onCommandStarted,this.onCommandExecuted,this.M)),this.B(this.onCommandExecuted(o=>{if(o.commandLineConfidence!=="high"){const s=o;o.command=s.extractCommandLine(),o.commandLineConfidence="low","getOutput"in s?s.promptStartMarker&&s.marker&&s.executedMarker&&o.command.indexOf(`
`)===-1&&s.startX!==void 0&&s.startX>0&&(o.commandLineConfidence="medium"):s.promptStartMarker&&s.commandStartMarker&&s.commandExecutedMarker&&o.command.indexOf(`
`)===-1&&s.commandStartX!==void 0&&s.commandStartX>0&&(o.commandLineConfidence="medium")}}));const v=this;this.z=new class{get onCurrentCommandInvalidatedEmitter(){return v.J}get onCommandStartedEmitter(){return v.D}get onCommandExecutedEmitter(){return v.H}get dimensions(){return v.s}get isCommandStorageDisabled(){return v.t}get commandMarkers(){return v.r}set commandMarkers(o){v.r=o}get clearCommandsInViewport(){return v.P.bind(v)}commitCommandFinished(){v.w?.flush(),v.w=void 0}},this.C=this.B(new $.$Wc(new b(this.L,this,this.z,this.M))),this.s={cols:this.L.cols,rows:this.L.rows},this.B(this.L.onResize(o=>this.N(o))),this.B(this.L.onCursorMove(()=>this.O()))}N(n){this.C.value.preHandleResize?.(n),this.s.cols=n.cols,this.s.rows=n.rows}O(){this.q.isDisposed||this.L.buffer.active===this.L.buffer.normal&&this.n.commandStartMarker&&this.L.buffer.active.baseY+this.L.buffer.active.cursorY<this.n.commandStartMarker.line&&(this.P(),this.n.isInvalid=!0,this.J.fire({reason:P.CommandInvalidationReason.Windows}))}P(){let n=0;for(let w=this.f.length-1;w>=0;w--){const v=this.f[w].marker?.line;if(v&&v<this.L.buffer.active.baseY)break;n++}n>0&&this.I.fire(this.f.splice(this.f.length-n,n))}setContinuationPrompt(n){this.c.setContinuationPrompt(n)}setPromptTerminator(n,w){this.M.debug("CommandDetectionCapability#setPromptTerminator",n),this.h=n,this.c.setLastPromptLine(w)}setCwd(n){this.g=n}setIsWindowsPty(n){if(n&&!(this.C.value instanceof u)){const w=this;this.C.value=new u(this.L,this,new class{get onCurrentCommandInvalidatedEmitter(){return w.J}get onCommandStartedEmitter(){return w.D}get onCommandExecutedEmitter(){return w.H}get dimensions(){return w.s}get isCommandStorageDisabled(){return w.t}get commandMarkers(){return w.r}set commandMarkers(v){w.r=v}get clearCommandsInViewport(){return w.P.bind(w)}commitCommandFinished(){w.w?.flush(),w.w=void 0}},this.M)}else!n&&!(this.C.value instanceof b)&&(this.C.value=new b(this.L,this,this.z,this.M))}setIsCommandStorageDisabled(){this.t=!0}getCommandForLine(n){if(this.n.promptStartMarker&&n>=this.n.promptStartMarker?.line)return this.n;if(this.f.length!==0&&!((this.f[0].promptStartMarker??this.f[0].marker).line>n)){for(let w=this.commands.length-1;w>=0;w--)if((this.commands[w].promptStartMarker??this.commands[w].marker).line<=n)return this.commands[w]}}getCwdForLine(n){if(this.n.promptStartMarker&&n>=this.n.promptStartMarker?.line)return this.g;const w=this.getCommandForLine(n);if(w&&"cwd"in w)return w.cwd}handlePromptStart(n){const w=this.commands.at(-1);w?.endMarker&&w?.executedMarker&&w.endMarker.line===w.executedMarker.line&&(this.M.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${w.endMarker.line} -> ${w.executedMarker.line+1}`),w.endMarker=f(this.L,w.executedMarker,1)),this.n.promptStartMarker=n?.marker||(w?.endMarker?f(this.L,w.endMarker):this.L.registerMarker(0)),this.M.debug("CommandDetectionCapability#handlePromptStart",this.L.buffer.active.cursorX,this.n.promptStartMarker?.line)}handleContinuationStart(){this.n.currentContinuationMarker=this.L.registerMarker(0),this.M.debug("CommandDetectionCapability#handleContinuationStart",this.n.currentContinuationMarker)}handleContinuationEnd(){if(!this.n.currentContinuationMarker){this.M.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this.n.continuations||(this.n.continuations=[]),this.n.continuations.push({marker:this.n.currentContinuationMarker,end:this.L.buffer.active.cursorX}),this.n.currentContinuationMarker=void 0,this.M.debug("CommandDetectionCapability#handleContinuationEnd",this.n.continuations[this.n.continuations.length-1])}handleRightPromptStart(){this.n.commandRightPromptStartX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleRightPromptStart",this.n.commandRightPromptStartX)}handleRightPromptEnd(){this.n.commandRightPromptEndX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleRightPromptEnd",this.n.commandRightPromptEndX)}handleCommandStart(n){if(this.u=n,this.n.cwd=this.g,this.n.commandStartMarker=n?.marker||this.n.commandStartMarker,this.n.commandStartMarker?.line===this.L.buffer.active.cursorY){this.n.commandStartX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleCommandStart",this.n.commandStartX,this.n.commandStartMarker?.line);return}this.C.value.handleCommandStart(n)}handleGenericCommand(n){n?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(n),this.handleCommandStart(n),this.handleCommandExecuted(n),this.handleCommandFinished(void 0,n)}handleCommandExecuted(n){this.C.value.handleCommandExecuted(n),this.n.markExecutedTime()}handleCommandFinished(n,w){if(this.n.markFinishedTime(),this.C.value.preHandleCommandFinished?.(),this.M.debug("CommandDetectionCapability#handleCommandFinished",this.L.buffer.active.cursorX,w?.marker?.line,this.n.command,this.n),n===void 0){const o=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this.n.command&&this.n.command.length>0&&o?.command===this.n.command&&(n=o.exitCode)}if(this.n.commandStartMarker===void 0||!this.L.buffer.active)return;this.n.commandFinishedMarker=w?.marker||this.L.registerMarker(0),this.C.value.postHandleCommandFinished?.();const v=this.n.promoteToFullCommand(this.g,n,this.u?.ignoreCommandLine??!1,w?.markProperties);v&&(this.f.push(v),this.w=new a.$Rh(()=>{this.F.fire(v),this.n.isInvalid||(this.M.debug("CommandDetectionCapability#onCommandFinished",v),this.G.fire(v))},50),this.w.schedule()),this.n=new p.$ms(this.L),this.u=void 0}setCommandLine(n,w){this.M.debug("CommandDetectionCapability#setCommandLine",n,w),this.n.command=n,this.n.commandLineConfidence="high",this.n.isTrusted=w,w&&this.c.setConfidentCommandLine(n)}serialize(){const n=this.commands.map(v=>v.serialize(this.t)),w=this.n.serialize(this.g);return w&&n.push(w),{isWindowsPty:this.C.value instanceof u,commands:n,promptInputModel:this.c.serialize()}}deserialize(n){n.isWindowsPty&&this.setIsWindowsPty(n.isWindowsPty);const w=this.L.buffer.normal;for(const v of n.commands){if(!v.endLine){const s=v.startLine!==void 0?this.L.registerMarker(v.startLine-(w.baseY+w.cursorY)):void 0;if(!s)continue;this.n.commandStartMarker=v.startLine!==void 0?this.L.registerMarker(v.startLine-(w.baseY+w.cursorY)):void 0,this.n.commandStartX=v.startX,this.n.promptStartMarker=v.promptStartLine!==void 0?this.L.registerMarker(v.promptStartLine-(w.baseY+w.cursorY)):void 0,this.g=v.cwd,this.D.fire({marker:s});continue}const o=p.$ls.deserialize(this.L,v,this.t);o&&(this.f.push(o),this.M.debug("CommandDetectionCapability#onCommandFinished",o),this.G.fire(o))}n.promptInputModel&&this.c.deserialize(n.promptInputModel)}};e.$Jwb=L,pe([(0,t.$$h)(500)],L.prototype,"O",null),e.$Jwb=L=pe([Be(1,B.$ak)],L);class b extends $.$Uc{constructor(n,w,v,o){super(),this.c=n,this.f=w,this.g=v,this.h=o,this.B(n.parser.registerCsiHandler({final:"J"},s=>(s.length>=1&&(s[0]===2||s[0]===3)&&v.clearCommandsInViewport(),!1)))}handleCommandStart(n){this.g.commitCommandFinished();const w=this.f.currentCommand;w.commandStartX=this.c.buffer.active.cursorX,w.commandStartMarker=n?.marker||this.c.registerMarker(0),w.commandExecutedMarker?.dispose(),w.commandExecutedMarker=void 0,w.commandExecutedX=void 0;for(const v of this.g.commandMarkers)v.dispose();this.g.commandMarkers.length=0,this.g.onCommandStartedEmitter.fire({marker:n?.marker||w.commandStartMarker,markProperties:n?.markProperties}),this.h.debug("CommandDetectionCapability#handleCommandStart",w.commandStartX,w.commandStartMarker?.line)}handleCommandExecuted(n){const w=this.f.currentCommand;if(w.commandExecutedMarker=n?.marker||this.c.registerMarker(0),w.commandExecutedX=this.c.buffer.active.cursorX,this.h.debug("CommandDetectionCapability#handleCommandExecuted",w.commandExecutedX,w.commandExecutedMarker?.line),!w.commandStartMarker||!w.commandExecutedMarker||w.commandStartX===void 0)return;w.command=this.g.isCommandStorageDisabled?"":this.c.buffer.active.getLine(w.commandStartMarker.line)?.translateToString(!0,w.commandStartX,w.commandRightPromptStartX).trim();let v=w.commandStartMarker.line+1;const o=w.commandExecutedMarker.line;for(;v<o;v++){const s=this.c.buffer.active.getLine(v);if(s){const i=w.continuations?.find(_=>_.marker.line===v);i&&(w.command+=`
`);const g=i?.end??0;w.command+=s.translateToString(!0,g)}}v===o&&(w.command+=this.c.buffer.active.getLine(o)?.translateToString(!0,void 0,w.commandExecutedX)||""),this.g.onCommandExecutedEmitter.fire(w)}}var d;(function(l){l[l.MaxCheckLineCount=10]="MaxCheckLineCount",l[l.Interval=20]="Interval",l[l.MaximumPollCount=10]="MaximumPollCount"})(d||(d={}));let u=class extends $.$Uc{constructor(n,w,v,o){super(),this.n=n,this.r=w,this.s=v,this.t=o,this.c=this.B(new $.$Vc),this.g=0,this.h=0,this.B(n.parser.registerCsiHandler({final:"J"},s=>(s.length>=1&&(s[0]===2||s[0]===3)&&this.s.clearCommandsInViewport(),!1))),this.B(this.r.onBeforeCommandFinished(s=>{(s.command.trim().toLowerCase()==="clear"||s.command.trim().toLowerCase()==="cls")&&(this.f?.cancel(),this.f=void 0,this.s.clearCommandsInViewport(),this.r.currentCommand.isInvalid=!0,this.s.onCurrentCommandInvalidatedEmitter.fire({reason:P.CommandInvalidationReason.Windows}))}))}preHandleResize(n){const w=this.n.buffer.active.baseY,v=n.rows-this.s.dimensions.rows;v>0&&this.D().then(()=>{const o=Math.min(v,w);for(let s=this.r.commands.length-1;s>=0;s--){const i=this.r.commands[s];if(!i.marker||i.marker.line<w||i.commandStartLineContent===void 0)break;const g=this.n.buffer.active.getLine(i.marker.line);if(!g||g.translateToString(!0)===i.commandStartLineContent)continue;const _=i.marker.line-o;this.n.buffer.active.getLine(_)?.translateToString(!0)===i.commandStartLineContent&&this.n._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this.n.buffer.active.baseY,amount:o})}})}handleCommandStart(){this.r.currentCommand.commandStartX=this.n.buffer.active.cursorX,this.s.commandMarkers.length=0;const n=this.r.currentCommand.commandStartMarker=this.r.currentCommand.promptStartMarker?f(this.n,this.r.currentCommand.promptStartMarker):this.n.registerMarker(0);this.r.currentCommand.commandStartX=0,this.g=0,this.h=0,this.f=new a.$Rh(()=>this.u(n),d.Interval),this.f.schedule()}u(n){if(this.q.isDisposed)return;const w=this.n.buffer.active;let v=this.g;for(;v<d.MaxCheckLineCount&&n.line+v<w.baseY+this.n.rows;){if(this.C()){const o=this.F(n.line+v);if(o){const s=typeof o=="string"?o:o.prompt;if(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0),typeof o=="object"&&o.likelySingleLine){this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this.r.currentCommand.promptStartMarker?.line} -> ${this.r.currentCommand.commandStartMarker.line}`),this.r.currentCommand.promptStartMarker?.dispose(),this.r.currentCommand.promptStartMarker=f(this.n,this.r.currentCommand.commandStartMarker);const i=this.r.commands.at(-1);i&&this.r.currentCommand.commandStartMarker.line!==i.endMarker?.line&&(i.endMarker?.dispose(),i.endMarker=f(this.n,this.r.currentCommand.commandStartMarker))}this.r.currentCommand.commandStartX=s.length,this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${n.line} -> ${this.r.currentCommand.commandStartMarker.line}:${this.r.currentCommand.commandStartX}`),this.w();return}}v++}v<d.MaxCheckLineCount?(this.g=v,++this.h<d.MaximumPollCount?this.f?.schedule():this.w()):this.w()}w(){if(this.f&&(this.h=d.MaximumPollCount,this.f.flush(),this.f=void 0),this.s.commitCommandFinished(),this.r.currentCommand.commandExecutedMarker||(this.c.value=this.n.onCursorMove(()=>{if(this.s.commandMarkers.length===0||this.s.commandMarkers[this.s.commandMarkers.length-1].line!==this.n.buffer.active.cursorY){const n=this.n.registerMarker(0);n&&this.s.commandMarkers.push(n)}})),this.r.currentCommand.commandStartMarker){const n=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);n&&(this.r.currentCommand.commandStartLineContent=n.translateToString(!0))}this.s.onCommandStartedEmitter.fire({marker:this.r.currentCommand.commandStartMarker}),this.t.debug("CommandDetectionCapability#_handleCommandStartWindows",this.r.currentCommand.commandStartX,this.r.currentCommand.commandStartMarker?.line)}handleCommandExecuted(n){this.f&&this.w(),this.c.clear(),this.z(),this.r.currentCommand.commandExecutedX=this.n.buffer.active.cursorX,this.s.onCommandExecutedEmitter.fire(this.r.currentCommand),this.t.debug("CommandDetectionCapability#handleCommandExecuted",this.r.currentCommand.commandExecutedX,this.r.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this.r.currentCommand.commandExecutedMarker||(this.s.commandMarkers.length===0&&(this.r.currentCommand.commandStartMarker||(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0)),this.r.currentCommand.commandStartMarker&&this.s.commandMarkers.push(this.r.currentCommand.commandStartMarker)),this.z())}postHandleCommandFinished(){const n=this.r.currentCommand,w=n.command,v=n.commandStartMarker?.line,o=n.commandExecutedMarker?.line;if(!w||w.length===0||v===void 0||v===-1||o===void 0||o===-1)return;let s=0,i=!1;for(let g=v;g<=o;g++){const _=this.n.buffer.active.getLine(g);if(!_)break;const C=_.translateToString(!0);for(let E=0;E<C.length;E++){for(;w.length<s&&w[s]===" ";)s++;if(C[E]===w[s]&&s++,s===w.length){const k=E>=this.n.cols-1;n.commandExecutedMarker=this.n.registerMarker(g-(this.n.buffer.active.baseY+this.n.buffer.active.cursorY)+(k?1:0)),n.commandExecutedX=k?0:E+1,i=!0;break}}if(i)break}}z(){if(this.s.commandMarkers.length!==0){if(this.s.commandMarkers=this.s.commandMarkers.sort((n,w)=>n.line-w.line),this.r.currentCommand.commandStartMarker=this.s.commandMarkers[0],this.r.currentCommand.commandStartMarker){const n=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);n&&(this.r.currentCommand.commandStartLineContent=n.translateToString(!0))}this.r.currentCommand.commandExecutedMarker=this.s.commandMarkers[this.s.commandMarkers.length-1],this.s.onCommandExecutedEmitter.fire(this.r.currentCommand)}}C(){const n=this.r.commands.at(-1);if(!n)return!0;const w=this.n.buffer.active.baseY+this.n.buffer.active.cursorY,v=(n.endMarker?n.endMarker.line:n.marker?.line)??-1;return w>v}D(){const n=this.n.buffer.active.cursorX,w=this.n.buffer.active.cursorY;let v=0;return new Promise((o,s)=>{const i=setInterval(()=>{if(n!==this.n.buffer.active.cursorX||w!==this.n.buffer.active.cursorY){o(),clearInterval(i);return}v+=10,v>1e3&&(clearInterval(i),o())},10)})}F(n=this.n.buffer.active.baseY+this.n.buffer.active.cursorY){const w=this.n.buffer.active.getLine(n);if(!w)return;const v=w.translateToString(!0);if(!v)return;const o=v.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(o){const C=this.G(o,v,">");if(C)return{prompt:C,likelySingleLine:!0}}const s=v.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(s){const C=this.G(s,v,"\u276F");if(C)return C}const i=v.match(/^(?<prompt>\$)/)?.groups?.prompt;if(i){const C=this.G(i,v,"$");if(C)return C}const g=v.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(g)return{prompt:g,likelySingleLine:!0};if(this.r.promptTerminator&&v.trim().endsWith(this.r.promptTerminator)){const C=this.G(v,v,this.r.promptTerminator);if(C)return C}const _=v.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return _?.groups?.prompt?{prompt:_.groups.prompt,likelySingleLine:!0}:void 0}G(n,w,v){if(n)return w===n&&n.endsWith(v)&&(n+=" "),n}};u=pe([Be(3,B.$ak)],u);function c(l,n,w,v){if(!v)return;const o=n.executedMarker,s=n.endMarker;if(!o||!s)return;const i=o.line,g=s.line,_=v.length,C=[];if(v.anchor==="bottom")for(let E=g-(v.offset||0);E>=i;E--){let k=E;const R=E;for(;k>=i&&l.getLine(k)?.isWrapped;)k--;E=k,C.unshift(h(l,k,R,w)),C.length>_&&C.pop()}else for(let E=i+(v.offset||0);E<g;E++){const k=E;let R=E;for(;R+1<g&&l.getLine(R+1)?.isWrapped;)R++;E=R,C.push(h(l,k,R,w)),C.length===_&&C.shift()}return C}function h(l,n,w,v){const o=Math.max(2048/v*2);w=Math.min(w,n+o);let s="";for(let i=n;i<=w;i++){const g=l.getLine(i);g&&(s+=g.translateToString(!0,0,v))}return s}function f(l,n,w=0){return l.registerMarker(n.line-(l.buffer.active.baseY+l.buffer.active.cursorY)+w)}}),define(he[85],fe([0,1,4,2,23]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lwb=void 0;class $ extends t.$Uc{constructor(){super(...arguments),this.type=S.TerminalCapability.CwdDetection,this.a="",this.b=new Map,this.c=this.B(new a.$le),this.onDidChangeCwd=this.c.event}get cwds(){return Array.from(this.b.keys())}getCwd(){return this.a}updateCwd(P){const p=this.a!==P;this.a=P;const r=this.b.get(this.a)||0;this.b.delete(this.a),this.b.set(this.a,r+1),p&&this.c.fire(P)}}e.$Lwb=$}),define(he[86],fe([0,1,4,2,23]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mwb=void 0;var $;(function(P){P[P.MinimumPromptLength=2]="MinimumPromptLength"})($||($={}));class B extends t.$Tc{get commands(){return this.a}constructor(p){super(),this.c=p,this.type=S.TerminalCapability.PartialCommandDetection,this.a=[],this.b=this.add(new a.$le),this.onCommandFinished=this.b.event,this.add(this.c.onData(r=>this.h(r))),this.add(this.c.parser.registerCsiHandler({final:"J"},r=>(r.length>=1&&(r[0]===2||r[0]===3)&&this.m(),!1)))}h(p){p==="\r"&&this.j()}j(){if(this.c&&this.c.buffer.active.cursorX>=$.MinimumPromptLength){const p=this.c.registerMarker(0);p&&(this.a.push(p),this.b.fire(p))}}m(){let p=0;for(let r=this.a.length-1;r>=0&&!(this.a[r].line<this.c.buffer.active.baseY);r--)p++;this.a.splice(this.a.length-p,p)}}e.$Mwb=B}),define(he[87],fe([0,1,4,2]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iwb=e.$Hwb=void 0;class S extends t.$Uc{constructor(){super(...arguments),this.a=new Map,this.b=this.B(new a.$le),this.onDidRemoveCapabilityType=this.b.event,this.f=this.B(new a.$le),this.onDidAddCapabilityType=this.f.event,this.g=this.B(new a.$le),this.onDidRemoveCapability=this.g.event,this.h=this.B(new a.$le),this.onDidAddCapability=this.h.event}get items(){return this.a.keys()}add(P,p){this.a.set(P,p),this.f.fire(P),this.h.fire({id:P,capability:p})}get(P){return this.a.get(P)}remove(P){const p=this.a.get(P);p&&(this.a.delete(P),this.b.fire(P),this.h.fire({id:P,capability:p}))}has(P){return this.a.has(P)}}e.$Hwb=S;class $ extends t.$Uc{constructor(){super(...arguments),this._stores=[],this.a=this.B(new a.$le),this.onDidRemoveCapabilityType=this.a.event,this.b=this.B(new a.$le),this.onDidAddCapabilityType=this.b.event,this.f=this.B(new a.$le),this.onDidRemoveCapability=this.f.event,this.g=this.B(new a.$le),this.onDidAddCapability=this.g.event}get items(){return this.h()}*h(){for(const P of this._stores)for(const p of P.items)yield p}has(P){for(const p of this._stores)for(const r of p.items)if(r===P)return!0;return!1}get(P){for(const p of this._stores){const r=p.get(P);if(r)return r}}add(P){this._stores.push(P);for(const p of P.items)this.b.fire(p),this.g.fire({id:p,capability:P.get(p)});this.B(P.onDidAddCapabilityType(p=>this.b.fire(p))),this.B(P.onDidAddCapability(p=>this.g.fire(p))),this.B(P.onDidRemoveCapabilityType(p=>this.a.fire(p))),this.B(P.onDidRemoveCapability(p=>this.f.fire(p)))}}e.$Iwb=$}),define(he[39],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var a;(function(t){t[t.Replace=1]="Replace",t[t.Append=2]="Append",t[t.Prepend=3]="Prepend"})(a||(e.EnvironmentVariableMutatorType=a={}))}),define(he[88],fe([0,1,3,39]),function(ie,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=void 0;const S=new Map([[t.EnvironmentVariableMutatorType.Append,"APPEND"],[t.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[t.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class ${constructor(L){this.collections=L,this.a=new Map,this.b=new Map,L.forEach((b,d)=>{this.d(b,d);const u=b.map.entries();let c=u.next();for(;!c.done;){const h=c.value[1],f=c.value[0];let l=this.a.get(f);if(l||(l=[],this.a.set(f,l)),l.length>0&&l[0].type===t.EnvironmentVariableMutatorType.Replace){c=u.next();continue}const n={extensionIdentifier:d,value:h.value,type:h.type,scope:h.scope,variable:h.variable,options:h.options};n.scope||delete n.scope,l.unshift(n),c=u.next()}})}async applyToProcessEnvironment(L,b,d){let u;a.$j&&(u={},Object.keys(L).forEach(c=>u[c.toLowerCase()]=c));for(const[c,h]of this.getVariableMap(b)){const f=a.$j&&u[c.toLowerCase()]||c;for(const l of h){const n=d?await d(l.value):l.value;if(l.options?.applyAtProcessCreation??!0)switch(l.type){case t.EnvironmentVariableMutatorType.Append:L[f]=(L[f]||"")+n;break;case t.EnvironmentVariableMutatorType.Prepend:L[f]=n+(L[f]||"");break;case t.EnvironmentVariableMutatorType.Replace:L[f]=n;break}if(l.options?.applyAtShellIntegration??!1){const w=`VSCODE_ENV_${S.get(l.type)}`;L[w]=(L[w]?L[w]+":":"")+c+"="+this.c(n)}}}}c(L){return L.replaceAll(":","\\x3a")}diff(L,b){const d=new Map,u=new Map,c=new Map;if(L.getVariableMap(b).forEach((h,f)=>{const l=this.getVariableMap(b).get(f),n=P(h,l);n&&d.set(f,n)}),this.getVariableMap(b).forEach((h,f)=>{const l=L.getVariableMap(b).get(f),n=P(h,l);n&&c.set(f,n)}),this.getVariableMap(b).forEach((h,f)=>{const l=L.getVariableMap(b).get(f),n=p(h,l);n&&u.set(f,n)}),!(d.size===0&&u.size===0&&c.size===0))return{added:d,changed:u,removed:c}}getVariableMap(L){const b=new Map;for(const d of this.a.values()){const u=d.filter(c=>B(c,L));u.length>0&&b.set(u[0].variable,u)}return b}getDescriptionMap(L){const b=new Map;for(const d of this.b.values()){const u=d.filter(c=>B(c,L,!0));for(const c of u)b.set(c.extensionIdentifier,c.description)}return b}d(L,b){if(!L.descriptionMap)return;const d=L.descriptionMap.entries();let u=d.next();for(;!u.done;){const c=u.value[1],h=u.value[0];let f=this.b.get(h);f||(f=[],this.b.set(h,f));const l={extensionIdentifier:b,scope:c.scope,description:c.description};l.scope||delete l.scope,f.push(l),u=d.next()}}}e.$Ls=$;function B(r,L,b=!1){return r.scope?!!(r.scope.workspaceFolder&&L?.workspaceFolder&&r.scope.workspaceFolder.index===L.workspaceFolder.index):b?L===r.scope:!0}function P(r,L){if(!L)return r;const b=new Set;L.forEach(u=>b.add(u.extensionIdentifier));const d=[];return r.forEach(u=>{b.has(u.extensionIdentifier)||d.push(u)}),d.length===0?void 0:d}function p(r,L){if(!L)return;const b=new Map;L.forEach(u=>b.set(u.extensionIdentifier,u));const d=[];return r.forEach(u=>{const c=b.get(u.extensionIdentifier);c&&(u.type!==c.type||u.value!==c.value||u.scope?.workspaceFolder?.index!==c.scope?.workspaceFolder?.index)&&d.push(c)}),d.length===0?void 0:d}}),define(he[89],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=a,e.$Gs=t,e.$Hs=S,e.$Is=$,e.$Js=B,e.$Ks=P;function a(p){return[...p.entries()]}function t(p){return p?[...p.entries()]:[]}function S(p){return new Map(p)}function $(p){return new Map(p??[])}function B(p){return Array.from(p.entries()).map(r=>[r[0],a(r[1].map),t(r[1].descriptionMap)])}function P(p){return new Map(p.map(r=>[r[0],{map:S(r[1]),descriptionMap:$(r[2])}]))}}),define(he[90],fe([0,1,11,18,4,2,8]),function(ie,e,a,t,S,$,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=void 0;let P=class extends $.$Uc{constructor(r,L){super(),this.h=L,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$le),this.onCreateRequest=this.g.event,this.b=r===void 0?15e3:r,this.B((0,$.$Sc)(()=>{for(const b of this.f.values())(0,$.$Pc)(b)}))}createRequest(r){return new Promise((L,b)=>{const d=++this.a;this.c.set(d,L),this.g.fire({requestId:d,...r});const u=new t.$we;(0,a.$Gh)(this.b,u.token).then(()=>b(`Request ${d} timed out (${this.b}ms)`)),this.f.set(d,[(0,$.$Sc)(()=>u.cancel())])})}acceptReply(r,L){const b=this.c.get(r);b?(this.c.delete(r),(0,$.$Pc)(this.f.get(r)||[]),this.f.delete(r),b(L)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${r}`)}};e.$ws=P,e.$ws=P=pe([Be(1,B.$ak)],P)}),define(he[16],fe([0,1,22,38,80]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ps=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$os=void 0,e.$os=new t.$Wj("terminalTabFocusMode",!1,!0);var $;(function(o){o.AutomationProfile="terminal.integrated.automationProfile.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})($||(e.TerminalSettingPrefix=$={}));var B;(function(o){o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationProfileLinux="terminal.integrated.automationProfile.linux",o.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",o.AutomationProfileWindows="terminal.integrated.automationProfile.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsDefaultColor="terminal.integrated.tabs.defaultColor",o.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.TabStopWidth="terminal.integrated.tabStopWidth",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorStyleInactive="terminal.integrated.cursorStyleInactive",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.TerminalTitleSeparator="terminal.integrated.tabs.separator",o.TerminalTitle="terminal.integrated.tabs.title",o.TerminalDescription="terminal.integrated.tabs.description",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.MiddleClickBehavior="terminal.integrated.middleClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.EnableVisualBell="terminal.integrated.enableVisualBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.TabFocusMode="terminal.integrated.tabFocusMode",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",o.HideOnStartup="terminal.integrated.hideOnStartup",o.CustomGlyphs="terminal.integrated.customGlyphs",o.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover",o.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",o.AutoReplies="terminal.integrated.autoReplies",o.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",o.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",o.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",o.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",o.EnableImages="terminal.integrated.enableImages",o.SmoothScrolling="terminal.integrated.smoothScrolling",o.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",o.FocusAfterRun="terminal.integrated.focusAfterRun",o.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",o.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",o.DevMode="terminal.integrated.developer.devMode"})(B||(e.TerminalSettingId=B={}));var P;(function(o){o.PowerShell="pwsh",o.Bash="bash",o.Fish="fish",o.Sh="sh",o.Csh="csh",o.Ksh="ksh",o.Zsh="zsh",o.Python="python"})(P||(e.PosixShellType=P={}));var p;(function(o){o.CommandPrompt="cmd",o.PowerShell="pwsh",o.Wsl="wsl",o.GitBash="gitbash",o.Python="python"})(p||(e.WindowsShellType=p={}));var r;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence",o[o.Config=3]="Config"})(r||(e.TitleEventSource=r={}));var L;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.PtyHostWindow="ptyHostWindow",o.Logger="logger",o.Heartbeat="heartbeat"})(L||(e.TerminalIpcChannels=L={}));var b;(function(o){o.Cwd="cwd",o.InitialCwd="initialCwd",o.FixedDimensions="fixedDimensions",o.Title="title",o.ShellType="shellType",o.HasChildProcesses="hasChildProcesses",o.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",o.OverrideDimensions="overrideDimensions",o.FailedShellIntegrationActivation="failedShellIntegrationActivation",o.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.$ps=(0,a.$Fi)("ptyService");var d;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(d||(e.HeartbeatConstants=d={}));var u;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})(u||(e.TerminalLocation=u={}));var c;(function(o){o.TerminalView="view",o.Editor="editor"})(c||(e.TerminalLocationString=c={}));var h;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(h||(e.LocalReconnectConstants=h={}));var f;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(f||(e.FlowControlConstants=f={}));var l;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(l||(e.ProfileSource=l={}));var n;(function(o){o[o.Off=0]="Off",o[o.FinalTerm=1]="FinalTerm",o[o.VSCode=2]="VSCode"})(n||(e.ShellIntegrationStatus=n={}));var w;(function(o){o[o.Unknown=0]="Unknown",o[o.Shutdown=1]="Shutdown",o[o.Process=2]="Process",o[o.User=3]="User",o[o.Extension=4]="Extension"})(w||(e.TerminalExitReason=w={})),e.$qs={Backend:"workbench.contributions.terminal.processBackend"};class v{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(s){const i=this.b(s.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,s)}getTerminalBackend(s){return this.a.get(this.b(s))}b(s){return s?.toLowerCase()??""}}S.$ro.add(e.$qs.Backend,new v),e.$rs=(0,a.$Fi)("localPtyService"),e.$ss=(0,a.$Fi)("terminalLogService")}),define(he[91],fe([0,1,11,2,3]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=void 0;class $ extends t.$Uc{constructor(P,p,r,L){super(),this.a=0,this.b=!1,this.c=!1,this.B(P.onProcessData(b=>{if(this.b||this.c)return;const d=typeof b=="string"?b:b.data;for(let u=0;u<d.length;u++)d[u]===p[this.a]?this.a++:this.f(),this.a===p.length&&(L.debug(`Auto reply match: "${p}", response: "${r}"`),P.input(r),this.c=!0,(0,a.$Gh)(1e3).then(()=>this.c=!1),this.f())}))}f(){this.a=0}handleResize(){S.$j&&(this.b=!0)}handleInput(){this.b=!1}}e.$Nmc=$}),define(he[92],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xxb=void 0;class a{constructor(S){this.b=S,this.a=new Map}dispose(){for(const S of this.a.values())S.dispose()}startBuffering(S,$,B=5){const P=$(p=>{const r=typeof p=="string"?p:p.data;let L=this.a.get(S);if(L){L.data.push(r);return}const b=setTimeout(()=>this.flushBuffer(S),B);L={data:[r],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(S),P.dispose()}},this.a.set(S,L)});return P}stopBuffering(S){this.a.get(S)?.dispose()}flushBuffer(S){const $=this.a.get(S);$&&(this.a.delete(S),this.b(S,$.data.join("")))}}e.$Xxb=a}),define(he[40],fe([0,1,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aR=t,e.$bR=S,e.$cR=$,e.$dR=B;function t(P){let p=P;p.includes("\\")&&(p=p.replace(/\\/g,"\\\\"));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return p=p.replace(r,""),`'${p}'`}function S(P,p,r){if(!P)return"";if(!p)return P;p.match(/[\/\\]$/)&&(p=p.slice(0,p.length-1));const L=P.replace(/\\/g,"/").toLowerCase(),b=p.replace(/\\/g,"/").toLowerCase();return L.includes(b)?`~${r}${P.slice(p.length+1)}`:P}function $(P){return P.match(/^['"].*['"]$/)&&(P=P.substring(1,P.length-1)),a.OS===a.OperatingSystem.Windows&&P&&P[1]===":"?P[0].toUpperCase()+P.substring(1):P}function B(P){return!P.strictEnv}}),define(he[93],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=t;var a;(function(S){S[S.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(a||(a={}));function t(S){const $=[];let B=0;for(let P=0;P<S.length-1;P++)(P-B+1>=a.WriteMaxChunkSize||S[P+1]==="\x1B")&&($.push(S.substring(B,P+1)),B=P+1,P++);return B!==S.length&&$.push(S.substring(B)),$}}),define(he[94],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PXb=a;function a(t,S={}){let $="";return S.excludeLeadingNewLine||($+=`\r
`),$+="\x1B[0m\x1B[7m * ",S.loudFormatting?$+="\x1B[0;104m":$+="\x1B[0m",$+=` ${t} \x1B[0m
\r`,$}}),define(he[95],fe([0,1,16,2,87,84,85,23,86,4,81,6,40,10]),function(ie,e,a,t,S,$,B,P,p,r,L,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Owb=e.ShellIntegrationOscPs=void 0,e.$Pwb=w,e.$Qwb=v,e.$Rwb=o;var c;(function(s){s[s.FinalTerm=133]="FinalTerm",s[s.VSCode=633]="VSCode",s[s.ITerm=1337]="ITerm",s[s.SetCwd=7]="SetCwd",s[s.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(c||(e.ShellIntegrationOscPs=c={}));var h;(function(s){s.PromptStart="A",s.CommandStart="B",s.CommandExecuted="C",s.CommandFinished="D"})(h||(h={}));var f;(function(s){s.PromptStart="A",s.CommandStart="B",s.CommandExecuted="C",s.CommandFinished="D",s.CommandLine="E",s.ContinuationStart="F",s.ContinuationEnd="G",s.RightPromptStart="H",s.RightPromptEnd="I",s.Property="P",s.SetMark="SetMark"})(f||(f={}));var l;(function(s){s.SetMark="SetMark",s.CurrentDir="CurrentDir"})(l||(l={}));class n extends t.$Uc{get status(){return this.g}constructor(i,g,_,C){super(),this.j=i,this.m=g,this.n=_,this.r=C,this.capabilities=this.B(new S.$Hwb),this.b=!1,this.f=[],this.g=a.ShellIntegrationStatus.Off,this.h=new r.$le,this.onDidChangeStatus=this.h.event,this.B((0,t.$Sc)(()=>{this.z(),this.s()}))}s(){(0,t.$Pc)(this.f),this.f.length=0}activate(i){this.a=i,this.capabilities.add(P.TerminalCapability.PartialCommandDetection,this.B(new p.$Mwb(this.a))),this.B(i.parser.registerOscHandler(c.VSCode,g=>this.w(g))),this.B(i.parser.registerOscHandler(c.ITerm,g=>this.H(g))),this.f.push(i.parser.registerOscHandler(c.FinalTerm,g=>this.t(g))),this.B(i.parser.registerOscHandler(c.SetCwd,g=>this.J(g))),this.B(i.parser.registerOscHandler(c.SetWindowsFriendlyCwd,g=>this.I(g))),this.y()}getMarkerId(i,g){this.N(i).getMark(g)}t(i){const g=this.u(i);return this.g===a.ShellIntegrationStatus.Off&&(this.g=a.ShellIntegrationStatus.FinalTerm,this.h.fire(this.g)),g}u(i){if(!this.a)return!1;const[g,..._]=i.split(";");switch(g){case h.PromptStart:return this.M(this.a).handlePromptStart(),!0;case h.CommandStart:return this.M(this.a).handleCommandStart({ignoreCommandLine:!0}),!0;case h.CommandExecuted:return this.M(this.a).handleCommandExecuted(),!0;case h.CommandFinished:{const C=_.length===1?parseInt(_[0]):void 0;return this.M(this.a).handleCommandFinished(C),!0}}return!1}w(i){const g=this.C(i);return!this.b&&g&&(this.n?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this.b=!0,this.z()),this.g!==a.ShellIntegrationStatus.VSCode&&(this.g=a.ShellIntegrationStatus.VSCode,this.h.fire(this.g)),g}async y(){!this.n||this.m||(this.c=setTimeout(()=>{!this.capabilities.get(P.TerminalCapability.CommandDetection)&&!this.capabilities.get(P.TerminalCapability.CwdDetection)&&(this.n?.publicLog2("terminal/shellIntegrationActivationTimeout"),this.r.warn("Shell integration failed to add capabilities within 10 seconds")),this.b=!0},1e4))}z(){this.c!==void 0&&(clearTimeout(this.c),this.c=void 0)}C(i){if(!this.a)return!1;const g=i.indexOf(";"),_=g===-1?i:i.substring(0,g),C=g===-1?[]:i.substring(g+1).split(";");switch(_){case f.PromptStart:return this.M(this.a).handlePromptStart(),!0;case f.CommandStart:return this.M(this.a).handleCommandStart(),!0;case f.CommandExecuted:return this.M(this.a).handleCommandExecuted(),!0;case f.CommandFinished:{const E=C[0],k=E!==void 0?parseInt(E):void 0;return this.M(this.a).handleCommandFinished(k),!0}case f.CommandLine:{const E=C[0],k=C[1];let R;return E!==void 0?R=w(E):R="",this.M(this.a).setCommandLine(R,k===this.j),!0}case f.ContinuationStart:return this.M(this.a).handleContinuationStart(),!0;case f.ContinuationEnd:return this.M(this.a).handleContinuationEnd(),!0;case f.RightPromptStart:return this.M(this.a).handleRightPromptStart(),!0;case f.RightPromptEnd:return this.M(this.a).handleRightPromptEnd(),!0;case f.Property:{const E=C[0],k=E!==void 0?w(E):"",{key:R,value:M}=v(k);if(M===void 0)return!0;switch(R){case"ContinuationPrompt":return this.D((0,u.$3f)(M)),!0;case"Cwd":return this.G(M),!0;case"IsWindows":return this.M(this.a).setIsWindowsPty(M==="True"),!0;case"Prompt":{const q=M.replace(/\x1b\[[0-9;]*m/g,"");return this.F(q),!0}case"Task":return this.N(this.a),this.capabilities.get(P.TerminalCapability.CommandDetection)?.setIsCommandStorageDisabled(),!0}}case f.SetMark:return this.N(this.a).addMark(o(C)),!0}return!1}D(i){this.a&&this.M(this.a).setContinuationPrompt(i)}F(i){if(!this.a)return;const g=i.substring(i.lastIndexOf(`
`)+1),_=g.substring(g.lastIndexOf(" "));_&&this.M(this.a).setPromptTerminator(_,g)}G(i){i=(0,d.$cR)(i),this.L().updateCwd(i),this.capabilities.get(P.TerminalCapability.CommandDetection)?.setCwd(i)}H(i){if(!this.a)return!1;const[g]=i.split(";");switch(g){case l.SetMark:this.N(this.a).addMark();default:{const{key:_,value:C}=v(g);if(C===void 0)return!0;switch(_){case l.CurrentDir:return this.G(C),!0}}}return!1}I(i){if(!this.a)return!1;const[g,..._]=i.split(";");switch(g){case"9":return _.length&&this.G(_[0]),!0}return!1}J(i){if(!this.a)return!1;const[g]=i.split(";");if(g.match(/^file:\/\/.*\//)){const _=b.URI.parse(g);if(_.path&&_.path.length>0)return this.G(_.path),!0}return!1}serialize(){return!this.a||!this.capabilities.has(P.TerminalCapability.CommandDetection)?{isWindowsPty:!1,commands:[],promptInputModel:void 0}:this.M(this.a).serialize()}deserialize(i){if(!this.a)throw new Error("Cannot restore commands before addon is activated");this.M(this.a).deserialize(i)}L(){let i=this.capabilities.get(P.TerminalCapability.CwdDetection);return i||(i=this.B(new B.$Lwb),this.capabilities.add(P.TerminalCapability.CwdDetection,i)),i}M(i){let g=this.capabilities.get(P.TerminalCapability.CommandDetection);return g||(g=this.B(new $.$Jwb(i,this.r)),this.capabilities.add(P.TerminalCapability.CommandDetection,g)),g}N(i){let g=this.capabilities.get(P.TerminalCapability.BufferMarkDetection);return g||(g=this.B(new L.$Nwb(i)),this.capabilities.add(P.TerminalCapability.BufferMarkDetection,g)),g}}e.$Owb=n;function w(s){return s.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(i,g,_)=>_?String.fromCharCode(parseInt(_,16)):g)}function v(s){const i=s.indexOf("=");return i===-1?{key:s,value:void 0}:{key:s.substring(0,i),value:s.substring(1+i)}}function o(s){let i,g=!1;for(const _ of s)_!==void 0&&(_==="Hidden"&&(g=!0),_.startsWith("Id=")&&(i=_.substring(3)));return{id:i,hidden:g}}}),define(he[41],fe([0,1,5,14,4,2,61,8]),function(ie,e,a,t,S,$,B,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=e.$Omc=void 0;var p;(function(L){L[L.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",L[L.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(p||(p={})),e.$Omc=[];let r=class extends $.$Uc{set hasChildProcesses(b){this.a!==b&&(this.a=b,this.f.debug("ChildProcessMonitor: Has child processes changed",b),this.b.fire(b))}get hasChildProcesses(){return this.a}constructor(b,d){super(),this.c=b,this.f=d,this.a=!1,this.b=this.B(new S.$le),this.onDidChangeHasChildProcesses=this.b.event}handleInput(){this.g()}handleOutput(){this.h()}async g(){if(!this.q.isDisposed)try{const b=await(0,B.$Xs)(this.c);this.hasChildProcesses=this.j(b)}catch(b){this.f.debug("ChildProcessMonitor: Fetching process tree failed",b)}}h(){this.g()}j(b){if(!b.children)return!1;if(b.children.length===1){const d=b.children[0];let u;if(d.cmd.startsWith('"'))u=d.cmd.substring(1,d.cmd.indexOf('"',1));else{const c=d.cmd.indexOf(" ");c===-1?u=d.cmd:u=d.cmd.substring(0,c)}return e.$Omc.indexOf((0,a.$qc)(u).name)===-1}return b.children.length>0}};e.$Pmc=r,pe([(0,t.$$h)(p.ActiveDebounceDuration)],r.prototype,"g",null),pe([(0,t.$_h)(p.InactiveThrottleDuration)],r.prototype,"h",null),e.$Pmc=r=pe([Be(1,P.$ak)],r)}),define(he[96],fe([0,1,4,2,16]),function(ie,e,a,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=void 0;class $ extends t.$Uc{constructor(){super(),this.a=this.B(new a.$le),this.onBeat=this.a.event;const P=setInterval(()=>{this.a.fire()},S.HeartbeatConstants.BeatInterval);this.B((0,t.$Sc)(()=>clearInterval(P)))}}e.$Qmc=$}),define(he[42],fe([0,1,21,20,33,5,3,15,10,9,28,39,89,88]),function(ie,e,a,t,S,$,B,P,p,r,L,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=c,e.$Ns=h,e.$Os=f,a=Se(a),$=Se($),P=Se(P),L=Se(L);function c(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(a.release());let k=0;return E&&E.length===4&&(k=parseInt(E[3])),k}async function h(E,k,R,M=P.env,q=L.Promises.exists){if($.$ic(E))return await q(E)?E:void 0;if(k===void 0&&(k=P.cwd()),$.$mc(E)!=="."){const A=$.$jc(k,E);return await q(A)?A:void 0}const y=(0,S.$lo)(M,"PATH");if(R===void 0&&(0,r.$eg)(y)&&(R=y.split($.$tc)),R===void 0||R.length===0){const A=$.$jc(k,E);return await q(A)?A:void 0}for(const A of R){let D;if($.$ic(A)?D=$.$jc(A,E):D=$.$jc(k,A,E),await q(D))return D;if(B.$j){let F=D+".com";if(await q(F)||(F=D+".exe",await q(F)))return F}}const U=$.$jc(k,E);return await q(U)?U:void 0}function f(E,k,R,M,q){const I=B.$j&&(!k.windowsEnableConpty||c()<18309);if(!k.shellIntegration.enabled||!E.executable||E.isFeatureTerminal&&!E.forceShellIntegration||E.ignoreShellIntegration||I)return;const y=E.args,U=P.$dc==="win32"?$.$nc(E.executable).toLowerCase():$.$nc(E.executable),A=$.$mc(t.$Zg.asFileUri("").fsPath);let D;const F={VSCODE_INJECTION:"1"};if(k.shellIntegration.nonce&&(F.VSCODE_NONCE=k.shellIntegration.nonce),B.$j){if(U==="pwsh.exe"||U==="powershell.exe")return!y||_(y)?D=w.get(n.WindowsPwsh):g(y)&&(D=w.get(n.WindowsPwshLogin)),D?(D=[...D],D[D.length-1]=(0,p.$df)(D[D.length-1],A,""),F.VSCODE_STABLE=q.quality==="stable"?"1":"0",k.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),{newArgs:D,envMixin:F}):void 0;if(U==="bash.exe")return!y||y.length===0?D=w.get(n.Bash):C(y)&&(F.VSCODE_SHELL_LOGIN="1",l(k,F),D=w.get(n.Bash)),D?(D=[...D],D[D.length-1]=(0,p.$df)(D[D.length-1],A),F.VSCODE_STABLE=q.quality==="stable"?"1":"0",{newArgs:D,envMixin:F}):void 0;M.warn(`Shell integration cannot be enabled for executable "${E.executable}" and args`,E.args);return}switch(U){case"bash":return!y||y.length===0?D=w.get(n.Bash):C(y)&&(F.VSCODE_SHELL_LOGIN="1",l(k,F),D=w.get(n.Bash)),D?(D=[...D],D[D.length-1]=(0,p.$df)(D[D.length-1],A),F.VSCODE_STABLE=q.quality==="stable"?"1":"0",{newArgs:D,envMixin:F}):void 0;case"fish":{const J=R?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",V=$.$jc(A,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return F.XDG_DATA_DIRS=`${J}:${V}`,l(k,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!y||_(y)?D=w.get(n.Pwsh):g(y)&&(D=w.get(n.PwshLogin)),D?(k.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),D=[...D],D[D.length-1]=(0,p.$df)(D[D.length-1],A,""),F.VSCODE_STABLE=q.quality==="stable"?"1":"0",{newArgs:D,envMixin:F}):void 0;case"zsh":{if(!y||y.length===0?D=w.get(n.Zsh):C(y)?(D=w.get(n.ZshLogin),l(k,F)):(y===w.get(n.Zsh)||y===w.get(n.ZshLogin))&&(D=y),!D)return;D=[...D],D[D.length-1]=(0,p.$df)(D[D.length-1],A);let J;try{J=a.userInfo().username}catch{J="unknown"}const V=$.$jc(a.tmpdir(),`${J}-${q.applicationName}-zsh`);F.ZDOTDIR=V;const Q=R?.ZDOTDIR??a.homedir()??"~";F.USER_ZDOTDIR=Q;const re=[];return re.push({source:$.$jc(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:$.$jc(V,".zshrc")}),re.push({source:$.$jc(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:$.$jc(V,".zprofile")}),re.push({source:$.$jc(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:$.$jc(V,".zshenv")}),re.push({source:$.$jc(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:$.$jc(V,".zlogin")}),{newArgs:D,envMixin:F,filesToCopy:re}}}M.warn(`Shell integration cannot be enabled for executable "${E.executable}" and args`,E.args)}function l(E,k){if(B.$k&&E.environmentVariableCollections){const R=(0,d.$Ks)(E.environmentVariableCollections),q=new u.$Ls(R).getVariableMap({workspaceFolder:E.workspaceFolder}).get("PATH"),I=[];if(q)for(const y of q)y.type===b.EnvironmentVariableMutatorType.Prepend&&I.push(y.value);I.length>0&&(k.VSCODE_PATH_PREFIX=I.join(""))}}var n;(function(E){E.WindowsPwsh="windows-pwsh",E.WindowsPwshLogin="windows-pwsh-login",E.Pwsh="pwsh",E.PwshLogin="pwsh-login",E.Zsh="zsh",E.ZshLogin="zsh-login",E.Bash="bash"})(n||(n={}));const w=new Map;w.set(n.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),w.set(n.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),w.set(n.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),w.set(n.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),w.set(n.Zsh,["-i"]),w.set(n.ZshLogin,["-il"]),w.set(n.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],o=["--login","-l"],s=["-i","--interactive"],i=["-nol","-nologo"];function g(E){return typeof E=="string"?v.includes(E.toLowerCase()):E.length===1&&v.includes(E[0].toLowerCase())||E.length===2&&(v.includes(E[0].toLowerCase())||v.includes(E[1].toLowerCase()))&&(i.includes(E[0].toLowerCase())||i.includes(E[1].toLowerCase()))}function _(E){return typeof E=="string"?i.includes(E.toLowerCase()):E.length===0||E?.length===1&&i.includes(E[0].toLowerCase())}function C(E){return typeof E!="string"&&(E=E.filter(k=>!s.includes(k.toLowerCase()))),E==="string"&&o.includes(E.toLowerCase())||typeof E!="string"&&E.length===1&&o.includes(E[0].toLowerCase())}}),define(he[97],fe([0,1,11,14,4,2,3,16]),function(ie,e,a,t,S,$,B,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0;const p=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let r;class L extends $.$Uc{get shellType(){return this.b}get shellTitle(){return this.c}get onShellNameChanged(){return this.f.event}get onShellTypeChanged(){return this.g.event}constructor(d){if(super(),this.h=d,this.c="",this.f=new S.$le,this.g=new S.$le,!B.$j)throw new Error(`WindowsShellHelper cannot be instantiated on ${B.$v}`);this.j()}async j(){this.q.isDisposed||this.checkShell()}async checkShell(){B.$j&&(await(0,a.$Gh)(300),this.getShellName().then(d=>{const u=this.getShellType(d);u!==this.b&&(this.g.fire(u),this.f.fire(d),this.b=u,this.c=d)}))}m(d){if(!d)return"";if(p.indexOf(d.name)===-1||!d.children||d.children.length===0)return d.name;let u=0;for(;u<d.children.length;u++){const c=d.children[u];if(!c.children||c.children.length===0||c.children[0].name!=="conhost.exe")break}return u>=d.children.length?d.name:this.m(d.children[u])}async getShellName(){return this.q.isDisposed?Promise.resolve(""):this.a?this.a:(r||(r=await new Promise((d,u)=>{ie(["@vscode/windows-process-tree"],d,u)}).then(Se)),this.a=new Promise(d=>{r.getProcessTree(this.h,u=>{const c=this.m(u);this.a=void 0,d(c)})}),this.a)}getShellType(d){switch(d.toLowerCase()){case"cmd.exe":return P.WindowsShellType.CommandPrompt;case"powershell.exe":case"pwsh.exe":return P.WindowsShellType.PowerShell;case"bash.exe":case"git-cmd.exe":return P.WindowsShellType.GitBash;case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return P.WindowsShellType.Wsl;default:return d.match(/python(\d(\.\d{0,2})?)?\.exe/)?P.WindowsShellType.Python:void 0}}}e.$Rmc=L,pe([(0,t.$$h)(500)],L.prototype,"checkShell",null)}),define(he[98],fe([0,1,35,29,11,4,2,5,3,6,12,8,79,16,41,42,97,102,93]),function(ie,e,a,t,S,$,B,P,p,r,L,b,d,u,c,h,f,l,n){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0,a=Se(a),P=Se(P);var v;(function(_){_[_.DataFlushTimeout=250]="DataFlushTimeout",_[_.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(v||(v={}));var o;(function(_){_[_.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",_[_.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",_[_.WriteInterval=5]="WriteInterval"})(o||(o={}));const s=new Map([["bash",u.PosixShellType.Bash],["csh",u.PosixShellType.Csh],["fish",u.PosixShellType.Fish],["ksh",u.PosixShellType.Ksh],["sh",u.PosixShellType.Sh],["pwsh",u.PosixShellType.PowerShell],["python",u.PosixShellType.Python],["zsh",u.PosixShellType.Zsh]]);let i=class extends B.$Uc{static{w=this}static{this.b=0}get exitMessage(){return this.h}get currentTitle(){return this.t?.shellTitle||this.n}get shellType(){return p.$j?this.t?.shellType:s.get(this.n)}get hasChildProcesses(){return this.u?.hasChildProcesses||!1}constructor(C,E,k,R,M,q,I,y,U){super(),this.shellLaunchConfig=C,this.N=q,this.O=I,this.P=y,this.Q=U,this.id=0,this.shouldPersist=!1,this.a={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this.n="",this.w=null,this.y=[],this.G=!1,this.H=0,this.I=this.B(new $.$le),this.onProcessData=this.I.event,this.J=this.B(new $.$le),this.onProcessReady=this.J.event,this.L=this.B(new $.$le),this.onDidChangeProperty=this.L.event,this.M=this.B(new $.$le),this.onProcessExit=this.M.event;let A;p.$j?A=P.$nc(this.shellLaunchConfig.executable||""):A="xterm-256color",this.D=E,this.a[u.ProcessPropertyType.InitialCwd]=this.D,this.a[u.ProcessPropertyType.Cwd]=this.D;const D=this.O.windowsEnableConpty&&process.platform==="win32"&&(0,h.$Ms)()>=18309;this.F={name:A,cwd:E,env:M,cols:k,rows:R,useConpty:D,conptyInheritCursor:D&&!!C.initialText},p.$j&&(D&&k===0&&R===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this.C=new g,this.B(this.C.onTrigger(F=>{this.C?.dispose(),this.C=void 0,F.cols&&F.rows&&this.resize(F.cols,F.rows)}))),this.onProcessReady(F=>{this.t=this.B(new f.$Rmc(F.pid)),this.B(this.t.onShellTypeChanged(J=>this.L.fire({type:u.ProcessPropertyType.ShellType,value:J}))),this.B(this.t.onShellNameChanged(J=>this.L.fire({type:u.ProcessPropertyType.Title,value:J})))})),this.B((0,B.$Sc)(()=>{this.w&&(clearInterval(this.w),this.w=null)}))}async start(){const E=(await Promise.all([this.R(),this.S()])).find(R=>R!==void 0);if(E)return E;let k;if(this.O.shellIntegration.enabled)if(k=(0,h.$Os)(this.shellLaunchConfig,this.O,this.F.env,this.P,this.Q),k){if(this.L.fire({type:u.ProcessPropertyType.UsedShellIntegrationInjection,value:!0}),k.envMixin)for(const[R,M]of Object.entries(k.envMixin))this.F.env||={},this.F.env[R]=M;if(k.filesToCopy)for(const R of k.filesToCopy){await a.promises.mkdir(P.$mc(R.dest),{recursive:!0});try{await a.promises.copyFile(R.source,R.dest)}catch{}}}else this.L.fire({type:u.ProcessPropertyType.FailedShellIntegrationActivation,value:!0});try{return await this.U(this.shellLaunchConfig,this.F,k),k?.newArgs?{injectedArgs:k.newArgs}:void 0}catch(R){return this.P.trace("node-pty.node-pty.IPty#spawn native exception",R),{message:`A native exception occurred during launch (${R.message})`}}}async R(){try{if(!(await a.promises.stat(this.D)).isDirectory())return{message:(0,L.localize)(11158,null,this.D.toString())}}catch(C){if(C?.code==="ENOENT")return{message:(0,L.localize)(11159,null,this.D.toString())}}this.L.fire({type:u.ProcessPropertyType.InitialCwd,value:this.D})}async S(){const C=this.shellLaunchConfig;if(!C.executable)throw new Error("IShellLaunchConfig.executable not set");const E=C.cwd instanceof r.URI?C.cwd.path:C.cwd,k=C.env&&C.env.PATH?C.env.PATH.split(P.$tc):void 0,R=await(0,h.$Ns)(C.executable,E,k,this.N);if(!R)return{message:(0,L.localize)(11160,null,C.executable)};try{const M=await a.promises.stat(R);if(!M.isFile()&&!M.isSymbolicLink())return{message:(0,L.localize)(11161,null,C.executable)};C.executable=R}catch(M){if(M?.code!=="EACCES")throw M}}async U(C,E,k){const R=k?.newArgs||C.args||[];await this.Z(),this.P.trace("node-pty.IPty#spawn",C.executable,R,E);const M=(0,l.spawn)(C.executable,R,E);this.m=M,this.u=this.B(new c.$Pmc(M.pid,this.P)),this.u.onDidChangeHasChildProcesses(q=>this.L.fire({type:u.ProcessPropertyType.HasChildProcesses,value:q})),this.s=new Promise(q=>{this.onProcessReady(()=>q())}),M.onData(q=>{this.H+=q.length,!this.G&&this.H>u.FlowControlConstants.HighWatermarkChars&&(this.P.trace(`Flow control: Pause (${this.H} > ${u.FlowControlConstants.HighWatermarkChars})`),this.G=!0,M.pause()),this.P.trace("node-pty.IPty#onData",q),this.I.fire(q),this.j&&this.X(),this.t?.checkShell(),this.u?.handleOutput()}),M.onExit(q=>{this.g=q.exitCode,this.X()}),this.$(M.pid),this.W(M)}W(C){setTimeout(()=>this.ab(C)),p.$j||(this.w=setInterval(()=>{this.n!==C.process&&this.ab(C)},200))}X(){this.P.getLevel()===b.LogLevel.Trace&&this.P.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this.j&&clearTimeout(this.j),this.j=setTimeout(()=>{this.j=void 0,this.Y()},v.DataFlushTimeout)}async Y(){if(await this.s,!this.q.isDisposed){try{this.m&&(await this.Z(),this.P.trace("node-pty.IPty#kill"),this.m.kill())}catch{}this.M.fire(this.g||0),this.dispose()}}async Z(){if(!(!p.$j||!("useConpty"in this.F)||!this.F.useConpty)){for(;Date.now()-w.b<o.KillSpawnThrottleInterval;)this.P.trace("Throttling kill/spawn call"),await(0,S.$Gh)(o.KillSpawnThrottleInterval-(Date.now()-w.b)+o.KillSpawnSpacingDuration);w.b=Date.now()}}$(C){this.J.fire({pid:C,cwd:this.D,windowsPty:this.getWindowsPty()})}ab(C){if(this.q.isDisposed)return;this.n=C.process??"",this.L.fire({type:u.ProcessPropertyType.Title,value:this.n});const E=this.currentTitle.replace(/ \(figterm\)$/g,"");E.toLowerCase().startsWith("python")?this.L.fire({type:u.ProcessPropertyType.ShellType,value:u.PosixShellType.Python}):this.L.fire({type:u.ProcessPropertyType.ShellType,value:s.get(E)})}shutdown(C){this.P.getLevel()===b.LogLevel.Trace&&this.P.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),C&&!p.$j?this.Y():!this.j&&!this.q.isDisposed&&(this.X(),setTimeout(()=>{this.j&&!this.q.isDisposed&&(this.j=void 0,this.Y())},v.MaximumShutdownTime))}input(C,E=!1){this.q.isDisposed||!this.m||(this.y.push(...(0,n.$ns)(C).map(k=>({isBinary:E,data:k}))),this.bb())}async processBinary(C){this.input(C,!0)}async refreshProperty(C){switch(C){case u.ProcessPropertyType.Cwd:{const E=await this.getCwd();return E!==this.a.cwd&&(this.a.cwd=E,this.L.fire({type:u.ProcessPropertyType.Cwd,value:this.a.cwd})),E}case u.ProcessPropertyType.InitialCwd:{const E=await this.getInitialCwd();return E!==this.a.initialCwd&&(this.a.initialCwd=E,this.L.fire({type:u.ProcessPropertyType.InitialCwd,value:this.a.initialCwd})),E}case u.ProcessPropertyType.Title:return this.currentTitle;default:return this.shellType}}async updateProperty(C,E){C===u.ProcessPropertyType.FixedDimensions&&(this.a.fixedDimensions=E)}bb(){if(!(this.z!==void 0||this.y.length===0)){if(this.cb(),this.y.length===0){this.z=void 0;return}this.z=setTimeout(()=>{this.z=void 0,this.bb()},o.WriteInterval)}}cb(){const C=this.y.shift();this.P.trace("node-pty.IPty#write",C.data),C.isBinary?this.m.write(Buffer.from(C.data,"binary")):this.m.write(C.data),this.u?.handleInput()}resize(C,E){if(!this.q.isDisposed&&!(typeof C!="number"||typeof E!="number"||isNaN(C)||isNaN(E))&&this.m){if(C=Math.max(C,1),E=Math.max(E,1),this.C){this.C.cols=C,this.C.rows=E;return}this.P.trace("node-pty.IPty#resize",C,E);try{this.m.resize(C,E)}catch(k){if(this.P.trace("node-pty.IPty#resize exception "+k.message),this.g!==void 0&&k.message!=="ioctl(2) failed, EBADF"&&k.message!=="Cannot resize a pty that has already exited")throw k}}}clearBuffer(){this.m?.clear()}acknowledgeDataEvent(C){this.H=Math.max(this.H-C,0),this.P.trace(`Flow control: Ack ${C} chars (unacknowledged: ${this.H})`),this.G&&this.H<u.FlowControlConstants.LowWatermarkChars&&(this.P.trace(`Flow control: Resume (${this.H} < ${u.FlowControlConstants.LowWatermarkChars})`),this.m?.resume(),this.G=!1)}clearUnacknowledgedChars(){this.H=0,this.P.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this.G&&(this.m?.resume(),this.G=!1)}async setUnicodeVersion(C){}getInitialCwd(){return Promise.resolve(this.D)}async getCwd(){if(p.$k)return new Promise(C=>{if(!this.m){C(this.D);return}this.P.trace("node-pty.IPty#pid"),(0,t.exec)("lsof -OPln -p "+this.m.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(E,k,R)=>{!E&&k!==""?C(k.substring(k.indexOf("/"),k.length-1)):(this.P.error("lsof did not run successfully, it may not be on the $PATH?",E,k,R),C(this.D))})});if(p.$l){if(!this.m)return this.D;this.P.trace("node-pty.IPty#pid");try{return await a.promises.readlink(`/proc/${this.m.pid}/cwd`)}catch{return this.D}}return this.D}getWindowsPty(){return p.$j?{backend:"useConpty"in this.F&&this.F.useConpty?"conpty":"winpty",buildNumber:(0,h.$Ms)()}:void 0}};e.$Smc=i,e.$Smc=i=w=pe([Be(7,b.$ak),Be(8,d.$tk)],i);class g extends B.$Uc{get onTrigger(){return this.b.event}constructor(){super(),this.b=this.B(new $.$le),this.a=setTimeout(()=>{this.b.fire({rows:this.rows,cols:this.cols})},1e3),this.B((0,B.$Sc)(()=>clearTimeout(this.a)))}}}),define(he[99],fe([0,1,29,11,4,2,3,62,8,90,16,92,40,42,98,12,41,91,7,95,94,71,14,103,104]),function(ie,e,a,t,S,$,B,P,p,r,L,b,d,u,c,h,f,l,n,w,v,o,s,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=void 0,e.$Tmc=_,i=Se(i);function _(U,A,D){if(typeof D.value!="function")throw new Error("not supported");const F="value",J=D.value;D[F]=async function(...V){this.traceRpcArgs.logService.getLevel()===p.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${J.name}(${V.map(re=>JSON.stringify(re)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,t.$Gh)(this.traceRpcArgs.simulatedLatency);let Q;try{Q=await J.apply(this,V)}catch(re){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${J.name}`,re),re}return this.traceRpcArgs.logService.getLevel()===p.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${J.name}`,Q),Q}}let C,E;class k extends $.$Uc{H(A,D){return D(F=>{this.I.getLevel()===p.LogLevel.Trace&&this.I.trace(`[RPC Event] PtyService#${A}.fire(${JSON.stringify(F)})`)}),D}get traceRpcArgs(){return{logService:this.I,simulatedLatency:this.M}}constructor(A,D,F,J){super(),this.I=A,this.J=D,this.L=F,this.M=J,this.a=new Map,this.b=new Map,this.g=new Map,this.j=new Map,this.n=0,this.u=this.B(new S.$le),this.onHeartbeat=this.H("_onHeartbeat",this.u.event),this.w=this.B(new S.$le),this.onProcessData=this.H("_onProcessData",this.w.event),this.y=this.B(new S.$le),this.onProcessReplay=this.H("_onProcessReplay",this.y.event),this.z=this.B(new S.$le),this.onProcessReady=this.H("_onProcessReady",this.z.event),this.C=this.B(new S.$le),this.onProcessExit=this.H("_onProcessExit",this.C.event),this.D=this.B(new S.$le),this.onProcessOrphanQuestion=this.H("_onProcessOrphanQuestion",this.D.event),this.F=this.B(new S.$le),this.onDidRequestDetach=this.H("_onDidRequestDetach",this.F.event),this.G=this.B(new S.$le),this.onDidChangeProperty=this.H("_onDidChangeProperty",this.G.event),this.B((0,$.$Sc)(()=>{for(const V of this.a.values())V.shutdown(!0);this.a.clear()})),this.f=this.B(new r.$ws(void 0,this.I)),this.f.onCreateRequest(this.F.fire,this.F)}async refreshIgnoreProcessNames(A){f.$Omc.length=0,f.$Omc.push(...A)}async requestDetachInstance(A,D){return this.f.createRequest({workspaceId:A,instanceId:D})}async acceptDetachInstanceReply(A,D){let F;const J=this.a.get(D);J&&(F=await this.S(D,J)),this.f.acceptReply(A,F)}async freePortKillProcess(A){const F=(await new Promise((J,V)=>{(0,a.exec)(B.$j?`netstat -ano | findstr "${A}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${A}`,{},(Q,re)=>{if(Q)return V("Problem occurred when listing active processes");J(re)})})).split(/\r?\n/).filter(J=>!!J.trim());if(F.length>=1){const J=/\s+(\d+)(?:\s+|$)/,V=F[0].match(J)?.[1];if(V)try{process.kill(Number.parseInt(V))}catch{}else throw new Error(`Processes for port ${A} were not found`);return{port:A,processId:V}}throw new Error(`Could not kill process with port ${A}`)}async serializeTerminalState(A){const D=[];for(const[J,V]of this.a.entries())V.hasWrittenData&&A.indexOf(J)!==-1&&D.push(t.Promises.withAsyncBody(async Q=>{Q({id:J,shellLaunchConfig:V.shellLaunchConfig,processDetails:await this.S(J,V),processLaunchConfig:V.processLaunchOptions,unicodeVersion:V.unicodeVersion,replayEvent:await V.serializeNormalBuffer(),timestamp:Date.now()})}));const F={version:1,state:await Promise.all(D)};return JSON.stringify(F)}async reviveTerminalProcesses(A,D,F){const J=[];for(const V of D)J.push(this.N(A,V));await Promise.all(J)}async N(A,D){const F=(0,h.localize)(11162,null),J=await this.createProcess({...D.shellLaunchConfig,cwd:D.processDetails.cwd,color:D.processDetails.color,icon:D.processDetails.icon,name:D.processDetails.titleSource===L.TitleEventSource.Api?D.processDetails.title:void 0,initialText:D.replayEvent.events[0].data+(0,v.$PXb)(F,{loudFormatting:!0})},D.processDetails.cwd,D.replayEvent.events[0].cols,D.replayEvent.events[0].rows,D.unicodeVersion,D.processLaunchConfig.env,D.processLaunchConfig.executableEnv,D.processLaunchConfig.options,!0,D.processDetails.workspaceId,D.processDetails.workspaceName,!0,D.replayEvent.events[0].data),V=this.R(A,D.id);this.g.set(V,{newId:J,state:D}),this.I.info(`Revived process, old id ${V} -> new id ${J}`)}async shutdownAll(){this.dispose()}async createProcess(A,D,F,J,V,Q,re,ce,K,j,Y,ee,le){if(A.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const G=++this.n,ae=new c.$Smc(A,D,F,J,Q,re,ce,this.I,this.J),me={env:Q,executableEnv:re,options:ce},te=new M(G,ae,j,Y,K,F,J,me,V,this.L,this.I,ee&&typeof A.initialText=="string"?A.initialText:void 0,le,A.icon,A.color,A.name,A.fixedDimensions);return ae.onProcessExit(m=>{te.dispose(),this.a.delete(G),this.C.fire({id:G,event:m})}),te.onProcessData(m=>this.w.fire({id:G,event:m})),te.onProcessReplay(m=>this.y.fire({id:G,event:m})),te.onProcessReady(m=>this.z.fire({id:G,event:m})),te.onProcessOrphanQuestion(()=>this.D.fire({id:G})),te.onDidChangeProperty(m=>this.G.fire({id:G,property:m})),te.onPersistentProcessReady(()=>{for(const m of this.j.entries())te.installAutoReply(m[0],m[1])}),this.a.set(G,te),G}async attachToProcess(A){try{await this.U(A).attach(),this.I.info(`Persistent process reconnection "${A}"`)}catch(D){throw this.I.warn(`Persistent process reconnection "${A}" failed`,D.message),D}}async updateTitle(A,D,F){this.U(A).setTitle(D,F)}async updateIcon(A,D,F,J){this.U(A).setIcon(D,F,J)}async clearBuffer(A){this.U(A).clearBuffer()}async refreshProperty(A,D){return this.U(A).refreshProperty(D)}async updateProperty(A,D,F){return this.U(A).updateProperty(D,F)}async detachFromProcess(A,D){return this.U(A).detach(D)}async reduceConnectionGraceTime(){for(const A of this.a.values())A.reduceGraceTime()}async listProcesses(){const A=Array.from(this.a.entries()).filter(([J,V])=>V.shouldPersistTerminal);this.I.info(`Listing ${A.length} persistent terminals, ${this.a.size} total terminals`);const D=A.map(async([J,V])=>this.S(J,V));return(await Promise.all(D)).filter(J=>J.isOrphan)}async getPerformanceMarks(){return i.getMarks()}async start(A){const D=this.a.get(A);return D?D.start():{message:`Could not find pty with id "${A}"`}}async shutdown(A,D){return this.a.get(A)?.shutdown(D)}async input(A,D){return this.U(A).input(D)}async processBinary(A,D){return this.U(A).writeBinary(D)}async resize(A,D,F){return this.U(A).resize(D,F)}async getInitialCwd(A){return this.U(A).getInitialCwd()}async getCwd(A){return this.U(A).getCwd()}async acknowledgeDataEvent(A,D){return this.U(A).acknowledgeDataEvent(D)}async setUnicodeVersion(A,D){return this.U(A).setUnicodeVersion(D)}async getLatency(){return[]}async orphanQuestionReply(A){return this.U(A).orphanQuestionReply()}async installAutoReply(A,D){this.j.set(A,D);for(const F of this.a.values())F.installAutoReply(A,D)}async uninstallAllAutoReplies(){for(const A of this.j.keys())for(const D of this.a.values())D.uninstallAutoReply(A)}async uninstallAutoReply(A){for(const D of this.a.values())D.uninstallAutoReply(A)}async getDefaultSystemShell(A=B.OS){return(0,P.$Am)(A,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(A,D){if(D==="win-to-unix"){if(!B.$j)return A;if((0,u.$Ms)()<17063)return A.replace(/\\/g,"/");const F=this.O();return F?new Promise(J=>{(0,a.execFile)(F,["-e","wslpath",A],{},(Q,re,ce)=>{J(Q?A:(0,d.$aR)(re.trim()))}).stdin.end()}):A}if(D==="unix-to-win"&&B.$j){if((0,u.$Ms)()<17063)return A;const F=this.O();return F?new Promise(J=>{(0,a.execFile)(F,["-e","wslpath","-w",A],{},(Q,re,ce)=>{J(Q?A:re.trim())}).stdin.end()}):A}return A}O(){const A=(0,u.$Ms)()>=16299,D=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),F=process.env.SystemRoot;if(F)return(0,o.join)(F,D?"Sysnative":"System32",A?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(A,D){try{return this.g.get(this.R(A,D))?.newId}catch(F){this.I.warn(`Couldn't find terminal ID ${A}-${D}`,F.message)}}async setTerminalLayoutInfo(A){this.b.set(A.workspaceId,A)}async getTerminalLayoutInfo(A){i.mark("code/willGetTerminalLayoutInfo");const D=this.b.get(A.workspaceId);if(D){const F=new Set,V=(await Promise.all(D.tabs.map(async Q=>this.P(A.workspaceId,Q,F)))).filter(Q=>Q.terminals.length>0);return i.mark("code/didGetTerminalLayoutInfo"),{tabs:V}}i.mark("code/didGetTerminalLayoutInfo")}async P(A,D,F){const V=(await Promise.all(D.terminals.map(Q=>this.Q(A,Q,F)))).filter(Q=>Q.terminal!==null);return{isActive:D.isActive,activePersistentProcessId:D.activePersistentProcessId,terminals:V}}async Q(A,D,F){try{const J=this.R(A,D.terminal),V=this.g.get(J)?.newId;this.I.info(`Expanding terminal instance, old id ${J} -> new id ${V}`),this.g.delete(J);const Q=V??D.terminal;if(F.has(Q))throw new Error(`Terminal ${Q} has already been expanded`);F.add(Q);const re=this.U(Q);return{terminal:{...re&&await this.S(D.terminal,re,V!==void 0),id:Q},relativeSize:D.relativeSize}}catch(J){return this.I.warn("Couldn't get layout info, a terminal was probably disconnected",J.message),this.I.debug("Reattach to wrong terminal debug info - layout info by id",D),this.I.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this.g.values())),this.I.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this.a.keys())),{terminal:null,relativeSize:D.relativeSize}}}R(A,D){return`${A}-${D}`}async S(A,D,F=!1){i.mark(`code/willBuildProcessDetails/${A}`);const[J,V]=await Promise.all([D.getCwd(),F?!0:D.isOrphaned()]),Q={id:A,title:D.title,titleSource:D.titleSource,pid:D.pid,workspaceId:D.workspaceId,workspaceName:D.workspaceName,cwd:J,isOrphan:V,icon:D.icon,color:D.color,fixedDimensions:D.fixedDimensions,environmentVariableCollections:D.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:D.shellLaunchConfig.reconnectionProperties,waitOnExit:D.shellLaunchConfig.waitOnExit,hideFromUser:D.shellLaunchConfig.hideFromUser,isFeatureTerminal:D.shellLaunchConfig.isFeatureTerminal,type:D.shellLaunchConfig.type,hasChildProcesses:D.hasChildProcesses,shellIntegrationNonce:D.processLaunchOptions.options.shellIntegration.nonce};return i.mark(`code/didBuildProcessDetails/${A}`),Q}U(A){const D=this.a.get(A);if(!D)throw new n.$ab("Could not find pty on pty host");return D}}e.$Umc=k,pe([s.$0h],k.prototype,"traceRpcArgs",null),pe([_],k.prototype,"refreshIgnoreProcessNames",null),pe([_],k.prototype,"requestDetachInstance",null),pe([_],k.prototype,"acceptDetachInstanceReply",null),pe([_],k.prototype,"freePortKillProcess",null),pe([_],k.prototype,"serializeTerminalState",null),pe([_],k.prototype,"reviveTerminalProcesses",null),pe([_],k.prototype,"shutdownAll",null),pe([_],k.prototype,"createProcess",null),pe([_],k.prototype,"attachToProcess",null),pe([_],k.prototype,"updateTitle",null),pe([_],k.prototype,"updateIcon",null),pe([_],k.prototype,"clearBuffer",null),pe([_],k.prototype,"refreshProperty",null),pe([_],k.prototype,"updateProperty",null),pe([_],k.prototype,"detachFromProcess",null),pe([_],k.prototype,"reduceConnectionGraceTime",null),pe([_],k.prototype,"listProcesses",null),pe([_],k.prototype,"getPerformanceMarks",null),pe([_],k.prototype,"start",null),pe([_],k.prototype,"shutdown",null),pe([_],k.prototype,"input",null),pe([_],k.prototype,"processBinary",null),pe([_],k.prototype,"resize",null),pe([_],k.prototype,"getInitialCwd",null),pe([_],k.prototype,"getCwd",null),pe([_],k.prototype,"acknowledgeDataEvent",null),pe([_],k.prototype,"setUnicodeVersion",null),pe([_],k.prototype,"getLatency",null),pe([_],k.prototype,"orphanQuestionReply",null),pe([_],k.prototype,"installAutoReply",null),pe([_],k.prototype,"uninstallAllAutoReplies",null),pe([_],k.prototype,"uninstallAutoReply",null),pe([_],k.prototype,"getDefaultSystemShell",null),pe([_],k.prototype,"getEnvironment",null),pe([_],k.prototype,"getWslPath",null),pe([_],k.prototype,"getRevivedPtyNewId",null),pe([_],k.prototype,"setTerminalLayoutInfo",null),pe([_],k.prototype,"getTerminalLayoutInfo",null);var R;(function(U){U.None="None",U.ReplayOnly="ReplayOnly",U.Session="Session"})(R||(R={}));class M extends $.$Uc{get pid(){return this.L}get shellLaunchConfig(){return this.W.shellLaunchConfig}get hasWrittenData(){return this.j.value!==R.None}get title(){return this.N||this.W.currentTitle}get titleSource(){return this.O}get icon(){return this.Y}get color(){return this.Z}get fixedDimensions(){return this.R}get hasChildProcesses(){return this.W.hasChildProcesses}setTitle(A,D){D===L.TitleEventSource.Api&&(this.j.setValue(R.Session,"setTitle"),this.P.freeRawReviveBuffer()),this.N=A,this.O=D}setIcon(A,D,F){(!this.Y||"id"in D&&"id"in this.Y&&D.id!==this.Y.id||!this.color||F!==this.Z)&&(this.P.freeRawReviveBuffer(),A&&this.j.setValue(R.Session,"setIcon")),this.Y=D,this.Z=F}S(A){this.R=A}constructor(A,D,F,J,V,Q,re,ce,K,j,Y,ee,le,G,ae,me,te){super(),this.U=A,this.W=D,this.workspaceId=F,this.workspaceName=J,this.shouldPersistTerminal=V,this.processLaunchOptions=ce,this.unicodeVersion=K,this.X=Y,this.Y=G,this.Z=ae,this.b=new Map,this.f=new Map,this.g=!1,this.w=new t.$Mh,this.C=this.B(new S.$le),this.onProcessReplay=this.C.event,this.D=this.B(new S.$le),this.onProcessReady=this.D.event,this.F=this.B(new S.$le),this.onPersistentProcessReady=this.F.event,this.G=this.B(new S.$le),this.onProcessData=this.G.event,this.H=this.B(new S.$le),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$le),this.onDidChangeProperty=this.I.event,this.J=!1,this.L=-1,this.M="",this.O=L.TitleEventSource.Process,this.j=new q(`Persistent process "${this.U}" interaction state`,R.None,this.X),this.Q=ee!==void 0,this.P=new I(Q,re,j.scrollback,K,ee,ce.options.shellIntegration.nonce,V?le:void 0,this.X),me&&this.setTitle(me,L.TitleEventSource.Api),this.R=te,this.n=null,this.u=0,this.y=this.B(new t.$Sh(()=>{this.X.info(`Persistent process "${this.U}": The reconnection grace time of ${y(j.graceTime)} has expired, shutting down pid "${this.L}"`),this.shutdown(!0)},j.graceTime)),this.z=this.B(new t.$Sh(()=>{this.X.info(`Persistent process "${this.U}": The short reconnection grace time of ${y(j.shortGraceTime)} has expired, shutting down pid ${this.L}`),this.shutdown(!0)},j.shortGraceTime)),this.B(this.W.onProcessExit(()=>this.a.stopBuffering(this.U))),this.B(this.W.onProcessReady(m=>{this.L=m.pid,this.M=m.cwd,this.D.fire(m)})),this.B(this.W.onDidChangeProperty(m=>{this.I.fire(m)})),this.a=new b.$Xxb((m,W)=>this.G.fire(W)),this.B(this.a.startBuffering(this.U,this.W.onProcessData)),this.B(this.onProcessData(m=>this.P.handleData(m))),this.B((0,$.$Sc)(()=>{for(const m of this.b.values())m.dispose();this.b.clear()}))}async attach(){!this.y.isScheduled()&&!this.z.isScheduled()&&this.X.warn(`Persistent process "${this.U}": Process had no disconnect runners but was an orphan`),this.y.cancel(),this.z.cancel()}async detach(A){this.shouldPersistTerminal&&(this.j.value!==R.None||A)?this.y.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this.P.generateReplayEvent(!0,this.j.value!==R.Session)}async refreshProperty(A){return this.W.refreshProperty(A)}async updateProperty(A,D){if(A===L.ProcessPropertyType.FixedDimensions)return this.S(D)}async start(){if(!this.g){const A=await this.W.start();return A&&"message"in A||(this.g=!0,this.Q?this.triggerReplay():this.F.fire()),A}this.D.fire({pid:this.L,cwd:this.M,windowsPty:this.W.getWindowsPty()}),this.I.fire({type:L.ProcessPropertyType.Title,value:this.W.currentTitle}),this.I.fire({type:L.ProcessPropertyType.ShellType,value:this.W.shellType}),this.triggerReplay()}shutdown(A){return this.W.shutdown(A)}input(A){if(this.j.setValue(R.Session,"input"),this.P.freeRawReviveBuffer(),!this.J){for(const D of this.b.values())D.handleInput();return this.W.input(A)}}writeBinary(A){return this.W.processBinary(A)}resize(A,D){if(!this.J){this.P.handleResize(A,D),this.a.flushBuffer(this.U);for(const F of this.b.values())F.handleResize();return this.W.resize(A,D)}}async clearBuffer(){this.P.clearBuffer(),this.W.clearBuffer()}setUnicodeVersion(A){this.unicodeVersion=A,this.P.setUnicodeVersion?.(A)}acknowledgeDataEvent(A){if(!this.J)return this.W.acknowledgeDataEvent(A)}getInitialCwd(){return this.W.getInitialCwd()}getCwd(){return this.W.getCwd()}async triggerReplay(){this.j.value===R.None&&this.j.setValue(R.ReplayOnly,"triggerReplay");const A=await this.P.generateReplayEvent();let D=0;for(const F of A.events)D+=F.data.length;this.X.info(`Persistent process "${this.U}": Replaying ${D} chars and ${A.events.length} size events`),this.C.fire(A),this.W.clearUnacknowledgedChars(),this.F.fire()}installAutoReply(A,D){this.b.get(A)?.dispose(),this.b.set(A,new l.$Nmc(this.W,A,D,this.X))}uninstallAutoReply(A){this.b.get(A)?.dispose(),this.b.delete(A)}sendCommandResult(A,D,F){this.f.get(A)&&this.f.delete(A)}orphanQuestionReply(){if(this.u=Date.now(),this.n){const A=this.n;this.n=null,A.open()}}reduceGraceTime(){this.z.isScheduled()||this.y.isScheduled()&&this.z.schedule()}async isOrphaned(){return await this.w.queue(async()=>this.$())}async $(){return this.y.isScheduled()||this.z.isScheduled()?!0:(this.n||(this.n=new t.$Fh(4e3),this.u=0,this.H.fire()),await this.n.wait(),Date.now()-this.u>500)}}class q{get value(){return this.b}setValue(A,D){this.b!==A&&(this.b=A,this.f(D))}constructor(A,D,F){this.a=A,this.b=D,this.d=F,this.f("initialized")}f(A){this.d.debug(`MutationLogger "${this.a}" set to "${this.b}", reason: ${A}`)}}class I{constructor(A,D,F,J,V,Q,re,ce){this.f=re,this.a=new g.Terminal({cols:A,rows:D,scrollback:F,allowProposedApi:!0}),V&&this.a.writeln(V),this.setUnicodeVersion(J),this.b=new w.$Owb(Q,!0,void 0,ce),this.a.loadAddon(this.b)}freeRawReviveBuffer(){this.f=void 0}handleData(A){this.a.write(A)}handleResize(A,D){this.a.resize(A,D)}clearBuffer(){this.a.clear()}async generateReplayEvent(A,D){const F=new(await this._getSerializeConstructor());this.a.loadAddon(F);const J={scrollback:this.a.options.scrollback};A&&(J.excludeAltBuffer=!0,J.excludeModes=!0);let V;return D&&this.f?V=this.f:V=F.serialize(J),{events:[{cols:this.a.cols,rows:this.a.rows,data:V}],commands:this.b.serialize()}}async setUnicodeVersion(A){this.a.unicode.activeVersion!==A&&(A==="11"?(this.d=new(await this._getUnicode11Constructor()),this.a.loadAddon(this.d)):(this.d?.dispose(),this.d=void 0),this.a.unicode.activeVersion=A)}async _getUnicode11Constructor(){return E||(E=(await new Promise((A,D)=>{ie(["@xterm/addon-unicode11"],A,D)}).then(Se)).Unicode11Addon),E}async _getSerializeConstructor(){return C||(C=(await new Promise((A,D)=>{ie(["@xterm/addon-serialize"],A,D)}).then(Se)).SerializeAddon),C}}function y(U){let A=0,D=0,F=0;U>=1e3&&(F=Math.floor(U/1e3),U-=F*1e3),F>=60&&(D=Math.floor(F/60),F-=D*60),D>=60&&(A=Math.floor(D/60),D-=A*60);const J=A?`${A}h`:"",V=D?`${D}m`:"",Q=F?`${F}s`:"",re=U?`${U}ms`:"";return`${J}${V}${Q}${re}`}});var Ke=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[105],fe([0,1,58,30,63,64,12,69,72,8,74,75,77,78,16,96,99,37,11,2]),function(ie,e,a,t,S,$,B,P,p,r,L,b,d,u,c,h,f,l,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),u=Ke(u),v();async function v(){const o=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),s=parseInt(process.env.VSCODE_LATENCY??"0"),i={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,o&&await(0,n.$Gh)(o);const g=(0,l.$9X)(process);let _;g?_=new $.$0X:_=new S.$hr(c.TerminalIpcChannels.PtyHost);const C={_serviceBrand:void 0,...u.default},E=new p.$9m((0,P.$Dm)(process.argv,P.$Cm),C),k=new d.$AR((0,r.$ok)(E),E.logsHome);_.registerChannel(c.TerminalIpcChannels.Logger,new L.$us(k,()=>a.$Nn));const R=k.createLogger("ptyhost",{name:(0,B.localize)(11163,null)}),M=new b.$KR(R);o&&M.warn(`Pty Host startup is delayed ${o}ms`),s&&M.warn(`Pty host is simulating ${s}ms latency`);const q=new w.$Tc,I=new h.$Qmc;_.registerChannel(c.TerminalIpcChannels.Heartbeat,t.ProxyChannel.fromService(I,q));const y=new f.$Umc(M,C,i,s),U=t.ProxyChannel.fromService(y,q);_.registerChannel(c.TerminalIpcChannels.PtyHost,U),g&&_.registerChannel(c.TerminalIpcChannels.PtyHostWindow,U),process.once("exit",()=>{M.trace("Pty host exiting"),M.dispose(),I.dispose(),y.dispose()})}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/fee1edb8d6d72a0ddff41e5f71a671c23ed924b9/core/vs/platform/terminal/node/ptyHostMain.js.map
