/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/charCode","vs/base/common/errors","vs/base/common/strings","vs/base/common/extpath","vs/base/common/functional","vs/base/common/lazy","vs/base/common/lifecycle","vs/base/common/process","vs/base/common/event","vs/base/common/cancellation","vs/base/common/uri","vs/base/common/async","fs","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/marshallingIds","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/symbols","vs/base/common/types","vs/base/common/uint","vs/base/common/network","vs/base/common/resources","vs/base/node/terminalEncoding","child_process","vs/nls","vs/platform/environment/node/argv","vs/platform/environment/node/stdin","os","vs/platform/environment/node/wait","minimist","vs/server/node/server.cli","url","http"],be=function(re){for(var e=[],m=0,t=re.length;m<t;m++)e[m]=me[re[m]];return e};define(me[17],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=m,e.$fb=t,e.$gb=v,e.$hb=U,e.$ib=x,e.$jb=j,e.$kb=N,e.$mb=B,e.$nb=K,e.$ob=F,e.$pb=Z,e.$qb=p;function m(c,$){const A=t(c,$);if(A!==-1)return c[A]}function t(c,$,A=c.length-1){for(let S=A;S>=0;S--){const G=c[S];if($(G))return S}return-1}function v(c,$){const A=U(c,$);return A===-1?void 0:c[A]}function U(c,$,A=0,S=c.length){let G=A,J=S;for(;G<J;){const W=Math.floor((G+J)/2);$(c[W])?G=W+1:J=W}return G-1}function x(c,$){const A=j(c,$);return A===c.length?void 0:c[A]}function j(c,$,A=0,S=c.length){let G=A,J=S;for(;G<J;){const W=Math.floor((G+J)/2);$(c[W])?J=W:G=W+1}return G}function N(c,$,A=0,S=c.length){const G=j(c,$,A,S);return G===c.length?-1:G}class I{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(I.assertInvariants){if(this.d){for(const S of this.e)if(this.d(S)&&!$(S))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const A=U(this.e,$,this.c);return this.c=A+1,A===-1?void 0:this.e[A]}}e.$lb=I;function B(c,$){if(c.length===0)return;let A=c[0];for(let S=1;S<c.length;S++){const G=c[S];$(G,A)>0&&(A=G)}return A}function K(c,$){if(c.length===0)return;let A=c[0];for(let S=1;S<c.length;S++){const G=c[S];$(G,A)>=0&&(A=G)}return A}function F(c,$){return B(c,(A,S)=>-$(A,S))}function Z(c,$){if(c.length===0)return-1;let A=0;for(let S=1;S<c.length;S++){const G=c[S];$(G,c[A])>0&&(A=S)}return A}function p(c,$){for(const A of c){const S=$(A);if(S!==void 0)return S}}}),define(me[4],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var m;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(m||(e.CharCode=m={}))}),define(me[18],be([0,1]),function(re,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=t,e.$d=v,e.$e=U,e.$f=x;function t(N,I){const B=Object.create(null);for(const K of N){const F=I(K);let Z=B[F];Z||(Z=B[F]=[]),Z.push(K)}return B}function v(N,I){const B=[],K=[];for(const F of N)I.has(F)||B.push(F);for(const F of I)N.has(F)||K.push(F);return{removed:B,added:K}}function U(N,I){const B=[],K=[];for(const[F,Z]of N)I.has(F)||B.push(Z);for(const[F,Z]of I)N.has(F)||K.push(Z);return{removed:B,added:K}}function x(N,I){const B=new Set;for(const K of I)N.has(K)&&B.add(K);return B}class j{static{m=Symbol.toStringTag}constructor(I,B){this.b=B,this.a=new Map,this[m]="SetWithKey";for(const K of I)this.add(K)}get size(){return this.a.size}add(I){const B=this.b(I);return this.a.set(B,I),this}delete(I){return this.a.delete(this.b(I))}has(I){return this.a.has(this.b(I))}*entries(){for(const I of this.a.values())yield[I,I]}keys(){return this.values()}*values(){for(const I of this.a.values())yield I}clear(){this.a.clear()}forEach(I,B){this.a.forEach(K=>I.call(B,K,K,this))}[Symbol.iterator](){return this.values()}}e.$g=j}),define(me[5],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=t,e.$X=v,e.$Y=U,e.$Z=x,e.$1=j,e.$2=N,e.$3=B,e.$5=F,e.$6=Z,e.$7=p,e.$9=$;class m{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?J.isErrorNoTelemetry(n)?new J(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$U=m,e.$V=new m;function t(i){e.$V.setUnexpectedErrorHandler(i)}function v(i){if(!i||typeof i!="object")return!1;const n=i;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function U(i){B(i)||e.$V.onUnexpectedError(i)}function x(i){B(i)||e.$V.onUnexpectedExternalError(i)}function j(i){if(i instanceof Error){const{name:n,message:s}=i,d=i.stacktrace||i.stack;return{$isError:!0,name:n,message:s,stack:d,noTelemetry:J.isErrorNoTelemetry(i)}}return i}function N(i){let n;return i.noTelemetry?n=new J:(n=new Error,n.name=i.name),n.message=i.message,n.stack=i.stack,n}const I="Canceled";function B(i){return i instanceof K?!0:i instanceof Error&&i.name===I&&i.message===I}class K extends Error{constructor(){super(I),this.name=this.message}}e.$4=K;function F(){const i=new Error(I);return i.name=i.message,i}function Z(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function p(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class c extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=c;function $(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class A extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$0=A;class S extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$$=S;class G extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=G;class J extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof J)return n;const s=new J;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$ab=J;class W extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,W.prototype)}}e.$bb=W}),define(me[19],be([0,1,5,17]),function(re,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=v,e.$sb=U,e.$tb=x,e.$ub=j,e.$vb=N,e.$wb=I,e.$xb=B,e.$yb=K,e.$zb=F,e.$Ab=Z,e.$Bb=p,e.$Cb=c,e.$Db=$,e.top=A,e.$Fb=S,e.$Gb=J,e.$Hb=W,e.$Ib=i,e.$Jb=n,e.$Kb=s,e.$Lb=d,e.$Mb=R,e.$Nb=h,e.$Ob=f,e.$Pb=u,e.$Qb=o,e.$Rb=O,e.$Sb=w,e.$Tb=g,e.$Ub=M,e.$Vb=P,e.$Wb=q,e.$Xb=T,e.$Yb=V,e.$Zb=le,e.$1b=z,e.$2b=se,e.$3b=ee,e.$4b=te,e.$5b=Le,e.$6b=ye,e.$9b=ce,e.$ac=ve;function v(E,y=0){return E[E.length-(1+y)]}function U(E){if(E.length===0)throw new Error("Invalid tail call");return[E.slice(0,E.length-1),E[E.length-1]]}function x(E,y,a=(r,_)=>r===_){if(E===y)return!0;if(!E||!y||E.length!==y.length)return!1;for(let r=0,_=E.length;r<_;r++)if(!a(E[r],y[r]))return!1;return!0}function j(E,y){const a=E.length-1;y<a&&(E[y]=E[a]),E.pop()}function N(E,y,a){return I(E.length,r=>a(E[r],y))}function I(E,y){let a=0,r=E-1;for(;a<=r;){const _=(a+r)/2|0,L=y(_);if(L<0)a=_+1;else if(L>0)r=_-1;else return _}return-(a+1)}function B(E,y,a){if(E=E|0,E>=y.length)throw new TypeError("invalid index");const r=y[Math.floor(y.length*Math.random())],_=[],L=[],k=[];for(const C of y){const _e=a(C,r);_e<0?_.push(C):_e>0?L.push(C):k.push(C)}return E<_.length?B(E,_,a):E<_.length+k.length?k[0]:B(E-(_.length+k.length),L,a)}function K(E,y){const a=[];let r;for(const _ of E.slice(0).sort(y))!r||y(r[0],_)!==0?(r=[_],a.push(r)):r.push(_);return a}function*F(E,y){let a,r;for(const _ of E)r!==void 0&&y(r,_)?a.push(_):(a&&(yield a),a=[_]),r=_;a&&(yield a)}function Z(E,y){for(let a=0;a<=E.length;a++)y(a===0?void 0:E[a-1],a===E.length?void 0:E[a])}function p(E,y){for(let a=0;a<E.length;a++)y(a===0?void 0:E[a-1],E[a],a+1===E.length?void 0:E[a+1])}function c(E,y,a){const r=[];function _(C,_e,Ee){if(_e===0&&Ee.length===0)return;const Y=r[r.length-1];Y&&Y.start+Y.deleteCount===C?(Y.deleteCount+=_e,Y.toInsert.push(...Ee)):r.push({start:C,deleteCount:_e,toInsert:Ee})}let L=0,k=0;for(;;){if(L===E.length){_(L,0,y.slice(k));break}if(k===y.length){_(L,E.length-L,[]);break}const C=E[L],_e=y[k],Ee=a(C,_e);Ee===0?(L+=1,k+=1):Ee<0?(_(L,1,[]),L+=1):Ee>0&&(_(L,0,[_e]),k+=1)}return r}function $(E,y,a){const r=c(E,y,a),_=[],L=[];for(const k of r)_.push(...E.slice(k.start,k.start+k.deleteCount)),L.push(...k.toInsert);return{removed:_,added:L}}function A(E,y,a){if(a===0)return[];const r=E.slice(0,a).sort(y);return G(E,y,r,a,E.length),r}function S(E,y,a,r,_){return a===0?Promise.resolve([]):new Promise((L,k)=>{(async()=>{const C=E.length,_e=E.slice(0,a).sort(y);for(let Ee=a,Y=Math.min(a+r,C);Ee<C;Ee=Y,Y=Math.min(Y+r,C)){if(Ee>a&&await new Promise(X=>setTimeout(X)),_&&_.isCancellationRequested)throw new m.$4;G(E,y,_e,Ee,Y)}return _e})().then(L,k)})}function G(E,y,a,r,_){for(const L=a.length;r<_;r++){const k=E[r];if(y(k,a[L-1])<0){a.pop();const C=(0,t.$jb)(a,_e=>y(k,_e)<0);a.splice(C,0,k)}}}function J(E){return E.filter(y=>!!y)}function W(E){let y=0;for(let a=0;a<E.length;a++)E[a]&&(E[y]=E[a],y+=1);E.length=y}function i(E,y,a){E.splice(a,0,E.splice(y,1)[0])}function n(E){return!Array.isArray(E)||E.length===0}function s(E){return Array.isArray(E)&&E.length>0}function d(E,y=a=>a){const a=new Set;return E.filter(r=>{const _=y(r);return a.has(_)?!1:(a.add(_),!0)})}function R(E){const y=new Set;return a=>{const r=E(a);return y.has(r)?!1:(y.add(r),!0)}}function h(E,y){return E.length>0?E[0]:y}function f(E,y){return E.length>0?E[E.length-1]:y}function u(E,y,a=(r,_)=>r===_){let r=0;for(let _=0,L=Math.min(E.length,y.length);_<L&&a(E[_],y[_]);_++)r++;return r}function o(E,y){let a=typeof y=="number"?E:0;typeof y=="number"?a=E:(a=0,y=E);const r=[];if(a<=y)for(let _=a;_<y;_++)r.push(_);else for(let _=a;_>y;_--)r.push(_);return r}function O(E,y,a){return E.reduce((r,_)=>(r[y(_)]=a?a(_):_,r),Object.create(null))}function w(E,y){return E.push(y),()=>g(E,y)}function g(E,y){const a=E.indexOf(y);if(a>-1)return E.splice(a,1),y}function M(E,y,a){const r=E.slice(0,y),_=E.slice(y);return r.concat(a,_)}function P(E,y){let a;if(typeof y=="number"){let r=y;a=()=>{const _=Math.sin(r++)*179426549;return _-Math.floor(_)}}else a=Math.random;for(let r=E.length-1;r>0;r-=1){const _=Math.floor(a()*(r+1)),L=E[r];E[r]=E[_],E[_]=L}}function q(E,y){const a=E.indexOf(y);a>-1&&(E.splice(a,1),E.unshift(y))}function T(E,y){const a=E.indexOf(y);a>-1&&(E.splice(a,1),E.push(y))}function V(E,y){for(const a of y)E.push(a)}function le(E,y){return Array.isArray(E)?E.map(y):y(E)}function z(E){return Array.isArray(E)?E:[E]}function se(E){return E[Math.floor(Math.random()*E.length)]}function ee(E,y,a){const r=oe(E,y),_=E.length,L=a.length;E.length=_+L;for(let k=_-1;k>=r;k--)E[k+L]=E[k];for(let k=0;k<L;k++)E[k+r]=a[k]}function te(E,y,a,r){const _=oe(E,y);let L=E.splice(_,a);return L===void 0&&(L=[]),ee(E,_,r),L}function oe(E,y){return y<0?Math.max(y+E.length,0):Math.min(y,E.length)}var fe;(function(E){function y(L){return L<0}E.isLessThan=y;function a(L){return L<=0}E.isLessThanOrEqual=a;function r(L){return L>0}E.isGreaterThan=r;function _(L){return L===0}E.isNeitherLessOrGreaterThan=_,E.greaterThan=1,E.lessThan=-1,E.neitherLessOrGreaterThan=0})(fe||(e.CompareResult=fe={}));function Le(E,y){return(a,r)=>y(E(a),E(r))}function ye(...E){return(y,a)=>{for(const r of E){const _=r(y,a);if(!fe.isNeitherLessOrGreaterThan(_))return _}return fe.neitherLessOrGreaterThan}}const Re=(E,y)=>E-y;e.$7b=Re;const Oe=(E,y)=>(0,e.$7b)(E?1:0,y?1:0);e.$8b=Oe;function ce(E){return(y,a)=>-E(y,a)}class Ae{constructor(y){this.g=y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(y){let a=this.c;for(;a<this.g.length&&y(this.g[a]);)a++;const r=a===this.c?null:this.g.slice(this.c,a);return this.c=a,r}takeFromEndWhile(y){let a=this.d;for(;a>=0&&y(this.g[a]);)a--;const r=a===this.d?null:this.g.slice(a+1,this.d+1);return this.d=a,r}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const y=this.g[this.c];return this.c++,y}removeLast(){const y=this.g[this.d];return this.d--,y}takeCount(y){const a=this.g.slice(this.c,this.c+y);return this.c+=y,a}}e.$0b=Ae;class de{static{this.empty=new de(y=>{})}constructor(y){this.iterate=y}forEach(y){this.iterate(a=>(y(a),!0))}toArray(){const y=[];return this.iterate(a=>(y.push(a),!0)),y}filter(y){return new de(a=>this.iterate(r=>y(r)?a(r):!0))}map(y){return new de(a=>this.iterate(r=>a(y(r))))}some(y){let a=!1;return this.iterate(r=>(a=y(r),!a)),a}findFirst(y){let a;return this.iterate(r=>y(r)?(a=r,!1):!0),a}findLast(y){let a;return this.iterate(r=>(y(r)&&(a=r),!0)),a}findLastMaxBy(y){let a,r=!0;return this.iterate(_=>((r||fe.isGreaterThan(y(_,a)))&&(r=!1,a=_),!0)),a}}e.$$b=de;class $e{constructor(y){this.c=y}static createSortPermutation(y,a){const r=Array.from(y.keys()).sort((_,L)=>a(y[_],y[L]));return new $e(r)}apply(y){return y.map((a,r)=>y[this.c[r]])}inverse(){const y=this.c.slice();for(let a=0;a<this.c.length;a++)y[this.c[a]]=a;return new $e(y)}}e.$_b=$e;async function ve(E,y){return(await Promise.all(E.map(async(r,_)=>({element:r,ok:await y(r,_)})))).find(r=>r.ok)?.element}}),define(me[8],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=m;function m(t,v){const U=this;let x=!1,j;return function(){if(x)return j;if(x=!0,v)try{j=t.apply(U,arguments)}finally{v()}else j=t.apply(U,arguments);return j}}}),define(me[20],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(t){function v(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=v;const U=Object.freeze([]);function x(){return U}t.empty=x;function*j(n){yield n}t.single=j;function N(n){return v(n)?n:j(n)}t.wrap=N;function I(n){return n||U}t.from=I;function*B(n){for(let s=n.length-1;s>=0;s--)yield n[s]}t.reverse=B;function K(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=K;function F(n){return n[Symbol.iterator]().next().value}t.first=F;function Z(n,s){let d=0;for(const R of n)if(s(R,d++))return!0;return!1}t.some=Z;function p(n,s){for(const d of n)if(s(d))return d}t.find=p;function*c(n,s){for(const d of n)s(d)&&(yield d)}t.filter=c;function*$(n,s){let d=0;for(const R of n)yield s(R,d++)}t.map=$;function*A(n,s){let d=0;for(const R of n)yield*s(R,d++)}t.flatMap=A;function*S(...n){for(const s of n)yield*s}t.concat=S;function G(n,s,d){let R=d;for(const h of n)R=s(R,h);return R}t.reduce=G;function*J(n,s,d=n.length){for(s<0&&(s+=n.length),d<0?d+=n.length:d>n.length&&(d=n.length);s<d;s++)yield n[s]}t.slice=J;function W(n,s=Number.POSITIVE_INFINITY){const d=[];if(s===0)return[d,n];const R=n[Symbol.iterator]();for(let h=0;h<s;h++){const f=R.next();if(f.done)return[d,t.empty()];d.push(f.value)}return[d,{[Symbol.iterator](){return R}}]}t.consume=W;async function i(n){const s=[];for await(const d of n)s.push(d);return Promise.resolve(s)}t.asyncToArray=i})(m||(e.Iterable=m={}))}),define(me[9],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class m{constructor(v){this.d=v,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(v){this.c=v}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=m}),define(me[21],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class m{static{this.Undefined=new m(void 0)}constructor(U){this.element=U,this.next=m.Undefined,this.prev=m.Undefined}}class t{constructor(){this.a=m.Undefined,this.b=m.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===m.Undefined}clear(){let U=this.a;for(;U!==m.Undefined;){const x=U.next;U.prev=m.Undefined,U.next=m.Undefined,U=x}this.a=m.Undefined,this.b=m.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,x){const j=new m(U);if(this.a===m.Undefined)this.a=j,this.b=j;else if(x){const I=this.b;this.b=j,j.prev=I,I.next=j}else{const I=this.a;this.a=j,j.next=I,I.prev=j}this.c+=1;let N=!1;return()=>{N||(N=!0,this.e(j))}}shift(){if(this.a!==m.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==m.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==m.Undefined&&U.next!==m.Undefined){const x=U.prev;x.next=U.next,U.next.prev=x}else U.prev===m.Undefined&&U.next===m.Undefined?(this.a=m.Undefined,this.b=m.Undefined):U.next===m.Undefined?(this.b=this.b.prev,this.b.next=m.Undefined):U.prev===m.Undefined&&(this.a=this.a.next,this.a.prev=m.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==m.Undefined;)yield U.element,U=U.next}}e.$5c=t}),define(me[22],be([0,1]),function(re,e){"use strict";var m,t,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=U,e.$yc=x,e.$zc=j,e.$Ic=J;function U(W,i,n){let s=W.get(i);return s===void 0&&(s=n,W.set(i,s)),s}function x(W){const i=[];return W.forEach((n,s)=>{i.push(`${s} => ${n}`)}),`Map(${W.size}) {${i.join(", ")}}`}function j(W){const i=[];return W.forEach(n=>{i.push(n)}),`Set(${W.size}) {${i.join(", ")}}`}class N{constructor(i,n){this.uri=i,this.value=n}}function I(W){return Array.isArray(W)}class B{static{this.c=i=>i.toString()}constructor(i,n){if(this[m]="ResourceMap",i instanceof B)this.d=new Map(i.d),this.e=n??B.c;else if(I(i)){this.d=new Map,this.e=n??B.c;for(const[s,d]of i)this.set(s,d)}else this.d=new Map,this.e=i??B.c}set(i,n){return this.d.set(this.e(i),new N(i,n)),this}get(i){return this.d.get(this.e(i))?.value}has(i){return this.d.has(this.e(i))}get size(){return this.d.size}clear(){this.d.clear()}delete(i){return this.d.delete(this.e(i))}forEach(i,n){typeof n<"u"&&(i=i.bind(n));for(const[s,d]of this.d)i(d.value,d.uri,this)}*values(){for(const i of this.d.values())yield i.value}*keys(){for(const i of this.d.values())yield i.uri}*entries(){for(const i of this.d.values())yield[i.uri,i.value]}*[(m=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.d)yield[i.uri,i.value]}}e.$Ac=B;class K{constructor(i,n){this[t]="ResourceSet",!i||typeof i=="function"?this.c=new B(i):(this.c=new B(n),i.forEach(this.add,this))}get size(){return this.c.size}add(i){return this.c.set(i,i),this}clear(){this.c.clear()}delete(i){return this.c.delete(i)}forEach(i,n){this.c.forEach((s,d)=>i.call(n,d,d,this))}has(i){return this.c.has(i)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=K;var F;(function(W){W[W.None=0]="None",W[W.AsOld=1]="AsOld",W[W.AsNew=2]="AsNew"})(F||(e.Touch=F={}));class Z{constructor(){this[v]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(i){return this.c.has(i)}get(i,n=F.None){const s=this.c.get(i);if(s)return n!==F.None&&this.m(s,n),s.value}set(i,n,s=F.None){let d=this.c.get(i);if(d)d.value=n,s!==F.None&&this.m(d,s);else{switch(d={key:i,value:n,next:void 0,previous:void 0},s){case F.None:this.k(d);break;case F.AsOld:this.j(d);break;case F.AsNew:this.k(d);break;default:this.k(d);break}this.c.set(i,d),this.f++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this.c.get(i);if(n)return this.c.delete(i),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const i=this.d;return this.c.delete(i.key),this.l(i),this.f--,i.value}forEach(i,n){const s=this.g;let d=this.d;for(;d;){if(n?i.bind(n)(d.value,d.key,this):i(d.value,d.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const i=this,n=this.g;let s=this.d;const d={[Symbol.iterator](){return d},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const R={value:s.key,done:!1};return s=s.next,R}else return{value:void 0,done:!0}}};return d}values(){const i=this,n=this.g;let s=this.d;const d={[Symbol.iterator](){return d},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const R={value:s.value,done:!1};return s=s.next,R}else return{value:void 0,done:!0}}};return d}entries(){const i=this,n=this.g;let s=this.d;const d={[Symbol.iterator](){return d},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const R={value:[s.key,s.value],done:!1};return s=s.next,R}else return{value:void 0,done:!0}}};return d}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.d,s=this.size;for(;n&&s>i;)this.c.delete(n.key),n=n.next,s--;this.d=n,this.f=s,n&&(n.previous=void 0),this.g++}i(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.e,s=this.size;for(;n&&s>i;)this.c.delete(n.key),n=n.previous,s--;this.e=n,this.f=s,n&&(n.next=void 0),this.g++}j(i){if(!this.d&&!this.e)this.e=i;else if(this.d)i.next=this.d,this.d.previous=i;else throw new Error("Invalid list");this.d=i,this.g++}k(i){if(!this.d&&!this.e)this.d=i;else if(this.e)i.previous=this.e,this.e.next=i;else throw new Error("Invalid list");this.e=i,this.g++}l(i){if(i===this.d&&i===this.e)this.d=void 0,this.e=void 0;else if(i===this.d){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.d=i.next}else if(i===this.e){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.e=i.previous}else{const n=i.next,s=i.previous;if(!n||!s)throw new Error("Invalid list");n.previous=s,s.next=n}i.next=void 0,i.previous=void 0,this.g++}m(i,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==F.AsOld&&n!==F.AsNew)){if(n===F.AsOld){if(i===this.d)return;const s=i.next,d=i.previous;i===this.e?(d.next=void 0,this.e=d):(s.previous=d,d.next=s),i.previous=void 0,i.next=this.d,this.d.previous=i,this.d=i,this.g++}else if(n===F.AsNew){if(i===this.e)return;const s=i.next,d=i.previous;i===this.d?(s.previous=void 0,this.d=s):(s.previous=d,d.next=s),i.next=void 0,i.previous=this.e,this.e.next=i,this.e=i,this.g++}}}toJSON(){const i=[];return this.forEach((n,s)=>{i.push([s,n])}),i}fromJSON(i){this.clear();for(const[n,s]of i)this.set(n,s)}}e.$Cc=Z;class p extends Z{constructor(i,n=1){super(),this.n=i,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(i){this.n=i,this.p()}get ratio(){return this.o}set ratio(i){this.o=Math.min(Math.max(0,i),1),this.p()}get(i,n=F.AsNew){return super.get(i,n)}peek(i){return super.get(i,F.None)}set(i,n){return super.set(i,n,F.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class c extends p{constructor(i,n=1){super(i,n)}q(i){this.h(i)}set(i,n){return super.set(i,n),this.p(),this}}e.$Dc=c;class $ extends p{constructor(i,n=1){super(i,n)}q(i){this.i(i)}set(i,n){return this.n<=this.size&&!this.has(i)&&this.q(Math.round(this.n*this.o)-1),super.set(i,n),this}}e.$Ec=$;class A{constructor(){this.c=new Map}add(i){return this.c.set(i,(this.c.get(i)||0)+1),this}delete(i){let n=this.c.get(i)||0;return n===0?!1:(n--,n===0?this.c.delete(i):this.c.set(i,n),!0)}has(i){return this.c.has(i)}}e.$Fc=A;class S{constructor(i){if(this.c=new Map,this.d=new Map,i)for(const[n,s]of i)this.set(n,s)}clear(){this.c.clear(),this.d.clear()}set(i,n){this.c.set(i,n),this.d.set(n,i)}get(i){return this.c.get(i)}getKey(i){return this.d.get(i)}delete(i){const n=this.c.get(i);return n===void 0?!1:(this.c.delete(i),this.d.delete(n),!0)}forEach(i,n){this.c.forEach((s,d)=>{i.call(n,s,d,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=S;class G{constructor(){this.c=new Map}add(i,n){let s=this.c.get(i);s||(s=new Set,this.c.set(i,s)),s.add(n)}delete(i,n){const s=this.c.get(i);s&&(s.delete(n),s.size===0&&this.c.delete(i))}forEach(i,n){const s=this.c.get(i);s&&s.forEach(n)}get(i){const n=this.c.get(i);return n||new Set}}e.$Hc=G;function J(W,i){if(W===i)return!0;if(W.size!==i.size)return!1;for(const[n,s]of W)if(!i.has(n)||i.get(n)!==s)return!1;for(const[n]of i)if(!W.has(n))return!1;return!0}}),define(me[10],be([0,1,19,18,22,8,20]),function(re,e,m,t,v,U,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=B,e.$Lc=K,e.$Mc=F,e.$Nc=c,e.$Oc=$,e.$Pc=A,e.$Qc=S,e.$Rc=G,e.$Sc=J,e.$3c=o;const j=!1;let N=null;class I{constructor(){this.b=new Map}static{this.a=0}c(g){let M=this.b.get(g);return M||(M={parent:null,source:null,isSingleton:!1,value:g,idx:I.a++},this.b.set(g,M)),M}trackDisposable(g){const M=this.c(g);M.source||(M.source=new Error().stack)}setParent(g,M){const P=this.c(g);P.parent=M}markAsDisposed(g){this.b.delete(g)}markAsSingleton(g){this.c(g).isSingleton=!0}f(g,M){const P=M.get(g);if(P)return P;const q=g.parent?this.f(this.c(g.parent),M):g;return M.set(g,q),q}getTrackedDisposables(){const g=new Map;return[...this.b.entries()].filter(([,P])=>P.source!==null&&!this.f(P,g).isSingleton).flatMap(([P])=>P)}computeLeakingDisposables(g=10,M){let P;if(M)P=M;else{const z=new Map,se=[...this.b.values()].filter(te=>te.source!==null&&!this.f(te,z).isSingleton);if(se.length===0)return;const ee=new Set(se.map(te=>te.value));if(P=se.filter(te=>!(te.parent&&ee.has(te.parent))),P.length===0)throw new Error("There are cyclic diposable chains!")}if(!P)return;function q(z){function se(te,oe){for(;te.length>0&&oe.some(fe=>typeof fe=="string"?fe===te[0]:te[0].match(fe));)te.shift()}const ee=z.source.split(`
`).map(te=>te.trim().replace("at ","")).filter(te=>te!=="");return se(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const T=new v.$Hc;for(const z of P){const se=q(z);for(let ee=0;ee<=se.length;ee++)T.add(se.slice(0,ee).join(`
`),z)}P.sort((0,m.$5b)(z=>z.idx,m.$7b));let V="",le=0;for(const z of P.slice(0,g)){le++;const se=q(z),ee=[];for(let te=0;te<se.length;te++){let oe=se[te];oe=`(shared with ${T.get(se.slice(0,te+1).join(`
`)).size}/${P.length} leaks) at ${oe}`;const Le=T.get(se.slice(0,te).join(`
`)),ye=(0,t.$c)([...Le].map(Re=>q(Re)[te]),Re=>Re);delete ye[se[te]];for(const[Re,Oe]of Object.entries(ye))ee.unshift(`    - stacktraces of ${Oe.length} other leaks continue with ${Re}`);ee.unshift(oe)}V+=`


==================== Leaking disposable ${le}/${P.length}: ${z.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return P.length>g&&(V+=`


... and ${P.length-g} more leaking disposables

`),{leaks:P,details:V}}}e.$Jc=I;function B(w){N=w}if(j){const w="__is_disposable_tracked__";B(new class{trackDisposable(g){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[w]||console.log(M)},3e3)}setParent(g,M){if(g&&g!==i.None)try{g[w]=!0}catch{}}markAsDisposed(g){if(g&&g!==i.None)try{g[w]=!0}catch{}}markAsSingleton(g){}})}function K(w){return N?.trackDisposable(w),w}function F(w){N?.markAsDisposed(w)}function Z(w,g){N?.setParent(w,g)}function p(w,g){if(N)for(const M of w)N.setParent(M,g)}function c(w){return N?.markAsSingleton(w),w}function $(w){return typeof w=="object"&&w!==null&&typeof w.dispose=="function"&&w.dispose.length===0}function A(w){if(x.Iterable.is(w)){const g=[];for(const M of w)if(M)try{M.dispose()}catch(P){g.push(P)}if(g.length===1)throw g[0];if(g.length>1)throw new AggregateError(g,"Encountered errors while disposing of store");return Array.isArray(w)?[]:w}else if(w)return w.dispose(),w}function S(w){for(const g of w)$(g)&&g.dispose();return[]}function G(...w){const g=J(()=>A(w));return p(w,g),g}function J(w){const g=K({dispose:(0,U.$cb)(()=>{F(g),w()})});return g}class W{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,K(this)}dispose(){this.g||(F(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{A(this.f)}finally{this.f.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return Z(g,this),this.g?W.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(g),g}delete(g){if(g){if(g===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(g),g.dispose()}}deleteAndLeak(g){g&&this.f.has(g)&&(this.f.delete(g),Z(g,null))}}e.$Tc=W;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new W,K(this),Z(this.q,this)}dispose(){F(this),this.q.dispose()}B(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(g)}}e.$Uc=i;class n{constructor(){this.b=!1,K(this)}get value(){return this.b?void 0:this.a}set value(g){this.b||g===this.a||(this.a?.dispose(),g&&Z(g,this),this.a=g)}clear(){this.value=void 0}dispose(){this.b=!0,F(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const g=this.a;return this.a=void 0,g&&Z(g,null),g}}e.$Vc=n;class s{constructor(g){this.a=new n,this.b=!1,this.a.value=g}get value(){return this.a.value}set value(g){this.b||g===this.a.value||(this.a.value=g)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=s;class d{constructor(g){this.b=g,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=d;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,K(this)}set(g){let M=g;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,F(this))},this}}e.$Yc=R;class h{constructor(){this.a=new Map}acquire(g,...M){let P=this.a.get(g);P||(P={counter:0,object:this.b(g,...M)},this.a.set(g,P));const{object:q}=P,T=(0,U.$cb)(()=>{--P.counter===0&&(this.c(g,P.object),this.a.delete(g))});return P.counter++,{object:q,dispose:T}}}e.$Zc=h;class f{constructor(g){this.a=g}async acquire(g,...M){const P=this.a.acquire(g,...M);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(q){throw P.dispose(),q}}}e.$1c=f;class u{constructor(g){this.object=g}dispose(){}}e.$2c=u;function o(w){const g=new W;try{w(g)}finally{g.dispose()}}class O{constructor(){this.a=new Map,this.b=!1,K(this)}dispose(){F(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{A(this.a.values())}finally{this.a.clear()}}has(g){return this.a.has(g)}get size(){return this.a.size}get(g){return this.a.get(g)}set(g,M,P=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),P||this.a.get(g)?.dispose(),this.a.set(g,M)}deleteAndDispose(g){this.a.get(g)?.dispose(),this.a.delete(g)}deleteAndLeak(g){const M=this.a.get(g);return this.a.delete(g),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=O}),define(me[23],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var m;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(m||(e.MarshalledId=m={}))}),define(me[2],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=i,e.$E=f,e.$K=u,e.$h="en";let m=!1,t=!1,v=!1,U=!1,x=!1,j=!1,N=!1,I=!1,B=!1,K=!1,F,Z=e.$h,p=e.$h,c,$;const A=globalThis;let S;typeof A.vscode<"u"&&typeof A.vscode.process<"u"?S=A.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(S=process);const G=typeof S?.versions?.electron=="string",J=G&&S?.type==="renderer";if(typeof S=="object"){m=S.platform==="win32",t=S.platform==="darwin",v=S.platform==="linux",U=v&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,N=G,B=!!S.env.CI||!!S.env.BUILD_ARTIFACTSTAGINGDIRECTORY,F=e.$h,Z=e.$h;const o=S.env.VSCODE_NLS_CONFIG;if(o)try{const O=JSON.parse(o);F=O.userLocale,p=O.osLocale,Z=O.resolvedLanguage||e.$h,c=O.languagePack?.translationsConfigFile}catch{}x=!0}else typeof navigator=="object"&&!J?($=navigator.userAgent,m=$.indexOf("Windows")>=0,t=$.indexOf("Macintosh")>=0,I=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,v=$.indexOf("Linux")>=0,K=$?.indexOf("Mobi")>=0,j=!0,Z=globalThis._VSCODE_NLS_LANGUAGE||e.$h,F=navigator.language.toLowerCase(),p=F):console.error("Unable to resolve platform.");var W;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(W||(e.Platform=W={}));function i(o){switch(o){case W.Web:return"Web";case W.Mac:return"Mac";case W.Linux:return"Linux";case W.Windows:return"Windows"}}let n=W.Web;t?n=W.Mac:m?n=W.Windows:v&&(n=W.Linux),e.$j=m,e.$k=t,e.$l=v,e.$m=U,e.$n=x,e.$o=N,e.$p=j,e.$q=j&&typeof A.importScripts=="function",e.$r=e.$q?A.origin:void 0,e.$s=I,e.$t=K,e.$u=B,e.$v=n,e.$w=$,e.$x=Z;var s;(function(o){function O(){return e.$x}o.value=O;function w(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}o.isDefaultVariant=w;function g(){return e.$x==="en"}o.isDefault=g})(s||(e.Language=s={})),e.$y=F,e.$z=p,e.$A=c,e.$B=typeof A.postMessage=="function"&&!A.importScripts,e.$C=(()=>{if(e.$B){const o=[];A.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let g=0,M=o.length;g<M;g++){const P=o[g];if(P.id===w.data.vscodeScheduleAsyncWork){o.splice(g,1),P.callback();return}}});let O=0;return w=>{const g=++O;o.push({id:g,callback:w}),A.postMessage({vscodeScheduleAsyncWork:g},"*")}}return o=>setTimeout(o)})();var d;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(d||(e.OperatingSystem=d={})),e.OS=t||I?d.Macintosh:m?d.Windows:d.Linux;let R=!0,h=!1;function f(){if(!h){h=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,R=new Uint16Array(o.buffer)[0]===513}return R}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function u(o){return parseFloat(o)>=20}}),define(me[11],be([0,1,2]),function(re,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let t;const v=globalThis.vscode;if(typeof v<"u"&&typeof v.process<"u"){const U=v.process;t={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return m.$j?"win32":m.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$dc=t.platform,e.$ec=t.arch});var Ye=this&&this.__createBinding||(Object.create?function(re,e,m,t){t===void 0&&(t=m);var v=Object.getOwnPropertyDescriptor(e,m);(!v||("get"in v?!e.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return e[m]}}),Object.defineProperty(re,t,v)}:function(re,e,m,t){t===void 0&&(t=m),re[t]=e[m]}),Ze=this&&this.__setModuleDefault||(Object.create?function(re,e){Object.defineProperty(re,"default",{enumerable:!0,value:e})}:function(re,e){re.default=e}),Se=this&&this.__importStar||function(re){if(re&&re.__esModule)return re;var e={};if(re!=null)for(var m in re)m!=="default"&&Object.prototype.hasOwnProperty.call(re,m)&&Ye(e,re,m);return Ze(e,re),e};define(me[3],be([0,1,11]),function(re,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0,m=Se(m);const t=65,v=97,U=90,x=122,j=46,N=47,I=92,B=58,K=63;class F extends Error{constructor(s,d,R){let h;typeof d=="string"&&d.indexOf("not ")===0?(h="must not be",d=d.replace(/^not /,"")):h="must be";const f=s.indexOf(".")!==-1?"property":"argument";let u=`The "${s}" ${f} ${h} of type ${d}`;u+=`. Received type ${typeof R}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function Z(n,s){if(n===null||typeof n!="object")throw new F(s,"Object",n)}function p(n,s){if(typeof n!="string")throw new F(s,"string",n)}const c=m.$dc==="win32";function $(n){return n===N||n===I}function A(n){return n===N}function S(n){return n>=t&&n<=U||n>=v&&n<=x}function G(n,s,d,R){let h="",f=0,u=-1,o=0,O=0;for(let w=0;w<=n.length;++w){if(w<n.length)O=n.charCodeAt(w);else{if(R(O))break;O=N}if(R(O)){if(!(u===w-1||o===1))if(o===2){if(h.length<2||f!==2||h.charCodeAt(h.length-1)!==j||h.charCodeAt(h.length-2)!==j){if(h.length>2){const g=h.lastIndexOf(d);g===-1?(h="",f=0):(h=h.slice(0,g),f=h.length-1-h.lastIndexOf(d)),u=w,o=0;continue}else if(h.length!==0){h="",f=0,u=w,o=0;continue}}s&&(h+=h.length>0?`${d}..`:"..",f=2)}else h.length>0?h+=`${d}${n.slice(u+1,w)}`:h=n.slice(u+1,w),f=w-u-1;u=w,o=0}else O===j&&o!==-1?++o:o=-1}return h}function J(n){return n?`${n[0]==="."?"":"."}${n}`:""}function W(n,s){Z(s,"pathObject");const d=s.dir||s.root,R=s.base||`${s.name||""}${J(s.ext)}`;return d?d===s.root?`${d}${R}`:`${d}${n}${R}`:R}e.$fc={resolve(...n){let s="",d="",R=!1;for(let h=n.length-1;h>=-1;h--){let f;if(h>=0){if(f=n[h],p(f,`paths[${h}]`),f.length===0)continue}else s.length===0?f=m.cwd():(f=m.env[`=${s}`]||m.cwd(),(f===void 0||f.slice(0,2).toLowerCase()!==s.toLowerCase()&&f.charCodeAt(2)===I)&&(f=`${s}\\`));const u=f.length;let o=0,O="",w=!1;const g=f.charCodeAt(0);if(u===1)$(g)&&(o=1,w=!0);else if($(g))if(w=!0,$(f.charCodeAt(1))){let M=2,P=M;for(;M<u&&!$(f.charCodeAt(M));)M++;if(M<u&&M!==P){const q=f.slice(P,M);for(P=M;M<u&&$(f.charCodeAt(M));)M++;if(M<u&&M!==P){for(P=M;M<u&&!$(f.charCodeAt(M));)M++;(M===u||M!==P)&&(O=`\\\\${q}\\${f.slice(P,M)}`,o=M)}}}else o=1;else S(g)&&f.charCodeAt(1)===B&&(O=f.slice(0,2),o=2,u>2&&$(f.charCodeAt(2))&&(w=!0,o=3));if(O.length>0)if(s.length>0){if(O.toLowerCase()!==s.toLowerCase())continue}else s=O;if(R){if(s.length>0)break}else if(d=`${f.slice(o)}\\${d}`,R=w,w&&s.length>0)break}return d=G(d,!R,"\\",$),R?`${s}\\${d}`:`${s}${d}`||"."},normalize(n){p(n,"path");const s=n.length;if(s===0)return".";let d=0,R,h=!1;const f=n.charCodeAt(0);if(s===1)return A(f)?"\\":n;if($(f))if(h=!0,$(n.charCodeAt(1))){let o=2,O=o;for(;o<s&&!$(n.charCodeAt(o));)o++;if(o<s&&o!==O){const w=n.slice(O,o);for(O=o;o<s&&$(n.charCodeAt(o));)o++;if(o<s&&o!==O){for(O=o;o<s&&!$(n.charCodeAt(o));)o++;if(o===s)return`\\\\${w}\\${n.slice(O)}\\`;o!==O&&(R=`\\\\${w}\\${n.slice(O,o)}`,d=o)}}}else d=1;else S(f)&&n.charCodeAt(1)===B&&(R=n.slice(0,2),d=2,s>2&&$(n.charCodeAt(2))&&(h=!0,d=3));let u=d<s?G(n.slice(d),!h,"\\",$):"";return u.length===0&&!h&&(u="."),u.length>0&&$(n.charCodeAt(s-1))&&(u+="\\"),R===void 0?h?`\\${u}`:u:h?`${R}\\${u}`:`${R}${u}`},isAbsolute(n){p(n,"path");const s=n.length;if(s===0)return!1;const d=n.charCodeAt(0);return $(d)||s>2&&S(d)&&n.charCodeAt(1)===B&&$(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,d;for(let f=0;f<n.length;++f){const u=n[f];p(u,"path"),u.length>0&&(s===void 0?s=d=u:s+=`\\${u}`)}if(s===void 0)return".";let R=!0,h=0;if(typeof d=="string"&&$(d.charCodeAt(0))){++h;const f=d.length;f>1&&$(d.charCodeAt(1))&&(++h,f>2&&($(d.charCodeAt(2))?++h:R=!1))}if(R){for(;h<s.length&&$(s.charCodeAt(h));)h++;h>=2&&(s=`\\${s.slice(h)}`)}return e.$fc.normalize(s)},relative(n,s){if(p(n,"from"),p(s,"to"),n===s)return"";const d=e.$fc.resolve(n),R=e.$fc.resolve(s);if(d===R||(n=d.toLowerCase(),s=R.toLowerCase(),n===s))return"";let h=0;for(;h<n.length&&n.charCodeAt(h)===I;)h++;let f=n.length;for(;f-1>h&&n.charCodeAt(f-1)===I;)f--;const u=f-h;let o=0;for(;o<s.length&&s.charCodeAt(o)===I;)o++;let O=s.length;for(;O-1>o&&s.charCodeAt(O-1)===I;)O--;const w=O-o,g=u<w?u:w;let M=-1,P=0;for(;P<g;P++){const T=n.charCodeAt(h+P);if(T!==s.charCodeAt(o+P))break;T===I&&(M=P)}if(P!==g){if(M===-1)return R}else{if(w>g){if(s.charCodeAt(o+P)===I)return R.slice(o+P+1);if(P===2)return R.slice(o+P)}u>g&&(n.charCodeAt(h+P)===I?M=P:P===2&&(M=3)),M===-1&&(M=0)}let q="";for(P=h+M+1;P<=f;++P)(P===f||n.charCodeAt(P)===I)&&(q+=q.length===0?"..":"\\..");return o+=M,q.length>0?`${q}${R.slice(o,O)}`:(R.charCodeAt(o)===I&&++o,R.slice(o,O))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=e.$fc.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===I){if(s.charCodeAt(1)===I){const d=s.charCodeAt(2);if(d!==K&&d!==j)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(S(s.charCodeAt(0))&&s.charCodeAt(1)===B&&s.charCodeAt(2)===I)return`\\\\?\\${s}`;return n},dirname(n){p(n,"path");const s=n.length;if(s===0)return".";let d=-1,R=0;const h=n.charCodeAt(0);if(s===1)return $(h)?n:".";if($(h)){if(d=R=1,$(n.charCodeAt(1))){let o=2,O=o;for(;o<s&&!$(n.charCodeAt(o));)o++;if(o<s&&o!==O){for(O=o;o<s&&$(n.charCodeAt(o));)o++;if(o<s&&o!==O){for(O=o;o<s&&!$(n.charCodeAt(o));)o++;if(o===s)return n;o!==O&&(d=R=o+1)}}}}else S(h)&&n.charCodeAt(1)===B&&(d=s>2&&$(n.charCodeAt(2))?3:2,R=d);let f=-1,u=!0;for(let o=s-1;o>=R;--o)if($(n.charCodeAt(o))){if(!u){f=o;break}}else u=!1;if(f===-1){if(d===-1)return".";f=d}return n.slice(0,f)},basename(n,s){s!==void 0&&p(s,"suffix"),p(n,"path");let d=0,R=-1,h=!0,f;if(n.length>=2&&S(n.charCodeAt(0))&&n.charCodeAt(1)===B&&(d=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let u=s.length-1,o=-1;for(f=n.length-1;f>=d;--f){const O=n.charCodeAt(f);if($(O)){if(!h){d=f+1;break}}else o===-1&&(h=!1,o=f+1),u>=0&&(O===s.charCodeAt(u)?--u===-1&&(R=f):(u=-1,R=o))}return d===R?R=o:R===-1&&(R=n.length),n.slice(d,R)}for(f=n.length-1;f>=d;--f)if($(n.charCodeAt(f))){if(!h){d=f+1;break}}else R===-1&&(h=!1,R=f+1);return R===-1?"":n.slice(d,R)},extname(n){p(n,"path");let s=0,d=-1,R=0,h=-1,f=!0,u=0;n.length>=2&&n.charCodeAt(1)===B&&S(n.charCodeAt(0))&&(s=R=2);for(let o=n.length-1;o>=s;--o){const O=n.charCodeAt(o);if($(O)){if(!f){R=o+1;break}continue}h===-1&&(f=!1,h=o+1),O===j?d===-1?d=o:u!==1&&(u=1):d!==-1&&(u=-1)}return d===-1||h===-1||u===0||u===1&&d===h-1&&d===R+1?"":n.slice(d,h)},format:W.bind(null,"\\"),parse(n){p(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const d=n.length;let R=0,h=n.charCodeAt(0);if(d===1)return $(h)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if($(h)){if(R=1,$(n.charCodeAt(1))){let M=2,P=M;for(;M<d&&!$(n.charCodeAt(M));)M++;if(M<d&&M!==P){for(P=M;M<d&&$(n.charCodeAt(M));)M++;if(M<d&&M!==P){for(P=M;M<d&&!$(n.charCodeAt(M));)M++;M===d?R=M:M!==P&&(R=M+1)}}}}else if(S(h)&&n.charCodeAt(1)===B){if(d<=2)return s.root=s.dir=n,s;if(R=2,$(n.charCodeAt(2))){if(d===3)return s.root=s.dir=n,s;R=3}}R>0&&(s.root=n.slice(0,R));let f=-1,u=R,o=-1,O=!0,w=n.length-1,g=0;for(;w>=R;--w){if(h=n.charCodeAt(w),$(h)){if(!O){u=w+1;break}continue}o===-1&&(O=!1,o=w+1),h===j?f===-1?f=w:g!==1&&(g=1):f!==-1&&(g=-1)}return o!==-1&&(f===-1||g===0||g===1&&f===o-1&&f===u+1?s.base=s.name=n.slice(u,o):(s.name=n.slice(u,f),s.base=n.slice(u,o),s.ext=n.slice(f,o))),u>0&&u!==R?s.dir=n.slice(0,u-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(c){const n=/\\/g;return()=>{const s=m.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>m.cwd()})();e.$gc={resolve(...n){let s="",d=!1;for(let R=n.length-1;R>=-1&&!d;R--){const h=R>=0?n[R]:i();p(h,`paths[${R}]`),h.length!==0&&(s=`${h}/${s}`,d=h.charCodeAt(0)===N)}return s=G(s,!d,"/",A),d?`/${s}`:s.length>0?s:"."},normalize(n){if(p(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===N,d=n.charCodeAt(n.length-1)===N;return n=G(n,!s,"/",A),n.length===0?s?"/":d?"./":".":(d&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return p(n,"path"),n.length>0&&n.charCodeAt(0)===N},join(...n){if(n.length===0)return".";let s;for(let d=0;d<n.length;++d){const R=n[d];p(R,"path"),R.length>0&&(s===void 0?s=R:s+=`/${R}`)}return s===void 0?".":e.$gc.normalize(s)},relative(n,s){if(p(n,"from"),p(s,"to"),n===s||(n=e.$gc.resolve(n),s=e.$gc.resolve(s),n===s))return"";const d=1,R=n.length,h=R-d,f=1,u=s.length-f,o=h<u?h:u;let O=-1,w=0;for(;w<o;w++){const M=n.charCodeAt(d+w);if(M!==s.charCodeAt(f+w))break;M===N&&(O=w)}if(w===o)if(u>o){if(s.charCodeAt(f+w)===N)return s.slice(f+w+1);if(w===0)return s.slice(f+w)}else h>o&&(n.charCodeAt(d+w)===N?O=w:w===0&&(O=0));let g="";for(w=d+O+1;w<=R;++w)(w===R||n.charCodeAt(w)===N)&&(g+=g.length===0?"..":"/..");return`${g}${s.slice(f+O)}`},toNamespacedPath(n){return n},dirname(n){if(p(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===N;let d=-1,R=!0;for(let h=n.length-1;h>=1;--h)if(n.charCodeAt(h)===N){if(!R){d=h;break}}else R=!1;return d===-1?s?"/":".":s&&d===1?"//":n.slice(0,d)},basename(n,s){s!==void 0&&p(s,"ext"),p(n,"path");let d=0,R=-1,h=!0,f;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let u=s.length-1,o=-1;for(f=n.length-1;f>=0;--f){const O=n.charCodeAt(f);if(O===N){if(!h){d=f+1;break}}else o===-1&&(h=!1,o=f+1),u>=0&&(O===s.charCodeAt(u)?--u===-1&&(R=f):(u=-1,R=o))}return d===R?R=o:R===-1&&(R=n.length),n.slice(d,R)}for(f=n.length-1;f>=0;--f)if(n.charCodeAt(f)===N){if(!h){d=f+1;break}}else R===-1&&(h=!1,R=f+1);return R===-1?"":n.slice(d,R)},extname(n){p(n,"path");let s=-1,d=0,R=-1,h=!0,f=0;for(let u=n.length-1;u>=0;--u){const o=n.charCodeAt(u);if(o===N){if(!h){d=u+1;break}continue}R===-1&&(h=!1,R=u+1),o===j?s===-1?s=u:f!==1&&(f=1):s!==-1&&(f=-1)}return s===-1||R===-1||f===0||f===1&&s===R-1&&s===d+1?"":n.slice(s,R)},format:W.bind(null,"/"),parse(n){p(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const d=n.charCodeAt(0)===N;let R;d?(s.root="/",R=1):R=0;let h=-1,f=0,u=-1,o=!0,O=n.length-1,w=0;for(;O>=R;--O){const g=n.charCodeAt(O);if(g===N){if(!o){f=O+1;break}continue}u===-1&&(o=!1,u=O+1),g===j?h===-1?h=O:w!==1&&(w=1):h!==-1&&(w=-1)}if(u!==-1){const g=f===0&&d?1:f;h===-1||w===0||w===1&&h===u-1&&h===f+1?s.base=s.name=n.slice(g,u):(s.name=n.slice(g,h),s.base=n.slice(g,u),s.ext=n.slice(h,u))}return f>0?s.dir=n.slice(0,f-1):d&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=c?e.$fc.normalize:e.$gc.normalize,e.$ic=c?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=c?e.$fc.join:e.$gc.join,e.$kc=c?e.$fc.resolve:e.$gc.resolve,e.$lc=c?e.$fc.relative:e.$gc.relative,e.$mc=c?e.$fc.dirname:e.$gc.dirname,e.$nc=c?e.$fc.basename:e.$gc.basename,e.$oc=c?e.$fc.extname:e.$gc.extname,e.$pc=c?e.$fc.format:e.$gc.format,e.$qc=c?e.$fc.parse:e.$gc.parse,e.$rc=c?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=c?e.$fc.sep:e.$gc.sep,e.$tc=c?e.$fc.delimiter:e.$gc.delimiter}),define(me[24],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const m=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(U){return new t(U)}constructor(U){this.c=m&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=t}),define(me[12],be([0,1,5,8,10,21,24]),function(re,e,m,t,v,U,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=Z;const j=!1,N=!1,I=!1;var B;(function(q){q.None=()=>v.$Uc.None;function T(Y){if(I){const{onDidAddListener:X}=Y,ne=c.create();let Q=0;Y.onDidAddListener=()=>{++Q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ne.print()),X?.()}}}function V(Y,X){return Re(Y,()=>{},0,void 0,!0,void 0,X)}q.defer=V;function le(Y){return(X,ne=null,Q)=>{let ue=!1,he;return he=Y(we=>{if(!ue)return he?he.dispose():ue=!0,X.call(ne,we)},null,Q),ue&&he.dispose(),he}}q.once=le;function z(Y,X,ne){return Le((Q,ue=null,he)=>Y(we=>Q.call(ue,X(we)),null,he),ne)}q.map=z;function se(Y,X,ne){return Le((Q,ue=null,he)=>Y(we=>{X(we),Q.call(ue,we)},null,he),ne)}q.forEach=se;function ee(Y,X,ne){return Le((Q,ue=null,he)=>Y(we=>X(we)&&Q.call(ue,we),null,he),ne)}q.filter=ee;function te(Y){return Y}q.signal=te;function oe(...Y){return(X,ne=null,Q)=>{const ue=(0,v.$Rc)(...Y.map(he=>he(we=>X.call(ne,we))));return ye(ue,Q)}}q.any=oe;function fe(Y,X,ne,Q){let ue=ne;return z(Y,he=>(ue=X(ue,he),ue),Q)}q.reduce=fe;function Le(Y,X){let ne;const Q={onWillAddFirstListener(){ne=Y(ue.fire,ue)},onDidRemoveLastListener(){ne?.dispose()}};X||T(Q);const ue=new n(Q);return X?.add(ue),ue.event}function ye(Y,X){return X instanceof Array?X.push(Y):X&&X.add(Y),Y}function Re(Y,X,ne=100,Q=!1,ue=!1,he,we){let Ue,Te,ke,ae=0,De;const We={leakWarningThreshold:he,onWillAddFirstListener(){Ue=Y(Ve=>{ae++,Te=X(Te,Ve),Q&&!ke&&(je.fire(Te),Te=void 0),De=()=>{const Ke=Te;Te=void 0,ke=void 0,(!Q||ae>1)&&je.fire(Ke),ae=0},typeof ne=="number"?(clearTimeout(ke),ke=setTimeout(De,ne)):ke===void 0&&(ke=0,queueMicrotask(De))})},onWillRemoveListener(){ue&&ae>0&&De?.()},onDidRemoveLastListener(){De=void 0,Ue.dispose()}};we||T(We);const je=new n(We);return we?.add(je),je.event}q.debounce=Re;function Oe(Y,X=0,ne){return q.debounce(Y,(Q,ue)=>Q?(Q.push(ue),Q):[ue],X,void 0,!0,void 0,ne)}q.accumulate=Oe;function ce(Y,X=(Q,ue)=>Q===ue,ne){let Q=!0,ue;return ee(Y,he=>{const we=Q||!X(he,ue);return Q=!1,ue=he,we},ne)}q.latch=ce;function Ae(Y,X,ne){return[q.filter(Y,X,ne),q.filter(Y,Q=>!X(Q),ne)]}q.split=Ae;function de(Y,X=!1,ne=[],Q){let ue=ne.slice(),he=Y(Te=>{ue?ue.push(Te):Ue.fire(Te)});Q&&Q.add(he);const we=()=>{ue?.forEach(Te=>Ue.fire(Te)),ue=null},Ue=new n({onWillAddFirstListener(){he||(he=Y(Te=>Ue.fire(Te)),Q&&Q.add(he))},onDidAddFirstListener(){ue&&(X?setTimeout(we):we())},onDidRemoveLastListener(){he&&he.dispose(),he=null}});return Q&&Q.add(Ue),Ue.event}q.buffer=de;function $e(Y,X){return(Q,ue,he)=>{const we=X(new E);return Y(function(Ue){const Te=we.evaluate(Ue);Te!==ve&&Q.call(ue,Te)},void 0,he)}}q.chain=$e;const ve=Symbol("HaltChainable");class E{constructor(){this.f=[]}map(X){return this.f.push(X),this}forEach(X){return this.f.push(ne=>(X(ne),ne)),this}filter(X){return this.f.push(ne=>X(ne)?ne:ve),this}reduce(X,ne){let Q=ne;return this.f.push(ue=>(Q=X(Q,ue),Q)),this}latch(X=(ne,Q)=>ne===Q){let ne=!0,Q;return this.f.push(ue=>{const he=ne||!X(ue,Q);return ne=!1,Q=ue,he?ue:ve}),this}evaluate(X){for(const ne of this.f)if(X=ne(X),X===ve)break;return X}}function y(Y,X,ne=Q=>Q){const Q=(...Ue)=>we.fire(ne(...Ue)),ue=()=>Y.on(X,Q),he=()=>Y.removeListener(X,Q),we=new n({onWillAddFirstListener:ue,onDidRemoveLastListener:he});return we.event}q.fromNodeEventEmitter=y;function a(Y,X,ne=Q=>Q){const Q=(...Ue)=>we.fire(ne(...Ue)),ue=()=>Y.addEventListener(X,Q),he=()=>Y.removeEventListener(X,Q),we=new n({onWillAddFirstListener:ue,onDidRemoveLastListener:he});return we.event}q.fromDOMEventEmitter=a;function r(Y){return new Promise(X=>le(Y)(X))}q.toPromise=r;function _(Y){const X=new n;return Y.then(ne=>{X.fire(ne)},()=>{X.fire(void 0)}).finally(()=>{X.dispose()}),X.event}q.fromPromise=_;function L(Y,X){return Y(ne=>X.fire(ne))}q.forward=L;function k(Y,X,ne){return X(ne),Y(Q=>X(Q))}q.runAndSubscribe=k;class C{constructor(X,ne){this._observable=X,this.f=0,this.g=!1;const Q={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};ne||T(Q),this.emitter=new n(Q),ne&&ne.add(this.emitter)}beginUpdate(X){this.f++}handlePossibleChange(X){}handleChange(X,ne){this.g=!0}endUpdate(X){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function _e(Y,X){return new C(Y,X).emitter.event}q.fromObservable=_e;function Ee(Y){return(X,ne,Q)=>{let ue=0,he=!1;const we={beginUpdate(){ue++},endUpdate(){ue--,ue===0&&(Y.reportChanges(),he&&(he=!1,X.call(ne)))},handlePossibleChange(){},handleChange(){he=!0}};Y.addObserver(we),Y.reportChanges();const Ue={dispose(){Y.removeObserver(we)}};return Q instanceof v.$Tc?Q.add(Ue):Array.isArray(Q)&&Q.push(Ue),Ue}}q.fromObservableLight=Ee})(B||(e.Event=B={}));class K{static{this.all=new Set}static{this.f=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${K.f++}`,K.all.add(this)}start(T){this.g=new x.$fe,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}e.$he=K;let F=-1;function Z(q){const T=F;return F=q,{dispose(){F=T}}}class p{static{this.f=1}constructor(T,V,le=(p.f++).toString(16).padStart(3,"0")){this.j=T,this.threshold=V,this.name=le,this.h=0}dispose(){this.g?.clear()}check(T,V){const le=this.threshold;if(le<=0||V<le)return;this.g||(this.g=new Map);const z=this.g.get(T.value)||0;if(this.g.set(T.value,z+1),this.h-=1,this.h<=0){this.h=le*.5;const[se,ee]=this.getMostFrequentStack(),te=`[${this.name}] potential listener LEAK detected, having ${V} listeners already. MOST frequent listener (${ee}):`;console.warn(te),console.warn(se);const oe=new $(te,se);this.j(oe)}return()=>{const se=this.g.get(T.value)||0;this.g.set(T.value,se-1)}}getMostFrequentStack(){if(!this.g)return;let T,V=0;for(const[le,z]of this.g)(!T||V<z)&&(T=[le,z],V=z);return T}}class c{static create(){const T=new Error;return new c(T.stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class $ extends Error{constructor(T,V){super(T),this.name="ListenerLeakError",this.stack=V}}e.$je=$;class A extends Error{constructor(T,V){super(T),this.name="ListenerRefusalError",this.stack=V}}e.$ke=A;let S=0;class G{constructor(T){this.value=T,this.id=S++}}const J=2,W=(q,T)=>{if(q instanceof G)T(q);else for(let V=0;V<q.length;V++){const le=q[V];le&&T(le)}};let i;if(j){const q=[];setInterval(()=>{q.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(q.join(`
`)),q.length=0)},3e3),i=new FinalizationRegistry(T=>{typeof T=="string"&&q.push(T)})}class n{constructor(T){this.z=0,this.f=T,this.g=F>0||this.f?.leakWarningThreshold?new p(T?.onListenerError??m.$Y,this.f?.leakWarningThreshold??F):void 0,this.j=this.f?._profName?new K(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(N){const T=this.u;queueMicrotask(()=>{W(T,V=>V.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(T,V,le)=>{if(this.g&&this.z>this.g.threshold**2){const oe=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(oe);const fe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],Le=new A(`${oe}. HINT: Stack shows most frequent listener (${fe[1]}-times)`,fe[0]);return(this.f?.onListenerError||m.$Y)(Le),v.$Uc.None}if(this.m)return v.$Uc.None;V&&(T=T.bind(V));const z=new G(T);let se,ee;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(z.stack=c.create(),se=this.g.check(z.stack,this.z+1)),N&&(z.stack=ee??c.create()),this.u?this.u instanceof G?(this.w??=new d,this.u=[this.u,z]):this.u.push(z):(this.f?.onWillAddFirstListener?.(this),this.u=z,this.f?.onDidAddFirstListener?.(this)),this.z++;const te=(0,v.$Sc)(()=>{i?.unregister(te),se?.(),this.A(z)});if(le instanceof v.$Tc?le.add(te):Array.isArray(le)&&le.push(te),i){const oe=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),fe=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(oe);i.register(te,fe?.[2]??oe,te)}return te},this.q}A(T){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const V=this.u,le=V.indexOf(T);if(le===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,V[le]=void 0;const z=this.w.current===this;if(this.z*J<=V.length){let se=0;for(let ee=0;ee<V.length;ee++)V[ee]?V[se++]=V[ee]:z&&(this.w.end--,se<this.w.i&&this.w.i--);V.length=se}}B(T,V){if(!T)return;const le=this.f?.onListenerError||m.$Y;if(!le){T.value(V);return}try{T.value(V)}catch(z){le(z)}}C(T){const V=T.current.u;for(;T.i<T.end;)this.B(V[T.i++],T.value);T.reset()}fire(T){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof G)this.B(this.u,T);else{const V=this.w;V.enqueue(this,T,this.u.length),this.C(V)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=n;const s=()=>new d;e.$me=s;class d{constructor(){this.i=-1,this.end=0}enqueue(T,V,le){this.i=0,this.end=le,this.current=T,this.value=V}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class R extends n{async fireAsync(T,V,le){if(this.u)for(this.h||(this.h=new U.$5c),W(this.u,z=>this.h.push([z.value,T]));this.h.size>0&&!V.isCancellationRequested;){const[z,se]=this.h.shift(),ee=[],te={...se,token:V,waitUntil:oe=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");le&&(oe=le(oe,z)),ee.push(oe)}};try{z(te)}catch(oe){(0,m.$Y)(oe);continue}Object.freeze(ee),await Promise.allSettled(ee).then(oe=>{for(const fe of oe)fe.status==="rejected"&&(0,m.$Y)(fe.reason)})}}}e.$ne=R;class h extends n{get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new U.$5c,this.t=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.t(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.z&&(this.h!==0?this.s.push(T):super.fire(T))}}e.$oe=h;class f extends h{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}e.$pe=f;class u extends n{constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(V=>super.fire(V)),this.h=[]}))}}e.$qe=u;class o{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const V={event:T,listener:null};this.h.push(V),this.g&&this.m(V);const le=()=>{this.g&&this.o(V);const z=this.h.indexOf(V);this.h.splice(z,1)};return(0,v.$Sc)((0,t.$cb)(le))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(V=>this.f.fire(V))}o(T){T.listener?.dispose(),T.listener=null}dispose(){this.f.dispose();for(const T of this.h)T.listener?.dispose();this.h=[]}}e.$re=o;class O{constructor(T,V,le,z){this.f=new v.$Tc;const se=this.f.add(new o),ee=this.f.add(new v.$4c);function te(oe){ee.set(oe,se.add(z(oe)))}for(const oe of T)te(oe);this.f.add(V(oe=>{te(oe)})),this.f.add(le(oe=>{ee.deleteAndDispose(oe)})),this.event=se.event}dispose(){this.f.dispose()}}e.$se=O;class w{constructor(){this.f=[]}wrapEvent(T,V,le){return(z,se,ee)=>T(te=>{const oe=this.f[this.f.length-1];if(!V){oe?oe.buffers.push(()=>z.call(se,te)):z.call(se,te);return}const fe=oe;if(!fe){z.call(se,V(le,te));return}fe.items??=[],fe.items.push(te),fe.buffers.length===0&&oe.buffers.push(()=>{fe.reducedResult??=le?fe.items.reduce(V,le):fe.items.reduce(V),z.call(se,fe.reducedResult)})},void 0,ee)}bufferEvents(T){const V={buffers:new Array};this.f.push(V);const le=T();return this.f.pop(),V.buffers.forEach(z=>z()),le}}e.$te=w;class g{constructor(){this.f=!1,this.g=B.None,this.h=v.$Uc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=g;class M{static const(T){return new P(T)}constructor(T){this.g=T,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(T){T!==this.g&&(this.g=T,this.f.fire(void 0))}}e.$ve=M;class P{constructor(T){this.value=T,this.onDidChange=B.None}}}),define(me[13],be([0,1,12]),function(re,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=j;const t=Object.freeze(function(N,I){const B=setTimeout(N.bind(I),0);return{dispose(){clearTimeout(B)}}});var v;(function(N){function I(B){return B===N.None||B===N.Cancelled||B instanceof U?!0:!B||typeof B!="object"?!1:typeof B.isCancellationRequested=="boolean"&&typeof B.onCancellationRequested=="function"}N.isCancellationToken=I,N.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),N.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(v||(e.CancellationToken=v={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new m.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class x{constructor(I){this.f=void 0,this.g=void 0,this.g=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new U),this.f}cancel(){this.f?this.f instanceof U&&this.f.cancel():this.f=v.Cancelled}dispose(I=!1){I&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof U&&this.f.dispose():this.f=v.None}}e.$we=x;function j(N){const I=new x;return N.add({dispose(){I.cancel()}}),I.token}}),define(me[25],be([0,1,13]),function(re,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=v;class t{constructor(N){this.b=N,this.a=null}get(){if(this.a)return this.a;const N=new m.$we,I=this.b(N.token);return this.a={promise:I,dispose:()=>{this.a=null,N.cancel(),N.dispose()}},this.a}}e.$9e=t;function v(j){return j}class U{constructor(N,I){this.a=void 0,this.b=void 0,typeof N=="function"?(this.c=N,this.d=v):(this.c=I,this.d=N.getCacheKey)}get(N){const I=this.d(N);return this.b!==I&&(this.b=I,this.a=this.c(N)),this.a}}e.$$e=U;class x{get cachedValues(){return this.a}constructor(N,I){this.a=new Map,this.b=new Map,typeof N=="function"?(this.c=N,this.d=v):(this.c=I,this.d=N.getCacheKey)}get(N){const I=this.d(N);if(this.b.has(I))return this.b.get(I);const B=this.c(N);return this.a.set(N,B),this.b.set(I,B),B}}e.$_e=x}),define(me[26],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(me[27],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=m,e.$fg=t,e.$gg=v,e.$hg=U,e.$ig=x,e.$jg=j,e.$kg=N,e.$lg=I,e.$mg=B,e.$ng=K,e.$og=F,e.$pg=Z,e.$qg=p,e.$rg=$,e.$sg=A,e.$tg=S,e.$ug=G,e.$vg=J,e.$wg=W;function m(i){return typeof i=="string"}function t(i){return Array.isArray(i)&&i.every(n=>m(n))}function v(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function U(i){const n=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof n}function x(i){return typeof i=="number"&&!isNaN(i)}function j(i){return!!i&&typeof i[Symbol.iterator]=="function"}function N(i){return i===!0||i===!1}function I(i){return typeof i>"u"}function B(i){return!K(i)}function K(i){return I(i)||i===null}function F(i,n){if(!i)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function Z(i){if(K(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function p(...i){const n=[];for(let s=0;s<i.length;s++){const d=i[s];if(K(d))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(d)}return n}const c=Object.prototype.hasOwnProperty;function $(i){if(!v(i))return!1;for(const n in i)if(c.call(i,n))return!1;return!0}function A(i){return typeof i=="function"}function S(...i){return i.length>0&&i.every(A)}function G(i,n){const s=Math.min(i.length,n.length);for(let d=0;d<s;d++)J(i[d],n[d])}function J(i,n){if(m(n)){if(typeof i!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(A(n)){try{if(i instanceof n)return}catch{}if(!K(i)&&i.constructor===n||n.length===1&&n.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function W(i){return i}}),define(me[28],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=t,e.$bf=v;var m;(function(U){U[U.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",U[U.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",U[U.MAX_UINT_8=255]="MAX_UINT_8",U[U.MAX_UINT_16=65535]="MAX_UINT_16",U[U.MAX_UINT_32=4294967295]="MAX_UINT_32",U[U.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m||(e.Constants=m={}));function t(U){return U<0?0:U>m.MAX_UINT_8?m.MAX_UINT_8:U|0}function v(U){return U<0?0:U>m.MAX_UINT_32?m.MAX_UINT_32:U|0}}),define(me[6],be([0,1,25,4,9,28]),function(re,e,m,t,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=x,e.$df=N,e.$ef=B,e.$ff=K,e.$gf=F,e.$hf=Z,e.$if=p,e.$jf=c,e.$kf=$,e.$lf=A,e.$mf=S,e.$nf=G,e.$of=J,e.$pf=W,e.$qf=i,e.$rf=n,e.$sf=s,e.$tf=d,e.$uf=R,e.$vf=h,e.$wf=f,e.$xf=u,e.$yf=o,e.$zf=O,e.$Af=w,e.$Bf=g,e.$Cf=M,e.$Df=P,e.$Ef=q,e.$Ff=T,e.$Gf=V,e.$Hf=le,e.$If=z,e.$Jf=se,e.$Kf=ee,e.$Lf=te,e.$Mf=oe,e.$Pf=Re,e.$Qf=Oe,e.$Rf=ce,e.$Sf=Ae,e.$Tf=ve,e.$Uf=y,e.$Wf=a,e.$Xf=r,e.$Yf=_,e.$Zf=L,e.$1f=C,e.$2f=_e,e.$3f=Y,e.$5f=X,e.$6f=ne,e.$7f=Q,e.$8f=ue,e.$9f=he,e.$0f=we,e.$$f=Ue,e.$_f=Te,e.$ag=je;function x(l){return!l||typeof l!="string"?!0:l.trim().length===0}const j=/{(\d+)}/g;function N(l,...b){return b.length===0?l:l.replace(j,function(D,H){const ie=parseInt(H,10);return isNaN(ie)||ie<0||ie>=b.length?D:b[ie]})}const I=/{([^}]+)}/g;function B(l,b){return Object.keys(b).length===0?l:l.replace(I,(D,H)=>b[H]??D)}function K(l){return l.replace(/[<>"'&]/g,b=>{switch(b){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return b})}function F(l){return l.replace(/[<>&]/g,function(b){switch(b){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return b}})}function Z(l){return l.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(l,b){let D=0,H=l.indexOf(b);for(;H!==-1;)D++,H=l.indexOf(b,H+b.length);return D}function c(l,b,D="\u2026"){return l.length<=b?l:`${l.substr(0,b)}${D}`}function $(l,b,D="\u2026"){if(l.length<=b)return l;const H=Math.ceil(b/2)-D.length/2,ie=Math.floor(b/2)-D.length/2;return`${l.substr(0,H)}${D}${l.substr(l.length-ie)}`}function A(l,b=" "){const D=S(l,b);return G(D,b)}function S(l,b){if(!l||!b)return l;const D=b.length;if(D===0||l.length===0)return l;let H=0;for(;l.indexOf(b,H)===H;)H=H+D;return l.substring(H)}function G(l,b){if(!l||!b)return l;const D=b.length,H=l.length;if(D===0||H===0)return l;let ie=H,ge=-1;for(;ge=l.lastIndexOf(b,ie-1),!(ge===-1||ge+D!==ie);){if(ge===0)return"";ie=ge}return l.substring(0,ie)}function J(l){return l.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function W(l){return l.replace(/\*/g,"")}function i(l,b,D={}){if(!l)throw new Error("Cannot create regex from empty string");b||(l=Z(l)),D.wholeWord&&(/\B/.test(l.charAt(0))||(l="\\b"+l),/\B/.test(l.charAt(l.length-1))||(l=l+"\\b"));let H="";return D.global&&(H+="g"),D.matchCase||(H+="i"),D.multiline&&(H+="m"),D.unicode&&(H+="u"),new RegExp(l,H)}function n(l){return l.source==="^"||l.source==="^$"||l.source==="$"||l.source==="^\\s*$"?!1:!!(l.exec("")&&l.lastIndex===0)}function s(l){return l.split(/\r\n|\r|\n/)}function d(l){const b=[],D=l.split(/(\r\n|\r|\n)/);for(let H=0;H<Math.ceil(D.length/2);H++)b.push(D[2*H]+(D[2*H+1]??""));return b}function R(l){for(let b=0,D=l.length;b<D;b++){const H=l.charCodeAt(b);if(H!==t.CharCode.Space&&H!==t.CharCode.Tab)return b}return-1}function h(l,b=0,D=l.length){for(let H=b;H<D;H++){const ie=l.charCodeAt(H);if(ie!==t.CharCode.Space&&ie!==t.CharCode.Tab)return l.substring(b,H)}return l.substring(b,D)}function f(l,b=l.length-1){for(let D=b;D>=0;D--){const H=l.charCodeAt(D);if(H!==t.CharCode.Space&&H!==t.CharCode.Tab)return D}return-1}function u(l,b,D){const H=[];let ie=0;for(const ge of l.matchAll(b)){if(H.push(l.slice(ie,ge.index)),ge.index===void 0)throw new Error("match.index should be defined");ie=ge.index+ge[0].length,H.push(D(ge[0],...ge.slice(1),ge.index,l,ge.groups))}return H.push(l.slice(ie)),Promise.all(H).then(ge=>ge.join(""))}function o(l,b){return l<b?-1:l>b?1:0}function O(l,b,D=0,H=l.length,ie=0,ge=b.length){for(;D<H&&ie<ge;D++,ie++){const Pe=l.charCodeAt(D),Ne=b.charCodeAt(ie);if(Pe<Ne)return-1;if(Pe>Ne)return 1}const Ie=H-D,Fe=ge-ie;return Ie<Fe?-1:Ie>Fe?1:0}function w(l,b){return g(l,b,0,l.length,0,b.length)}function g(l,b,D=0,H=l.length,ie=0,ge=b.length){for(;D<H&&ie<ge;D++,ie++){let Pe=l.charCodeAt(D),Ne=b.charCodeAt(ie);if(Pe===Ne)continue;if(Pe>=128||Ne>=128)return O(l.toLowerCase(),b.toLowerCase(),D,H,ie,ge);P(Pe)&&(Pe-=32),P(Ne)&&(Ne-=32);const pe=Pe-Ne;if(pe!==0)return pe}const Ie=H-D,Fe=ge-ie;return Ie<Fe?-1:Ie>Fe?1:0}function M(l){return l>=t.CharCode.Digit0&&l<=t.CharCode.Digit9}function P(l){return l>=t.CharCode.a&&l<=t.CharCode.z}function q(l){return l>=t.CharCode.A&&l<=t.CharCode.Z}function T(l,b){return l.length===b.length&&g(l,b)===0}function V(l,b){const D=b.length;return b.length>l.length?!1:g(l,b,0,D)===0}function le(l,b){const D=Math.min(l.length,b.length);let H;for(H=0;H<D;H++)if(l.charCodeAt(H)!==b.charCodeAt(H))return H;return D}function z(l,b){const D=Math.min(l.length,b.length);let H;const ie=l.length-1,ge=b.length-1;for(H=0;H<D;H++)if(l.charCodeAt(ie-H)!==b.charCodeAt(ge-H))return H;return D}function se(l){return 55296<=l&&l<=56319}function ee(l){return 56320<=l&&l<=57343}function te(l,b){return(l-55296<<10)+(b-56320)+65536}function oe(l,b,D){const H=l.charCodeAt(D);if(se(H)&&D+1<b){const ie=l.charCodeAt(D+1);if(ee(ie))return te(H,ie)}return H}function fe(l,b){const D=l.charCodeAt(b-1);if(ee(D)&&b>1){const H=l.charCodeAt(b-2);if(se(H))return te(H,D)}return D}class Le{get offset(){return this.e}constructor(b,D=0){this.c=b,this.d=b.length,this.e=D}setOffset(b){this.e=b}prevCodePoint(){const b=fe(this.c,this.e);return this.e-=b>=U.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,b}nextCodePoint(){const b=oe(this.c,this.d,this.e);return this.e+=b>=U.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,b}eol(){return this.e>=this.d}}e.$Nf=Le;class ye{get offset(){return this.c.offset}constructor(b,D=0){this.c=new Le(b,D)}nextGraphemeLength(){const b=De.getInstance(),D=this.c,H=D.offset;let ie=b.getGraphemeBreakType(D.nextCodePoint());for(;!D.eol();){const ge=D.offset,Ie=b.getGraphemeBreakType(D.nextCodePoint());if(ke(ie,Ie)){D.setOffset(ge);break}ie=Ie}return D.offset-H}prevGraphemeLength(){const b=De.getInstance(),D=this.c,H=D.offset;let ie=b.getGraphemeBreakType(D.prevCodePoint());for(;D.offset>0;){const ge=D.offset,Ie=b.getGraphemeBreakType(D.prevCodePoint());if(ke(Ie,ie)){D.setOffset(ge);break}ie=Ie}return H-D.offset}eol(){return this.c.eol()}}e.$Of=ye;function Re(l,b){return new ye(l,b).nextGraphemeLength()}function Oe(l,b){return new ye(l,b).prevGraphemeLength()}function ce(l,b){b>0&&ee(l.charCodeAt(b))&&b--;const D=b+Re(l,b);return[D-Oe(l,D),D]}function Ae(l){const b=new ye(l);let D=0;for(;!b.eol();)D++,b.nextGraphemeLength();return D}let de;function $e(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve(l){return de||(de=$e()),de.test(l)}const E=/^[\t\n\r\x20-\x7E]*$/;function y(l){return E.test(l)}e.$Vf=/[\u2028\u2029]/;function a(l){return e.$Vf.test(l)}function r(l){return l>=11904&&l<=55215||l>=63744&&l<=64255||l>=65281&&l<=65374}function _(l){return l>=127462&&l<=127487||l===8986||l===8987||l===9200||l===9203||l>=9728&&l<=10175||l===11088||l===11093||l>=127744&&l<=128591||l>=128640&&l<=128764||l>=128992&&l<=129008||l>=129280&&l<=129535||l>=129648&&l<=129782}function L(l,b,D=""){const H=l.trimStart();if(H.length<b)return H;const ie=/\b/g;let ge=0;for(;ie.test(H)&&!(H.length-ie.lastIndex<b);)ge=ie.lastIndex,ie.lastIndex+=1;return ge===0?H:D+H.substring(ge).trimStart()}const k=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*C(l){let b=0;for(const D of l.matchAll(k))b!==D.index&&(yield{isCode:!1,str:l.substring(b,D.index)}),yield{isCode:!0,str:D[0]},b=D.index+D[0].length;b!==l.length&&(yield{isCode:!1,str:l.substring(b)})}function _e(l){return l&&(l=l.replace(k,"")),l}const Ee=/\\\[.*?\\\]/g;function Y(l){return _e(l).replace(Ee,"")}e.$4f=String.fromCharCode(t.CharCode.UTF8_BOM);function X(l){return!!(l&&l.length>0&&l.charCodeAt(0)===t.CharCode.UTF8_BOM)}function ne(l){return X(l)?l.substr(1):l}function Q(l,b){if(!l||!b||l.length<b.length)return!1;const D=b.length,H=l.toLowerCase();let ie=0,ge=-1;for(;ie<D;){const Ie=H.indexOf(b[ie],ge+1);if(Ie<0)return!1;ge=Ie,ie++}return!0}function ue(l,b=!1){return l?(b&&(l=l.replace(/\\./g,"")),l.toLowerCase()!==l):!1}function he(l){return l.charAt(0).toUpperCase()+l.slice(1)}function we(l,b=1){if(b===0)return"";let D=-1;do D=l.indexOf(`
`,D+1),b--;while(b>0&&D>=0);return D===-1?l:(l[D-1]==="\r"&&D--,l.substr(0,D))}function Ue(l){const b=t.CharCode.Z-t.CharCode.A+1;return l=l%(2*b),l<b?String.fromCharCode(t.CharCode.a+l):String.fromCharCode(t.CharCode.A+l-b)}function Te(l){return De.getInstance().getGraphemeBreakType(l)}function ke(l,b){return l===ae.Other?b!==ae.Extend&&b!==ae.SpacingMark:l===ae.CR&&b===ae.LF?!1:l===ae.Control||l===ae.CR||l===ae.LF||b===ae.Control||b===ae.CR||b===ae.LF?!0:!(l===ae.L&&(b===ae.L||b===ae.V||b===ae.LV||b===ae.LVT)||(l===ae.LV||l===ae.V)&&(b===ae.V||b===ae.T)||(l===ae.LVT||l===ae.T)&&b===ae.T||b===ae.Extend||b===ae.ZWJ||b===ae.SpacingMark||l===ae.Prepend||l===ae.ZWJ&&b===ae.Extended_Pictographic||l===ae.Regional_Indicator&&b===ae.Regional_Indicator)}var ae;(function(l){l[l.Other=0]="Other",l[l.Prepend=1]="Prepend",l[l.CR=2]="CR",l[l.LF=3]="LF",l[l.Control=4]="Control",l[l.Extend=5]="Extend",l[l.Regional_Indicator=6]="Regional_Indicator",l[l.SpacingMark=7]="SpacingMark",l[l.L=8]="L",l[l.V=9]="V",l[l.T=10]="T",l[l.LV=11]="LV",l[l.LVT=12]="LVT",l[l.ZWJ=13]="ZWJ",l[l.Extended_Pictographic=14]="Extended_Pictographic"})(ae||(e.GraphemeBreakType=ae={}));class De{static{this.c=null}static getInstance(){return De.c||(De.c=new De),De.c}constructor(){this.d=We()}getGraphemeBreakType(b){if(b<32)return b===t.CharCode.LineFeed?ae.LF:b===t.CharCode.CarriageReturn?ae.CR:ae.Control;if(b<127)return ae.Other;const D=this.d,H=D.length/3;let ie=1;for(;ie<=H;)if(b<D[3*ie])ie=2*ie;else if(b>D[3*ie+1])ie=2*ie+1;else return D[3*ie+2];return ae.Other}}function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(l,b){if(l===0)return 0;const D=Ve(l,b);if(D!==void 0)return D;const H=new Le(b,l);return H.prevCodePoint(),H.offset}function Ve(l,b){const D=new Le(b,l);let H=D.prevCodePoint();for(;Ke(H)||H===Ge.emojiVariantSelector||H===Ge.enclosingKeyCap;){if(D.offset===0)return;H=D.prevCodePoint()}if(!_(H))return;let ie=D.offset;return ie>0&&D.prevCodePoint()===Ge.zwj&&(ie=D.offset),ie}function Ke(l){return 127995<=l&&l<=127999}var Ge;(function(l){l[l.zwj=8205]="zwj",l[l.emojiVariantSelector=65039]="emojiVariantSelector",l[l.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.$bg="\xA0";class qe{static{this.c=new v.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new m.$$e({getCacheKey:JSON.stringify},b=>{function D(pe){const Be=new Map;for(let Me=0;Me<pe.length;Me+=2)Be.set(pe[Me],pe[Me+1]);return Be}function H(pe,Be){const Me=new Map(pe);for(const[He,Xe]of Be)Me.set(He,Xe);return Me}function ie(pe,Be){if(!pe)return Be;const Me=new Map;for(const[He,Xe]of pe)Be.has(He)&&Me.set(He,Xe);return Me}const ge=this.c.value;let Ie=b.filter(pe=>!pe.startsWith("_")&&pe in ge);Ie.length===0&&(Ie=["_default"]);let Fe;for(const pe of Ie){const Be=D(ge[pe]);Fe=ie(Fe,Be)}const Pe=D(ge._common),Ne=H(Pe,Fe);return new qe(Ne)})}static getInstance(b){return qe.d.get(Array.from(b))}static{this.e=new v.$T(()=>Object.keys(qe.c.value).filter(b=>!b.startsWith("_")))}static getLocales(){return qe.e.value}constructor(b){this.f=b}isAmbiguous(b){return this.f.has(b)}containsAmbiguousCharacter(b){for(let D=0;D<b.length;D++){const H=b.codePointAt(D);if(typeof H=="number"&&this.isAmbiguous(H))return!0}return!1}getPrimaryConfusable(b){return this.f.get(b)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=qe;class ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ze.c())),this.d}static isInvisibleCharacter(b){return ze.e().has(b)}static containsInvisibleCharacter(b){for(let D=0;D<b.length;D++){const H=b.codePointAt(D);if(typeof H=="number"&&ze.isInvisibleCharacter(H))return!0}return!1}static get codePoints(){return ze.e()}}e.$dg=ze}),define(me[7],be([0,1,4,3,2,6,27]),function(re,e,m,t,v,U,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=j,e.$yg=N,e.$zg=I,e.$Ag=B,e.$Bg=K,e.$Cg=c,e.$Dg=$,e.$Eg=A,e.$Fg=S,e.$Gg=G,e.$Hg=J,e.$Ig=W,e.$Jg=i,e.$Kg=n,e.$Lg=s,e.$Mg=d,e.$Ng=f;function j(u){return u===m.CharCode.Slash||u===m.CharCode.Backslash}function N(u){return u.replace(/[\\/]/g,t.$gc.sep)}function I(u){return u.indexOf("/")===-1&&(u=N(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function B(u,o=t.$gc.sep){if(!u)return"";const O=u.length,w=u.charCodeAt(0);if(j(w)){if(j(u.charCodeAt(1))&&!j(u.charCodeAt(2))){let M=3;const P=M;for(;M<O&&!j(u.charCodeAt(M));M++);if(P!==M&&!j(u.charCodeAt(M+1))){for(M+=1;M<O;M++)if(j(u.charCodeAt(M)))return u.slice(0,M+1).replace(/[\\/]/g,o)}}return o}else if(S(w)&&u.charCodeAt(1)===m.CharCode.Colon)return j(u.charCodeAt(2))?u.slice(0,2)+o:u.slice(0,2);let g=u.indexOf("://");if(g!==-1){for(g+=3;g<O;g++)if(j(u.charCodeAt(g)))return u.slice(0,g+1)}return""}function K(u){if(!v.$j||!u||u.length<5)return!1;let o=u.charCodeAt(0);if(o!==m.CharCode.Backslash||(o=u.charCodeAt(1),o!==m.CharCode.Backslash))return!1;let O=2;const w=O;for(;O<u.length&&(o=u.charCodeAt(O),o!==m.CharCode.Backslash);O++);return!(w===O||(o=u.charCodeAt(O+1),isNaN(o)||o===m.CharCode.Backslash))}const F=/[\\/:\*\?"<>\|]/g,Z=/[/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(u,o=v.$j){const O=o?F:Z;return!(!u||u.length===0||/^\s+$/.test(u)||(O.lastIndex=0,O.test(u))||o&&p.test(u)||u==="."||u===".."||o&&u[u.length-1]==="."||o&&u.length!==u.trim().length||u.length>255)}function $(u,o,O){const w=u===o;return!O||w?w:!u||!o?!1:(0,U.$Ff)(u,o)}function A(u,o,O,w=t.sep){if(u===o)return!0;if(!u||!o||o.length>u.length)return!1;if(O){if(!(0,U.$Gf)(u,o))return!1;if(o.length===u.length)return!0;let M=o.length;return o.charAt(o.length-1)===w&&M--,u.charAt(M)===w}return o.charAt(o.length-1)!==w&&(o+=w),u.indexOf(o)===0}function S(u){return u>=m.CharCode.A&&u<=m.CharCode.Z||u>=m.CharCode.a&&u<=m.CharCode.z}function G(u,o){return v.$j&&u.endsWith(":")&&(u+=t.sep),(0,t.$ic)(u)||(u=(0,t.$jc)(o,u)),u=(0,t.$hc)(u),J(u)}function J(u){return v.$j?(u=(0,U.$nf)(u,t.sep),u.endsWith(":")&&(u+=t.sep)):(u=(0,U.$nf)(u,t.sep),u||(u=t.sep)),u}function W(u){const o=(0,t.$hc)(u);return v.$j?u.length>3?!1:i(o)&&(u.length===2||o.charCodeAt(2)===m.CharCode.Backslash):o===t.$gc.sep}function i(u,o=v.$j){return o?S(u.charCodeAt(0))&&u.charCodeAt(1)===m.CharCode.Colon:!1}function n(u,o=v.$j){return i(u,o)?u[0]:void 0}function s(u,o,O){return o.length>u.length?-1:u===o?0:(O&&(u=u.toLowerCase(),o=o.toLowerCase()),u.indexOf(o))}function d(u){const o=u.split(":");let O,w,g;for(const M of o){const P=Number(M);(0,x.$ig)(P)?w===void 0?w=P:g===void 0&&(g=P):O=O?[O,M].join(":"):M}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:w!==void 0?w:void 0,column:g!==void 0?g:w!==void 0?1:void 0}}const R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function f(u,o,O=8){let w="";for(let M=0;M<O;M++){let P;M===0&&v.$j&&!o&&(O===3||O===4)?P=h:P=R,w+=P.charAt(Math.floor(Math.random()*P.length))}let g;return o?g=`${o}-${w}`:g=w,u?(0,t.$jc)(u,g):g}}),define(me[14],be([0,1,4,23,3,2]),function(re,e,m,t,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=$,e.$wc=i,v=Se(v);const x=/^\w[\w\d+.-]*$/,j=/^\//,N=/^\/\//;function I(h,f){if(!h.scheme&&f)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!x.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!j.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function B(h,f){return!h&&!f?"file":h}function K(h,f){switch(h){case"https":case"http":case"file":f?f[0]!==Z&&(f=Z+f):f=Z;break}return f}const F="",Z="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(f){return f instanceof c?!0:f?typeof f.authority=="string"&&typeof f.fragment=="string"&&typeof f.path=="string"&&typeof f.query=="string"&&typeof f.scheme=="string"&&typeof f.fsPath=="string"&&typeof f.with=="function"&&typeof f.toString=="function":!1}constructor(f,u,o,O,w,g=!1){typeof f=="object"?(this.scheme=f.scheme||F,this.authority=f.authority||F,this.path=f.path||F,this.query=f.query||F,this.fragment=f.fragment||F):(this.scheme=B(f,g),this.authority=u||F,this.path=K(this.scheme,o||F),this.query=O||F,this.fragment=w||F,I(this,g))}get fsPath(){return i(this,!1)}with(f){if(!f)return this;let{scheme:u,authority:o,path:O,query:w,fragment:g}=f;return u===void 0?u=this.scheme:u===null&&(u=F),o===void 0?o=this.authority:o===null&&(o=F),O===void 0?O=this.path:O===null&&(O=F),w===void 0?w=this.query:w===null&&(w=F),g===void 0?g=this.fragment:g===null&&(g=F),u===this.scheme&&o===this.authority&&O===this.path&&w===this.query&&g===this.fragment?this:new S(u,o,O,w,g)}static parse(f,u=!1){const o=p.exec(f);return o?new S(o[2]||F,R(o[4]||F),R(o[5]||F),R(o[7]||F),R(o[9]||F),u):new S(F,F,F,F,F)}static file(f){let u=F;if(U.$j&&(f=f.replace(/\\/g,Z)),f[0]===Z&&f[1]===Z){const o=f.indexOf(Z,2);o===-1?(u=f.substring(2),f=Z):(u=f.substring(2,o),f=f.substring(o)||Z)}return new S("file",u,f,F,F)}static from(f,u){return new S(f.scheme,f.authority,f.path,f.query,f.fragment,u)}static joinPath(f,...u){if(!f.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return U.$j&&f.scheme==="file"?o=c.file(v.$fc.join(i(f,!0),...u)).path:o=v.$gc.join(f.path,...u),f.with({path:o})}toString(f=!1){return n(this,f)}toJSON(){return this}static revive(f){if(f){if(f instanceof c)return f;{const u=new S(f);return u._formatted=f.external??null,u._fsPath=f._sep===A?f.fsPath??null:null,u}}else return f}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=c;function $(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const A=U.$j?1:void 0;class S extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(f=!1){return f?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const f={$mid:t.MarshalledId.Uri};return this._fsPath&&(f.fsPath=this._fsPath,f._sep=A),this._formatted&&(f.external=this._formatted),this.path&&(f.path=this.path),this.scheme&&(f.scheme=this.scheme),this.authority&&(f.authority=this.authority),this.query&&(f.query=this.query),this.fragment&&(f.fragment=this.fragment),f}}const G={[m.CharCode.Colon]:"%3A",[m.CharCode.Slash]:"%2F",[m.CharCode.QuestionMark]:"%3F",[m.CharCode.Hash]:"%23",[m.CharCode.OpenSquareBracket]:"%5B",[m.CharCode.CloseSquareBracket]:"%5D",[m.CharCode.AtSign]:"%40",[m.CharCode.ExclamationMark]:"%21",[m.CharCode.DollarSign]:"%24",[m.CharCode.Ampersand]:"%26",[m.CharCode.SingleQuote]:"%27",[m.CharCode.OpenParen]:"%28",[m.CharCode.CloseParen]:"%29",[m.CharCode.Asterisk]:"%2A",[m.CharCode.Plus]:"%2B",[m.CharCode.Comma]:"%2C",[m.CharCode.Semicolon]:"%3B",[m.CharCode.Equals]:"%3D",[m.CharCode.Space]:"%20"};function J(h,f,u){let o,O=-1;for(let w=0;w<h.length;w++){const g=h.charCodeAt(w);if(g>=m.CharCode.a&&g<=m.CharCode.z||g>=m.CharCode.A&&g<=m.CharCode.Z||g>=m.CharCode.Digit0&&g<=m.CharCode.Digit9||g===m.CharCode.Dash||g===m.CharCode.Period||g===m.CharCode.Underline||g===m.CharCode.Tilde||f&&g===m.CharCode.Slash||u&&g===m.CharCode.OpenSquareBracket||u&&g===m.CharCode.CloseSquareBracket||u&&g===m.CharCode.Colon)O!==-1&&(o+=encodeURIComponent(h.substring(O,w)),O=-1),o!==void 0&&(o+=h.charAt(w));else{o===void 0&&(o=h.substr(0,w));const M=G[g];M!==void 0?(O!==-1&&(o+=encodeURIComponent(h.substring(O,w)),O=-1),o+=M):O===-1&&(O=w)}}return O!==-1&&(o+=encodeURIComponent(h.substring(O))),o!==void 0?o:h}function W(h){let f;for(let u=0;u<h.length;u++){const o=h.charCodeAt(u);o===m.CharCode.Hash||o===m.CharCode.QuestionMark?(f===void 0&&(f=h.substr(0,u)),f+=G[o]):f!==void 0&&(f+=h[u])}return f!==void 0?f:h}function i(h,f){let u;return h.authority&&h.path.length>1&&h.scheme==="file"?u=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===m.CharCode.Slash&&(h.path.charCodeAt(1)>=m.CharCode.A&&h.path.charCodeAt(1)<=m.CharCode.Z||h.path.charCodeAt(1)>=m.CharCode.a&&h.path.charCodeAt(1)<=m.CharCode.z)&&h.path.charCodeAt(2)===m.CharCode.Colon?f?u=h.path.substr(1):u=h.path[1].toLowerCase()+h.path.substr(2):u=h.path,U.$j&&(u=u.replace(/\//g,"\\")),u}function n(h,f){const u=f?W:J;let o="",{scheme:O,authority:w,path:g,query:M,fragment:P}=h;if(O&&(o+=O,o+=":"),(w||O==="file")&&(o+=Z,o+=Z),w){let q=w.indexOf("@");if(q!==-1){const T=w.substr(0,q);w=w.substr(q+1),q=T.lastIndexOf(":"),q===-1?o+=u(T,!1,!1):(o+=u(T.substr(0,q),!1,!1),o+=":",o+=u(T.substr(q+1),!1,!0)),o+="@"}w=w.toLowerCase(),q=w.lastIndexOf(":"),q===-1?o+=u(w,!1,!0):(o+=u(w.substr(0,q),!1,!0),o+=w.substr(q))}if(g){if(g.length>=3&&g.charCodeAt(0)===m.CharCode.Slash&&g.charCodeAt(2)===m.CharCode.Colon){const q=g.charCodeAt(1);q>=m.CharCode.A&&q<=m.CharCode.Z&&(g=`/${String.fromCharCode(q+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===m.CharCode.Colon){const q=g.charCodeAt(0);q>=m.CharCode.A&&q<=m.CharCode.Z&&(g=`${String.fromCharCode(q+32)}:${g.substr(2)}`)}o+=u(g,!0,!1)}return M&&(o+="?",o+=u(M,!1,!1)),P&&(o+="#",o+=f?P:J(P,!1,!1)),o}function s(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+s(h.substr(3)):h}}const d=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function R(h){return h.match(d)?h.replace(d,f=>s(f)):h}}),define(me[29],be([0,1,5,2,6,14,3]),function(re,e,m,t,v,U,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=N,e.$Pg=I,e.$Tg=K,m=Se(m),t=Se(t),x=Se(x);var j;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatCodeBlock="vscode-chat-code-block",p.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",p.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm",p.commentsInput="comment",p.codeSetting="code-setting"})(j||(e.Schemas=j={}));function N(p,c){return U.URI.isUri(p)?(0,v.$Ff)(p.scheme,c):(0,v.$Gf)(p,c+":")}function I(p,...c){return c.some($=>N(p,$))}e.$Qg="vscode-tkn",e.$Rg="tkn";class B{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,$){this.f=K(c,$)}getServerRootPath(){return this.f}get g(){return x.$gc.join(this.f,j.vscodeRemoteResource)}set(c,$,A){this.a[c]=$,this.b[c]=A}setConnectionToken(c,$){this.c[c]=$}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(W){return m.$Y(W),c}const $=c.authority;let A=this.a[$];A&&A.indexOf(":")!==-1&&A.indexOf("[")===-1&&(A=`[${A}]`);const S=this.b[$],G=this.c[$];let J=`path=${encodeURIComponent(c.path)}`;return typeof G=="string"&&(J+=`&${e.$Rg}=${encodeURIComponent(G)}`),U.URI.from({scheme:t.$p?this.d:j.vscodeRemoteResource,authority:`${A}:${S}`,path:this.g,query:J})}}e.$Sg=new B;function K(p,c){return x.$gc.join(c??"/",`${p.quality??"oss"}-${p.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class F{static{this.a=e.$Yg}asBrowserUri(c){const $=this.b(c,re);return this.uriToBrowserUri($)}uriToBrowserUri(c){return c.scheme===j.vscodeRemote?e.$Sg.rewrite(c):c.scheme===j.file&&(t.$n||t.$r===`${j.vscodeFileResource}://${F.a}`)?c.with({scheme:j.vscodeFileResource,authority:c.authority||F.a,query:null,fragment:null}):c}asFileUri(c){const $=this.b(c,re);return this.uriToFileUri($)}uriToFileUri(c){return c.scheme===j.vscodeFileResource?c.with({scheme:j.file,authority:c.authority!==F.a?c.authority:null,query:null,fragment:null}):c}b(c,$){return U.URI.isUri(c)?c:U.URI.parse($.toUrl(c))}}e.$Zg=new F;var Z;(function(p){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(c.get("3"));const $="vscode-coi";function A(G){let J;typeof G=="string"?J=new URL(G).searchParams:G instanceof URL?J=G.searchParams:U.URI.isUri(G)&&(J=new URL(G.toString(!0)).searchParams);const W=J?.get($);if(W)return c.get(W)}p.getHeadersFromQuery=A;function S(G,J,W){if(!globalThis.crossOriginIsolated)return;const i=J&&W?"3":W?"2":"1";G instanceof URLSearchParams?G.set($,i):G[$]=i}p.addSearchParam=S})(Z||(e.COI=Z={}))}),define(me[30],be([0,1,4,7,29,3,2,6,14]),function(re,e,m,t,v,U,x,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=I,e.$ph=K,e.$qh=Z,t=Se(t),U=Se(U);function I(p){return(0,N.$wc)(p,!0)}class B{constructor(c){this.a=c}compare(c,$,A=!1){return c===$?0:(0,j.$yf)(this.getComparisonKey(c,A),this.getComparisonKey($,A))}isEqual(c,$,A=!1){return c===$?!0:!c||!$?!1:this.getComparisonKey(c,A)===this.getComparisonKey($,A)}getComparisonKey(c,$=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:$?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,$,A=!1){if(c.scheme===$.scheme){if(c.scheme===v.Schemas.file)return t.$Eg(I(c),I($),this.a(c))&&c.query===$.query&&(A||c.fragment===$.fragment);if((0,e.$lh)(c.authority,$.authority))return t.$Eg(c.path,$.path,this.a(c),"/")&&c.query===$.query&&(A||c.fragment===$.fragment)}return!1}joinPath(c,...$){return N.URI.joinPath(c,...$)}basenameOrAuthority(c){return(0,e.$dh)(c)||c.authority}basename(c){return U.$gc.basename(c.path)}extname(c){return U.$gc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let $;return c.scheme===v.Schemas.file?$=N.URI.file(U.$mc(I(c))).path:($=U.$gc.dirname(c.path),c.authority&&$.length&&$.charCodeAt(0)!==m.CharCode.Slash&&(console.error(`dirname("${c.toString})) resulted in a relative path`),$="/")),c.with({path:$})}normalizePath(c){if(!c.path.length)return c;let $;return c.scheme===v.Schemas.file?$=N.URI.file(U.$hc(I(c))).path:$=U.$gc.normalize(c.path),c.with({path:$})}relativePath(c,$){if(c.scheme!==$.scheme||!(0,e.$lh)(c.authority,$.authority))return;if(c.scheme===v.Schemas.file){const G=U.$lc(I(c),I($));return x.$j?t.$yg(G):G}let A=c.path||"/";const S=$.path||"/";if(this.a(c)){let G=0;for(const J=Math.min(A.length,S.length);G<J&&!(A.charCodeAt(G)!==S.charCodeAt(G)&&A.charAt(G).toLowerCase()!==S.charAt(G).toLowerCase());G++);A=S.substr(0,G)+A.substr(G)}return U.$gc.relative(A,S)}resolvePath(c,$){if(c.scheme===v.Schemas.file){const A=N.URI.file(U.$kc(I(c),$));return c.with({authority:A.authority,path:A.path})}return $=t.$zg($),c.with({path:U.$gc.resolve(c.path,$)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,$){return c===$||c!==void 0&&$!==void 0&&(0,j.$Ff)(c,$)}hasTrailingPathSeparator(c,$=U.sep){if(c.scheme===v.Schemas.file){const A=I(c);return A.length>t.$Ag(A).length&&A[A.length-1]===$}else{const A=c.path;return A.length>1&&A.charCodeAt(A.length-1)===m.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,$=U.sep){return(0,e.$mh)(c,$)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,$=U.sep){let A=!1;if(c.scheme===v.Schemas.file){const S=I(c);A=S!==void 0&&S.length===t.$Ag(S).length&&S[S.length-1]===$}else{$="/";const S=c.path;A=S.length===1&&S.charCodeAt(S.length-1)===m.CharCode.Slash}return!A&&!(0,e.$mh)(c,$)?c.with({path:c.path+"/"}):c}}e.$8g=B,e.$9g=new B(()=>!1),e.$0g=new B(p=>p.scheme===v.Schemas.file?!x.$l:!0),e.$$g=new B(p=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function K(p,c){const $=[];for(let A=0;A<p.length;A++){const S=c(p[A]);p.some((G,J)=>J===A?!1:(0,e.$ah)(S,c(G)))||$.push(p[A])}return $}var F;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function c($){const A=new Map;$.path.substring($.path.indexOf(";")+1,$.path.lastIndexOf(";")).split(";").forEach(J=>{const[W,i]=J.split(":");W&&i&&A.set(W,i)});const G=$.path.substring(0,$.path.indexOf(";"));return G&&A.set(p.META_DATA_MIME,G),A}p.parseMetaData=c})(F||(e.DataUri=F={}));function Z(p,c,$){if(c){let A=p.path;return A&&A[0]!==U.$gc.sep&&(A=U.$gc.sep+A),p.with({scheme:$,authority:c,path:A})}return p.with({scheme:$})}}),define(me[15],be([0,1,13,5,12,10,30,2,26,9]),function(re,e,m,t,v,U,x,j,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=B,e.$sh=K,e.$th=F,e.$uh=Z,e.$vh=p,e.$wh=c,e.$xh=$,e.$yh=A,e.$Gh=h,e.$Hh=f,e.$Ih=u,e.$Jh=o,e.$Kh=O,e.$Zh=oe,e.$8h=E;function B(a){return!!a&&typeof a.then=="function"}function K(a){const r=new m.$we,_=a(r.token),L=new Promise((k,C)=>{const _e=r.token.onCancellationRequested(()=>{_e.dispose(),C(new t.$4)});Promise.resolve(_).then(Ee=>{_e.dispose(),r.dispose(),k(Ee)},Ee=>{_e.dispose(),r.dispose(),C(Ee)})});return new class{cancel(){r.cancel(),r.dispose()}then(k,C){return L.then(k,C)}catch(k){return this.then(void 0,k)}finally(k){return L.finally(k)}}}function F(a,r,_){return new Promise((L,k)=>{const C=r.onCancellationRequested(()=>{C.dispose(),L(_)});a.then(L,k).finally(()=>C.dispose())})}function Z(a,r){return new Promise((_,L)=>{const k=r.onCancellationRequested(()=>{k.dispose(),L(new t.$4)});a.then(_,L).finally(()=>k.dispose())})}async function p(a){let r=-1;const _=a.map((L,k)=>L.then(C=>(r=k,C)));try{return await Promise.race(_)}finally{a.forEach((L,k)=>{k!==r&&L.cancel()})}}function c(a,r,_){let L;const k=setTimeout(()=>{L?.(void 0),_?.()},r);return Promise.race([a.finally(()=>clearTimeout(k)),new Promise(C=>L=C)])}function $(a){return new Promise((r,_)=>{const L=a();B(L)?L.then(r,_):r(L)})}function A(){let a,r;return{promise:new Promise((L,k)=>{a=L,r=k}),resolve:a,reject:r}}class S{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(r){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=r,!this.b){const _=()=>{if(this.b=null,this.f)return;const L=this.queue(this.d);return this.d=null,L};this.b=new Promise(L=>{this.a.then(_,_).then(L)})}return new Promise((_,L)=>{this.b.then(_,L)})}return this.a=r(),new Promise((_,L)=>{this.a.then(k=>{this.a=null,_(k)},k=>{this.a=null,L(k)})})}dispose(){this.f=!0}}e.$zh=S;class G{constructor(){this.a=Promise.resolve(null)}queue(r){return this.a=this.a.then(()=>r(),()=>r())}}e.$Ah=G;class J{constructor(){this.a=new Map}queue(r,_){const k=(this.a.get(r)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.a.get(r)===k&&this.a.delete(r)});return this.a.set(r,k),k}}e.$Bh=J;const W=(a,r)=>{let _=!0;const L=setTimeout(()=>{_=!1,r()},a);return{isTriggered:()=>_,dispose:()=>{clearTimeout(L),_=!1}}},i=a=>{let r=!0;return queueMicrotask(()=>{r&&(r=!1,a())}),{isTriggered:()=>r,dispose:()=>{r=!1}}};class n{constructor(r){this.defaultDelay=r,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(r,_=this.defaultDelay){this.g=r,this.h(),this.b||(this.b=new Promise((k,C)=>{this.d=k,this.f=C}).then(()=>{if(this.b=null,this.d=null,this.g){const k=this.g;return this.g=null,k()}}));const L=()=>{this.a=null,this.d?.(null)};return this.a=_===N.$ge?i(L):W(_,L),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=n;class s{constructor(r){this.a=new n(r),this.b=new S}trigger(r,_){return this.a.trigger(()=>this.b.queue(r),_)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=s;class d{constructor(){this.a=!1,this.b=new Promise((r,_)=>{this.d=r})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=d;class R extends d{constructor(r){super(),this.f=setTimeout(()=>this.open(),r)}open(){clearTimeout(this.f),super.open()}}e.$Fh=R;function h(a,r){return r?new Promise((_,L)=>{const k=setTimeout(()=>{C.dispose(),_()},a),C=r.onCancellationRequested(()=>{clearTimeout(k),C.dispose(),L(new t.$4)})}):K(_=>h(a,_))}function f(a,r=0,_){const L=setTimeout(()=>{a(),_&&k.dispose()},r),k=(0,U.$Sc)(()=>{clearTimeout(L),_?.deleteAndLeak(k)});return _?.add(k),k}function u(a){const r=[];let _=0;const L=a.length;function k(){return _<L?a[_++]():null}function C(_e){_e!=null&&r.push(_e);const Ee=k();return Ee?Ee.then(C):Promise.resolve(r)}return Promise.resolve(null).then(C)}function o(a,r=L=>!!L,_=null){let L=0;const k=a.length,C=()=>{if(L>=k)return Promise.resolve(_);const _e=a[L++];return Promise.resolve(_e()).then(Y=>r(Y)?Promise.resolve(Y):C())};return C()}function O(a,r=L=>!!L,_=null){if(a.length===0)return Promise.resolve(_);let L=a.length;const k=()=>{L=-1;for(const C of a)C.cancel?.()};return new Promise((C,_e)=>{for(const Ee of a)Ee.then(Y=>{--L>=0&&r(Y)?(k(),C(Y)):L===0&&C(_)}).catch(Y=>{--L>=0&&(k(),_e(Y))})})}class w{constructor(r){this.a=0,this.b=!1,this.f=r,this.g=[],this.d=0,this.h=new v.$le}whenIdle(){return this.size>0?v.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(r){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((_,L)=>{this.g.push({factory:r,c:_,e:L}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const r=this.g.shift();this.d++;const _=r.factory();_.then(r.c,r.e),_.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=w;class g extends w{constructor(){super(1)}}e.$Mh=g;class M{constructor(){this.a=new fe,this.b=0}queue(r){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,r())):this.a.run(this.b++,r())}}e.$Nh=M;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const r=new Re;return this.b.add(r),r.p}g(){for(const[,r]of this.a)if(r.size>0)return!1;return!0}queueSize(r,_=x.$9g){const L=_.getComparisonKey(r);return this.a.get(L)?.size??0}queueFor(r,_,L=x.$9g){const k=L.getComparisonKey(r);let C=this.a.get(k);if(!C){C=new g;const _e=this.f++,Ee=v.Event.once(C.onDrained)(()=>{C?.dispose(),this.a.delete(k),this.h(),this.d?.deleteAndDispose(_e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new U.$4c),this.d.set(_e,Ee),this.a.set(k,C)}return C.queue(_)}h(){this.g()&&this.j()}j(){for(const r of this.b)r.complete();this.b.clear()}dispose(){for(const[,r]of this.a)r.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=P;class q{constructor(r,_){this.b=!1,this.a=-1,typeof r=="function"&&typeof _=="number"&&this.setIfNotSet(r,_)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(r,_){if(this.b)throw new t.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,r()},_)}setIfNotSet(r,_){if(this.b)throw new t.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,r()},_))}}e.$Ph=q;class T{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(r,_,L=globalThis){if(this.f)throw new t.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const k=L.setInterval(()=>{r()},_);this.d=(0,U.$Sc)(()=>{L.clearInterval(k),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=T;class V{constructor(r,_){this.b=-1,this.a=r,this.d=_,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(r=this.d){this.cancel(),this.b=setTimeout(this.f,r)}get delay(){return this.d}set delay(r){this.d=r}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=V;class le{constructor(r,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.a=r,this.b=_,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(r=this.b){r%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${r}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(r/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=le;class z extends V{constructor(r,_){super(r,_),this.j=[]}work(r){this.j.push(r),this.isScheduled()||this.schedule()}h(){const r=this.j;this.j=[],this.a?.(r)}dispose(){this.j=[],super.dispose()}}e.$Th=z;class se extends U.$Uc{constructor(r,_){super(),this.g=r,this.h=_,this.a=[],this.b=this.B(new U.$Vc),this.f=!1}get pending(){return this.a.length}work(r){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+r.length>this.g.maxBufferedWork)return!1}else if(this.pending+r.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const _ of r)this.a.push(_);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=se,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(a,r)=>{(0,j.$C)(()=>{if(_)return;const L=Date.now()+15;r(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,L-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.$Wh=(a,r,_)=>{const L=a.requestIdleCallback(r,typeof _=="number"?{timeout:_}:void 0);let k=!1;return{dispose(){k||(k=!0,a.cancelIdleCallback(L))}}},e.$Vh=a=>(0,e.$Wh)(globalThis,a)}();class ee{constructor(r,_){this.g=!1,this.d=()=>{try{this.j=_()}catch(L){this.l=L}finally{this.g=!0}},this.f=(0,e.$Wh)(r,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=ee;class te extends ee{constructor(r){super(globalThis,r)}}e.$Yh=te;async function oe(a,r,_){let L;for(let k=0;k<_;k++)try{return await a()}catch(C){L=C,await h(r)}throw L}class fe{isRunning(r){return typeof r=="number"?this.a?.taskId===r:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(r,_,L){return this.a={taskId:r,cancel:()=>L?.(),promise:_},_.then(()=>this.d(r),()=>this.d(r)),_}d(r){this.a&&r===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const r=this.b;this.b=void 0,r.run().then(r.promiseResolve,r.promiseReject)}}queue(r){if(this.b)this.b.run=r;else{const{promise:_,resolve:L,reject:k}=A();this.b={run:r,promise:_,promiseResolve:L,promiseReject:k}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=fe;class Le{constructor(r,_=()=>Date.now()){this.d=r,this.f=_,this.a=0,this.b=0}increment(){const r=this.f();return r-this.a>this.d&&(this.a=r,this.b=0),this.b++,this.b}}e.$2h=Le;var ye;(function(a){a[a.Resolved=0]="Resolved",a[a.Rejected=1]="Rejected"})(ye||(ye={}));class Re{get isRejected(){return this.d?.outcome===ye.Rejected}get isResolved(){return this.d?.outcome===ye.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ye.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((r,_)=>{this.a=r,this.b=_})}complete(r){return new Promise(_=>{this.a(r),this.d={outcome:ye.Resolved,value:r},_()})}error(r){return new Promise(_=>{this.b(r),this.d={outcome:ye.Rejected,value:r},_()})}cancel(){return this.error(new t.$4)}}e.$3h=Re;var Oe;(function(a){async function r(L){let k;const C=await Promise.all(L.map(_e=>_e.then(Ee=>Ee,Ee=>{k||(k=Ee)})));if(typeof k<"u")throw k;return C}a.settled=r;function _(L){return new Promise(async(k,C)=>{try{await L(k,C)}catch(_e){C(_e)}})}a.withAsyncBody=_})(Oe||(e.Promises=Oe={}));class ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(r){this.a=void 0,this.b=void 0,this.d=!1,this.promise=r.then(_=>(this.a=_,this.d=!0,_),_=>{throw this.b=_,this.d=!0,_})}requireValue(){if(!this.d)throw new t.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=ce;class Ae{constructor(r){this.b=r,this.a=new I.$T(()=>new ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=Ae;var de;(function(a){a[a.Initial=0]="Initial",a[a.DoneOK=1]="DoneOK",a[a.DoneError=2]="DoneError"})(de||(de={}));class $e{static fromArray(r){return new $e(_=>{_.emitMany(r)})}static fromPromise(r){return new $e(async _=>{_.emitMany(await r)})}static fromPromises(r){return new $e(async _=>{await Promise.all(r.map(async L=>_.emitOne(await L)))})}static merge(r){return new $e(async _=>{await Promise.all(r.map(async L=>{for await(const k of L)_.emitOne(k)}))})}static{this.EMPTY=$e.fromArray([])}constructor(r,_){this.a=de.Initial,this.b=[],this.d=null,this.f=_,this.g=new v.$le,queueMicrotask(async()=>{const L={emitOne:k=>this.h(k),emitMany:k=>this.j(k),reject:k=>this.l(k)};try{await Promise.resolve(r(L)),this.k()}catch(k){this.l(k)}finally{L.emitOne=void 0,L.emitMany=void 0,L.reject=void 0}})}[Symbol.asyncIterator](){let r=0;return{next:async()=>{do{if(this.a===de.DoneError)throw this.d;if(r<this.b.length)return{done:!1,value:this.b[r++]};if(this.a===de.DoneOK)return{done:!0,value:void 0};await v.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(r,_){return new $e(async L=>{for await(const k of r)L.emitOne(_(k))})}map(r){return $e.map(this,r)}static filter(r,_){return new $e(async L=>{for await(const k of r)_(k)&&L.emitOne(k)})}filter(r){return $e.filter(this,r)}static coalesce(r){return $e.filter(r,_=>!!_)}coalesce(){return $e.coalesce(this)}static async toPromise(r){const _=[];for await(const L of r)_.push(L);return _}toPromise(){return $e.toPromise(this)}h(r){this.a===de.Initial&&(this.b.push(r),this.g.fire())}j(r){this.a===de.Initial&&(this.b=this.b.concat(r),this.g.fire())}k(){this.a===de.Initial&&(this.a=de.DoneOK,this.g.fire())}l(r){this.a===de.Initial&&(this.a=de.DoneError,this.d=r,this.g.fire())}}e.$6h=$e;class ve extends $e{constructor(r,_){super(_),this.m=r}cancel(){this.m.cancel()}}e.$7h=ve;function E(a){const r=new m.$we,_=a(r.token);return new ve(r,async L=>{const k=r.token.onCancellationRequested(()=>{k.dispose(),r.dispose(),L.reject(new t.$4)});try{for await(const C of _){if(r.token.isCancellationRequested)return;L.emitOne(C)}k.dispose(),r.dispose()}catch(C){k.dispose(),r.dispose(),L.reject(C)}})}class y{constructor(r){this.a=new Re,this.b=new $e(k=>{if(_){k.reject(_);return}return L&&k.emitMany(L),this.d=C=>k.reject(C),this.f=C=>k.emitOne(C),this.a.p},r);let _,L;this.f=k=>{L||(L=[]),L.push(k)},this.d=k=>{_||(_=k)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(r){this.d(r),this.a.complete()}emitOne(r){this.f(r)}}e.$9h=y}),define(me[31],be([0,1,32,2]),function(re,e,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TX=N;const v={437:"cp437",850:"cp850",852:"cp852",855:"cp855",857:"cp857",860:"cp860",861:"cp861",863:"cp863",865:"cp865",866:"cp866",869:"cp869",936:"cp936",1252:"cp1252"};function U(I){const B=I.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return x[B]||B}const x={ibm866:"cp866",big5:"cp950"},j="utf8";async function N(I){let B;const K=process.env.VSCODE_CLI_ENCODING;K?(I&&console.log(`Found VSCODE_CLI_ENCODING variable: ${K}`),B=Promise.resolve(K)):t.$j?B=new Promise(Z=>{I&&console.log('Running "chcp" to detect terminal encoding...'),(0,m.exec)("chcp",(p,c,$)=>{if(c){I&&console.log(`Output from "chcp" command is: ${c}`);const A=Object.keys(v);for(const S of A)if(c.indexOf(S)>=0)return Z(v[S])}return Z(void 0)})}):B=new Promise(Z=>{I&&console.log('Running "locale charmap" to detect terminal encoding...'),(0,m.exec)("locale charmap",(p,c,$)=>Z(c))});const F=await B;return I&&console.log(`Detected raw terminal encoding: ${F}`),!F||F.toLowerCase()==="utf-8"||F.toLowerCase()===j?j:U(F)}}),define(me[33],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=v,e.localize2=x;const m=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function t(j,N){let I;return N.length===0?I=j:I=j.replace(/\{(\d+)\}/g,(B,K)=>{const F=K[0],Z=N[F];let p=B;return typeof Z=="string"?p=Z:(typeof Z=="number"||typeof Z=="boolean"||Z===void 0||Z===null)&&(p=String(Z)),p}),m&&(I="\uFF3B"+I.replace(/[aouei]/g,"$&$&")+"\uFF3D"),I}function v(j,N,...I){return t(typeof j=="number"?U(j,N):N,I)}function U(j,N){const I=globalThis._VSCODE_NLS_MESSAGES?.[j];if(typeof I!="string"){if(typeof N=="string")return N;throw new Error(`!!! NLS MISSING: ${j} !!!`)}return I}function x(j,N,...I){let B;typeof j=="number"?B=U(j,N):B=N;const K=t(B,I);return{value:K,original:N===B?K:t(N,I)}}});var Je=this&&this.__importDefault||function(re){return re&&re.__esModule?re:{default:re}};define(me[34],be([0,1,38,2,33]),function(re,e,m,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=void 0,e.$Dm=j,e.$Em=I,e.$Fm=Z,e.$Gm=p,m=Je(m);const U={o:(0,v.localize)(11522,null),e:(0,v.localize)(11523,null),t:(0,v.localize)(11524,null)};e.$Bm=["tunnel","serve-web"],e.$Cm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,v.localize)(11525,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,v.localize)(11526,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,v.localize)(11527,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,v.localize)(11528,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,v.localize)(11529,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,v.localize)(11530,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,v.localize)(11531,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,v.localize)(11532,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,v.localize)(11533,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,v.localize)(11534,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,v.localize)(11535,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,v.localize)(11536,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,v.localize)(11537,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,v.localize)(11538,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,v.localize)(11539,null)},"show-versions":{type:"boolean",cat:"e",description:(0,v.localize)(11540,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,v.localize)(11541,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,v.localize)(11542,null)},"pre-release":{type:"boolean",cat:"e",description:(0,v.localize)(11543,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,v.localize)(11544,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,v.localize)(11545,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,v.localize)(11546,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,v.localize)(11547,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,v.localize)(11548,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,v.localize)(11549,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,v.localize)(11550,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,v.localize)(11551,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,v.localize)(11552,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,v.localize)(11553,null)},sync:{type:"string",cat:"t",description:(0,v.localize)(11554,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,v.localize)(11555,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,v.localize)(11556,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,v.localize)(11557,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,v.localize)(11558,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,v.localize)(11559,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,v.localize)(11560,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const x={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function j(c,$,A=x){const S=c.find(h=>h.length>0&&h[0]!=="-"),G={},J=["_"],W=[],i={};let n;for(const h in $){const f=$[h];f.type==="subcommand"?h===S&&(n=f):(f.alias&&(G[h]=f.alias),f.type==="string"||f.type==="string[]"?(J.push(h),f.deprecates&&J.push(...f.deprecates)):f.type==="boolean"&&(W.push(h),f.deprecates&&W.push(...f.deprecates)),f.global&&(i[h]=f))}if(n&&S){const h=i;for(const O in n.options)h[O]=n.options[O];const f=c.filter(O=>O!==S),u=A.getSubcommandReporter?A.getSubcommandReporter(S):void 0,o=j(f,h,u);return{[S]:o,_:[]}}const s=(0,m.default)(c,{string:J,boolean:W,alias:G}),d={},R=s;d._=s._.map(h=>String(h)).filter(h=>h.length>0),delete R._;for(const h in $){const f=$[h];if(f.type==="subcommand")continue;f.alias&&delete R[f.alias];let u=R[h];if(f.deprecates)for(const o of f.deprecates)R.hasOwnProperty(o)&&(u||(u=R[o],u&&A.onDeprecatedOption(o,f.deprecationMessage||(0,v.localize)(11561,null,h))),delete R[o]);if(typeof u<"u"){if(f.type==="string[]"){if(Array.isArray(u)||(u=[u]),!f.allowEmptyValue){const o=u.filter(O=>O.length>0);o.length!==u.length&&(A.onEmptyValue(h),u=o.length>0?o:void 0)}}else f.type==="string"&&(Array.isArray(u)?(u=u.pop(),A.onMultipleValues(h,u)):!u&&!f.allowEmptyValue&&(A.onEmptyValue(h),u=void 0));d[h]=u,f.deprecationMessage&&A.onDeprecatedOption(h,f.deprecationMessage)}delete R[h]}for(const h in R)A.onUnknownOption(h);return d}function N(c,$){let A="";return $.args&&(Array.isArray($.args)?A=` <${$.args.join("> <")}>`:A=` <${$.args}>`),$.alias?`-${$.alias} --${c}${A}`:`--${c}${A}`}function I(c,$){const A=[];for(const S in c){const G=c[S],J=N(S,G);A.push([J,G.description])}return B(A,$)}function B(c,$){const S=c.reduce((W,i)=>Math.max(W,i[0].length),12)+2+1;if($-S<25)return c.reduce((W,i)=>W.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const G=$-S-1,J=[];for(const W of c){const i=W[0],n=F(W[1],G),s=K(S-i.length-2);J.push("  "+i+s+n[0]);for(let d=1;d<n.length;d++)J.push(K(S)+n[d])}return J}function K(c){return" ".repeat(c)}function F(c,$){const A=[];for(;c.length;){const S=c.length<$?c.length:c.lastIndexOf(" ",$),G=c.slice(0,S).trim();c=c.slice(S),A.push(G)}return A}function Z(c,$,A,S,G){const J=process.stdout.isTTY&&process.stdout.columns||80,W=G?.noInputFiles!==!0?`[${(0,v.localize)(11562,null)}...]`:"",i=[`${c} ${A}`];i.push(""),i.push(`${(0,v.localize)(11563,null)}: ${$} [${(0,v.localize)(11564,null)}]${W}`),i.push(""),G?.noPipe!==!0&&(t.$j?i.push((0,v.localize)(11565,null,$)):i.push((0,v.localize)(11566,null,$)),i.push(""));const n={},s=[];for(const d in S){const R=S[d];if(R.type==="subcommand")R.description&&s.push({command:d,description:R.description});else if(R.description&&R.cat){let h=n[R.cat];h||(n[R.cat]=h={}),h[d]=R}}for(const d in n){const R=d,h=n[R];h&&(i.push(U[R]),i.push(...I(h,J)),i.push(""))}return s.length&&(i.push((0,v.localize)(11567,null)),i.push(...B(s.map(d=>[d.command,d.description]),J)),i.push("")),i.join(`
`)}function p(c,$){return`${c||(0,v.localize)(11568,null)}
${$||(0,v.localize)(11569,null)}
${process.arch}`}}),define(me[35],be([0,1,16,36,15,7,31]),function(re,e,m,t,v,U,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=j,e.$0hc=N,e.$$hc=I,e.$_hc=B,m=Se(m);function j(){try{return!process.stdin.isTTY}catch{}return!1}function N(K){return new Promise(F=>{const Z=()=>F(!0);setTimeout(()=>{process.stdin.removeListener("data",Z),F(!1)},K),process.stdin.once("data",Z)})}function I(){return(0,U.$Ng)((0,t.tmpdir)(),"code-stdin",3)}async function B(K,F,Z){let[p,c]=await Promise.all([(0,x.$TX)(F),new Promise((S,G)=>{re(["@vscode/iconv-lite-umd"],S,G)}).then(Se),m.promises.appendFile(K,"")]);c.encodingExists(p)||(console.log(`Unsupported terminal encoding: ${p}, falling back to UTF-8.`),p="utf8");const $=new v.$Mh,A=c.getDecoder(p);process.stdin.on("data",S=>{const G=A.write(S);$.queue(()=>m.promises.appendFile(K,G))}),process.stdin.on("end",()=>{const S=A.end();$.queue(async()=>{try{typeof S=="string"&&await m.promises.appendFile(K,S)}finally{Z?.()}})})}}),define(me[37],be([0,1,16,36,7]),function(re,e,m,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=U;function U(x){const j=(0,v.$Ng)((0,t.tmpdir)());try{return(0,m.writeFileSync)(j,""),x&&console.log(`Marker file for --wait created: ${j}`),j}catch(N){x&&console.error(`Failed to create marker file for --wait: ${N}`);return}}}),define(me[39],be([0,1,16,40,32,41,11,3,34,37,35,15]),function(re,e,m,t,v,U,x,j,N,I,B,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=G,m=Se(m),t=Se(t),v=Se(v),U=Se(U);const F=P=>{switch(P){case"user-data-dir":case"extensions-dir":case"export-default-configuration":case"install-source":case"enable-smoke-test-driver":case"extensions-download-dir":case"builtin-extensions-dir":case"telemetry":return!1;default:return!0}},Z=P=>{switch(P){case"version":case"help":case"folder-uri":case"file-uri":case"add":case"diff":case"merge":case"wait":case"goto":case"reuse-window":case"new-window":case"status":case"install-extension":case"uninstall-extension":case"update-extensions":case"list-extensions":case"force":case"show-versions":case"category":case"verbose":case"remote":case"locate-shell-integration-path":return!0;default:return!1}},p=process.env.VSCODE_IPC_HOOK_CLI,c=process.env.VSCODE_CLIENT_COMMAND,$=process.env.VSCODE_CLIENT_COMMAND_CWD,A=process.env.VSCODE_CLI_AUTHORITY,S=process.env.VSCODE_STDIN_FILE_PATH;async function G(P,q){if(!p&&!c){console.log("Command is only available in WSL or inside a Visual Studio Code terminal.");return}const T={...N.$Cm,gitCredential:{type:"string"},openExternal:{type:"boolean"}},V=c?F:Z;for(const ce in N.$Cm){const Ae=ce;V(Ae)||delete T[Ae]}p&&(T.openExternal={type:"boolean"});const le={onMultipleValues:(ce,Ae)=>{console.error(`Option '${ce}' can only be defined once. Using value ${Ae}.`)},onEmptyValue:ce=>{console.error(`Ignoring option '${ce}': Value must not be empty.`)},onUnknownOption:ce=>{console.error(`Ignoring option '${ce}': not supported for ${P.executableName}.`)},onDeprecatedOption:(ce,Ae)=>{console.warn(`Option '${ce}' is deprecated: ${Ae}`)}},z=(0,N.$Dm)(q,T,le),se=A?u:ce=>ce,ee=!!z.verbose;if(z.help){console.log((0,N.$Fm)(P.productName,P.executableName,P.version,T));return}if(z.version){console.log((0,N.$Gm)(P.version,P.commit));return}if(z["locate-shell-integration-path"]){let ce;switch(z["locate-shell-integration-path"]){case"bash":ce="shellIntegration-bash.sh";break;case"pwsh":ce="shellIntegration.ps1";break;case"zsh":ce="shellIntegration-rc.zsh";break;case"fish":ce="fish_xdg_data/fish/vendor_conf.d/shellIntegration.fish";break;default:throw new Error("Error using --locate-shell-integration-path: Invalid shell type")}console.log((0,j.$kc)(__dirname,"../..","workbench","contrib","terminal","browser","media",ce));return}if(p&&z.openExternal){i(z._,ee);return}let te=z.remote;(te==="local"||te==="false"||te==="")&&(te=null);const oe=(z["folder-uri"]||[]).map(se);z["folder-uri"]=oe;const fe=(z["file-uri"]||[]).map(se);z["file-uri"]=fe;const Le=z._;let ye=!1;for(const ce of Le)ce==="-"?ye=!0:f(ce,se,oe,fe);z._=[];let Re;if(ye&&(0,B.$9hc)())try{let ce=S;if(!ce){ce=(0,B.$$hc)();const Ae=new K.$3h;await(0,B.$_hc)(ce,ee,()=>Ae.complete()),z.wait||(Re=Ae.p)}f(ce,se,oe,fe),z["skip-add-to-recently-opened"]=!0,console.log(`Reading from stdin via: ${ce}`)}catch(ce){console.log(`Failed to create file to read via stdin: ${ce.toString()}`)}z.extensionDevelopmentPath&&(z.extensionDevelopmentPath=z.extensionDevelopmentPath.map(ce=>se(h(ce).href))),z.extensionTestsPath&&(z.extensionTestsPath=se(h(z.extensionTestsPath).href));const Oe=z["crash-reporter-directory"];if(Oe!==void 0&&!Oe.match(/^([a-zA-Z]:[\\\/])/)){console.log(`The crash reporter directory '${Oe}' must be an absolute Windows path (e.g. c:/crashes)`);return}if(c){if(z["install-extension"]!==void 0||z["uninstall-extension"]!==void 0||z["list-extensions"]||z["update-extensions"]){const de=[];z["install-extension"]?.forEach(ve=>de.push("--install-extension",ve)),z["uninstall-extension"]?.forEach(ve=>de.push("--uninstall-extension",ve)),["list-extensions","force","show-versions","category"].forEach(ve=>{const E=z[ve];E!==void 0&&de.push(`--${ve}=${E}`)}),z["update-extensions"]&&de.push("--update-extensions"),v.fork((0,j.$jc)(__dirname,"../../../server-main.js"),de,{stdio:"inherit"}).on("error",ve=>console.log(ve));return}const ce=[];for(const de in z){const $e=z[de];if(typeof $e=="boolean")$e&&ce.push("--"+de);else if(Array.isArray($e))for(const ve of $e)ce.push(`--${de}=${ve.toString()}`);else $e&&ce.push(`--${de}=${$e.toString()}`)}te!==null&&ce.push(`--remote=${te||A}`);const Ae=(0,j.$oc)(c);if(Ae===".bat"||Ae===".cmd"){const de=$||(0,x.cwd)();ee&&console.log(`Invoking: cmd.exe /C ${c} ${ce.join(" ")} in ${de}`),v.spawn("cmd.exe",["/C",c,...ce],{stdio:"inherit",cwd:de})}else{const de=(0,j.$mc)(c),$e={...process.env,ELECTRON_RUN_AS_NODE:"1"};if(ce.unshift("resources/app/out/cli.js"),ee&&console.log(`Invoking: cd "${de}" && ELECTRON_RUN_AS_NODE=1 "${c}" "${ce.join('" "')}"`),J()){ee&&console.log("Using pipes for output.");const ve=v.spawn(c,ce,{cwd:de,env:$e,stdio:["inherit","pipe","pipe"]});ve.stdout.on("data",E=>process.stdout.write(E)),ve.stderr.on("data",E=>process.stderr.write(E))}else v.spawn(c,ce,{cwd:de,env:$e,stdio:"inherit"})}}else{if(z.status){n({type:"status"},ee).then(Ae=>{console.log(Ae)}).catch(Ae=>{console.error("Error when requesting status:",Ae)});return}if(z["install-extension"]!==void 0||z["uninstall-extension"]!==void 0||z["list-extensions"]||z["update-extensions"]){n({type:"extensionManagement",list:z["list-extensions"]?{showVersions:z["show-versions"],category:z.category}:void 0,install:s(z["install-extension"]),uninstall:s(z["uninstall-extension"]),force:z.force},ee).then(Ae=>{console.log(Ae)}).catch(Ae=>{console.error("Error when invoking the extension management command:",Ae)});return}let ce;if(z.wait){if(!fe.length){console.log("At least one file must be provided to wait for.");return}ce=(0,I.$Nhc)(ee)}n({type:"open",fileURIs:fe,folderURIs:oe,diffMode:z.diff,mergeMode:z.merge,addMode:z.add,gotoLineMode:z.goto,forceReuseWindow:z["reuse-window"],forceNewWindow:z["new-window"],waitMarkerFilePath:ce,remoteAuthority:te},ee).catch(Ae=>{console.error("Error when invoking the open command:",Ae)}),ce&&W(ce),Re&&await Re}}function J(){if(process.env.WSL_DISTRO_NAME)try{return v.execSync("uname -r",{encoding:"utf8"}).includes("-microsoft-")}catch{}return!1}async function W(P){for(;m.existsSync(P);)await new Promise(q=>setTimeout(q,1e3))}function i(P,q){const T=[];for(const V of P)try{/^(http|https|file):\/\//.test(V)?T.push(t.parse(V).href):T.push(h(V).href)}catch{console.log(`Invalid url: ${V}`)}T.length&&n({type:"openExternal",uris:T},q).catch(V=>{console.error("Error when invoking the open external command:",V)})}function n(P,q){return q&&console.log(JSON.stringify(P,null,"  ")),new Promise((T,V)=>{const le=JSON.stringify(P);if(!p){console.log("Message "+le),T("");return}const z={socketPath:p,path:"/",method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},se=U.request(z,ee=>{if(ee.headers["content-type"]!=="application/json"){V("Error in response: Invalid content type: Expected 'application/json', is: "+ee.headers["content-type"]);return}const te=[];ee.setEncoding("utf8"),ee.on("data",oe=>{te.push(oe)}),ee.on("error",oe=>d("Error in response.",oe)),ee.on("end",()=>{const oe=te.join("");try{const fe=JSON.parse(oe);ee.statusCode===200?T(fe):V(fe)}catch{V("Error in response: Unable to parse response as JSON: "+oe)}})});se.on("error",ee=>d("Error in request.",ee)),se.write(le),se.end()})}function s(P){return P?.map(q=>/\.vsix$/i.test(q)?h(q).href:q)}function d(P,q){console.error("Unable to connect to VS Code server: "+P),console.error(q),process.exit(1)}const R=process.env.PWD||(0,x.cwd)();function h(P){return P=P.trim(),P=(0,j.$kc)(R,P),t.pathToFileURL(P)}function f(P,q,T,V){const le=h(P),z=q(le.href);try{const se=m.lstatSync(m.realpathSync(P));se.isFile()?V.push(z):se.isDirectory()?T.push(z):P==="/dev/null"&&V.push(z)}catch(se){se.code==="ENOENT"?V.push(z):console.log(`Problem accessing file ${P}. Ignoring file`,se)}}function u(P){return P.replace(/^file:\/\//,"vscode-remote://"+A)}const[,,o,O,w,g,...M]=process.argv;G({productName:o,version:O,commit:w,executableName:g},M).then(null,P=>{console.error(P.message||P.stack||P)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/fee1edb8d6d72a0ddff41e5f71a671c23ed924b9/core/vs/server/node/server.cli.js.map
